local key = ModPath .. '	' .. RequiredScript
if _G[key] then return else _G[key] = true end
_G.sydchSO = _G.sydchSO or {}
sydchSO._path = ModPath

sydchSO._data_path = SavePath .. 'sydchSO.json'
sydchSO.settings = sydchSO.settings or {
	skillOVERHAUL = 2,
	vocalHEISTERS = 3,
	buffEFFECTS = 2,
	userINTERFACE = 3,
	variousTEXT = true,
	variousTEXT_difficulties = true,
	variousTEXT_heists = true,
	variousTEXT_soundtracks = true,
	mugshotICON = true,
	moreHINTS = true,
	improveVISUALS = true,
	soundIMMERSION = true,
	voiceFILTER = true,
	stepDODGE = 2,
	stepSLIDE = 3,
	copBEHAVIOR = true,
	mixedSPAWN = 3,
	assaultTWEAKS = 2,
	expandedCREW = 2,
	reloadTYPE = 1,
	recoilKICK = 2,
	shotgunREALISM = 3,
	weaponOVERHAUL = false,
	weaponINERTIA_mode = 1,
	weaponINERTIA_init = true,
	streamLINED = 2,
	restorePROJOB = true, 
	holdoutRETUNE = true,
	crimeWAVE = false,
	betterMUTATORS = true,
	levelOUTFITS = 1,
	cameraSHAKE = false,
	showERROR = true
}

function sydchSO:Save()
	local file = io.open(sydchSO._data_path, 'w+')
	if file then
		file:write(json.encode(sydchSO.settings))
		file:close()
	end
end

function sydchSO:Load()
	local file = io.open(sydchSO._data_path, 'r')
	if file then
		for k, v in pairs(json.decode(file:read('*all')) or {}) do
			sydchSO.settings[k] = v
		end
		file:close()
	end
end

sydchSO.Load()
sydchSO.Save()

sydchSO.peersWithMod = {}
sydchSO.arrestModPeers = {}
dofile(ModPath .. "utils/coputils.lua")

sydchSO.crimeWAVE_add = 0

Hooks:Add('BaseNetworkSessionOnLoadComplete', 'sydchSO', function(local_peer, id)
    LuaNetworking:SendToPeers("sydchSO_network", "uwu")
end)

Hooks:Add('BaseNetworkSessionOnPeerEnteredLobby', 'BaseNetworkSessionOnPeerEnteredLobby_sydchSO', function(peer, peer_id)
    LuaNetworking:SendToPeer(peer_id, "sydchSO_network", "uwu")
end)

Hooks:Add('NetworkReceivedData', 'NetworkReceivedData_sydchSO', function(sender, messageType, data)
    if messageType == "sydchSO_network" then
        sydchSO.peersWithMod[sender] = true
    end

    if messageType == "coparrest_hello" then
        sydchSO.arrestModPeers[sender] = true
    end
end)

Hooks:Add('BaseNetworkSessionOnPeerRemoved', 'sydchSO_VocalHeisters', function(peer, peer_id, reason)
    sydchSO.peersWithMod[peer_id] = nil
    sydchSO.arrestModPeers[peer_id] = nil
end)

--log(",,,,,,,,,,,,*********,,,,,********/***,,,,,,,,,,*/((/*,,,,,,,,,,**,,,,*/,**,,,,,,,,,,**,,,,,,*/(((*,,,,,,.        ..***********************")
--log(",,,,,,,********,,,**************/**,,,,,,,,,,,*/(//*,,,,,,,,,,,**,,,,,*/,/,,,,,,,,,,,*/,,,,,,,,/(((/*,,,,,.         .,*********************")
--log(",,,******,,,,*********,,,,,**//*,...........*/(/*,.,,,,,**,,,,,/,,,,,,*/*/,,,*,,,,,,,//,,,,,,,,,*/(((*,,,,..          .********************")
--log("*****,,,*//((//**,,,,,,,,*****....   ....,,///*,...,,**,.,,,,,/,,,,.,,*/*/,,,*,,,,,,,((,,,,,,,,,,,*((/*,,,,.           ..******************")
--log("*,,,*//((((((((((//**,,****,.    ....,,,,*///*...,*/*,..,,,,,/*,,,,..,,/*/,,,,,,,,,,*((,,,,,,,,,,,,,*(*,,,,,.            .,****************")
--log(",,**(((((((((((#####(/***,..  ....,,,,,,*///*..,*//,,..,,,,,*/,,,,..,,,(*/,,*,,,,,,,//(,,,,,,,,,,,,,,/(*,,,*,.           ..,***************")
--log("***/((((((((((###%%%%#/,......,,,,,,,,*///*,,.,*/*,...,,,,,//,,,,,..,,,///,,,,.,,,,,(*(*,,,,,,*,,,,,,*((*,,,*..            .,**************")
--log("*,*/((((((((((##%%%#(*...,,,,,,,,,,,,*//*,,,,,/(,,,.,,,,,,/(*,,,,,..,,,///,,,,,..,,,/*//,,,,,,,,,,,,,,//(,,,,*,             .,*************")
--log(",,*((((((((((##%%#/*,,,,,,,,,,,,,,,,//*,,,,,*/(,,,,,,,,**/(*,,*,,,..,,,*((,,,,,,.,,,/**(,,,,,,,*,,,,,,*///,,,**.             .,/***********")
--log(",*/#(((#########(*,,,,,,,,,,,,,,,,*/*,*,,,,*/(*,,,,,,,*////,*(*,,,,,,,,,((,,,,,,,,,,/*,(*,,,,,,,*,,,,,*/,(*,,,**.              ,*/*********")
--log(",*(############/,,,,,*/,,,,,,,,,,*****,,,,,/((,,,,,,,,/(*#*,*(*,,,,,,,,,/(,,,,,,,,,,/*,//,,,,,*,,,,,,,*/,*(*,,,/,              .,**********")
--log(",*###########(*,,,/(%(,,,,,,,,,***,**,,..,//(,..,,,,,/(,(*,,/#,,,,,,,,,,,(,*,,,,,,,,(*,*(,,,,,/,,,,,,,/(,,//,,,*/.               ,,,*//(((#")
--log("*/#########(*,,*(%%%/,,,,,,,,,*,,,/,,,..,*/(*.....,,/(,//,,*/#,,,,,,,,,,,/***,,,,,,,(*,,(/,,,,*/,,,,,,*(,**(*,,,**.              ..,.,/(###")
--log("*########(/,,*(%%%/,,,,,,,,**,,,*/,,,..,*//(,....../(,,(,,,//%,,,,,,,,,,,*/**,,,,,,,(*,,*#/,,,,(*,,,,,*(,*,*(,,,,/,                ..  .*(#")
--log("/#######/,,*#%&&%*,,,,,,,,*,,,,****,..,*//(/,,,,.,*(,,/*,,*//#*.,,,,,,,,,,**/*,,,,,,(/,,,(#,,,,((,,,,,*/,*,,//,,,,/.                .    .,")
--log("(%#####*,*(%&&,,,,,,,,,*,,,,****,,..,///(*...,,/#(*,(,,,*/*//.,,,,,,,,,,**/*,,,,,,(/,,,*(*,,,*#*,,,,//,/,,*(*,,,/*.               .        ")
--log("####%(*/#%&&&%(,,,,,,,,*,,,,,,**/,,..,*///(,....*(*,.**,**#*,,#,,,,,,,,,,,,*//,,,,,,//,,,,*#,,,,#(,,,,(**//,,((,,,,/.                      ")
--log("####//%%&&&&%*.,,,,,,**,,,,,,,/(*,,,,*//(((...,,(,,  /,.,(***(#/.,,,,,,,,,,,/(/,,,,,/(,..,,/(,,,/#/,,*/,*,(/,*(*,,,/*.                  ...")
--log("##(/#%&&&&,.,,,,,,**,,,,,,*/(*,,.,,*/#/*/.,,,#/,..,/.,/*,,,,,(.,,,,,,,,,,,*/#,,,,,*(,  ..,(*.,*(#/,(***,*#**/*,,,*(,.                 .,(  ")
--log("#(#&&&&&/.,,,,,,***,,,,,,*#(*,,,.,*/#//(/,,*(#*,. /*,**,,,. .//.,,,,,,,,,,*/((*,,,*#/*,,.,*(,,,(*##**///,/(,**,,*,/*..                  .  ")
--log("#%%&&&&&(,.,,,,,,*/*,,,,,,,(#/,,,,,,/%&&&%/**/%###%&%*,///*.   ,(,,,,,,,,,,,*//#(,,,,(,     ./*,.*///,*,,,,,(,**,,***/,..             .    ")
--log("%#%&&&%*.,,,,,,,**,,,,,,,,(&/,,,.,,/#&&&%(*.,(..(%%*(#,.,  .*(.,,,,,,,,,,//(#/,,,/,       /,,,/*,**,,,,,(*,*,,*/*/,...           .*/*,,    ")
--log("##%&,,,,,,,,,**,,,,,,,,/#(*,,,,,*#@&/****,(#(/*/#&/#&&%/(/,   .(*,,,,,,,,,,*///#*,.*,       .*,,,**/#,,,,,/(**,,,/*/,.....          ,(%&&  ")
--log("##%%/.,,,,,,,,//,,,,,,,,/%*(,,,,,,(%@#***.,*&&&&&@@@@&@&/(/.   .#,,,,,,,,,,,//(#(,,*,.,*/((((//,,*,,*#,,,,*(/,,,,/(//...**..        .,#&&  ")
--log("#%#,,,,,,,,,*//,,,,,,,,*%/*(,,,,,(##/#(    #&%*//%&&@&(/(&(,,/.   ,(,,,,,,,,,,*/((,(,,#&%##(####(*,,*&%(#*,,,((,,,,/(/(...(/(..        .*%&")
--log("%(,,,,,,,,,*((*,,,,,,,,(#,/(,,,,/%(#,*/,  ,/#&//*/#@&/****,.. .    *(,,,,,,,,,,/((*#*,*,.  ,&&@#*#/,,(((,,,((,,,,*#/(,.*(/((,.        .(&  ")
--log("*,,,,,,,,//(#/,,,,,,,,#%*,(/,,,/%(#(,,,,*/(,.%&/***(//(((*.         //,,,,,,,,,*(/,.*,/&(*(&(/&@&/,,*%&/,,,//,,,,*#/#,,(/(//(*..      .,#  ")
--log(",,,,,,,*////#,,,,,,,,#&/,,(*,,*%((#*,,,,,*###(///****,,,,,...        *(*,,,,,,,*(,   ./%%%%&&/%@@#&@%,,*(*,,*//,,,,,#(#/(**((((/(,..     .,")
--log(",,,,,*/(/**((*,,,,,,(#%*,,#*,*%(((#*,,,../,........                   .(/,,,,,,*(.  .*%(///((@@%/#&@%../,,***//,,,,,#(%#*,,#((((//(*..    .")
--log(",,,,(#/*/(**#*,,,,*(#%(,,*#,*##((#(,**.,,*........                   ,/,*(,,,,,/(.   .*#%((/..,*/(&(. ,*.,,,*//*,,,,(##/*,,((((((/*/(*..   ")
--log(",*(#(//((,,/%*,,,,(%(%/,,*#,#%(((#/,*....,. ..                      .,*,.*/,,,,/(     .*/*/%&%%(, .   /,,,,,*//,,,,,((#//,,*#(((((/**((,.. ")
--log("#(///(#,,,,/%,,,,/#((%*,**((#((((#*,,   ..                         .,,,.,..(*,,/(   ,,.   .,,,*(%%/,,/*,,,,,*//*,,,,(/((/*,,(##(((((*,*(#/*")
--log("((/(#*,,,,,(#,,,*%((#%*,**%#((/((#,,.                              ......   */,/(.           ..,,***//,,,,,,*//*,,,,%(((/*,,*##((((((*,*((#")
--log("((#*,,,,,,,#(,,*#(((#%,*/*#/(//((#,,                               .....     .(/(.        .......,,((,,,,,,,*//*,,,*#%%//*,,,(##(%#(((*,,/#")
--log("#*,,,,,,,,,%(,,(((((#%**/,,//*/(#(,.                               ....        .*,            ...,(/*,,,,,,,///*,,,((/%(**,,,*(##%%((((/,,*")
--log(",,,,,,,,,,*%/,*#((((#%*//,,//*/(#(..                                ..           ,             ../(,,,,,,,,,///*,,,#(/%*,,,,(###%%%#((/,,  ")
--log(",,,,,,,,,,*#/*#/#((((#(*(,,//*/(%#.                                                            .*(,,,,,,,,,*/((/,,/#/(((#(,,,,*(##%&&&&&%(*")
--log(",,,,,,,,,,*#/#(((((####*(,,/*,/(#%,                                                            ,#*,,,,,,,,,*(((/,,#(/#/,*#/,,,,*((#&&&&&%%%")
--log(",,,,,,,,///#(#*#((##((#/(*,/*,*(#&/               .,                                          .(*,,,,,,,,,,/((((,/%((%*,,*#*,,,,*(#@&&&&%%%")
--log(",,,*(#((#**(#//((((####((/,//,*(#%&,               .,*,..,,**//*/*,..                        .(*,,*/*,,,,,,/((((*%((##,,,,*#/,,,,*(@&&&&&%%")
--log("(#%#((((#,*(%*(((((####(/(,*/**(##&(.                  ...        .*///*,..                  //,,,(/*,,,,,*((((#(#((#(,,,,,*#/,,,,*&@&&&&&%")
--log("%#(((((#(,,((*#((((##(##(#**/**(###&/.                                      ./*,**,,/*      //,,,/#,,,,,,,*(((#(%(((%*,,,,,,*((,,,*%@&&&&&&")
--log("((##(((#*,,(*((((#########(,/*,/#%(%%*.                                                    //,*(/(*,,,,,,,/((#%%(((#%,,,,,,*//*#/,,(@@&&&&&")
--log("###(((##,,*(*#(((#%#((####%***,/#%(##%*..                                                ,/**(/,/(,,,,,,,*(((%%#(((%#,,,,,,*((/,*##/&@&&&&&")
--log("*##(((%/,,*//#((#*#%((####%(,*,*(%((####/..                                             ,(/#*,,,#*,,,,,,,*(((%#(#(#&(,,,,,,*(((*,,,*#@@&&&&")
--log("*%(((#%*,,**(#(#/,/##(#####%*,,*(%((#((#%(,.                           .               .##/,..,/(,,,,,,,,/(((##%((%%/,,,,,,/(((/*,,,/&@@&@@")
--log("*%##(##,,,,*###(,**/%(#####%(*,,/%#(###((#%(,.                         ((,            /(,. .,*%%*,,,,,,,*/((#&%((#%%/,,,,,,/(##(/*,,,#@@@@&")
--log("*%###%/,,,,/###*****##(#####%#,,*##(###((((#%(,.                       ,* */.        ,.  ,*#%#%/,,,,,,,,*((#(((%%%/,,,,,*((%#((/*,,*%@@@@  ")
--log("*%###%*,**,(#%******/%######/(/,,(%(###((((###%#*.                      /,  ./(,.     .*#%%%###*,,,,,,,,/(%%%#((#%#%/,,,,,*(#%(((((*,,/&@&@")
--log("*###%(*#(**#%/*******######%/*#*,*%########(###%%(*,.                    /*     ./(,,(%%%#**%%/,,**,,*,*#%#(%#(#%#(#/,**,,/(#%##((((*,*(&@@")
--log(",###&(%#(*/#(********/%####%/*/(*,############%%(#%#*,.                   (*      ./#%##%*,,(#*,,,,,,*,/%#(#%#(#%#(#/,,,,,/(%%((%#(((*,*%@&")
--log(",/%%%###(*(#**********#####%/**/(,/%(#########%#(//(%%(*,.                 ,#*.       .(%/*,,((,***,**(%#((#%##%##(#/,,,,*/(%#(#(#%%(/***#(")
--log("#%&(##((#*,**********%###%/***(/*###########%(/////(#%#*,,,.      ...,*/(#%%%/*.       .,#(*/#**/((%((((##%#####(#(,,***(#######%%/***#    ")
--log("//#(((%%#/#(*********(%##%(****(//##########%(///////((%#((*****/(%%%%(((#%####%(*..       ,#%@&%%%%&&&%##%%###((##*****(#########%(***    ")
--log("/////(///(////#/********#####/****(/(########%#////////((/(##(#%%#(///////(&%######%%(**,...(&%%%%%%%%%%%%%&&%###((#%*****(%%###########%#*")
--log("//////((/////((%/*******/%##%/***/(#/########%(**//////((/(((((((###################%#//(%%%%%%%%%%%%%%%%%%&&%###(%/****(%%###########%%%  ")
--log("///////((//////#%%%#(/***(%#%(*(%%%%#####%%(#(*****//((###(//*.... ........,,*(#%%%#####%&%%%%%%%%%%%%%%%%%%%%%%&%%%%#//**(&%############%#")
--log("////////(((//////%%%%%(///%&&%%&%%(*/#%(/**((*******///##(*..             ..      ... *%%%%%%%%%%%%%%%%%%%%%%%%&(/(((///(%%############%*  ")
--log("/////////(((///(//&&%%%%/%%&&%%#(/******/****************((##(/*,.                .#&%%%%%%%%%%%%%%%%%%%%&&%#///////////(%/(%%##########*  ")
--log("///////////((//((/#%%%%%%%*(@@&%%/********************************/(#####(/*,,.....,&&%%%%%%%%%%%%%%%%%%%&//////////////((///%%#######%(,  ")
--log("///////////(((//#//#&%%%%%#*%@&**********************************/(((((((((///**/&&%%%%%%%%%%%%%%%%%%&&%(///////////////////########%*,    ")
--log("(////////////((//#(/&%%%%%%%%%%*,(#(*************************/##/*.           ...,&@%%%%%%%%%%%%%%%&&&&&(///////////////////////%%%%%####,,")
--log("/((///////////(#(/(%%&%%%%%&&&%(   .*#(****************(((*,.                   .&@&&%%%%%%%%%%%%&&&&/////////////////////////(%#//(%%***  ")
--log("##(#(//////////(#(((%@&%%%%&&&&&*      ,*#(******(#(/,.........,,,,********,,,,/%@&&&%%%%%%%%%%%&&&(///////////////////////////%%////##**  ")
--log("(###(#(/////////(#####&%%%%&&&%&&/.        ,/#/*******((/********,,,..........,&@@&&&&%%%%%%%%%&&&%//////////////////////////////#&(/((/#(*")
--log("//(###%#/////////#####&&&%%&&&%%#,.        .,//*****(#(*..                  /@@@@&&&&%%%%%%%%&&%///////////////////////////////#%((((/##*  ")
--log("/////(##////////#####%%&&&%%%((##*,..       .,,/((/*****/(###(/**,,,,,,...&@@@@&&&&&%%%%%&&&%////////////////////////////////(%#((//(#*    ")
--log("//////(((#%%//////((###%%##&&&%%#((((##*,,,         .,,**,*******//((##%####(#@@@@@&&&&&&%%&&@@#/////////////////////////////////(#%(((/(#*")
--log("##(////##(((%%//////#####%%&&%#(((((((##,,,.         .,,.. ....,,.       ./@@@@@@@@&&&&&&&@&(/////////////////////////////////(((&(((((#*  ")
--log("##((((////(%#(%#////(###%%##&%%&%(((((((((##*,.           .   ,,.           .%@@@@@@@@&&@@@@%//////////////////////////////////((((&((((##*")
--log("((((((((////(%%#%(///###%&((#%%&&%((((((((((##,                         ....*%@@@@@@@@@@@@@&(//////////////////////////////////(((((((#(*  ")
--log("(((((((((((////#%##(//###(((%&%#/%(((((((((((%/,.                ..,,,/#%###@@@@@@@@@@@@@(//////////////////////////////////(((((%%(((%/*  ")