dofile(ModPath .. "lua/core/sydchSO.lua")

sydchSO.worse = {
	sah = {
		initial_spawn_delay = 30
}}

Hooks:PostHook(GroupAIStateBase, "_set_converted_police", "sydchSO", function(ass)
	if managers.player:has_team_category_upgrade("damage", "hostage_absorption") then
		local hostage_count = math.min((managers.groupai:state():hostage_count()+managers.groupai:state():get_amount_enemies_converted_to_criminals()), tweak_data.upgrades.values.team.damage.hostage_absorption_limit)
		local absorption = managers.player:team_upgrade_value("damage", "hostage_absorption", 0) * hostage_count
		managers.player:set_damage_absorption("hostage_absorption", absorption)
	end
end)

Hooks:PostHook(GroupAIStateBase, "sync_hostage_headcount", "sydchSO", function(ass)
	if managers.player:has_team_category_upgrade("damage", "hostage_absorption") then
		local hostage_count = math.min((managers.groupai:state():hostage_count()+managers.groupai:state():get_amount_enemies_converted_to_criminals()), tweak_data.upgrades.values.team.damage.hostage_absorption_limit)
		local absorption = managers.player:team_upgrade_value("damage", "hostage_absorption", 0) * hostage_count
		managers.player:set_damage_absorption("hostage_absorption", absorption)
	end
end)

function GroupAIStateBase:_get_balancing_multiplier(balance_multipliers)
-- AI IMPROVEMENTS: bots will count as player
if sydchSO.settings.assaultTWEAKS == 2 or sydchSO.settings.assaultTWEAKS == 3 or sydchSO.settings.expandedCREW == 3 then
    local nr_players = 0

    for u_key, u_data in pairs(self:all_player_criminals()) do
        if not u_data.status then
            nr_players = nr_players + 1
        end
    end

    local nr_ai = 0

    for u_key, u_data in pairs(self:all_AI_criminals()) do
        if not u_data.status then
            nr_ai = nr_ai + 1
        end
    end

    nr_players = nr_players + nr_ai
    nr_players = math.clamp(nr_players, 1, 4)

    return balance_multipliers[nr_players]
else
	local nr_players = 0

	for u_key, u_data in pairs(self:all_player_criminals()) do
		if not u_data.status then
			nr_players = nr_players + 1
		end
	end

	local nr_ai = 0

	for u_key, u_data in pairs(self:all_AI_criminals()) do
		if not u_data.status then
			nr_ai = nr_ai + 1
		end
	end

	nr_players = nr_players == 1 and nr_players + math.max(0, nr_ai - 1) or nr_players + nr_ai
	nr_players = math.clamp(nr_players, 1, 4)

	return balance_multipliers[nr_players]
end
end

local add_drama_original = GroupAIStateBase._add_drama
function GroupAIStateBase:_add_drama(amount)
	if sydchSO.settings.assaultTWEAKS == 2 or sydchSO.settings.assaultTWEAKS == 3 then
		if self._drama_data.amount >= 0.74 then
			self._drama_data.amount = 0.55
		elseif self._drama_data.amount <= 0.55 then
			self._drama_data.amount = 0.55
		end
	end
	add_drama_original(self,amount)
end

Hooks:PostHook(GroupAIStateBase, "set_whisper_mode", "sydchSO", function(self, enabled)
if sydchSO.settings.assaultTWEAKS == 3 then
    if enabled then
        return
    end

    local job = Global.level_data and Global.level_data.level_id

    if job and sydchSO.worse[job] and sydchSO.worse[job].initial_spawn_delay then
        local current_difficulty = self._difficulty_value
        self:set_difficulty(0)

        DelayedCalls:Add("sydchSO_dospawndelay", sydchSO.worse[job].initial_spawn_delay, function()
            self:set_difficulty(current_difficulty)
        end)
    end
end
end)

function GroupAIStateBase:has_room_for_police_hostage()
	local nr_hostages_allowed = 4

	for u_key, u_data in pairs(self._player_criminals) do
		if u_data.unit:base().is_local_player then
			if not managers.groupai:state():get_assault_mode() or managers.player:has_category_upgrade("player", "intimidate_enemies") then
				nr_hostages_allowed = nr_hostages_allowed + 1
			end
		elseif not managers.groupai:state():get_assault_mode() or u_data.unit:base():upgrade_value("player", "intimidate_enemies") then
			nr_hostages_allowed = nr_hostages_allowed + 1
		end
	end

	return nr_hostages_allowed > self._police_hostage_headcount + table.size(self._converted_police)
end

function GroupAIStateBase:check_gameover_conditions()
	if not Network:is_server() or managers.platform:presence() ~= "Playing" or setup:has_queued_exec() then
		return false
	end
	if game_state_machine:current_state().game_ended and game_state_machine:current_state():game_ended() then
		return false
	end
	if Global.load_start_menu or Application:editor() then
		return false
	end
	if not self:whisper_mode() and self._super_syndrome_peers and self:hostage_count() > 0 then
		for _, active in pairs(self._super_syndrome_peers) do
			if active then
				return false
			end
		end
	end
	local plrs_alive = false
	local plrs_disabled = true
	for u_key, u_data in pairs(self._player_criminals) do
		plrs_alive = true

		if u_data.status ~= "dead" then
			plrs_disabled = false

			break
		end
	end
	local ai_alive = false
	local ai_disabled = true
	for u_key, u_data in pairs(self._ai_criminals) do
		ai_alive = true

		if u_data.status ~= "dead" and u_data.status ~= "disabled" then
			ai_disabled = false

			break
		end
	end
	local gameover = false
	if not plrs_alive and not self:is_ai_trade_possible() then
		gameover = true
	elseif plrs_disabled and not ai_alive then
		gameover = true
	elseif plrs_disabled and ai_disabled then
		gameover = true
	end
	if gameover then
		if not self._gameover_clbk then
			self._gameover_clbk = callback(self, self, "_gameover_clbk_func")

			managers.enemy:add_delayed_clbk("_gameover_clbk", self._gameover_clbk, Application:time() + 28)
		end
	elseif self._gameover_clbk then
		managers.enemy:remove_delayed_clbk("_gameover_clbk")

		self._gameover_clbk = nil
	end
	return gameover
end

if not sydchSO.settings.vocalHEISTERS == 1 or not sydchSO.settings.vocalHEISTERS == 2 then
local last_assault_end_speak_time = 0
local assault_mode_speak = function(self, enabled)
    local gameTime = TimerManager and TimerManager:game() and TimerManager:game():time()
    if gameTime and gameTime < 1 then
        return
    end

    if enabled or (os.clock() - last_assault_end_speak_time) < 20 then
        return
    end

    DelayedCalls:Add("sydchSO_commentassaultend", sydchSO:_float(5, 8), function()
        sydchSO:_say_once("p24")
        last_assault_end_speak_time = os.clock()
    end)
end
end

if not Network:is_server() or not sydchSO.settings.expandedCREW == 3 then
	return
end

if sydchSO.settings.vocalHEISTERS == 1 then
	function GroupAIStateBase:chk_say_teamAI_combat_chatter()
	end
end

if not Keepers then
-- AI IMPROVEMENTS: bots will return to their objective
local old_determine_objective_for_criminal_AI = GroupAIStateBase._determine_objective_for_criminal_AI
function GroupAIStateBase:_determine_objective_for_criminal_AI(unit, ...)
	local movement = unit:movement()
	if movement._should_stay and movement._should_stay_pos then
		return {
			type = "defend_area",
			scan = true,
			pos = movement._should_stay_pos,
			nav_seg = managers.navigation:get_nav_seg_from_pos(movement._should_stay_pos)
		}
	end

	return old_determine_objective_for_criminal_AI(self, unit, ...)
end

Hooks:PostHook(GroupAIStateBase, "on_player_criminal_death", "on_player_criminal_death_ub", function (self)
	for _, u_data in pairs(self._player_criminals) do
		if u_data.status ~= "dead" then
			return
		end
	end

	for _, u_data in pairs(self._ai_criminals) do
		u_data.unit:movement():set_should_stay(false)
	end
end)
end