dofile(ModPath .. "lua/core/sydchSO.lua")

if sydchSO.settings.betterMUTATORS == false then
	return
end

local massive_font = tweak_data.menu.pd2_massive_font
local large_font = tweak_data.menu.pd2_large_font
local medium_font = tweak_data.menu.pd2_medium_font
local small_font = tweak_data.menu.pd2_small_font
local massive_font_size = tweak_data.menu.pd2_massive_font_size
local large_font_size = tweak_data.menu.pd2_large_font_size
local medium_font_size = tweak_data.menu.pd2_medium_font_size
local small_font_size = tweak_data.menu.pd2_small_font_size
local PANEL_PADDING = 10
MutatorsCategoryPage = MutatorsCategoryPage or class(MenuGuiTabPage)
MutatorsCategoryPage.category = "all"

function MutatorsCategoryPage:_setup_help_panel()
	self._help_text_panel = self:info_panel():panel({})
	self._buttons_panel = self:info_panel():panel({})
	local text_title = self:info_panel():text({
		name = "title_text",
		blend_mode = "add",
		align = "left",
		vertical = "top",
		valign = "scale",
		halign = "scale",
		layer = 1,
		font_size = medium_font_size,
		font = medium_font,
		color = tweak_data.screen_colors.title,
		text = managers.localization:to_upper_text("menu_mutators"),
		w = self:info_panel():w() - PANEL_PADDING * 2,
		h = medium_font_size
	})

	text_title:set_left(PANEL_PADDING)
	text_title:set_top(PANEL_PADDING)

	local text_desc = self:info_panel():text({
		blend_mode = "add",
		name = "help_text",
		word_wrap = true,
		wrap = true,
		align = "left",
		vertical = "top",
		valign = "scale",
		halign = "scale",
		layer = 1,
		font_size = small_font_size,
		font = small_font,
		color = tweak_data.screen_colors.text,
		text = managers.localization:text("menu_mutators_desc"),
		w = self:info_panel():w() - PANEL_PADDING * 2
	})

	text_desc:set_left(PANEL_PADDING)
	text_desc:set_top(text_title:bottom())
	local _, _, _, h = text_desc:text_rect()
	text_desc:set_h(h)

	local text_longdesc = self:info_panel():text({
		blend_mode = "add",
		name = "mutator_longdesc_text",
		word_wrap = true,
		wrap = true,
		align = "left",
		vertical = "top",
		text = "",
		valign = "scale",
		halign = "scale",
		layer = 1,
		font_size = small_font_size,
		font = small_font,
		color = tweak_data.screen_colors.text,
		w = self:info_panel():w() - PANEL_PADDING * 2
	})

	text_longdesc:set_left(PANEL_PADDING)
	text_longdesc:set_top(text_desc:bottom() + PANEL_PADDING)
	local _, _, _, h = text_longdesc:text_rect()
	text_longdesc:set_h(h)

	self._mutator_longdesc = text_longdesc
	local text_incompatibilities = self:info_panel():text({
		blend_mode = "add",
		name = "incompatibilities_text",
		word_wrap = true,
		wrap = true,
		align = "left",
		vertical = "top",
		valign = "scale",
		halign = "scale",
		layer = 1,
		font_size = small_font_size,
		font = small_font,
		color = tweak_data.screen_colors.important_1,
		text = managers.localization:text("menu_mutators_incompatibilities"),
		w = self:info_panel():w() - PANEL_PADDING * 2
	})

	text_incompatibilities:set_left(PANEL_PADDING)
	text_incompatibilities:set_top(text_longdesc:bottom() + PANEL_PADDING)
	local _, _, _, h = text_incompatibilities:text_rect()
	text_incompatibilities:set_h(h)
	text_incompatibilities:set_visible(false)

	self._incompatibilities_text = text_incompatibilities
	local text_achievements = self:info_panel():text({
		blend_mode = "add",
		name = "achievement_text",
		wrap = true,
		align = "left",
		word_wrap = true,
		vertical = "top",
		halign = "scale",
		valign = "scale",
		layer = 1,
		font_size = small_font_size,
		font = small_font,
		color = tweak_data.screen_colors.important_1,
		text = managers.localization:text("menu_mutators_achievement_disabled"),
		w = self:info_panel():w() - PANEL_PADDING * 2,
		h = small_font_size * 2
	})

	text_achievements:set_left(PANEL_PADDING)
	text_achievements:set_top(text_longdesc:bottom() + PANEL_PADDING)
	local _, _, _, h = text_achievements:text_rect()
	text_achievements:set_h(h)
	--text_achievements:set_visible(managers.mutators:are_mutators_enabled())
	text_achievements:set_visible(false)
	
	local text_active_notify = self:info_panel():text({
		blend_mode = "add",
		name = "achievement_text",
		wrap = true,
		align = "left",
		word_wrap = true,
		vertical = "top",
		halign = "scale",
		valign = "scale",
		layer = 1,
		font_size = small_font_size,
		font = small_font,
		color = tweak_data.screen_colors.important_1,
		text = managers.localization:text("menu_mutators_active_notify"),
		w = self:info_panel():w() - PANEL_PADDING * 2,
		h = small_font_size * 2
	})
	
	text_active_notify:set_left(PANEL_PADDING)
	text_active_notify:set_top(text_longdesc:bottom() + PANEL_PADDING)
	local _, _, _, h = text_active_notify:text_rect()
	text_active_notify:set_h(h)
	text_active_notify:set_visible(managers.mutators:are_mutators_enabled())

	self._achievements_text = text_achievements
	self._active_notify = text_active_notify
	
	local text_reduction = self:info_panel():text({
		blend_mode = "add",
		name = "reduction_text",
		wrap = true,
		align = "left",
		word_wrap = true,
		vertical = "top",
		halign = "scale",
		valign = "scale",
		layer = 1,
		font_size = small_font_size,
		font = small_font,
		color = tweak_data.screen_colors.important_1,
		text = managers.localization:text("menu_mutators_reduction", self:_get_reduction_macros()),
		w = self:info_panel():w() - PANEL_PADDING * 2,
		h = small_font_size * 2
	})

	text_reduction:set_left(PANEL_PADDING)
	text_reduction:set_top(text_achievements:bottom() + PANEL_PADDING)
	local _, _, _, h = text_reduction:text_rect()
	text_reduction:set_h(h)
	text_reduction:set_visible(false)

	local text_cash_reduction = self:info_panel():text({
		blend_mode = "add",
		name = "cash_reduction_text",
		wrap = true,
		align = "left",
		word_wrap = true,
		vertical = "top",
		halign = "scale",
		valign = "scale",
		layer = 1,
		font_size = small_font_size,
		font = small_font,
		color = tweak_data.screen_colors.important_1,
		text = managers.localization:text("menu_mutators_cash_reduction", self:_get_reduction_macros()),
		w = self:info_panel():w() - PANEL_PADDING * 2,
		h = small_font_size * 2
	})
	
	text_cash_reduction:set_left(PANEL_PADDING)
	text_cash_reduction:set_top(text_achievements:bottom() + PANEL_PADDING)
	local _, _, _, h = text_cash_reduction:text_rect()
	text_cash_reduction:set_h(h)
	--text_cash_reduction:set_visible(managers.mutators:are_mutators_enabled() and managers.mutators:get_cash_multiplier() < 1)
	text_cash_reduction:set_visible(false)
	
	local text_experience_reduction = self:info_panel():text({
		blend_mode = "add",
		name = "reduction_text",
		wrap = true,
		align = "left",
		word_wrap = true,
		vertical = "top",
		halign = "scale",
		valign = "scale",
		layer = 1,
		font_size = small_font_size,
		font = small_font,
		color = tweak_data.screen_colors.important_1,
		text = managers.localization:text("menu_mutators_experience_reduction", self:_get_reduction_macros()),
		w = self:info_panel():w() - PANEL_PADDING * 2,
		h = small_font_size * 2
	})
	
	text_experience_reduction:set_left(PANEL_PADDING)
	text_experience_reduction:set_top(text_achievements:bottom() + (PANEL_PADDING * 2))
	local _, _, _, h = text_experience_reduction:text_rect()
	text_experience_reduction:set_h(h)
	--text_experience_reduction:set_visible(managers.mutators:are_mutators_enabled() and managers.mutators:get_experience_multiplier() < 1)
	text_experience_reduction:set_visible(false)
	
	local text_cash_promotion = self:info_panel():text({
		blend_mode = "add",
		name = "promotion_text",
		wrap = true,
		align = "left",
		word_wrap = true,
		vertical = "top",
		halign = "scale",
		valign = "scale",
		layer = 1,
		font_size = small_font_size,
		font = small_font,
		color = tweak_data.screen_colors.important_1,
		text = managers.localization:text("menu_mutators_cash_promotion", self:_get_promotion_macros()),
		w = self:info_panel():w() - PANEL_PADDING * 2,
		h = small_font_size * 2
	})
	
	text_cash_promotion:set_left(PANEL_PADDING)
	text_cash_promotion:set_top(text_achievements:bottom() + PANEL_PADDING)
	local _, _, _, h = text_cash_promotion:text_rect()
	text_cash_promotion:set_h(h)
	--text_cash_promotion:set_visible(managers.mutators:are_mutators_enabled() and managers.mutators:get_cash_multiplier() > 1)
	text_cash_promotion:set_visible(false)
	
	local text_experience_promotion = self:info_panel():text({
		blend_mode = "add",
		name = "promotion_text",
		wrap = true,
		align = "left",
		word_wrap = true,
		vertical = "top",
		halign = "scale",
		valign = "scale",
		layer = 1,
		font_size = small_font_size,
		font = small_font,
		color = tweak_data.screen_colors.important_1,
		text = managers.localization:text("menu_mutators_experience_promotion", self:_get_promotion_macros()),
		w = self:info_panel():w() - PANEL_PADDING * 2,
		h = small_font_size * 2
	})
	
	text_experience_promotion:set_left(PANEL_PADDING)
	text_experience_promotion:set_top(text_achievements:bottom() + PANEL_PADDING)
	local _, _, _, h = text_experience_promotion:text_rect()
	text_experience_promotion:set_h(h)
	--text_experience_promotion:set_visible(managers.mutators:are_mutators_enabled() and managers.mutators:get_experience_multiplier() > 1)
	text_experience_promotion:set_visible(false)

	self._cash_reduction_text = text_cash_reduction
	self._experience_reduction_text = text_experience_reduction
	self._cash_promotion_text = text_cash_promotion
	self._experience_promotion_text = text_experience_promotion
	
	self._buttons = {}
	self._controllers_pc_mapping = {}
	self._controllers_mapping = {}
	local buttons = {
		{
			btn = "BTN_Y",
			name_id = "menu_mutators_reset_all",
			pc_btn = "menu_modify_item",
			callback = callback(self, self, "_reset_mutators")
		}
	}

	if not managers.menu:is_pc_controller() then
		table.insert(buttons, {
			name_id = "menu_mutators_toggle",
			prio = 10,
			btn = "BTN_A"
		})
		table.insert(buttons, {
			btn = "BTN_X",
			name_id = "menu_mutators_change_options",
			pc_btn = "menu_remove_item",
			callback = callback(self, self, "_open_selected_options")
		})
	end

	table.sort(buttons, function (a, b)
		return (a.prio or 0) > (b.prio or 0)
	end)

	local btn_x = 10

	for btn, btn_data in pairs(buttons) do
		local new_button = MenuGuiButtonItem:new(self:buttons_panel(), btn_data, btn_x, btn)
		self._buttons[btn] = new_button

		if btn_data.pc_btn then
			self._controllers_mapping[btn_data.pc_btn:key()] = new_button
		end
	end

	self:buttons_panel():set_h(table.size(buttons) * tweak_data.menu.pd2_small_font_size + 20)
	self:help_text_panel():set_h(self:help_text_panel():h() - self:buttons_panel():h() - 10)
	self:buttons_panel():set_top(self:help_text_panel():bottom() + 10)
	BoxGuiObject:new(self:help_text_panel(), {
		sides = {
			1,
			1,
			1,
			1
		}
	})
	BoxGuiObject:new(self:buttons_panel(), {
		sides = {
			1,
			1,
			1,
			1
		}
	})
end

function MutatorsCategoryPage:refresh()
	MutatorsCategoryPage.super.refresh(self)

	local compatible, incompatible_mutator = nil

	if self._selected_item then
		local longdesc = self._selected_item:mutator():longdesc()

		self._mutator_longdesc:set_text(longdesc and longdesc ~= "" and longdesc or "")

		local _, _, _, h = self._mutator_longdesc:text_rect()

		self._mutator_longdesc:set_h(h)

		compatible, incompatible_mutator = managers.mutators:can_enable_mutator(self._selected_item:mutator())

		if not compatible then
			self._incompatibilities_text:set_text(managers.localization:text("menu_mutators_incompatibilities", {
				mutators = incompatible_mutator:name()
			}))
			self._incompatibilities_text:set_visible(true)

			local _, _, _, h = self._incompatibilities_text:text_rect()

			self._incompatibilities_text:set_h(h)
			self._incompatibilities_text:set_top(self._mutator_longdesc:bottom() + PANEL_PADDING)
		else
			self._incompatibilities_text:set_text("")
			self._incompatibilities_text:set_h(0)
			self._incompatibilities_text:set_visible(false)
		end
	end

	if self._achievements_text then
		--self._achievements_text:set_visible(managers.mutators:are_mutators_enabled())
		self._achievements_text:set_visible(false)
		self._achievements_text:set_top((not compatible and self._incompatibilities_text or self._mutator_longdesc):bottom() + PANEL_PADDING)
	end
	
	if self._active_notify then
		self._active_notify:set_visible(managers.mutators:are_mutators_enabled())
		self._active_notify:set_top((not compatible and self._incompatibilities_text or self._mutator_longdesc):bottom() + PANEL_PADDING)
	end
	
	if self._cash_reduction_text then
		--self._cash_reduction_text:set_visible(managers.mutators:are_mutators_enabled() and managers.mutators:get_cash_multiplier() < 1)
		self._cash_reduction_text:set_visible(false)

		if managers.mutators:are_mutators_enabled() then
			self._cash_reduction_text:set_text(managers.localization:text("menu_mutators_cash_reduction", self:_get_reduction_macros()))
		end

		self._cash_reduction_text:set_top(self._achievements_text:bottom() + PANEL_PADDING)
	end
	
	if self._experience_reduction_text then
		--self._experience_reduction_text:set_visible(managers.mutators:are_mutators_enabled() and managers.mutators:get_experience_multiplier() < 1)
		self._experience_reduction_text:set_visible(false)

		if managers.mutators:are_mutators_enabled() then
			self._experience_reduction_text:set_text(managers.localization:text("menu_mutators_experience_reduction", self:_get_reduction_macros()))
		end

		self._experience_reduction_text:set_top(self._achievements_text:bottom() + (PANEL_PADDING * 2))
	end

	if self._cash_promotion_text then
		--self._cash_promotion_text:set_visible(managers.mutators:are_mutators_enabled() and managers.mutators:get_cash_multiplier() > 1)
		self._cash_promotion_text:set_visible(false)

		if managers.mutators:are_mutators_enabled() then
			self._cash_promotion_text:set_text(managers.localization:text("menu_mutators_cash_promotion", self:_get_promotion_macros()))
		end

		self._cash_promotion_text:set_top(self._achievements_text:bottom() + PANEL_PADDING)
	end
	
	if self._experience_promotion_text then
		--self._experience_promotion_text:set_visible(managers.mutators:are_mutators_enabled() and managers.mutators:get_experience_multiplier() > 1)
		self._experience_promotion_text:set_visible(false)

		if managers.mutators:are_mutators_enabled() then
			self._experience_promotion_text:set_text(managers.localization:text("menu_mutators_experience_promotion", self:_get_promotion_macros()))
		end

		self._experience_promotion_text:set_top(self._achievements_text:bottom() + (PANEL_PADDING * 2))
	end

	if self._items then
		for _, item in ipairs(self._items) do
			item:refresh()
		end
	end
end

function MutatorsCategoryPage:_get_reduction_macros()
	return {
		cash_reduction = math.round((1 - managers.mutators:get_cash_multiplier()) * 100),
		exp_reduction = math.round((1 - managers.mutators:get_experience_multiplier()) * 100)
	}
end

function MutatorsCategoryPage:_get_promotion_macros()
	return {
		cash_reduction = math.round((managers.mutators:get_cash_multiplier() - 1) * 100),
		exp_reduction = math.round((managers.mutators:get_experience_multiplier() - 1) * 100)
	}
end