dofile(ModPath .. "lua/core/sydchSO.lua")

-- Eightan's code from Bulletstorm Indicator
local add_to_temporary_property = PlayerManager.add_to_temporary_property
function PlayerManager:_clbk_bulletstorm_expire()
	self._bullet_storm_clbk = nil
	if sydchSO.settings.mugshotICON == true then
		managers.hud:set_teammate_condition(HUDManager.PLAYER_PANEL, "mugshot_normal", "EXPIRED")
	end
end

function PlayerManager:add_to_temporary_property(name, time, value, ...)
   add_to_temporary_property(self, name, time, value, ...)

	if name == "bullet_storm" and time then
		if not self._bullet_storm_clbk then
			self._bullet_storm_clbk = "infinite"
			if sydchSO.settings.mugshotICON == true then
				managers.hud:set_teammate_condition(HUDManager.PLAYER_PANEL, "mugshot_bulletstorm", "STARTED")
			end
			managers.enemy:add_delayed_clbk(self._bullet_storm_clbk, callback(self , self , "_clbk_bulletstorm_expire"), TimerManager:game():time() + time)
		end
	end
end

function PlayerManager:_on_enter_shock_and_awe_event()
	if not self._coroutine_mgr:is_running("automatic_faster_reload") then
		local equipped_unit = self:get_current_state()._equipped_unit
		local data = self:upgrade_value("player", "automatic_faster_reload", nil)

		if data and equipped_unit and (equipped_unit:base():fire_mode() == "auto" or equipped_unit:base():fire_mode() == "single" or equipped_unit:base():is_category("saw", "grenade_launcher", "flamethrower", "minigun")) then
			self._coroutine_mgr:add_and_run_coroutine("automatic_faster_reload", PlayerAction.ShockAndAwe, self, data.target_enemies, data.max_reload_increase, data.min_reload_increase, data.penalty, data.min_bullets, equipped_unit)
			if sydchSO.settings.buffEFFECTS == 2 or sydchSO.settings.buffEFFECTS == 3 then
				managers.environment_controller:set_buff_effect(0.2)
			end
		end
	end
end

function PlayerManager:refill_messiah_charges()
	if self._max_messiah_charges then
		self._messiah_charges = self._max_messiah_charges
	end

	self._messiah_cooldown_t = 0
end

function PlayerManager:use_messiah_charge()
	if self:has_category_upgrade("player", "infinite_messiah") then 
		self._messiah_cooldown_t = Application:time() + 90
		self._messiah_cooldown = true
	elseif self._messiah_charges then 
		self._messiah_charges = math.max(self._messiah_charges - 1, 0)
	end
end

function PlayerManager:_on_messiah_event()
	if self._current_state == "bleed_out" and not self._coroutine_mgr:is_running("get_up_messiah") and self._messiah_charges > 0 and self._messiah_cooldown_t < Application:time() then
		self._coroutine_mgr:add_coroutine("get_up_messiah", PlayerAction.MessiahGetUp, self)
		if sydchSO.settings.buffEFFECTS == 2 or sydchSO.settings.buffEFFECTS == 3 then
			managers.environment_controller:set_buff_effect(0.2)
		end
	end
	if self._current_state == "bleed_out" and managers.player:has_category_upgrade("player", "infinite_messiah_faster") and not self._coroutine_mgr:is_running("get_up_messiah") then
		self._messiah_cooldown_t = self._messiah_cooldown_t
		if self._messiah_charges > 0 and self._messiah_cooldown_t < Application:time() then
			self._coroutine_mgr:add_coroutine("get_up_messiah", PlayerAction.MessiahGetUp, self)
			if sydchSO.settings.buffEFFECTS == 2 or sydchSO.settings.buffEFFECTS == 3 then
				managers.environment_controller:set_buff_effect(0.2)
			end
		end
	end
end

function PlayerManager:health_skill_multiplier()
local multiplier = 1
	multiplier = multiplier + self:upgrade_value("player", "health_multiplier", 1) - 1
	multiplier = multiplier + self:upgrade_value("player", "passive_health_multiplier", 1) - 1
	multiplier = multiplier + self:team_upgrade_value("health", "passive_multiplier", 1) - 1
	multiplier = multiplier + self:get_hostage_bonus_multiplier("health") - 1
	multiplier = multiplier - self:upgrade_value("player", "health_decrease", 0)
	multiplier = multiplier + self:upgrade_value("player", "mrwi_health_multiplier", 1) - 1
	
	if self:has_inactivate_temporary_upgrade("temporary", "health_multiplier") then
		multiplier = multiplier + self:temporary_upgrade_value("temporary", "health_multiplier", 0) - 1
	end

	if self:num_local_minions() > 0 then
		multiplier = multiplier + self:upgrade_value("player", "minion_master_health_multiplier", 1) - 1
	end

	return multiplier
end

function PlayerManager:health_regen()
	local health_regen = tweak_data.player.damage.HEALTH_REGEN
	health_regen = health_regen + self:temporary_upgrade_value("temporary", "wolverine_health_regen", 0)
	health_regen = health_regen + self:get_hostage_bonus_addend("health_regen")
	health_regen = health_regen + self:upgrade_value("player", "passive_health_regen", 0)

	return health_regen
end

function PlayerManager:_on_enemy_killed_bloodthirst(equipped_unit, variant, killed_unit)
	if variant == "melee" then
		local data = self:upgrade_value("player", "melee_kill_increase_reload_speed", 0)
		if sydchSO.settings.buffEFFECTS == 2 or sydchSO.settings.buffEFFECTS == 3 then
			managers.environment_controller:set_buff_effect(0.2)
		end

		if data ~= 0 then
			self._temporary_properties:activate_property("bloodthirst_reload_speed", data[2], data[1])
		end
	end
end

function PlayerManager:_on_enemy_killed_stacking_hit_damage_multiplier(equipped_unit, variant, killed_unit)
	if variant == "melee" then
		if sydchSO.settings.buffEFFECTS == 2 or sydchSO.settings.buffEFFECTS == 3 then
			managers.environment_controller:set_buff_effect(0.2)
		end
		self:activate_temporary_upgrade("temporary", "melee_kill_stacking_hit_damage_multiplier")
	end
end

function PlayerManager:activate_cupcake()
	self._cupcake_t = Application:time() + tweak_data.upgrades.values.doctor_bag.cupcake_duration
	if self:is_cupcake_active() then
		self._cupcake_t = self._cupcake_t + tweak_data.upgrades.values.doctor_bag.cupcake_duration
	end
end

function PlayerManager:deactivate_cupcake()
	self._cupcake_t = nil
end

function PlayerManager:is_cupcake_active()
	if self._cupcake_t and Application:time() < self._cupcake_t then
		return true
	end
	return false
end

function PlayerManager:on_headshot_dealt()
	local player_unit = self:player_unit()

	if not player_unit then
		return
	end

	self._message_system:notify(Message.OnHeadShot, nil, nil)

	local t = Application:time()

	if self._on_headshot_dealt_t and t < self._on_headshot_dealt_t then
		return
	end

	self._on_headshot_dealt_t = t + (tweak_data.upgrades.on_headshot_dealt_cooldown or 0)
	self._on_headshot_dealt_disciple = t + 4
	local damage_ext = player_unit:character_damage()
	local regen_armor_bonus = managers.player:upgrade_value("player", "headshot_regen_armor_bonus", 0)

	if damage_ext and regen_armor_bonus > 0 then
		damage_ext:restore_armor(regen_armor_bonus)
		if sydchSO.settings.buffEFFECTS == 2 or sydchSO.settings.buffEFFECTS == 3 then
			managers.environment_controller:set_buff_effect(0.2)
		end
	end
	
	if self._on_headshot_dealt_disciple and t < self._on_headshot_dealt_disciple then
		return
	end
	
	local regen_health_bonus = managers.player:upgrade_value("player", "headshot_regen_health_bonus", 0)
	if damage_ext and regen_health_bonus > 0 then
		damage_ext:restore_health(regen_health_bonus, true)
		if sydchSO.settings.buffEFFECTS == 2 or sydchSO.settings.buffEFFECTS == 3 then
			managers.environment_controller:set_buff_effect(0.2)
		end
	end
end

function PlayerManager:on_lethal_headshot_dealt(attacker_unit, attack_data)
	if not self:player_unit() or attacker_unit ~= self:player_unit() then
		return
	end

	self._message_system:notify(Message.OnLethalHeadShot, nil, attack_data)
	
	local player_unit = self:player_unit()
	if not player_unit then
		return
	end
	
	local damage_ext = player_unit:character_damage()
	local regen_armor_extra = managers.player:upgrade_value("player", "lethal_headshot_regen_armor_extra", 0)
	
	if damage_ext and regen_armor_extra > 0 then
		damage_ext:restore_armor(regen_armor_extra)
		if sydchSO.settings.buffEFFECTS == 2 or sydchSO.settings.buffEFFECTS == 3 then
			managers.environment_controller:set_buff_effect(0.2)
		end
	end
end

function PlayerManager:get_contour_for_marked_enemy(enemy_type)
	local contour_type = "mark_enemy"

	if enemy_type == "swat_turret" or enemy_type == "sentry_gun" then
		contour_type = "mark_unit_dangerous"

		if managers.player:has_category_upgrade("player", "marked_enemy_extra_damage") or managers.player:has_category_upgrade("trip_mine", "marked_enemy_extra_damage") then
			contour_type = "mark_unit_dangerous_damage_bonus"
		end

		if managers.player:has_category_upgrade("player", "marked_inc_dmg_distance") then
			contour_type = "mark_unit_dangerous_damage_bonus_distance"

			if "mark_unit_dangerous_damage_bonus_distance" then
			end
		end
	else
		if managers.player:has_category_upgrade("player", "marked_enemy_extra_damage") then
			contour_type = "mark_enemy_damage_bonus"
		end

		if managers.player:has_category_upgrade("player", "marked_inc_dmg_distance") then
			contour_type = "mark_enemy_damage_bonus_distance"
		end
	end

	return contour_type
end

function PlayerManager:on_killshot(killed_unit, variant, headshot, weapon_id)
	local player_unit = self:player_unit()

	if not player_unit then
		return
	end

	if CopDamage.is_civilian(killed_unit:base()._tweak_table) then
		return
	end

	local weapon_melee = weapon_id and tweak_data.blackmarket and tweak_data.blackmarket.melee_weapons and tweak_data.blackmarket.melee_weapons[weapon_id] and true

	if killed_unit:brain().surrendered and killed_unit:brain():surrendered() and (variant == "melee" or weapon_melee) then
		managers.custom_safehouse:award("daily_honorable")
	end

	managers.modifiers:run_func("OnPlayerManagerKillshot", player_unit, killed_unit:base()._tweak_table, variant)

	local equipped_unit = self:get_current_state()._equipped_unit
	self._num_kills = self._num_kills + 1

	if self._num_kills % self._SHOCK_AND_AWE_TARGET_KILLS == 0 and self:has_category_upgrade("player", "automatic_faster_reload") then
		self:_on_enter_shock_and_awe_event()
	end
	
	local selection_index = equipped_unit and equipped_unit:base() and equipped_unit:base():selection_index() or 0
	local reload_last_t = Application:time()
	if selection_index == 2 and self._has_primary_reload_secondary then
		local kills_to_reload = self:upgrade_value("player", "primary_reload_secondary", 9)
		local primary_kills = self:get_property("primary_reload_secondary_kills", 0) + 1

		if kills_to_reload <= primary_kills then
			local secondary_unit = player_unit:inventory():unit_by_selection(1)
			local secondary_base = alive(secondary_unit) and secondary_unit:base()
			local can_reload = secondary_base and secondary_base.can_reload and secondary_base:can_reload()

			if can_reload and reload_last_t < Application:time() then
				secondary_base:on_reload()
				managers.statistics:reloaded()
				managers.hud:set_ammo_amount(secondary_base:selection_index(), secondary_base:ammo_info())
				reload_last_t = reload_last_t + 20
				if sydchSO.settings.buffEFFECTS == 2 or sydchSO.settings.buffEFFECTS == 3 then
					managers.environment_controller:set_buff_effect(0.2)
				end
			end

			primary_kills = 0
		end

		self:set_property("primary_reload_secondary_kills", primary_kills)
	end
	
	if selection_index == 1 and self._has_secondary_reload_primary then
		local kills_to_reload = self:upgrade_value("player", "secondary_reload_primary", 10)
		local secondary_kills = self:get_property("secondary_reload_primary_kills", 0) + 1

		if kills_to_reload <= secondary_kills then
			local primary_unit = player_unit:inventory():unit_by_selection(2)
			local primary_base = alive(primary_unit) and primary_unit:base()
			local can_reload = primary_base and primary_base.can_reload and primary_base:can_reload()

			if can_reload then
				primary_base:on_reload()
				managers.statistics:reloaded()
				managers.hud:set_ammo_amount(primary_base:selection_index(), primary_base:ammo_info())
				if sydchSO.settings.buffEFFECTS == 2 or sydchSO.settings.buffEFFECTS == 3 then
					managers.environment_controller:set_buff_effect(0.2)
				end
			end

			secondary_kills = 0
		end

		self:set_property("secondary_reload_primary_kills", secondary_kills)
	end

	self._message_system:notify(Message.OnEnemyKilled, nil, equipped_unit, variant, killed_unit)

	if self._player_panic_when_kill then
		local pos = player_unit:position()
		local skill = self:upgrade_value("player", "panic_when_kill")
		if skill and type(skill) ~= "number" then
			local area = skill.area
			local chance = skill.chance
			local amount = skill.amount
			local enemies = World:find_units_quick("sphere", pos, area, 12, 21)

			for i, unit in ipairs(enemies) do
				if unit:character_damage() then
					unit:character_damage():build_suppression(amount, chance)
					if sydchSO.settings.buffEFFECTS == 2 or sydchSO.settings.buffEFFECTS == 3 then
						managers.environment_controller:set_buff_effect(0.2)
					end
				end
			end
		end
	end

	if self:has_category_upgrade("team", "crew_heavy_impact") then
		local pos = player_unit:position()
		local panic_last_t = Application:time()
		local panic_data = managers.player:crew_ability_upgrade_value("crew_heavy_impact", 1)
		if panic_last_t < Application:time() then
			local area = 1800
			local chance = 1
			local amount = 400
			local enemies = World:find_units_quick("sphere", pos, area, 12, 21)
	
			for i, unit in ipairs(enemies) do
				if unit:character_damage() then
					unit:character_damage():build_suppression(amount, chance)
				end
			end
			panic_last_t = panic_last_t + panic_data
		end
	end
	
	if self:has_category_upgrade("player", "copr_out_of_health_move_slow") and managers.player:has_activate_temporary_upgrade("temporary", "copr_ability") then
		local pos = player_unit:position()
		local area = 1800
		local chance = 1
		local amount = 400
		local enemies = World:find_units_quick("sphere", pos, area, 12, 21)
		local health_ratio = self:player_unit():character_damage():health_ratio()
		local out_of_health = health_ratio + 0.01 < managers.player:upgrade_value("player", "copr_static_damage_ratio", 0)
	
		if out_of_health then
			self:_activate_copr_died()
			for i, unit in ipairs(enemies) do
				if unit:character_damage() then
					unit:character_damage():build_suppression(amount, chance)
				end
			end
		end
	end

	local t = Application:time()
	local damage_ext = player_unit:character_damage()

	if self:has_category_upgrade("player", "kill_change_regenerate_speed") then
		local amount = self:body_armor_value("skill_kill_change_regenerate_speed", nil, 1)
		local multiplier = self:upgrade_value("player", "kill_change_regenerate_speed", 0)

		damage_ext:change_regenerate_speed(amount * multiplier, tweak_data.upgrades.kill_change_regenerate_speed_percentage)
	end

	local gain_throwable_per_kill = managers.player:upgrade_value("team", "crew_throwable_regen", 0)

	if gain_throwable_per_kill ~= 0 then
		self._throw_regen_kills = (self._throw_regen_kills or 0) + 1

		if gain_throwable_per_kill < self._throw_regen_kills then
			managers.player:add_grenade_amount(1, true)

			self._throw_regen_kills = 0
		end
	end
	
	if self:has_activate_temporary_upgrade("temporary", "copr_ability") then
		local kill_life_leech = self:upgrade_value_nil("player", "copr_kill_life_leech")
		local static_damage_ratio = self:upgrade_value_nil("player", "copr_static_damage_ratio")

		if kill_life_leech and static_damage_ratio and damage_ext then
			self._copr_kill_life_leech_num = (self._copr_kill_life_leech_num or 0) + 1

			if kill_life_leech <= self._copr_kill_life_leech_num then
				self._copr_kill_life_leech_num = 0
				local current_health_ratio = damage_ext:health_ratio()
				local wanted_health_ratio = math.floor((current_health_ratio + 0.01 + static_damage_ratio) / static_damage_ratio) * static_damage_ratio
				local health_regen = wanted_health_ratio - current_health_ratio

				if health_regen > 0 then
					damage_ext:restore_health(health_regen)
					damage_ext:on_copr_killshot()
				end
			end
		end
	end
	
	if self:has_category_upgrade("player", "killshot_combo_meter") then
		self._combo_kills = math.min(self._combo_kills + 1, 12)
		self._combo_kill_time = self._combo_t
		self._last_combo_kill_time = self._combo_kill_time
		local combo = self._combo_kills
		local combo_regen_armor = self:has_category_upgrade("player", "killshot_combo_regen_armor")
		if combo > 3 and combo_regen_armor then
			if sydchSO.settings.buffEFFECTS == 2 or sydchSO.settings.buffEFFECTS == 3 then
				managers.environment_controller:set_buff_effect(0.2)
			end
			damage_ext:restore_armor(damage_ext:_max_armor())
		end
		local combo_regen_health = self:upgrade_value("player", "killshot_combo_regen_health", 0) * combo
		if self:has_category_upgrade("player", "killshot_combo_regen_health") then
			if combo > 11 or variant == "melee" then
				if sydchSO.settings.buffEFFECTS == 2 or sydchSO.settings.buffEFFECTS == 3 then
					managers.environment_controller:set_buff_effect(0.2)
				end
				damage_ext:restore_health(combo_regen_health, true)
			end
		end
		self:activate_temporary_upgrade("temporary", "killshot_combo_regen_dodge")
		
		self._combo_t = Application:time()
		if (self._combo_kill_time - self._last_combo_kill_time) > 3 then
			self._combo_kills = 1
		end
		if (t - self._combo_kill_time) > 3 then
			local player_unit = self:player_unit()
			local damage_ext = player_unit:character_damage()
			local regen_health_bonus = managers.player:upgrade_value("player", "killshot_combo_regen_health", 0) * self._combo_kills
			if damage_ext then
				damage_ext:restore_health(regen_health_bonus, true)
				if sydchSO.settings.buffEFFECTS == 2 or sydchSO.settings.buffEFFECTS == 3 then
					managers.environment_controller:set_buff_effect(0.2)
				end
			end
			self._combo_kills = 0
		end
	end

	if self._on_killshot_t and t < self._on_killshot_t then
		return
	end

	local regen_armor_bonus = self:upgrade_value("player", "killshot_regen_armor_bonus", 0)
	local dist_sq = mvector3.distance_sq(player_unit:movement():m_pos(), killed_unit:movement():m_pos())
	local close_combat_sq = tweak_data.upgrades.close_combat_distance * tweak_data.upgrades.close_combat_distance

	if dist_sq <= close_combat_sq then
		self:activate_temporary_upgrade("temporary", "passive_armor_regen")
		regen_armor_bonus = regen_armor_bonus + self:upgrade_value("player", "killshot_close_regen_armor_bonus", 0)
		local panic_chance = self:upgrade_value("player", "killshot_close_panic_chance", 0)
		panic_chance = managers.modifiers:modify_value("PlayerManager:GetKillshotPanicChance", panic_chance)

		if panic_chance > 0 or panic_chance == -1 then
			local slotmask = managers.slot:get_mask("enemies")
			local units = World:find_units_quick("sphere", player_unit:movement():m_pos(), tweak_data.upgrades.killshot_close_panic_range, slotmask)

			for e_key, unit in pairs(units) do
				if alive(unit) and unit:character_damage() and not unit:character_damage():dead() then
					unit:character_damage():build_suppression(0, panic_chance)
					if sydchSO.settings.buffEFFECTS == 2 or sydchSO.settings.buffEFFECTS == 3 then
						managers.environment_controller:set_buff_effect(0.2)
					end
				end
			end
		end
	end

	if damage_ext and regen_armor_bonus > 0 then
		damage_ext:restore_armor(regen_armor_bonus)
		if sydchSO.settings.buffEFFECTS == 2 or sydchSO.settings.buffEFFECTS == 3 then
			managers.environment_controller:set_buff_effect(0.2)
		end
	end

	local regen_health_bonus = 0
	if variant == "melee" then
		regen_health_bonus = regen_health_bonus + self:upgrade_value("player", "melee_kill_life_leech", 0)
	end

	if damage_ext and regen_health_bonus > 0 then
		damage_ext:restore_health(regen_health_bonus, true)
		if sydchSO.settings.buffEFFECTS == 2 or sydchSO.settings.buffEFFECTS == 3 then
			managers.environment_controller:set_buff_effect(0.2)
		end
	end

	self._on_killshot_t = t + (tweak_data.upgrades.on_killshot_cooldown or 0)
	
	if self:has_category_upgrade("player", "special_double_drop") and CopDamage.is_gangster(killed_unit:base()._tweak_table) then
		if sydchSO.settings.buffEFFECTS == 2 or sydchSO.settings.buffEFFECTS == 3 then
			managers.environment_controller:set_buff_effect(0.2)
		end
		if Network:is_client() then
            managers.network:session():send_to_host("sync_spawn_extra_ammo", killed_unit)
        else
            self:spawn_extra_ammo(killed_unit)
        end
	end
	
	if _G.IS_VR then
		local steelsight_multiplier = equipped_unit:base():enter_steelsight_speed_multiplier()
		local stamina_percentage = (steelsight_multiplier - 1) * tweak_data.vr.steelsight_stamina_regen
		local stamina_regen = player_unit:movement():_max_stamina() * stamina_percentage

		player_unit:movement():add_stamina(stamina_regen)
	end
end

function PlayerManager:_on_enter_ammo_efficiency_event()
	if not self._coroutine_mgr:is_running("ammo_efficiency") then
		local weapon_unit = self:equipped_weapon_unit()

		if weapon_unit and weapon_unit:base():fire_mode() == "single" then
			if sydchSO.settings.buffEFFECTS == 2 or sydchSO.settings.buffEFFECTS == 3 then
				managers.environment_controller:set_buff_effect(0.2)
			end
			self._coroutine_mgr:add_coroutine("ammo_efficiency", PlayerAction.AmmoEfficiency, self, self._ammo_efficiency.headshots, self._ammo_efficiency.ammo, Application:time() + self._ammo_efficiency.time)
		end
	end
end

function PlayerManager:_update_damage_dealt(t, dt)
	local local_peer_id = managers.network:session() and managers.network:session():local_peer():id()

	if not local_peer_id or not self:has_category_upgrade("player", "cocaine_stacking") then
		return
	end

	self._damage_dealt_to_cops_t = self._damage_dealt_to_cops_t or t + (tweak_data.upgrades.cocaine_stacks_tick_t or 1)
	self._damage_dealt_to_cops_decay_t = self._damage_dealt_to_cops_decay_t or t + (tweak_data.upgrades.cocaine_stacks_decay_t or 5)
	local cocaine_stack = self:get_synced_cocaine_stacks(local_peer_id)
	local amount = cocaine_stack and cocaine_stack.amount or 0
	local new_amount = amount

	if self._damage_dealt_to_cops_t <= t then
		self._damage_dealt_to_cops_t = t + (tweak_data.upgrades.cocaine_stacks_tick_t or 1)
		local new_stacks = (self._damage_dealt_to_cops or 0) * (tweak_data.gui.stats_present_multiplier or 10) * self:upgrade_value("player", "cocaine_stacking", 0)
		self._damage_dealt_to_cops = 0
		new_amount = new_amount + math.min(new_stacks, tweak_data.upgrades.max_cocaine_stacks_per_tick or 20)
	end

	if self._damage_dealt_to_cops_decay_t <= t then
		self._damage_dealt_to_cops_decay_t = t + (tweak_data.upgrades.cocaine_stacks_decay_t or 5)
		local decay = amount * (tweak_data.upgrades.cocaine_stacks_decay_percentage_per_tick or 0)
		decay = decay + (tweak_data.upgrades.cocaine_stacks_decay_amount_per_tick or 20) - self:upgrade_value("player", "cocaine_stacks_decay_multiplier", 1)
		new_amount = new_amount - decay
	end

	new_amount = math.clamp(math.floor(new_amount), 0, tweak_data.upgrades.max_total_cocaine_stacks or 2047)

	if new_amount ~= amount then
		self:update_synced_cocaine_stacks_to_peers(new_amount, self:upgrade_value("player", "sync_cocaine_upgrade_level", 1), self:upgrade_level("player", "cocaine_stack_absorption_multiplier", 0))
	end
end

function PlayerManager:damage_absorption()
	local total = 0

	for _, absorption in pairs(self._damage_absorption) do
		total = total + Application:digest_value(absorption, false)
	end

	total = total + self:get_best_cocaine_damage_absorption()
	total = managers.modifiers:modify_value("PlayerManager:GetDamageAbsorption", total)

	return total
end

function PlayerManager:movement_speed_multiplier(speed_state, bonus_multiplier, upgrade_level, health_ratio)
	local multiplier = 1
	local armor_penalty = self:mod_movement_penalty(self:body_armor_value("movement", upgrade_level, 1))
	multiplier = multiplier + armor_penalty - 1
	if bonus_multiplier then
		multiplier = multiplier + bonus_multiplier - 1
	end

	if speed_state then
		multiplier = multiplier + self:upgrade_value("player", speed_state .. "_speed_multiplier", 1) - 1
		multiplier = multiplier + self:upgrade_value("player", "mrwi_" .. speed_state .. "_speed_multiplier", 1) - 1
	end

	multiplier = multiplier + self:get_hostage_bonus_multiplier("speed") - 1
	multiplier = multiplier + self:upgrade_value("player", "movement_speed_multiplier", 1) - 1

	if self:num_local_minions() > 0 then
		multiplier = multiplier + self:upgrade_value("player", "minion_master_speed_multiplier", 1) - 1
	end
	
	if self:has_category_upgrade("player", "detection_risk_add_movement_speed") then
		multiplier = multiplier + self:detection_risk_movement_speed_bonus()
	end

	if self:has_category_upgrade("player", "secured_bags_speed_multiplier") then
		local bags = 0
		bags = bags + (managers.loot:get_secured_mandatory_bags_amount() or 0)
		bags = bags + (managers.loot:get_secured_bonus_bags_amount() or 0)
		multiplier = multiplier + bags * (self:upgrade_value("player", "secured_bags_speed_multiplier", 1) - 1)
	end

	if managers.player:has_activate_temporary_upgrade("temporary", "berserker_damage_multiplier") then
		multiplier = multiplier * (tweak_data.upgrades.berserker_movement_speed_multiplier or 1)
	end
	
	if managers.player:has_activate_temporary_upgrade("temporary", "dodge_movement_speed") then
		multiplier = multiplier * managers.player:temporary_upgrade_value("temporary", "dodge_movement_speed", 1)
	end

	if health_ratio then
		local damage_health_ratio = self:get_damage_health_ratio(health_ratio, "movement_speed")
		multiplier = multiplier * (1 + managers.player:upgrade_value("player", "movement_speed_damage_health_ratio_multiplier", 0) * damage_health_ratio)
	end

	local damage_speed_multiplier = managers.player:temporary_upgrade_value("temporary", "damage_speed_multiplier", managers.player:temporary_upgrade_value("temporary", "team_damage_speed_multiplier_received", 1))
	multiplier = multiplier * damage_speed_multiplier

	return multiplier
end

if sydchSO.settings.skillOVERHAUL == 2 then
function PlayerManager:body_armor_skill_addend(override_armor)
	local addend = 0
	addend = addend + self:upgrade_value("player", tostring(override_armor or managers.blackmarket:equipped_armor(true, true)) .. "_armor_addend", 0)

	if self:has_category_upgrade("player", "armor_increase") then
		addend = addend + self:upgrade_value("player", "armor_increase", 0)
	end

	addend = addend + self:upgrade_value("team", "crew_add_armor", 0)

	return addend
end
end

function PlayerManager:skill_dodge_chance(running, crouching, on_zipline, override_armor, detection_risk)
	local chance = self:upgrade_value("player", "passive_dodge_chance", 0)
	chance = chance + self:upgrade_value("player", "mrwi_dodge_chance", 0)
	local dodge_shot_gain = self:_dodge_shot_gain()

	for _, smoke_screen in ipairs(self._smoke_screen_effects or {}) do
		if smoke_screen:is_in_smoke(self:player_unit()) then
			if smoke_screen:mine() then
				chance = chance * self:upgrade_value("player", "sicario_multiplier", 1)
				dodge_shot_gain = dodge_shot_gain * self:upgrade_value("player", "sicario_multiplier", 1)
			else
				chance = chance + smoke_screen:dodge_bonus()
			end
		end
	end

	chance = chance + dodge_shot_gain
	chance = chance + self:upgrade_value("player", "tier_dodge_chance", 0)
	
	if self:is_less_targeted() and self:has_category_upgrade("player", "hostage_dodge_chance") then	
		chance = chance + self:upgrade_value("player", "hostage_dodge_chance", 0)
	end
	
	if self:has_category_upgrade("player", "stamina_to_dodge") then
		if self:local_player() and self:local_player():movement() then
			local prec_stamina = 1 - (self:local_player():movement()._stamina / self:local_player():movement():_max_stamina())
			local muilt = self:upgrade_value("player", "stamina_to_dodge") or 0
			prec_stamina = prec_stamina * muilt
			chance = chance + prec_stamina
		end
	end
	
	if tostring(self._current_state) == "driving" then
		chance = chance + self:upgrade_value("player", "vehicle_dodge_chance", 0)
	end
	
	if managers.player:has_activate_temporary_upgrade("temporary", "dodge") then
		local upgrade_value = managers.player:upgrade_value("temporary", "dodge") or {0, 0}
		chance = chance + self:upgrade_value("player", "temporary_dodge", 0)
	end
	
	if managers.player:has_activate_temporary_upgrade("temporary", "killshot_combo_regen_dodge") then
		local combo_regen_dodge = self:upgrade_value("player", "killshot_combo_regen_dodge", 0) * self._combo_kills
		chance = chance + combo_regen_dodge
	end

	if running then
		chance = chance + self:upgrade_value("player", "run_dodge_chance", 0)
		chance = chance + self:upgrade_value("player", "moving_dodge_chance", 0)
	end

	if crouching then
		chance = chance + self:upgrade_value("player", "crouch_dodge_chance", 0)
	end

	if on_zipline then
		chance = chance + self:upgrade_value("player", "on_zipline_dodge_chance", 0)
	end

	local detection_risk_add_dodge_chance = managers.player:upgrade_value("player", "detection_risk_add_dodge_chance")
	chance = chance + self:get_value_from_risk_upgrade(detection_risk_add_dodge_chance, detection_risk)
	chance = chance + self:upgrade_value("player", tostring(override_armor or managers.blackmarket:equipped_armor(true, true)) .. "_dodge_addend", 0)
	chance = chance + self:upgrade_value("team", "crew_add_dodge", 0)
	chance = chance + self:temporary_upgrade_value("temporary", "pocket_ecm_kill_dodge", 0)
	chance = chance + self:temporary_upgrade_value("temporary", "dmg_dodge_outnumbered", 0)
	chance = chance + self:temporary_upgrade_value("temporary", "dmg_dodge_close_contact", 0)

	return chance
end

function PlayerManager:damage_reduction_skill_multiplier(damage_type)
	local multiplier = 1
	multiplier = multiplier * self:temporary_upgrade_value("temporary", "dmg_dampener_outnumbered", 1)
	multiplier = multiplier * self:temporary_upgrade_value("temporary", "dmg_dampener_outnumbered_strong", 1)
	multiplier = multiplier * self:temporary_upgrade_value("temporary", "dmg_dampener_close_contact", 1)
	multiplier = multiplier * self:temporary_upgrade_value("temporary", "revived_damage_resist", 1)
	multiplier = multiplier * self:upgrade_value("player", "damage_dampener", 1)
	multiplier = multiplier * self:upgrade_value("player", "health_damage_reduction", 1)
	multiplier = multiplier * self:temporary_upgrade_value("temporary", "first_aid_damage_reduction", 1)
	multiplier = multiplier * self:temporary_upgrade_value("temporary", "revive_damage_reduction", 1)
	multiplier = multiplier * self:get_hostage_bonus_multiplier("damage_dampener")
	multiplier = multiplier * self._properties:get_property("revive_damage_reduction", 1)
	multiplier = multiplier * self._temporary_properties:get_property("revived_damage_reduction", 1)
	multiplier = multiplier * self:upgrade_value("team", "crew_hard", 1)
	local dmg_red_mul = self:team_upgrade_value("damage_dampener", "team_damage_reduction", 1)

	local health_ratio = self:player_unit():character_damage():health_ratio()
	local min_ratio = self:upgrade_value("player", "passive_damage_reduction")
	if health_ratio < min_ratio and self:has_category_upgrade("player", "passive_damage_reduction") then
		dmg_red_mul = dmg_red_mul - (1 - dmg_red_mul)
	end
	multiplier = multiplier * dmg_red_mul

	if self:is_damage_health_ratio_active(health_ratio) then
		multiplier = multiplier * (1 - managers.player:upgrade_value("player", "resistance_damage_health_ratio_multiplier", 0) * (1 - health_ratio))
	end

	if damage_type == "melee" then
		multiplier = multiplier * managers.player:upgrade_value("player", "melee_damage_dampener", 1)
	end

	local current_state = self:get_current_state()
	local damage_ext = self:player_unit():character_damage()

	--if current_state and current_state:_interacting() and (damage_ext:get_real_armor() > 0) then
	if current_state and current_state:_interacting() then
		--local max = managers.player:upgrade_value("player", "interacting_damage_multiplier", 1)
		--multiplier = multiplier * math.random(max, 0.9)
		multiplier = multiplier * managers.player:upgrade_value("player", "interacting_damage_multiplier", 1)
	end
	
	if self:is_less_targeted() and self:has_category_upgrade("player", "dmg_dampener_hostage_taker") then
		multiplier = multiplier * managers.player:upgrade_value("player", "dmg_dampener_hostage_taker", 1)
	end

	return multiplier
end

function PlayerManager:body_armor_regen_multiplier(crouching, health_ratio)
	local multiplier = 1
	multiplier = multiplier * self:upgrade_value("player", "armor_regen_timer_multiplier_tier", 1)
	multiplier = multiplier * self:upgrade_value("player", "armor_regen_timer_multiplier", 1)
	multiplier = multiplier * self:upgrade_value("player", "armor_regen_timer_multiplier_passive", 1)
	multiplier = multiplier * self:team_upgrade_value("armor", "regen_time_multiplier", 1)
	multiplier = multiplier * self:team_upgrade_value("armor", "passive_regen_time_multiplier", 1)
	multiplier = multiplier * self:upgrade_value("player", "perk_armor_regen_timer_multiplier", 1)
	multiplier = multiplier * self:crew_ability_upgrade_value("crew_die_hard", 1)

	--if not moving then
	if crouching then
		multiplier = multiplier * managers.player:upgrade_value("player", "armor_regen_timer_stand_still_multiplier", 1)
	end

	if health_ratio then
		local damage_health_ratio = self:get_damage_health_ratio(health_ratio, "armor_regen")
		multiplier = multiplier * (1 - managers.player:upgrade_value("player", "armor_regen_damage_health_ratio_multiplier", 0) * damage_health_ratio)
	end
	
	if self:has_category_upgrade("player", "cocaine_armor_regen_timer") then
		local cocaine_armor_regen_timer = self:get_best_cocaine_damage_absorption(managers.network:session():local_peer():id())
		multiplier = multiplier * (1 - (cocaine_armor_regen_timer * 0.2)) + 0.4
	end
	
	return multiplier
end

function PlayerManager:get_damage_health_ratio(health_ratio, category)
	local damage_ratio = 1 - health_ratio / math.max(0.01, self:_get_damage_health_ratio_threshold(category))
	
	if self:has_category_upgrade("player", "max_health_reduction") then
		damage_ratio = damage_ratio * 0 + 1
	else
		damage_ratio = damage_ratio * 1 + 0
	end
	
	return math.max(damage_ratio, 0)
end

function PlayerManager:_get_damage_health_ratio_threshold(category)
	local threshold = tweak_data.upgrades.player_damage_health_ratio_threshold

	if category then
		threshold = threshold * self:upgrade_value("player", category .. "_damage_health_ratio_threshold_multiplier", 1)
	end

	return threshold
end

function PlayerManager:health_skill_addend()
	local addend = 0
	addend = addend + self:upgrade_value("team", "crew_add_health", 0)
	addend = addend + self:upgrade_value("player", "health_addend", 0)

	if table.contains(self._global.kit.equipment_slots, "thick_skin") then
		addend = addend + self:upgrade_value("player", "thick_skin", 0)
	end

	return addend
end

function PlayerManager:carry_blocked_by_cooldown()
	if self:has_category_upgrade("carry", "no_cooldown") then
		return false
	else
		return self._carry_blocked_cooldown_t and Application:time() < self._carry_blocked_cooldown_t or false
	end
end

function PlayerManager:_attempt_chico_injector()
	if self:has_activate_temporary_upgrade("temporary", "chico_injector") then
		return false
	end

	local duration = self:upgrade_value("temporary", "chico_injector")[2]
	local now = managers.game_play_central:get_heist_timer()
	local player_unit = self:player_unit()
	local damage_ext = player_unit:character_damage()

	managers.network:session():send_to_peers("sync_ability_hud", now + duration, duration)
	self:activate_temporary_upgrade("temporary", "chico_injector")
	
	if self:has_category_upgrade("player", "chico_preferred_target") then
		damage_ext:restore_armor(damage_ext:_max_armor())
	end
	
	local function speed_up_on_kill() end

	self:register_message(Message.OnEnemyKilled, "speed_up_chico_injector", speed_up_on_kill)

	return true
end

function PlayerManager:_attempt_copr_ability()
	if self:has_activate_temporary_upgrade("temporary", "copr_ability") then
		return false
	end
	
	local player_unit = self:player_unit()
	local damage_ext = player_unit:character_damage()
	
	if damage_ext:_block_revive_ability() then
		if sydchSO.settings.moreHINTS == true then	
			managers.hud:show_hint({text ="You will be revived once bleedout time expires."})
		end
		return false
	end

	local character_damage = self:local_player():character_damage()
	local duration = self:upgrade_value("temporary", "copr_ability")[2]
	local now = managers.game_play_central:get_heist_timer()

	managers.network:session():send_to_peers("sync_ability_hud", now + duration, duration)

	local is_downed = game_state_machine:verify_game_state(GameStateFilters.downed)

	self:set_property("copr_risen", is_downed)

	if is_downed then
		character_damage:revive(true)
	end

	self:activate_temporary_upgrade("temporary", "copr_ability")

	local expire_time = self:get_activate_temporary_expire_time("temporary", "copr_ability")

	managers.enemy:add_delayed_clbk("copr_ability_active", callback(self, self, "clbk_copr_ability_ended"), expire_time)
	managers.hud:activate_teammate_ability_radial(HUDManager.PLAYER_PANEL, duration)

	local bonus_health = self:upgrade_value("player", "copr_activate_bonus_health_ratio", tweak_data.upgrades.values.player.copr_activate_bonus_health_ratio[1])
	local armor_ratio = bonus_health + (bonus_health * damage_ext:armor_ratio())
	bonus_health = math.max(bonus_health, armor_ratio)
	character_damage:restore_health(bonus_health)
	character_damage:set_armor(0)
	character_damage:send_set_status()

	local speed_up_on_kill_time = self:upgrade_value("player", "copr_speed_up_on_kill", 0)

	if speed_up_on_kill_time > 0 then
		local function speed_up_on_kill_func()
			managers.player:speed_up_grenade_cooldown(speed_up_on_kill_time)
		end

		self:register_message(Message.OnEnemyKilled, "speed_up_copr_ability", speed_up_on_kill_func)
	end

	character_damage:on_copr_ability_activated()

	self._copr_kill_life_leech_num = 0
	local static_damage_ratio = self:upgrade_value("player", "copr_static_damage_ratio", 0)

	managers.hud:set_copr_indicator(true, static_damage_ratio)

	if is_downed then
		self:register_message("ability_activated", "copr_risen_cooldown_key", callback(self, self, "add_copr_risen_cooldown"))
		self:activate_temporary_upgrade("temporary", "copr_risen")
		self:_activate_copr_died()
	end

	return true
end

-- three new functions that will be called for survive_one_hit.
function PlayerManager:_activate_copr_died()
	local expire_time = self:get_activate_temporary_expire_time("temporary", "copr_ability")
	self._check_copr_t = Application:time() + (expire_time + 1)
end

function PlayerManager:is_copr_died()
	if self._check_copr_t  and Application:time() < self._check_copr_t then
		return true
	end
	return false
end

function PlayerManager:spawn_smoke_screen(position, normal, grenade_unit, has_dodge_bonus)
	
	local time = tweak_data.projectiles.smoke_screen_grenade.duration
	self._smoke_screen_effects = self._smoke_screen_effects or {}
	table.insert(self._smoke_screen_effects, SmokeScreenEffect:new(position, normal, time, has_dodge_bonus, grenade_unit))
	if alive(self._smoke_grenade) then
		self._smoke_grenade:set_slot(0)
	end
	self._smoke_grenade = grenade_unit
	local function speed_up_on_kill() end
	
	self:register_message(Message.OnEnemyKilled, "speed_up_sicario_smoke", speed_up_on_kill) 
end

function PlayerManager:is_less_targeted()
	if not self:player_unit() then
		return
	end
	for u_key, u_data in pairs(managers.enemy:all_civilians()) do
	--for u_key, u_data in pairs(managers.groupai:state():all_hostages()) do
		if u_data.unit then
			local dis = math.abs(mvector3.distance(u_data.unit:position(), self:player_unit():position()))
			if dis < 900 then
				return true
			end
		end
	end
	return
end

function PlayerManager:get_max_grenades(grenade_id)
	grenade_id = grenade_id or managers.blackmarket:equipped_grenade()
	local max_amount = tweak_data:get_raw_value("blackmarket", "projectiles", grenade_id, "max_amount") or 0

	if max_amount and self:has_category_upgrade("player", "throwables_multiplier") and not tweak_data:get_raw_value("blackmarket", "projectiles", grenade_id, "base_cooldown") then
		max_amount = math.ceil(max_amount + self:upgrade_value("player", "throwables_multiplier", 0))
	end
	max_amount = managers.modifiers:modify_value("PlayerManager:GetThrowablesMaxAmount", max_amount)

	return max_amount
end
	
function PlayerManager:detection_risk_movement_speed_bonus()
	local multiplier = 0
	local detection_risk_add_movement_speed = managers.player:upgrade_value("player", "detection_risk_add_movement_speed")
	multiplier = multiplier + self:get_value_from_risk_upgrade(detection_risk_add_movement_speed)
	return multiplier
end

function PlayerManager:check_skills()
	self:send_message_now("check_skills")
	self._coroutine_mgr:clear()
	self._player_panic_when_kill = self:has_category_upgrade("player", "panic_when_kill")
	self._unseen_strike = self:has_category_upgrade("player", "unseen_increased_crit_chance")
	local stacked_accuracy_bonus = self:has_category_upgrade("player", "stacked_accuracy_bonus")
	local stacked_hit_damage_multiplier = self:has_category_upgrade("pistol", "stacking_hit_damage_multiplier")
	if self:has_category_upgrade("player", "killshot_combo_meter") then
		self._combo_t = 0
		self._combo_kill_time = 0
		self._last_combo_kill_time = 0
		self._combo_kills = 0
	end
	if self:has_category_upgrade("player", "messiah_revive_from_bleed_out") then
		self._messiah_charges = self:upgrade_value("player", "messiah_revive_from_bleed_out", 0)
		self._max_messiah_charges = self._messiah_charges
		self._messiah_cooldown_t = 0
		self._message_system:register(Message.OnEnemyKilled, "messiah_revive_from_bleed_out", callback(self, self, "_on_messiah_event"))
	else
		self._messiah_charges = 0
		self._max_messiah_charges = self._messiah_charges
		self._messiah_cooldown_t = 0
		self._message_system:unregister(Message.OnEnemyKilled, "messiah_revive_from_bleed_out")
	end
	if self:has_category_upgrade("player", "recharge_messiah") then
		self._message_system:register(Message.OnDoctorBagUsed, "recharge_messiah", callback(self, self, "_on_messiah_recharge_event"))
	else
		self._message_system:unregister(Message.OnDoctorBagUsed, "recharge_messiah")
	end
	if self:has_category_upgrade("player", "dodge_replenish_stamina") then
        local replenish_stamina = self:upgrade_value("player", "dodge_replenish_stamina")
        self._message_system:register(Message.OnPlayerDodge, "dodge_replenish_stamina", function() self:player_unit():movement():_change_stamina(replenish_stamina) end)
    else
        self._message_system:unregister(Message.OnPlayerDodge, "dodge_replenish_stamina")
    end
	if stacked_accuracy_bonus then
		self._message_system:register(Message.OnEnemyShot, self, callback(self, self, "_on_expert_handling_event"))
	else
		self._message_system:unregister(Message.OnEnemyShot, self)
	end
	if stacked_hit_damage_multiplier then
		self._message_system:register(Message.OnEnemyShot, "trigger_happy", callback(self, self, "_on_enter_trigger_happy_event"))
	else
		self._message_system:unregister(Message.OnEnemyShot, "trigger_happy")
	end
	if self:has_category_upgrade("player", "melee_damage_stacking") then
		local function start_bloodthirst_base(weapon_unit, variant)
			if not self._coroutine_mgr:is_running(PlayerAction.BloodthirstBase) then
				local data = self:upgrade_value("player", "melee_damage_stacking", nil)

				if data and type(data) ~= "number" then
					self._coroutine_mgr:add_coroutine(PlayerAction.BloodthirstBase, PlayerAction.BloodthirstBase, self, data.melee_multiplier, data.max_multiplier)
				end
			end
		end

		self._message_system:register(Message.OnEnemyKilled, "bloodthirst_base", start_bloodthirst_base)
	else
		self._message_system:unregister(Message.OnEnemyKilled, "bloodthirst_base")
	end
	if self:has_category_upgrade("temporary", "melee_kill_stacking_hit_damage_multiplier") then
		self._message_system:register(Message.OnEnemyKilled, "bloodthirst_stacking_hit_damage_multiplier", callback(self, self, "_on_enemy_killed_stacking_hit_damage_multiplier"))
	else
		self._message_system:unregister(Message.OnEnemyKilled, "bloodthirst_stacking_hit_damage_multiplier")
	end
	if self:has_category_upgrade("player", "double_drop") then
		self._target_kills = self:upgrade_value("player", "double_drop", 0)

		self._message_system:register(Message.OnEnemyKilled, "double_ammo_drop", callback(self, self, "_on_spawn_special_ammo_event"))
	else
		self._target_kills = 0

		self._message_system:unregister(Message.OnEnemyKilled, "double_ammo_drop")
	end
	if self:has_category_upgrade("temporary", "gun_kata_onenemykilled") then
		self._message_system:register(Message.OnEnemyKilled, "activate_aggressive_reload", callback(self, self, "_on_activate_aggressive_reload_event"))
	else
		self._message_system:unregister(Message.OnEnemyKilled, "activate_aggressive_reload")
	end
	if self:has_category_upgrade("temporary", "gun_kata_onplayerdodge") then
		self._message_system:register(Message.OnPlayerDodge, "activate_aggressive_reload", callback(self, self, "_on_activate_aggressive_reload_event"))
	else
		self._message_system:unregister(Message.OnPlayerDodge, "activate_aggressive_reload")
	end
	if self:has_category_upgrade("player", "head_shot_ammo_return") then
		self._ammo_efficiency = self:upgrade_value("player", "head_shot_ammo_return", nil)

		self._message_system:register(Message.OnHeadShot, "ammo_efficiency", callback(self, self, "_on_enter_ammo_efficiency_event"))
	else
		self._ammo_efficiency = nil

		self._message_system:unregister(Message.OnHeadShot, "ammo_efficiency")
	end
	if self:has_category_upgrade("player", "melee_kill_increase_reload_speed") then
		self._message_system:register(Message.OnEnemyKilled, "bloodthirst_reload_speed", callback(self, self, "_on_enemy_killed_bloodthirst"))
	else
		self._message_system:unregister(Message.OnEnemyKilled, "bloodthirst_reload_speed")
	end
	if self:has_category_upgrade("player", "super_syndrome") then
		self._super_syndrome_count = self:upgrade_value("player", "super_syndrome")
	else
		self._super_syndrome_count = 0
	end
	
	if managers.mutators:is_mutator_active(MutatorPiggyBank) then
			self._message_system:register(Message.OnLethalHeadShot, "play_pda9_headshot", callback(self, self, "_play_pda9_headshot_event"))
	else
			self._message_system:unregister(Message.OnLethalHeadShot, "play_pda9_headshot")
	end
	
	self._has_primary_reload_secondary = self:has_category_upgrade("player", "primary_reload_secondary")
	self._has_secondary_reload_primary = self:has_category_upgrade("player", "secondary_reload_primary")
	self:set_property("primary_reload_secondary_kills", 0)
	self:set_property("secondary_reload_primary_kills", 0)
	
	if self:has_category_upgrade("player", "dodge_shot_gain") then
		local last_gain_time = 0
		local dodge_gain = self:upgrade_value("player", "dodge_shot_gain")[1]
		local cooldown = self:upgrade_value("player", "dodge_shot_gain")[2]

		local function on_player_damage(attack_data)
			local t = TimerManager:game():time()

			if attack_data.variant == "bullet" and t > last_gain_time + cooldown then
				last_gain_time = t

				managers.player:_dodge_shot_gain(managers.player:_dodge_shot_gain() + dodge_gain)
			end
		end

		self:register_message(Message.OnPlayerDodge, "dodge_shot_gain_dodge", callback(self, self, "_dodge_shot_gain", 0))
		self:register_message(Message.OnPlayerDamage, "dodge_shot_gain_damage", on_player_damage)
	else
		self:unregister_message(Message.OnPlayerDodge, "dodge_shot_gain_dodge")
		self:unregister_message(Message.OnPlayerDamage, "dodge_shot_gain_damage")
	end
	if self:has_category_upgrade("player", "dodge_replenish_armor") then
		self:register_message(Message.OnPlayerDodge, "dodge_replenish_armor", callback(self, self, "_dodge_replenish_armor"))
	else
		self:unregister_message(Message.OnPlayerDodge, "dodge_replenish_armor")
	end
	if self:has_category_upgrade("temporary", "dodge_movement_speed") then
		self:register_message(Message.OnPlayerDodge, "dodge_movement_speed", callback(self, self, "_dodge_movement_speed"))
	else
		self:unregister_message(Message.OnPlayerDodge, "dodge_movement_speed")
	end
	self:add_coroutine("damage_control", PlayerAction.DamageControl)
	if self:has_category_upgrade("snp", "graze_damage") then
		self:register_message(Message.OnWeaponFired, "graze_damage", callback(SniperGrazeDamage, SniperGrazeDamage, "on_weapon_fired"))
	else
		self:unregister_message(Message.OnWeaponFired, "graze_damage")
	end
	if self:has_category_upgrade("player", "dodge_replenish_health") then
		local cooldown = Application:time()
		self._message_system:register(Message.OnPlayerDodge, "dodge_replenish_health", function() if cooldown <= Application:time() then self:player_unit():character_damage():restore_health(self:upgrade_value("player", "dodge_replenish_health"), true) cooldown = (Application:time() + 1) end end)
	else
		self:unregister_message(Message.OnPlayerDodge, "dodge_replenish_health")
	end
end

function PlayerManager:_on_expert_handling_event(unit, attack_data)
	local attacker_unit = attack_data.attacker_unit
	local variant = attack_data.variant

	if attacker_unit == self:player_unit() and variant == "bullet" and not self._coroutine_mgr:is_running(PlayerAction.ExpertHandling) then
		local data = self:upgrade_value("player", "stacked_accuracy_bonus", nil)

		if data and type(data) ~= "number" then
			self._coroutine_mgr:add_coroutine(PlayerAction.ExpertHandling, PlayerAction.ExpertHandling, self, data.accuracy_bonus, data.max_stacks, Application:time() + data.max_time)
		end
	end
end

function PlayerManager:_dodge_replenish_armor()
	local player_unit = self:player_unit()
	local damage_ext = player_unit:character_damage()
	local max_armor = damage_ext:_max_armor()
	local cooldown = Application:time()
	if cooldown <= Application:time() then
		damage_ext:restore_armor(max_armor)
		cooldown = Application:time() + 9
	end
end

function PlayerManager:_dodge_movement_speed()
	self:activate_temporary_upgrade("temporary", "dodge_movement_speed")
end

function PlayerManager:_check_damage_to_hot(t, unit, damage_info)
	local player_unit = self:player_unit()
	local damage_ext = player_unit:character_damage()
	local current_armor = damage_ext:get_real_armor()
	local max_armor = damage_ext:get_real_armor()
	local armor_full = max_armor > 0 and max_armor == current_armor
	local wildcard = self:has_category_upgrade("player", "wildcard_hotandarmor")
	
	if not self:has_category_upgrade("player", "damage_to_hot") then
		return
	end
	
	if wildcard and not armor_full then
		return
	end

	if not alive(player_unit) or player_unit:character_damage():need_revive() or player_unit:character_damage():dead() then
		return
	end

	if not alive(unit) or not unit:base() or not damage_info then
		return
	end

	if damage_info.is_fire_dot_damage then
		return
	end

	local data = tweak_data.upgrades.damage_to_hot_data
	if not data then
		return
	end

	if self._next_allowed_doh_t and t < self._next_allowed_doh_t then
		return
	end

	local add_stack_sources = data.add_stack_sources or {}
	if not add_stack_sources.swat_van and unit:base().sentry_gun then
		return
	elseif not add_stack_sources.civilian and CopDamage.is_civilian(unit:base()._tweak_table) then
		return
	end

	if not add_stack_sources[damage_info.variant] then
		return
	end

	if not unit:brain():is_hostile() then
		return
	end

	local player_armor = managers.blackmarket:equipped_armor(data.works_with_armor_kit, true)
	if not table.contains(data.armors_allowed or {}, player_armor) then
		return
	end

	player_unit:character_damage():add_damage_to_hot()
	self._next_allowed_doh_t = t + data.stacking_cooldown
end

function PlayerManager:_attempt_pocket_ecm_jammer()
	local player_inventory = self:player_unit():inventory()

	if player_inventory:is_jammer_active() then
		return false
	end

	local stealth = managers.groupai and managers.groupai:state():whisper_mode()
	local base_upgrade = self:upgrade_value("player", "pocket_ecm_jammer_base")
	local range = math.min(base_upgrade.feedback_range, tweak_data.weapon["sentry_gun"].FIRE_RANGE)
	local my_team = self:player_unit():movement():team()
	local turret_states = {active = true, rearming = true, activating = true}
	local started, is_enemy_sentry

	for _, unit in pairs(not stealth and World:find_units("sphere", self:player_unit():position(), range, managers.slot:get_mask("sentry_gun")) or {}) do
		local movement = unit:movement()

		if unit:base().sentry_gun and movement:team() ~= my_team and turret_states[movement._state] then
			is_enemy_sentry = true
			break
		end
	end

	local should_jam = stealth or is_enemy_sentry

	if should_jam then
		started = player_inventory:start_jammer_effect()
	else
		started = player_inventory:start_feedback_effect()
	end

	if not started then
		return false
	end

	local function speed_up_on_kill()
		managers.player:speed_up_grenade_cooldown(base_upgrade.cooldown_drain)
	end

	self:register_message(Message.OnEnemyKilled, "speed_up_pocket_ecm_jammer", speed_up_on_kill)
	managers.hud:activate_teammate_ability_radial(HUDManager.PLAYER_PANEL, base_upgrade.duration)

	return true
end

-- Hinaomi's code, made by Offyerrocker. Check her skill overhaul for great and more vanilla friendly gameplay!
function PlayerManager:body_armor_value(category, override_value, default)
    local armor_data = tweak_data.blackmarket.armors[managers.blackmarket:equipped_armor(true, true)]
    local armor_dodge_value = self:upgrade_value_by_level("player", "body_armor", category, {})[override_value or armor_data.upgrade_level] or default or 0
    if category == "dodge" then
        local skill_less_dodge_penalty = managers.player:upgrade_value("player","level_" .. tostring(armor_data.upgrade_level) .. "_less_dodge_penalty",0)
        local skill_less_dodge_penalty_sicario = managers.player:upgrade_value("player","level_" .. tostring(armor_data.upgrade_level) .. "_less_dodge_penalty_sicario",0)
        armor_dodge_value = math.min(armor_dodge_value + skill_less_dodge_penalty , 5)
        armor_dodge_value = math.min(armor_dodge_value + skill_less_dodge_penalty_sicario , 5)
    end
    return armor_dodge_value
end

function PlayerManager:_on_activate_aggressive_reload_event(attack_data)
	if attack_data and attack_data.variant ~= "projectile" then
		local weapon_unit = self:equipped_weapon_unit()

		if weapon_unit then
			local weapon = weapon_unit:base()

			if weapon then
				if self:has_category_upgrade("temporary", "gun_kata_onenemykilled") then
					self:activate_temporary_upgrade("temporary", "gun_kataonenemykilled")
				end
				if self:has_category_upgrade("temporary", "gun_kata_onplayerdodge") then
					self:activate_temporary_upgrade("temporary", "gun_kataonplayerdodge")
				end
			end
		end
	end
end

-- Restoration Mod
function PlayerManager:_on_spawn_special_ammo_event(equipped_unit, variant, killed_unit)
	if killed_unit.base and tweak_data.character[killed_unit:base()._tweak_table].priority_shout and variant and variant == "bullet" then
		if Network:is_client() then
			managers.network:session():send_to_host("sync_spawn_extra_ammo", killed_unit)
		else
			self:spawn_extra_ammo(killed_unit)
		end
	end
end

function PlayerManager:add_special(params)
	local name = params.equipment or params.name

	if not tweak_data.equipments.specials[name] then
		Application:error("Special equipment " .. name .. " doesn't exist!")

		return
	end

	local unit = self:player_unit()
	local respawn = params.amount and true or false
	local equipment = tweak_data.equipments.specials[name]
	local special_equipment = self._equipment.specials[name]
	local amount = params.amount or equipment.quantity
	local extra = self:_equipped_upgrade_value(equipment) + self:upgrade_value(name, "quantity")

	if name == "cable_tie" then
		extra = self:upgrade_value(name, "quantity_1") + self:upgrade_value(name, "quantity_2")
	end

	if special_equipment then
		if equipment.max_quantity or equipment.quantity or params.transfer and equipment.transfer_quantity then
			local dedigested_amount = special_equipment.amount and Application:digest_value(special_equipment.amount, false) or 1
			local new_amount = self:has_category_upgrade(name, "quantity_unlimited") and -1 or math.min(dedigested_amount + amount, (params.transfer and equipment.transfer_quantity or equipment.max_quantity or equipment.quantity) + extra)
			special_equipment.amount = Application:digest_value(new_amount, true)

			if special_equipment.is_cable_tie then
				managers.hud:set_cable_ties_amount(HUDManager.PLAYER_PANEL, new_amount)
				self:update_synced_cable_ties_to_peers(new_amount)
			else
				managers.hud:set_special_equipment_amount(name, new_amount)
				self:update_equipment_possession_to_peers(name, new_amount)
			end
		end

		return
	end

	local icon = equipment.icon
	local action_message = equipment.action_message

	if not params.silent then
		local text = managers.localization:text(equipment.text_id)
		local title = managers.localization:text("present_obtained_mission_equipment_title")

		managers.hud:present_mid_text({
			time = 4,
			text = text,
			title = title,
			icon = icon
		})

		if action_message and alive(unit) then
			managers.network:session():send_to_peers_synched("sync_show_action_message", unit, action_message)
		end
	end

	local is_cable_tie = name == "cable_tie"
	local quantity = nil

	if is_cable_tie or not params.transfer then
		quantity = self:has_category_upgrade(name, "quantity_unlimited") and -1 or equipment.quantity and (respawn and math.min(params.amount, (equipment.max_quantity or equipment.quantity or 1) + extra) or equipment.quantity and math.min(amount + extra, (equipment.max_quantity or equipment.quantity or 1) + extra))
	else
		quantity = params.amount
	end

	if is_cable_tie then
		managers.hud:set_cable_tie(HUDManager.PLAYER_PANEL, {
			icon = icon,
			amount = quantity or nil
		})
		self:update_synced_cable_ties_to_peers(quantity)
	else
		managers.hud:add_special_equipment({
			id = name,
			icon = icon,
			amount = quantity or equipment.transfer_quantity and 1 or nil
		})
		self:update_equipment_possession_to_peers(name, quantity)
	end

	self._equipment.specials[name] = {
		amount = quantity and Application:digest_value(quantity, true) or nil,
		is_cable_tie = is_cable_tie
	}

	if equipment.player_rule then
		self:set_player_rule(equipment.player_rule, true)
	end
end

function PlayerManager:reload_weapons()
	local weapons = {
		self:player_unit():inventory():unit_by_selection(1),
		self:player_unit():inventory():unit_by_selection(2),
		self:player_unit():inventory():unit_by_selection(3)
	}

	for _, weapon in pairs(weapons) do
		if weapon and weapon.base then
			local weapon_base = weapon:base()
			weapon_base:on_reload(nil)
			managers.statistics:reloaded()
			managers.hud:set_ammo_amount(weapon_base:selection_index(), weapon_base:ammo_info())
		end
	end
end

Hooks:PostHook(PlayerManager, "update", "sydchSO", function(self, amount, sync)
	if amount == -1 and managers.blackmarket:equipped_grenade() == "damage_control" then
		local player_unit = managers.player:player_unit()
		local enviroment = managers.environment_controller

		if player_unit then
			local player_damage = player_unit:character_damage()
			if player_damage:remaining_delayed_damage() <= 0 then
				return
			elseif enviroment then
				enviroment._current_concussion = 0.5
				enviroment._concussion_duration = 1
			end
		end
	end
end)

Hooks:PostHook(PlayerManager, "update", "sydchSO", function(self, t, dt)
	if self._messiah_cooldown and self._messiah_cooldown_t and self._messiah_cooldown_t < t then
		if sydchSO.settings.moreHINTS == true then
			managers.hud:show_hint({text ="You can now revive yourself when you kill an enemy."})
		end
		self._messiah_cooldown = false
	end
	
	if self._chico_injector and self._chico_injector_t and self._chico_injector_t < t then
		SoundDevice:set_rtpc("downed_state_progression", 0)
		self._chico_injector = false
	end
	
	if self._copr_ampule and self._copr_ampule_t and self._copr_ampule_t < t then
		SoundDevice:set_rtpc("downed_state_progression", 0)
		self._copr_ampule = false
	end
	
	if self:has_activate_temporary_upgrade("temporary", "chico_injector") then
		SoundDevice:set_rtpc("downed_state_progression", 30)
		self._chico_injector_t = Application:time()
		self._chico_injector = true
	end
	
	if managers.player:has_activate_temporary_upgrade("temporary", "copr_ability") then
		SoundDevice:set_rtpc("downed_state_progression", 30)
		self._copr_ampule_t = Application:time()
		self._copr_ampule = true
	end
end)

Hooks:PostHook(PlayerManager, "add_coroutine", "sydchSO", function(self, name, func, tagged, owner)
	if name and func and type(name) == "string" and name:find("tag_team") then
		if owner == self:local_player() and self:has_category_upgrade("player", "tag_team_end_damage_absorption_user") then
			self:activate_temporary_upgrade("temporary", "damage_absorption")
		end
		if tagged == self:local_player() and sydchSO.settings.moreHINTS == true then
			managers.hud:show_hint({text ="You have been paired with."})
		end
		if name == "tag_team" and tagged ~= player and tagged ~= managers.player:player_unit() then
			self:remove_tag_team_contour(self._tagged)
			self._tagged = tagged
			self._tagged:contour():add("deployable_selected")
		end
	end
end)

-- dr. newbie's code, thank you
Hooks:PostHook(PlayerManager, "end_tag_team", "sydchSO", function(self, tagged, owner)
	if tagged == self:local_player() then
		self:activate_temporary_upgrade("temporary", "damage_absorption")
		if sydchSO.settings.moreHINTS == true then	
			managers.hud:show_hint({text ="Paired connection has been lost."})
		end
	end
	self:remove_tag_team_contour(tagged)
end)

Hooks:PostHook(PlayerManager, "update", "sydchSO", function(self, t)
	if self._tagged and alive(self._tagged) then
		self._tagged:contour():remove("deployable_selected")
		self._tagged:contour():add("deployable_selected")		
	end
	if self:has_activate_temporary_upgrade("temporary", "armor_break_chaos") then
		local pos = player_unit:position()
		local skill = self:upgrade_value("player", "panic_when_chaos")
		if skill and type(skill) ~= "number" then
			local area = skill.area
			local chance = skill.chance
			local amount = skill.amount
			local enemies = World:find_units_quick("sphere", pos, area, 12, 21)

			for i, unit in ipairs(enemies) do
				if unit:character_damage() then
					unit:character_damage():build_suppression(amount, chance)
					if sydchSO.settings.buffEFFECTS == 2 or sydchSO.settings.buffEFFECTS == 3 then
						managers.environment_controller:set_buff_effect(0.2)
					end
				end
			end
		end
	end
end)

function PlayerManager:remove_tag_team_contour(tagged)
	if self._tagged and self._tagged == tagged then
		self._tagged:contour():remove("deployable_selected")
		self._tagged = nil
	end
end

skill_buff_effect_effect_timer = 0

local function skill_buff_effect_update(t, dt)
	local hud = managers.hud:script( PlayerBase.PLAYER_INFO_HUD_FULLSCREEN_PD2)
	local skill_buff_effect_hud_panel = hud.panel:child("skill_buff_effect_hud_panel")
	if not skill_buff_effect_hud_panel then
		return
	end
	
	if skill_buff_effect_effect_timer > 0 then
		skill_buff_effect_effect_timer = skill_buff_effect_effect_timer - TimerManager:main():delta_time()
		skill_buff_effect_hud_panel:set_visible(true)
		local hudinfo = managers.hud:script(PlayerBase.PLAYER_INFO_HUD_PD2)
		skill_buff_effect_hud_panel:animate(hudinfo.flash_icon, 4000000000)
	elseif skill_buff_effect_effect_timer <= 0 then
		skill_buff_effect_hud_panel:stop()
		skill_buff_effect_hud_panel:set_visible(false)
	end
end

Hooks:PreHook(PlayerManager, "activate_temporary_upgrade", "sydchSO", function (self, category, upgrade)
	if not upgrade == "armor_break_invulnerable" then
		return
	end
	
	local upgrade_value = self:upgrade_value(category, upgrade)
	if not upgrade_value then
		return
	end
	
	if type(upgrade_value) == "table" then
		if upgrade_value[1] == 2 then
			skill_buff_effect_effect_timer = upgrade_value[1]
		end
	end
	
	local hud = managers.hud:script( PlayerBase.PLAYER_INFO_HUD_FULLSCREEN_PD2)
	if not hud.panel:child("skill_buff_effect_hud_panel") then
		local Armor_Break_Invulnerability_Effect_hud_panel = hud.panel:bitmap({
			name = "skill_buff_effect_hud_panel",
			visible = false,
			texture = "guis/textures/sso/alphawipe",
			layer = 0,
			alpha = 0.2,
			color = Color(0.8, 0.8, 0.8),
			blend_mode = "add",
			w = hud.panel:w(),
			h = hud.panel:h(),
			x = 0,
			y = 0 
		})
	end
end)

if sydchSO.settings.vocalHEISTERS == 1 or sydchSO.settings.vocalHEISTERS == 2 then
	return
end

sydchSO._say_once_roll = math.random(1, 1000)
sydchSO._lost_roll = false
sydchSO._has_mod_peer = {}

function sydchSO:Say(voice_id)
    if Utils:IsInHeist() and not Utils:IsInCustody() and Utils:IsInGameState() then
        if managers and managers.player and managers.player:local_player() and managers.player:local_player():sound() then
            if sydchSO.settings.vocalHEISTERS == 3 then
				managers.player:local_player():sound():say(voice_id, true, false)
			else
				managers.player:local_player():sound():say(voice_id, false, false)
			end
        end
    end
end

function sydchSO:_say_once(voice_id)
    if not self._lost_roll then
        self:Say(voice_id)
    end
end

function sydchSO:_say_line_thirdperson(voice_id)
    if Utils:IsInHeist() and not Utils:IsInCustody() and Utils:IsInGameState() then
        if managers and managers.player and managers.player:local_player() and managers.player:local_player():sound() and managers.player:local_player():sound()._unit then
            managers.player:local_player():sound()._unit:sound_source():set_switch("int_ext", "third")
            if sydchSO.settings.vocalHEISTERS == 3 then 
				managers.player:local_player():sound():say(voice_id, true, false)
			else
				managers.player:local_player():sound():say(voice_id, false, false)
			end
            managers.player:local_player():sound()._unit:sound_source():set_switch("int_ext", "first")
        end
    end
end

function sydchSO:_say_once_thirdperson(voice_id)
    if not self._lost_roll then
        self:_say_line_thirdperson(voice_id)
    end
end

function sydchSO:_recalculate_dice_roll()
    self._lost_roll = false

    for peer, roll in pairs(self._has_mod_peer) do
        if peer and roll and roll > self._say_once_roll then
            self._lost_roll = true
        end
    end
end

function sydchSO:_float(min, max)
	return math.random() + math.random(min, max - 1)
end

if sydchSO.settings.vocalHEISTERS == 4 then
    Hooks:Add('BaseNetworkSessionOnLoadComplete', 'BaseNetworkSessionOnLoadComplete_sydchSO', function(local_peer, id)
        LuaNetworking:SendToPeers("sydchSO_hello", tostring(math.floor(sydchSO._say_once_roll)))
    end)

    Hooks:Add('BaseNetworkSessionOnPeerEnteredLobby', 'BaseNetworkSessionOnPeerEnteredLobby_sydchSO', function(peer, peer_id)
        LuaNetworking:SendToPeer(peer_id, "sydchSO_hello", tostring(math.floor(sydchSO._say_once_roll)))
    end)
    
    Hooks:Add('NetworkReceivedData', 'NetworkReceivedData_sydchSO', function(sender, messageType, data)
        if messageType == "sydchSO_hello" then
            sydchSO._has_mod_peer[sender] = tonumber(data)
            sydchSO:_recalculate_dice_roll()
        end
    end)

    Hooks:Add('BaseNetworkSessionOnPeerRemoved', 'BaseNetworkSessionOnPeerRemoved_sydchSO', function(peer, peer_id, reason)
        sydchSO._has_mod_peer[peer_id] = nil
        sydchSO:_recalculate_dice_roll()
    end)
end

Hooks:PreHook(PlayerManager, "remove_special", "sydchSOcore_remove_specialequipment", function(self, name)
    local special_equipment = self._equipment.specials[name]

	if not special_equipment then
		return
    end

    local special_amount = special_equipment.amount and Application:digest_value(special_equipment.amount, false)
    
    if special_equipment.is_cable_tie and special_amount == 1 then
        sydchSO:Say("s32x_sin")
    end
end)