dofile(ModPath .. "lua/core/sydchSO.lua")

MutatorEnemyHealth = MutatorEnemyHealth or class(BaseMutator)
MutatorEnemyHealth._type = "MutatorEnemyHealth"
MutatorEnemyHealth.name_id = "mutator_enemy_health"
MutatorEnemyHealth.desc_id = "mutator_enemy_health_desc"
MutatorEnemyHealth.has_options = true
MutatorEnemyHealth.categories = {"enemies"}
MutatorEnemyHealth.icon_coords = {4, 1}

function MutatorEnemyHealth:additive_character_tweak_data(character_tweak, multiplier, exclude_list)
	if character_tweak then
		multiplier = multiplier or self:get_health_multiplier()

		for i, character in ipairs(character_tweak:enemy_list()) do
			if character_tweak[character] and (not exclude_list or not exclude_list[character]) then
				character_tweak[character].HEALTH_INIT = character_tweak[character].HEALTH_INIT + multiplier
			end
		end
	end
end

if sydchSO.settings.betterMUTATORS == false then
	return
end

MutatorEnemyHealth.reductions = {money = 1.15, exp = 0.9}
MutatorEnemyHealth.disables_achievements = false
MutatorEnemyHealth.disables_challenges = false
MutatorEnemyHealth.disables_trophies = false
MutatorEnemyHealth.disables_statistics = false

function MutatorEnemyHealth:_min_health()
	return 1.1
end

function MutatorEnemyHealth:_max_health()
	return 10
end