PlayerAction.BloodthirstBase = {
Priority = 1,
Function = function (player_manager, melee_multiplier, max_multiplier, max_time)
	local co = coroutine.running()
	local current_time = Application:time()
	local multiplier = 1
	local add_time = player_manager:upgrade_value("player", "melee_damage_stacking", nil).max_time
	local quit = false

	local function increase_multiplier()
		multiplier = math.min(multiplier + melee_multiplier, max_multiplier)
		player_manager:set_melee_dmg_multiplier(multiplier)
	end

	increase_multiplier()

	local function on_enemy_killed(weapon_unit, variant)
		increase_multiplier()
		
		if variant == "melee" then
			quit = true
			max_time = current_time + add_time
		end
	end
	
	player_manager:register_message(Message.OnEnemyKilled, co, on_enemy_killed)
	
	while not quit do
		coroutine.yield(co)
	end
	
	while current_time < max_time and quit do
		current_time = Application:time()
		coroutine.yield(co)
	end
	
	player_manager:reset_melee_dmg_multiplier()
	player_manager:unregister_message(Message.OnEnemyKilled, co)
end
}