function GameOverState:_shut_down_network(...)
	if managers.dlc:is_trial() then
		GameOverState.super._shut_down_network(self)
	end
end

function GameOverState:_load_start_menu(...)
	if managers.dlc:is_trial() then
		Global.open_trial_buy = true

		setup:load_start_menu()
	end
end

function GameOverState:continue()
	if self:_continue_blocked() then
		return
	end

	if Network:is_server() and not managers.dlc:is_trial() then
		managers.network:session():send_to_peers_loaded("enter_ingame_lobby_menu", managers.network:session():load_counter())
	end

	if managers.dlc:is_trial() then
		self:gsm():change_state_by_name("empty")

		return
	end

	if self._old_state then
		self:_clear_controller()
		managers.menu_component:close_stage_endscreen_gui()
		self:gsm():change_state_by_name("ingame_lobby_menu")
	else
		Application:error("Trying to continue from game over screen, but I have no state to goto")
	end
end