dofile(ModPath .. "lua/core/sydchSO.lua")

local is_america = false
local is_murky = false

Hooks:PostHook(CharacterTweakData, "init", "sydchSO", function(self)
	-- Kuziz's and Rokk's work, I take no credit
	local surrender_preset_easy = {
		base_chance = 0.3,
		significant_chance = 0.4,
		violence_timeout = 2,
		reasons = {
			health = {
				[1] = 0.2,
				[0.5] = 1
			},
			weapon_down = 0.8,
			pants_down = 1,
			isolated = 0.5
		},
		factors = {
			flanked = 0.4,
			unaware_of_aggressor = 0.2,
			enemy_weap_cold = 0.4,
			aggressor_dis = {
				[1000] = 0,
				[300] = 0.4
	}}}
	
	local surrender_preset_normal = {
		base_chance = 0.2,
		significant_chance = 0.3,
		violence_timeout = 2,
		reasons = {
			health = {
				[1] = 0.1,
				[0.4] = 0.5
			},
			weapon_down = 0.6,
			pants_down = 0.8
		},
		factors = {
			isolated = 0.4,
			flanked = 0.3,
			unaware_of_aggressor = 0.2,
			enemy_weap_cold = 0.3,
			aggressor_dis = {
				[1000] = 0,
				[300] = 0.3
	}}}

	local surrender_preset_hard = {
		base_chance = 0.1,
		significant_chance = 0.2,
		violence_timeout = 2,
		reasons = {
			health = {
				[1] = 0.1,
				[0.3] = 0.3
			},
			weapon_down = 0.4,
			pants_down = 0.8
		},
		factors = {
			isolated = 0.3,
			flanked = 0.2,
			unaware_of_aggressor = 0.2,
			enemy_weap_cold = 0.2,
			aggressor_dis = {
				[1000] = 0,
				[300] = 0.2
	}}}
	
	self.fbi_swat.surrender = surrender_preset_hard
	self.swat.surrender = surrender_preset_hard
	self.heavy_swat.surrender = surrender_preset_hard
	self.fbi_heavy_swat.surrender = surrender_preset_hard
	self.fbi_swat.surrender = surrender_preset_hard
	self.city_swat.surrender = surrender_preset_hard

	self.security.surrender = surrender_preset_easy
	self.cop_scared.surrender = surrender_preset_easy

	self.cop.surrender = surrender_preset_normal
	self.fbi.surrender = surrender_preset_normal
	
	if sydchSO.settings.voiceFILTER == true then
		is_america = false
		is_murky = false
	end
end)

local _init_civilian_original = CharacterTweakData._init_civilian
function CharacterTweakData:_init_civilian(...)
	_init_civilian_original(self, ...)
	self.civilian.silent_priority_shout = "f37"
	self.civilian_female.silent_priority_shout = "f37"
end

Hooks:PostHook(CharacterTweakData, "_init_marshal_shield", "sydchSO", function(self,presets)	
	if sydchSO.settings.streamLINED == 2 or sydchSO.settings.streamLINED == 3 then
		self.marshal_shield_break.tmp_invulnerable_on_tweak_change = 0
	end
end)

-- ellie and zdann's work. they are credited in mod page!
local old_set_sm_wish = CharacterTweakData._set_sm_wish
function CharacterTweakData:_set_sm_wish()
	if sydchSO.settings.assaultTWEAKS == 2 or sydchSO.settings.assaultTWEAKS == 3 then
		self:_multiply_all_hp(6, 1.5)
		self.tank.HEALTH_INIT = 2400
		self.tank_mini.HEALTH_INIT = 4800
		self.tank_medic.HEALTH_INIT = 2400
		local zeal_heavy = {
			aim_delay = {
				0,
				0
			},
			focus_delay = 0,
			focus_dis = 200,
			spread = 20,
			miss_dis = 40,
			RELOAD_SPEED = 1.4,
			melee_speed = 1,
			melee_dmg = 20,
			melee_retry_delay = {
				1,
				2
			},
			range = {
				optimal = 3500,
				far = 6000,
				close = 2000
			},
			autofire_rounds = {
				3,
				6
			},
			FALLOFF = {{
					dmg_mul = 3,
					r = 100,
					acc = {
						0.9,
						0.975
					},
					recoil = {
						0.25,
						0.3
					},
					mode = {
						0,
						0,
						0,
						1
					},
					autofire_rounds = {
						6,
						12
				}},
				{
					dmg_mul = 3,
					r = 500,
					acc = {
						0.875,
						0.95
					},
					recoil = {
						0.25,
						0.3
					},
					mode = {
						0,
						0,
						0,
						1
					},
					autofire_rounds = {
						4,
						8
				}},
				{
					dmg_mul = 2.5,
					r = 1000,
					acc = {
						0.7,
						0.9
					},
					recoil = {
						0.35,
						0.55
					},
					mode = {
						0,
						0,
						0,
						1
					},
					autofire_rounds = {
						3,
						5
				}},
				{
					dmg_mul = 2,
					r = 2000,
					acc = {
						0.7,
						0.85
					},
					recoil = {
						0.4,
						0.7
					},
					mode = {
						0,
						3,
						3,
						1
				}},
				{
					dmg_mul = 1.6666667,
					r = 3000,
					acc = {
						0.65,
						0.75
					},
					recoil = {
						0.7,
						1.1
					},
					mode = {
						3,
						1,
						5,
						0.5
				}},
				{
					dmg_mul = 1.1666667,
					r = 6000,
					acc = {
						0.25,
						0.7
					},
					recoil = {
						1,
						2
					},
					mode = {
						3,
						1,
						1,
						0
		}}}}
		local zeal_light = {
			aim_delay = {
				0,
				0
			},
			focus_delay = 0,
			focus_dis = 200,
			spread = 15,
			miss_dis = 10,
			RELOAD_SPEED = 1.4,
			melee_speed = 1,
			melee_dmg = 20,
			melee_retry_delay = {
				1,
				2
			},
			range = {
				optimal = 3200,
				far = 6000,
				close = 2000
			},
			autofire_rounds = {
				8,
				16
			},
			FALLOFF = {{
					dmg_mul = 7.5,
					r = 100,
					acc = {
						0.95,
						0.95
					},
					recoil = {
						0.1,
						0.25
					},
					mode = {
						0,
						0,
						0,
						1
					},
					autofire_rounds = {
						8,
						16
				}},
				{
					dmg_mul = 7.5,
					r = 500,
					acc = {
						0.9,
						0.9
					},
					recoil = {
						0.1,
						0.3
					},
					mode = {
						0,
						0,
						0,
						1
					},
					autofire_rounds = {
						4,
						10
				}},
				{
					dmg_mul = 6,
					r = 1000,
					acc = {
						0.85,
						0.85
					},
					recoil = {
						0.35,
						0.5
					},
					mode = {
						0,
						0,
						0,
						1
					},
					autofire_rounds = {
						3,
						6
				}},
				{
					dmg_mul = 5,
					r = 2000,
					acc = {
						0.6,
						0.7
					},
					recoil = {
						0.35,
						0.5
					},
					mode = {
						0,
						6,
						3,
						0
				}},
				{
					dmg_mul = 4,
					r = 3000,
					acc = {
						0.55,
						0.6
					},
					recoil = {
						0.5,
						1.5
					},
					mode = {
						1,
						6,
						2,
						0
				}},
				{
					dmg_mul = 4,
					r = 4500,
					acc = {
						0.3,
						0.6
					},
					recoil = {
						1,
						1.5
					},
					mode = {
						1,
						3,
						2,
						0
		}}}}
		self.hector_boss.weapon.is_shotgun_mag.FALLOFF = {{
				dmg_mul = 3.14,
				r = 200,
				acc = {
					0.6,
					0.9
				},
				recoil = {
					0.4,
					0.7
				},
				mode = {
					0,
					1,
					2,
					1
			}},
			{
				dmg_mul = 2.5,
				r = 500,
				acc = {
					0.6,
					0.9
				},
				recoil = {
					0.4,
					0.7
				},
				mode = {
					0,
					3,
					3,
					1
			}},
			{
				dmg_mul = 2.1,
				r = 1000,
				acc = {
					0.4,
					0.8
				},
				recoil = {
					0.45,
					0.8
				},
				mode = {
					1,
					2,
					2,
					0
			}},
			{
				dmg_mul = 1.8,
				r = 2000,
				acc = {
					0.4,
					0.55
				},
				recoil = {
					0.45,
					0.8
				},
				mode = {
					3,
					2,
					2,
					0
			}},
			{
				dmg_mul = 1.4,
				r = 3000,
				acc = {
					0.1,
					0.35
				},
				recoil = {
					1,
					1.2
				},
				mode = {
					3,
					1,
					1,
					0
		}}}
		self.hector_boss.HEALTH_INIT = 900
		self.mobster_boss.HEALTH_INIT = 900
		self.biker_boss.HEALTH_INIT = 3000
		self.chavez_boss.HEALTH_INIT = 900
		self:_multiply_all_speeds(4.05, 4.1)
		self:_multiply_weapon_delay(self.presets.weapon.normal, 0)
		self:_multiply_weapon_delay(self.presets.weapon.good, 0)
		self:_multiply_weapon_delay(self.presets.weapon.expert, 0)
		self:_multiply_weapon_delay(self.presets.weapon.sniper, 3)
		self:_multiply_weapon_delay(self.presets.weapon.gang_member, 0)
		self.presets.gang_member_damage.REGENERATE_TIME = 1.8
		self.presets.gang_member_damage.REGENERATE_TIME_AWAY = 0.6
		self.presets.gang_member_damage.HEALTH_INIT = 800
		self.presets.weapon.gang_member.is_pistol.FALLOFF = {{
				dmg_mul = 10,
				r = 300,
				acc = {
					1,
					1
				},
				recoil = {
					0.25,
					0.45
				},
				mode = {
					0.1,
					0.3,
					4,
					7
			}},
			{
				dmg_mul = 5,
				r = 10000,
				acc = {
					1,
					1
				},
				recoil = {
					2,
					3
				},
				mode = {
					0.1,
					0.3,
					4,
					7
		}}}
		self.presets.weapon.gang_member.is_rifle.FALLOFF = {{
				dmg_mul = 10,
				r = 300,
				acc = {
					1,
					1
				},
				recoil = {
					0.25,
					0.45
				},
				mode = {
					0.1,
					0.3,
					4,
					7
			}},
			{
				dmg_mul = 5,
				r = 10000,
				acc = {
					1,
					1
				},
				recoil = {
					2,
					3
				},
				mode = {
					0.1,
					0.3,
					4,
					7
		}}}
		self.presets.weapon.gang_member.is_sniper.FALLOFF = {{
				dmg_mul = 20,
				r = 500,
				acc = {
					1,
					1
				},
				recoil = {
					1,
					1
				},
				mode = {
					1,
					0,
					0,
					0
			}},
			{
				dmg_mul = 20,
				r = 1000,
				acc = {
					1,
					1
				},
				recoil = {
					1,
					1
				},
				mode = {
					1,
					0,
					0,
					0
			}},
			{
				dmg_mul = 20,
				r = 2500,
				acc = {
					0.95,
					1
				},
				recoil = {
					1,
					1
				},
				mode = {
					1,
					0,
					0,
					0
			}},
			{
				dmg_mul = 10,
				r = 4000,
				acc = {
					0.9,
					0.95
				},
				recoil = {
					1,
					1
				},
				mode = {
					1,
					0,
					0,
					0
			}},
			{
				dmg_mul = 10,
				r = 10000,
				acc = {
					0.85,
					0.9
				},
				recoil = {
					1,
					1
				},
				mode = {
					1,
					0,
					0,
					0
		}}}
		self.presets.weapon.gang_member.is_lmg.FALLOFF = {{
				dmg_mul = 10,
				r = 100,
				acc = {
					1,
					1
				},
				recoil = {
					0.25,
					0.45
				},
				mode = {
					0,
					0,
					0,
					1
			}},
			{
				dmg_mul = 7.5,
				r = 1000,
				acc = {
					0.85,
					0.9
				},
				recoil = {
					0.4,
					0.65
				},
				mode = {
					0,
					0,
					0,
					1
			}},
			{
				dmg_mul = 5,
				r = 2000,
				acc = {
					0.6,
					0.8
				},
				recoil = {
					0.8,
					1.25
				},
				mode = {
					0,
					0,
					0,
					1
			}},
			{
				dmg_mul = 3,
				r = 3000,
				acc = {
					0.5,
					0.7
				},
				recoil = {
					0.8,
					1.25
				},
				mode = {
					0,
					0,
					0,
					1
			}},
			{
				dmg_mul = 2,
				r = 4000,
				acc = {
					0.02,
					0.25
				},
				recoil = {
					1,
					2
				},
				mode = {
					0,
					0,
					0,
					1
			}},
			{
				dmg_mul = 0.5,
				r = 10000,
				acc = {
					0.01,
					0.1
				},
				recoil = {
					2,
					3
				},
				mode = {
					0,
					0,
					0,
					1
		}}}
		self.presets.weapon.gang_member.is_shotgun_pump.FALLOFF = {{
				dmg_mul = 10,
				r = 300,
				acc = {
					1,
					1
				},
				recoil = {
					0.25,
					0.45
				},
				mode = {
					0.1,
					0.3,
					4,
					7
			}},
			{
				dmg_mul = 5,
				r = 10000,
				acc = {
					1,
					1
				},
				recoil = {
					2,
					3
				},
				mode = {
					0.1,
					0.3,
					4,
					7
		}}}
		self.presets.weapon.gang_member.is_shotgun_mag.FALLOFF = {{
				dmg_mul = 10,
				r = 100,
				acc = {
					1,
					1
				},
				recoil = {
					0.1,
					0.1
				},
				mode = {
					1,
					1,
					4,
					6
			}},
			{
				dmg_mul = 8,
				r = 500,
				acc = {
					1,
					1
				},
				recoil = {
					0.1,
					0.1
				},
				mode = {
					1,
					1,
					4,
					5
			}},
			{
				dmg_mul = 7,
				r = 1000,
				acc = {
					0.85,
					0.95
				},
				recoil = {
					0.1,
					0.15
				},
				mode = {
					1,
					2,
					4,
					4
			}},
			{
				dmg_mul = 5,
				r = 2000,
				acc = {
					0.75,
					0.9
				},
				recoil = {
					0.25,
					0.45
				},
				mode = {
					1,
					4,
					4,
					1
			}},
			{
				dmg_mul = 2,
				r = 3000,
				acc = {
					0.4,
					0.7
				},
				recoil = {
					0.4,
					0.5
				},
				mode = {
					4,
					2,
					1,
					0
			}},
			{
				dmg_mul = 0.2,
				r = 10000,
				acc = {
					0.05,
					0.2
				},
				recoil = {
					0.5,
					1
				},
				mode = {
					2,
					1,
					0,
					0
		}}}
		self.presets.weapon.gang_member.is_smg = self.presets.weapon.gang_member.is_rifle
		self.presets.weapon.gang_member.is_pistol = self.presets.weapon.gang_member.is_pistol
		self.presets.weapon.gang_member.is_revolver = self.presets.weapon.gang_member.is_pistol
		self.presets.weapon.gang_member.is_rifle = self.presets.weapon.gang_member.is_rifle
		self.presets.weapon.gang_member.is_shotgun_pump = self.presets.weapon.gang_member.is_shotgun_pump
		self.presets.weapon.gang_member.mac11 = self.presets.weapon.gang_member.is_smg
		self.presets.weapon.gang_member.rifle = deep_clone(self.presets.weapon.gang_member.is_rifle)
		self.presets.weapon.gang_member.rifle.autofire_rounds = nil
		self.presets.weapon.gang_member.akimbo_pistol = self.presets.weapon.gang_member.is_pistol
		self.presets.weapon.gang_member.is_shotgun_mag = deep_clone(self.presets.weapon.gang_member.is_shotgun_pump)
		self:_set_characters_weapon_preset("deathwish")
		self.spooc.spooc_attack_timeout = {3, 4}
		self.sniper.weapon.is_rifle.FALLOFF = {{
				r = 700,
				acc = {0.7, 1},
				dmg_mul = 12,
				recoil = {3, 5},
				mode = {
					1,
					0,
					0,
					0
			}},
			{
				r = 4000,
				acc = {0.6, 0.95},
				dmg_mul = 12,
				recoil = {3, 5},
				mode = {
					1,
					0,
					0,
					0
			}},
			{
				r = 10000,
				acc = {0.2, 0.8},
				dmg_mul = 12,
				recoil = {3, 5},
				mode = {
					1,
					0,
					0,
					0
		}}}
		self.tank.weapon.is_shotgun_mag.aim_delay = {
			0,
			0
		}
		self.tank.weapon.is_shotgun_mag.focus_delay = 0
		self.tank.weapon.is_shotgun_mag.focus_dis = 200
		self.tank.weapon.is_shotgun_mag.FALLOFF = {{
				dmg_mul = 9,
				r = 100,
				acc = {
					0.75,
					0.9
				},
				recoil = {
					0.4,
					0.7
				},
				mode = {
					0,
					3,
					3,
					1
			}},
			{
				dmg_mul = 8.5,
				r = 500,
				acc = {
					0.75,
					0.9
				},
				recoil = {
					0.4,
					0.7
				},
				mode = {
					0,
					3,
					3,
					1
			}},
			{
				dmg_mul = 8,
				r = 1000,
				acc = {
					0.7,
					0.85
				},
				recoil = {
					0.45,
					0.8
				},
				mode = {
					1,
					2,
					2,
					0
			}},
			{
				dmg_mul = 5,
				r = 2000,
				acc = {
					0.5,
					0.65
				},
				recoil = {
					0.45,
					0.8
				},
				mode = {
					3,
					2,
					2,
					0
			}},
			{
				dmg_mul = 3.5,
				r = 3000,
				acc = {
					0.3,
					0.5
				},
				recoil = {
					1,
					1.2
				},
				mode = {
					3,
					1,
					1,
					0
		}}}
		self.tank.weapon.is_shotgun_pump.focus_dis = 200
		self.tank.weapon.is_shotgun_pump.FALLOFF[1].dmg_mul = 9
		self.tank.weapon.is_shotgun_pump.FALLOFF[2].dmg_mul = 8
		self.tank.weapon.is_shotgun_pump.FALLOFF[3].dmg_mul = 7
		self.tank.weapon.is_rifle.aim_delay = {
			0,
			0
		}
		self.tank.weapon.is_rifle.focus_delay = 0
		self.tank.weapon.is_rifle.FALLOFF = {{
				dmg_mul = 4,
				r = 100,
				acc = {
					0.7,
					0.9
				},
				recoil = {
					0.4,
					0.7
				},
				mode = {
					0,
					0,
					0,
					1
			}},
			{
				dmg_mul = 4,
				r = 500,
				acc = {
					0.5,
					0.75
				},
				recoil = {
					0.5,
					0.8
				},
				mode = {
					0,
					0,
					0,
					6
			}},
			{
				dmg_mul = 3,
				r = 1000,
				acc = {
					0.3,
					0.6
				},
				recoil = {
					1,
					1
				},
				mode = {
					0,
					0,
					2,
					6
			}},
			{
				dmg_mul = 3,
				r = 2000,
				acc = {
					0.25,
					0.55
				},
				recoil = {
					1,
					1
				},
				mode = {
					0,
					0,
					2,
					6
			}},
			{
				dmg_mul = 3,
				r = 3000,
				acc = {
					0.15,
					0.5
				},
				recoil = {
					1,
					2
				},
				mode = {
					0,
					0,
					2,
					6
		}}}
		self.tank_mini.weapon.mini.aim_delay = {
			0,
			0
		}
		self.tank_mini.weapon.mini.focus_delay = 0
		self.tank_mini.weapon.mini.FALLOFF = {{
				dmg_mul = 4,
				r = 100,
				acc = {
					0.7,
					0.9
				},
				recoil = {
					0.4,
					0.7
				},
				mode = {
					0,
					0,
					0,
					1
				},
				autofire_rounds = {
					500,
					700
			}},
			{
				dmg_mul = 3.5,
				r = 500,
				acc = {
					0.5,
					0.75
				},
				recoil = {
					0.5,
					0.8
				},
				mode = {
					0,
					0,
					0,
					1
				},
				autofire_rounds = {
					500,
					500
			}},
			{
				dmg_mul = 3,
				r = 1000,
				acc = {
					0.3,
					0.6
				},
				recoil = {
					1,
					1
				},
				mode = {
					0,
					0,
					0,
					1
				},
				autofire_rounds = {
					300,
					500
			}},
			{
				dmg_mul = 2.5,
				r = 2000,
				acc = {
					0.25,
					0.55
				},
				recoil = {
					1,
					1
				},
				mode = {
					0,
					0,
					0,
					1
				},
				autofire_rounds = {
					100,
					300
			}},
			{
				dmg_mul = 2,
				r = 3000,
				acc = {
					0.15,
					0.5
				},
				recoil = {
					1,
					2
				},
				mode = {
					0,
					0,
					0,
					1
				},
				autofire_rounds = {
					40,
					100
		}}}
		self.tank_medic.weapon.is_smg = {
			aim_delay = {
				0,
				0
			},
			focus_delay = 0,
			focus_dis = 200,
			spread = 15,
			miss_dis = 10,
			RELOAD_SPEED = 1.4,
			melee_speed = 1,
			melee_dmg = 20,
			melee_retry_delay = {
				1,
				2
			},
			range = {
				optimal = 3200,
				far = 6000,
				close = 2000
			},
			autofire_rounds = {
				8,
				16
			},
			FALLOFF = {
				{
					dmg_mul = 4,
					r = 100,
					acc = {
						0.95,
						0.95
					},
					recoil = {
						0.1,
						0.25
					},
					mode = {
						0,
						0,
						0,
						1
					},
					autofire_rounds = {
						8,
						16
				}},
				{
					dmg_mul = 4,
					r = 500,
					acc = {
						0.9,
						0.9
					},
					recoil = {
						0.1,
						0.3
					},
					mode = {
						0,
						0,
						0,
						1
					},
					autofire_rounds = {
						4,
						10
				}},
				{
					dmg_mul = 4,
					r = 1000,
					acc = {
						0.85,
						0.85
					},
					recoil = {
						0.35,
						0.5
					},
					mode = {
						0,
						0,
						0,
						1
					},
					autofire_rounds = {
						3,
						6
				}},
				{
					dmg_mul = 3,
					r = 2000,
					acc = {
						0.6,
						0.7
					},
					recoil = {
						0.35,
						0.5
					},
					mode = {
						0,
						6,
						3,
						0
				}},
				{
					dmg_mul = 2,
					r = 3000,
					acc = {
						0.55,
						0.6
					},
					recoil = {
						0.5,
						1.5
					},
					mode = {
						1,
						6,
						2,
						0
				}},
				{
					dmg_mul = 2,
					r = 4500,
					acc = {
						0.3,
						0.6
					},
					recoil = {
						1,
						1.5
					},
					mode = {
						1,
						3,
						2,
						0
		}}}}
		self.shield.weapon.is_smg.aim_delay = {0, 0}
		self.shield.weapon.is_smg.focus_delay = 0
		self.shield.weapon.is_smg.focus_dis = 200
		self.shield.weapon.is_smg.FALLOFF = {{
				r = 0,
				acc = {0.9, 0.95},
				dmg_mul = 7,
				recoil = {0.35, 0.35},
				mode = {
					0.2,
					2,
					4,
					10
			}},
			{
				r = 700,
				acc = {0.8, 0.8},
				dmg_mul = 7,
				recoil = {0.35, 0.55},
				mode = {
					0.2,
					2,
					4,
					10
			}},
			{
				r = 1000,
				acc = {0.6, 0.65},
				dmg_mul = 7,
				recoil = {0.35, 0.55},
				mode = {
					0.2,
					2,
					4,
					10
			}},
			{
				r = 2000,
				acc = {0.5, 0.7},
				dmg_mul = 7,
				recoil = {0.35, 1},
				mode = {
					2,
					5,
					6,
					4
			}},
			{
				r = 3000,
				acc = {0.5, 0.5},
				dmg_mul = 7,
				recoil = {0.5, 1.2},
				mode = {
					6,
					4,
					2,
					0
		}}}
		self.shield.weapon.is_pistol.aim_delay = {0, 0}
		self.shield.weapon.is_pistol.focus_delay = 0
		self.shield.weapon.is_pistol.FALLOFF = {{
				r = 100,
				acc = {0.95, 0.95},
				dmg_mul = 7,
				recoil = {0.1, 0.25},
				mode = {
					0,
					3,
					3,
					4
			}},
			{
				r = 500,
				acc = {0.6, 0.75},
				dmg_mul = 7,
				recoil = {0.1, 0.3},
				mode = {
					0,
					3,
					3,
					4
			}},
			{
				r = 1000,
				acc = {0.5, 0.65},
				dmg_mul = 7,
				recoil = {0.35, 0.5},
				mode = {
					0,
					6,
					3,
					3
			}},
			{
				r = 2000,
				acc = {0.5, 0.6},
				dmg_mul = 7,
				recoil = {0.35, 0.5},
				mode = {
					0,
					6,
					3,
					0
			}},
			{
				r = 3000,
				acc = {0.5, 0.6},
				dmg_mul = 7,
				recoil = {0.5, 1.5},
				mode = {
					1,
					6,
					2,
					0
			}}}
			self.heavy_swat.weapon.is_rifle = zeal_heavy
			self.medic.weapon.is_rifle = zeal_heavy
			self.fbi_heavy_swat.weapon.is_rifle = zeal_heavy
			self.city_swat.weapon.is_rifle = zeal_heavy
			self.swat.weapon.is_smg = zeal_light
			self.spooc.weapon.is_smg = zeal_light
			self.city_swat.damage.explosion_damage_mul = 1
			self.city_swat.damage.hurt_severity = self.presets.hurt_severities.light_hurt_fire_poison
			self.city_swat.weapon.is_smg = zeal_light
			self.taser.weapon.is_rifle.FALLOFF = {{
						dmg_mul = 3,
						r = 100,
						acc = {
							0.9,
							0.975
						},
						recoil = {
							0.25,
							0.3
						},
						mode = {
							0,
							3,
							3,
							1
					}},
					{
						dmg_mul = 3,
						r = 500,
						acc = {
							0.875,
							0.95
						},
						recoil = {
							0.25,
							0.3
						},
						mode = {
							0,
							3,
							8,
							1
					}},
					{
						dmg_mul = 2.5,
						r = 1000,
						acc = {
							0.7,
							0.9
						},
						recoil = {
							0.35,
							0.55
						},
						mode = {
							0,
							2,
							5,
							1
					}},
					{
						dmg_mul = 2,
						r = 2000,
						acc = {
							0.7,
							0.85
						},
						recoil = {
							0.4,
							0.7
						},
						mode = {
							3,
							2,
							5,
							1
					}},
					{
						dmg_mul = 1.6666667,
						r = 3000,
						acc = {
							0.65,
							0.75
						},
						recoil = {
							0.7,
							1.1
						},
						mode = {
							3,
							1,
							5,
							0.5
					}},
					{
						dmg_mul = 1.1666667,
						r = 6000,
						acc = {
							0.25,
							0.7
						},
						recoil = {
							1,
							2
						},
						mode = {
							3,
							1,
							1,
							0
		}}}
		self.phalanx_minion.HEALTH_INIT = 400
		self.phalanx_minion.DAMAGE_CLAMP_BULLET = 40
		self.phalanx_minion.DAMAGE_CLAMP_EXPLOSION = self.phalanx_minion.DAMAGE_CLAMP_BULLET
		self.phalanx_vip.HEALTH_INIT = 800
		self.phalanx_vip.DAMAGE_CLAMP_BULLET = 80
		self.phalanx_vip.DAMAGE_CLAMP_EXPLOSION = self.phalanx_vip.DAMAGE_CLAMP_BULLET
		self.flashbang_multiplier = 2
		self.concussion_multiplier = 1
	else
		old_set_sm_wish(self)
	end
end

if sydchSO.settings.voiceFILTER == true then
	Hooks:PostHook(CharacterTweakData, "_init_region_america", "sydchSO", function(self)
		is_america = true
	end)

	Hooks:PostHook(CharacterTweakData, "_init_region_murkywater", "sydchSO", function(self)
		is_murky = true
	end)

	Hooks:PostHook(CharacterTweakData, "_init_fbi_heavy_swat", "sydchSO", function(self)
		if is_america then
			self.fbi_heavy_swat.speech_prefix_p1 = "l"
			self.fbi_heavy_swat.speech_prefix_count = 5
			self.fbi_heavy_swat.speech_prefix_p2 = "d"
		end
	end)

	Hooks:PostHook(CharacterTweakData, "_init_fbi_swat", "sydchSO", function(self)
		if is_america and not is_murky then
			self.fbi_swat.speech_prefix_p1 = "l"
			self.fbi_swat.speech_prefix_p2 = "d"
		end
	end)

	Hooks:PostHook(CharacterTweakData, "_init_city_swat", "sydchSO", function(self)
		if is_america then
			self.city_swat.speech_prefix_p1 = "l"
			self.city_swat.speech_prefix_p2 = "d"
		end
	end)

	Hooks:PostHook(CharacterTweakData, "_init_gangster", "sydchSO", function(self, presets)
		local job_speech_prefixes = {
			russian = {
				p1 = "rt",
				p2 = nil,
				count = 2
			},
			ovkmc = {
				p1 = "ict",
				p2 = nil,
				count = 2
			},
			default = {
				p1 = "lt",
				p2 = nil,
				count = 2
			}
		}

		local jobs_speech = {
			nightclub = job_speech_prefixes.russian,
			short2_stage1 = job_speech_prefixes.russian,
			jolly = job_speech_prefixes.russian,
			spa = job_speech_prefixes.russian,
			alex_2 = job_speech_prefixes.ovkmc,
			welcome_to_the_jungle_1 = job_speech_prefixes.ovkmc,
			mex = job_speech_prefixes.ovkmc
		}

		local job = Global.level_data and Global.level_data.level_id
		if job and jobs_speech[job] then
			self.gangster.speech_prefix_p1 = jobs_speech[job].p1
			self.gangster.speech_prefix_count = jobs_speech[job].count
			self.gangster.speech_prefix_p2 = jobs_speech[job].p2

			if jobs_speech[job].gangster_is_cop then
				self.gangster.no_arrest = false
				self.gangster.rescue_hostages = true
				self.gangster.use_radio = self._default_chatter	
			end
		else
			self.gangster.speech_prefix_p1 = job_speech_prefixes.default.p1
			self.gangster.speech_prefix_count = job_speech_prefixes.default.count
			self.gangster.speech_prefix_p2 = job_speech_prefixes.default.p2
		end

		self.gangster.chatter = {
			aggressive = true,
			retreat = true,
			contact = true,
			go_go = true,
			suppress = true
		}
	end)
end

if sydchSO.settings.copBEHAVIOR == true then
	Hooks:PostHook(CharacterTweakData, "init", "sydchSO", function(self)
		self.fbi_heavy_swat.arrest_player_priority = 0
		self.heavy_swat.arrest_player_priority = 1
		self.swat.arrest_player_priority = 2
		self.cop.arrest_player_priority = 3
		self.fbi.arrest_player_priority = 2
		self.medic.arrest_player_priority = 0
		self.taser.arrest_player_priority = 0
		self.spooc.arrest_player_priority = 3
	end)
end

if sydchSO.settings.streamLINED == 3 then
Hooks:PostHook(CharacterTweakData, "_init_phalanx_vip", "sydchSO", function(self, presets)
	self.phalanx_vip.LOWER_HEALTH_PERCENTAGE_LIMIT = nil
	self.phalanx_vip.FINAL_LOWER_HEALTH_PERCENTAGE_LIMIT = nil
end)
end

if sydchSO.settings.assaultTWEAKS == 3 then
local nil_value = {}
local function based_on(preset, values)
	local p = deep_clone(preset)
	if not values then
		return p
	end
	for _, entry in pairs(p) do
		for val_name, val in pairs(values) do
			if type(val) == "function" then
				val(entry[val_name])
			else
				entry[val_name] = val ~= nil_value and val
			end
		end
	end
	return p
end

local function manipulate_entries(tbl, value_name, func)
	for _, v in pairs(tbl) do
		if type(v) == "table" then
			v[value_name] = func(v[value_name])
		end
	end
end
end

local city_swat_hurts = {
	tase = true,
	bullet = {
		health_reference = 1,
		zones = {{light = 1}}
	},
	explosion = {
		health_reference = 1,
		zones = {{explode = 1}}
	},
	melee = {
		health_reference = "current",
		zones = {
			{heavy = 0, health_limit = 0.3, light = 0.7, moderate = 0, none = 0.3},
			{heavy = 0, light = 1, moderate = 0, health_limit = 0.8},
			{heavy = 0.2, light = 0.6, moderate = 0.2, health_limit = 0.9},
			{light = 0, moderate = 0, heavy = 9}}
		},
	fire = {
		health_reference = 1,
		zones = {{fire = 1}}
	},
	poison = {
		health_reference = 1,
		zones = {{poison = 1}}
	}
}

local heavy_swat_hurts = {
		bullet = {
			health_reference = "current",
			zones = {
				{
					heavy = 0.0,
					health_limit = 0.3,
					light = 0.8,
					moderate = 0.0,
					none = 0.2
				},
				{
					heavy = 0.0,
					light = 0.5,
					moderate = 0.5,
					health_limit = 0.6
				},
				{
					heavy = 0.4,
					light = 0.0,
					moderate = 0.6,
					health_limit = 0.9
				},
				{
					light = 0,
					moderate = 0,
					heavy = 1
				}
			}
		},
		explosion = {
			health_reference = "current",
			zones = {
				{
					none = 0.6,
					heavy = 0.4,
					health_limit = 0.2
				},
				{
					explode = 0.4,
					heavy = 0.6,
					health_limit = 0.5
				},
				{
					explode = 0.8,
					heavy = 0.2
				}
			}
		},
		melee = {
			health_reference = "current",
			zones = {
				{
					heavy = 0,
					health_limit = 0.3,
					light = 0.7,
					moderate = 0,
					none = 0.3
				},
				{
					heavy = 0,
					light = 1,
					moderate = 0,
					health_limit = 0.8
				},
				{
					heavy = 0.2,
					light = 0.6,
					moderate = 0.2,
					health_limit = 0.9
				},
				{
					light = 0,
					moderate = 0,
					heavy = 9
				}
			}
		},
		fire = {
			health_reference = "current",
			zones = {
				{
					fire = 1
				}
			}
		},
		poison = {
			health_reference = "current",
			zones = {
				{
					poison = 1,
					none = 0
				}
			}
		}
	}

local function apply_acc(unitweapon, acctype)
	if sydchSO.settings.streamLINED == 2 then
		if acctype == "standard" then
			unitweapon.FALLOFF[1].acc = {0.90, 0.95}
			unitweapon.FALLOFF[2].acc = {0.70, 0.90}
			unitweapon.FALLOFF[3].acc = {0.60, 0.70}
			unitweapon.FALLOFF[4].acc = {0.35, 0.50}
			unitweapon.FALLOFF[5].acc = {0.15, 0.35}
			if not unitweapon.FALLOFF[6] then
				unitweapon.FALLOFF[6] = deep_clone(unitweapon.FALLOFF[5])
				unitweapon.FALLOFF[6].r = 6000
			end
			unitweapon.FALLOFF[6].acc = {0.05, 0.20}
		elseif acctype == "dozer" then
			unitweapon.FALLOFF[1].acc = {0.60, 0.80}
			unitweapon.FALLOFF[2].acc = {0.50, 0.70}
			unitweapon.FALLOFF[3].acc = {0.40, 0.60}
			unitweapon.FALLOFF[4].acc = {0.30, 0.50}
			unitweapon.FALLOFF[5].acc = {0.20, 0.40}
			if not unitweapon.FALLOFF[6] then
				unitweapon.FALLOFF[6] = deep_clone(unitweapon.FALLOFF[5])
				unitweapon.FALLOFF[6].r = 6000
			end
			unitweapon.FALLOFF[6].acc = {0.05, 0.20}
		elseif acctype == "shield" then
			unitweapon.FALLOFF[1].acc = {0.80, 0.80}
			unitweapon.FALLOFF[2].acc = {0.70, 0.75}
			unitweapon.FALLOFF[3].acc = {0.40, 0.65}
			unitweapon.FALLOFF[4].acc = {0.25, 0.50}
			unitweapon.FALLOFF[5].acc = {0.10, 0.25}
			if not unitweapon.FALLOFF[6] then
				unitweapon.FALLOFF[6] = deep_clone(unitweapon.FALLOFF[5])
				unitweapon.FALLOFF[6].r = 6000
			end
			unitweapon.FALLOFF[6].acc = {0.05, 0.15}
		end
	end
end

Hooks:PostHook(CharacterTweakData, "_set_normal", "sydchSO", function(self)
	if sydchSO.settings.streamLINED == 2 then
		self.tank.weapon.is_rifle.focus_delay = 5
		self.tank.weapon.is_rifle.FALLOFF[1].dmg_mul = 0.3 
		self.tank.weapon.is_rifle.FALLOFF[2].dmg_mul = 0.3 
		self.tank.weapon.is_rifle.FALLOFF[3].dmg_mul = 0.2 
		self.tank.weapon.is_rifle.FALLOFF[4].dmg_mul = 0.15
		self.tank.weapon.is_rifle.FALLOFF[5].dmg_mul = 0.1 
	end
	apply_acc(self.tank.weapon.is_rifle, "dozer")
end)

Hooks:PostHook(CharacterTweakData, "_set_hard", "sydchSO", function(self)
	if sydchSO.settings.streamLINED == 2 then
		self.tank.weapon.is_rifle.focus_delay = 4
		self.tank.weapon.is_rifle.FALLOFF[1].dmg_mul = 0.75
		self.tank.weapon.is_rifle.FALLOFF[2].dmg_mul = 0.75
		self.tank.weapon.is_rifle.FALLOFF[3].dmg_mul = 0.5 
		self.tank.weapon.is_rifle.FALLOFF[4].dmg_mul = 0.35
		self.tank.weapon.is_rifle.FALLOFF[5].dmg_mul = 0.25
	end
	apply_acc(self.tank.weapon.is_rifle, "dozer")
end)

Hooks:PostHook(CharacterTweakData, "_set_overkill", "sydchSO", function(self)
	if sydchSO.settings.streamLINED == 2 then
		self.tank.weapon.is_rifle.focus_delay = 3
		self.tank.weapon.is_rifle.FALLOFF[1].dmg_mul = 1.5 
		self.tank.weapon.is_rifle.FALLOFF[2].dmg_mul = 1.5 
		self.tank.weapon.is_rifle.FALLOFF[3].dmg_mul = 1.0 
		self.tank.weapon.is_rifle.FALLOFF[4].dmg_mul = 0.75
		self.tank.weapon.is_rifle.FALLOFF[5].dmg_mul = 0.5 
	end
	apply_acc(self.tank.weapon.is_rifle, "dozer")
end)

Hooks:PostHook(CharacterTweakData, "_set_overkill_145", "sydchSO", function(self)
	if sydchSO.settings.streamLINED == 3 then
		self.gangster.HEALTH_INIT = 10.0
		self.gangster.headshot_dmg_mul = 2
		self.biker.HEALTH_INIT = 10.0
		self.biker.headshot_dmg_mul = 2
		self.captain.HEALTH_INIT = 10.0
		self.captain.headshot_dmg_mul = 2
		self.biker_escape.HEALTH_INIT = 10.0
		self.biker_escape.headshot_dmg_mul = 2
		self.mobster.HEALTH_INIT = 10.0
		self.mobster.headshot_dmg_mul = 2
		self.bolivian.HEALTH_INIT = 10.0
		self.bolivian.headshot_dmg_mul = 2
		self.bolivian_indoors.HEALTH_INIT = 10.0
		self.bolivian_indoors.headshot_dmg_mul = 2
		self.security.HEALTH_INIT = 10.0
		self.security.headshot_dmg_mul = 2
		self.security_undominatable.HEALTH_INIT = 10.0
		self.security_undominatable.headshot_dmg_mul = 2
		self.mute_security_undominatable.HEALTH_INIT = 10.0
		self.mute_security_undominatable.headshot_dmg_mul = 2
		self.gensec.HEALTH_INIT = 11.0
		self.gensec.headshot_dmg_mul = 2
		self.cop.HEALTH_INIT = 10.0
		self.cop.headshot_dmg_mul = 2
		self.cop_scared.HEALTH_INIT = 10.0
		self.cop_scared.headshot_dmg_mul = 2
		self.cop_female.HEALTH_INIT = 10.0
		self.cop_female.headshot_dmg_mul = 2
		self.fbi.HEALTH_INIT = 11.0
		self.fbi.headshot_dmg_mul = 2
		self.swat.HEALTH_INIT = 13.5
		self.swat.headshot_dmg_mul = 3
		self.fbi_swat.HEALTH_INIT = 15.0
		self.fbi_swat.headshot_dmg_mul = 3.0
		self.city_swat.HEALTH_INIT = 16.5
		self.city_swat.headshot_dmg_mul = 3.0
		self.heavy_swat.HEALTH_INIT = 17.5
		self.heavy_swat.headshot_dmg_mul = 2.5
		self.fbi_heavy_swat.HEALTH_INIT = 20.0
		self.fbi_heavy_swat.headshot_dmg_mul = 2.0
		self.fbi_heavy_swat.damage.hurt_severity = heavy_swat_hurts
		self.shield.HEALTH_INIT = 10.0
		self.shield.headshot_dmg_mul = 2
		self.sniper.HEALTH_INIT = 5.0
		self.sniper.headshot_dmg_mul = 2
		self.taser.HEALTH_INIT = 31.0
		self.taser.headshot_dmg_mul = 2
		self.medic.HEALTH_INIT = 31.0
		self.medic.headshot_dmg_mul = 2
		self.spooc.HEALTH_INIT = 36.0
		self.spooc.headshot_dmg_mul = 4
		self.tank.HEALTH_INIT = 900.0
		self.tank.headshot_dmg_mul = 25
		self.tank.critical_hits = {damage_mul = 3}
		self.tank_medic.HEALTH_INIT = 900.0
		self.tank_medic.headshot_dmg_mul = 25
		self.tank_medic.critical_hits = {damage_mul = 3}
		self.tank_mini.HEALTH_INIT = 900.0 * 1.25
		self.tank_mini.headshot_dmg_mul = 25
		self.tank_mini.critical_hits = {damage_mul = 3}

		self.phalanx_minion.HEALTH_INIT = 40.0
		self.phalanx_minion.headshot_dmg_mul = 2
		self.phalanx_minion.DAMAGE_CLAMP_BULLET = 100.0
		self.phalanx_minion.DAMAGE_CLAMP_EXPLOSION = 100.0
		self.phalanx_vip.HEALTH_INIT = 120.0
		self.phalanx_vip.headshot_dmg_mul = 2
		self.phalanx_vip.DAMAGE_CLAMP_BULLET = 200.0
		self.phalanx_vip.DAMAGE_CLAMP_EXPLOSION = 200.0

		self.mobster_boss.HEALTH_INIT = 271
		self.mobster_boss.headshot_dmg_mul = 2
		self.biker_boss.HEALTH_INIT = 271
		self.biker_boss.headshot_dmg_mul = 2
		self.chavez_boss.HEALTH_INIT = 271
		self.chavez_boss.headshot_dmg_mul = 2
		self.hector_boss.HEALTH_INIT = 271
		self.hector_boss.headshot_dmg_mul = 2
		self.drug_lord_boss.HEALTH_INIT = 271
		self.drug_lord_boss.headshot_dmg_mul = 2
		self.piggydozer.HEALTH_INIT = 271
		self.snowman_boss.HEALTH_INIT = 271
	end

	if sydchSO.settings.streamLINED == 2 then
		self.swat.weapon.is_smg.FALLOFF[1].dmg_mul = 2.5 
		self.swat.weapon.is_smg.FALLOFF[2].dmg_mul = 2.5 
		self.swat.weapon.is_smg.FALLOFF[3].dmg_mul = 2.0 
		self.swat.weapon.is_smg.FALLOFF[4].dmg_mul = 1.5 
		self.swat.weapon.is_smg.FALLOFF[5].dmg_mul = 1.0 

		self.tank.weapon.is_rifle.focus_delay = 2
		self.tank.weapon.is_rifle.FALLOFF[1].dmg_mul = 2.0 
		self.tank.weapon.is_rifle.FALLOFF[2].dmg_mul = 2.0 
		self.tank.weapon.is_rifle.FALLOFF[3].dmg_mul = 1.5 
		self.tank.weapon.is_rifle.FALLOFF[4].dmg_mul = 1.0 
		self.tank.weapon.is_rifle.FALLOFF[5].dmg_mul = 0.5 
	end

	apply_acc(self.shield.weapon.is_smg, "shield")
	apply_acc(self.shield.weapon.is_pistol, "shield")
	apply_acc(self.tank.weapon.is_rifle, "dozer")
end)

Hooks:PostHook(CharacterTweakData, "_set_easy_wish", "sydchSO", function(self)
	if sydchSO.settings.streamLINED == 3 then
		self.gangster.HEALTH_INIT = 10.0
		self.gangster.headshot_dmg_mul = 2
		self.biker.HEALTH_INIT = 10.0
		self.biker.headshot_dmg_mul = 2
		self.captain.HEALTH_INIT = 10.0
		self.captain.headshot_dmg_mul = 2
		self.biker_escape.HEALTH_INIT = 10.0
		self.biker_escape.headshot_dmg_mul = 2
		self.mobster.HEALTH_INIT = 10.0
		self.mobster.headshot_dmg_mul = 2
		self.bolivian.HEALTH_INIT = 10.0
		self.bolivian.headshot_dmg_mul = 2
		self.bolivian_indoors.HEALTH_INIT = 10.0
		self.bolivian_indoors.headshot_dmg_mul = 2
		self.security.HEALTH_INIT = 10.0
		self.security.headshot_dmg_mul = 2
		self.security_undominatable.HEALTH_INIT = 10.0
		self.security_undominatable.headshot_dmg_mul = 2
		self.mute_security_undominatable.HEALTH_INIT = 10.0
		self.mute_security_undominatable.headshot_dmg_mul = 2
		self.gensec.HEALTH_INIT = 11.0
		self.gensec.headshot_dmg_mul = 2
		self.cop.HEALTH_INIT = 10.0
		self.cop.headshot_dmg_mul = 2
		self.cop_scared.HEALTH_INIT = 10.0
		self.cop_scared.headshot_dmg_mul = 2
		self.cop_female.HEALTH_INIT = 10.0
		self.cop_female.headshot_dmg_mul = 2
		self.fbi.HEALTH_INIT = 11.0
		self.fbi.headshot_dmg_mul = 2
		self.swat.HEALTH_INIT = 15.0
		self.swat.headshot_dmg_mul = 2
		self.fbi_swat.HEALTH_INIT = 16.0
		self.fbi_swat.headshot_dmg_mul = 2
		self.city_swat.HEALTH_INIT = 20.0
		self.city_swat.headshot_dmg_mul = 2.5
		self.city_swat.damage.hurt_severity = city_swat_hurts
		self.heavy_swat.HEALTH_INIT = 24.0
		self.heavy_swat.headshot_dmg_mul = 2
		self.fbi_heavy_swat.HEALTH_INIT = 27.0
		self.fbi_heavy_swat.headshot_dmg_mul = 1.8
		self.fbi_heavy_swat.damage.hurt_severity = heavy_swat_hurts
		self.shield.HEALTH_INIT = 11.0
		self.shield.headshot_dmg_mul = 2
		self.sniper.HEALTH_INIT = 7.0
		self.sniper.headshot_dmg_mul = 2
		self.taser.HEALTH_INIT = 38.5
		self.taser.headshot_dmg_mul = 1.75
		self.medic.HEALTH_INIT = 38.5
		self.medic.headshot_dmg_mul = 1.75
		self.spooc.HEALTH_INIT = 56.0
		self.spooc.headshot_dmg_mul = 4
		self.tank.HEALTH_INIT = 1000.0
		self.tank.headshot_dmg_mul = 20
		self.tank.critical_hits = {damage_mul = 3}
		self.tank_medic.HEALTH_INIT = 1000.0
		self.tank_medic.headshot_dmg_mul = 20
		self.tank_medic.critical_hits = {damage_mul = 3}
		self.tank_mini.HEALTH_INIT = 1000.0 * 1.25
		self.tank_mini.headshot_dmg_mul = 20
		self.tank_mini.critical_hits = {damage_mul = 3}

		self.phalanx_minion.HEALTH_INIT = 50.0
		self.phalanx_minion.headshot_dmg_mul = 2
		self.phalanx_minion.damage.explosion_damage_mul = 0.2
		self.phalanx_minion.DAMAGE_CLAMP_BULLET = 100.0
		self.phalanx_minion.DAMAGE_CLAMP_EXPLOSION = 100.0
		self.phalanx_vip.HEALTH_INIT = 150.0
		self.phalanx_vip.headshot_dmg_mul = 2
		self.phalanx_vip.damage.explosion_damage_mul = 0.2
		self.phalanx_vip.DAMAGE_CLAMP_BULLET = 200.0
		self.phalanx_vip.DAMAGE_CLAMP_EXPLOSION = 200.0

		self.mobster_boss.HEALTH_INIT = 500.0
		self.mobster_boss.headshot_dmg_mul = 2
		self.biker_boss.HEALTH_INIT = 500.0
		self.biker_boss.headshot_dmg_mul = 2
		self.chavez_boss.HEALTH_INIT = 500.0
		self.chavez_boss.headshot_dmg_mul = 2
		self.hector_boss.HEALTH_INIT = 500.0
		self.hector_boss.headshot_dmg_mul = 2
		self.drug_lord_boss.HEALTH_INIT = 500.0
		self.drug_lord_boss.headshot_dmg_mul = 2
	end

	if sydchSO.settings.streamLINED == 2 then
		self.swat.weapon.is_smg.FALLOFF[1].dmg_mul = 2.5 
		self.swat.weapon.is_smg.FALLOFF[2].dmg_mul = 2.5 
		self.swat.weapon.is_smg.FALLOFF[3].dmg_mul = 2.0 
		self.swat.weapon.is_smg.FALLOFF[4].dmg_mul = 1.5 
		self.swat.weapon.is_smg.FALLOFF[5].dmg_mul = 1.0 


		self.tank.weapon.is_shotgun_mag.focus_delay = 2
		self.tank.weapon.is_shotgun_mag.FALLOFF[1].dmg_mul = 3.0 
		self.tank.weapon.is_shotgun_mag.FALLOFF[2].dmg_mul = 3.0 
		self.tank.weapon.is_shotgun_mag.FALLOFF[3].dmg_mul = 2.5 
		self.tank.weapon.is_shotgun_mag.FALLOFF[4].dmg_mul = 2.0 
		self.tank.weapon.is_shotgun_mag.FALLOFF[5].dmg_mul = 1.5 
		self.tank.weapon.is_shotgun_mag.FALLOFF[6] = deep_clone(self.tank.weapon.is_shotgun_mag.FALLOFF[5])
		self.tank.weapon.is_shotgun_mag.FALLOFF[6].dmg_mul = 1.0
		self.tank.weapon.is_shotgun_mag.FALLOFF[6].r = 6000
		
		self.tank.weapon.is_rifle.focus_delay = 2
		self.tank.weapon.is_rifle.FALLOFF[1].dmg_mul = 2.5
		self.tank.weapon.is_rifle.FALLOFF[2].dmg_mul = 2.5
		self.tank.weapon.is_rifle.FALLOFF[3].dmg_mul = 2.0
		self.tank.weapon.is_rifle.FALLOFF[4].dmg_mul = 1.5
		self.tank.weapon.is_rifle.FALLOFF[5].dmg_mul = 1.0
	end

	apply_acc(self.shield.weapon.is_smg, "shield")
	apply_acc(self.shield.weapon.is_pistol, "shield")
	apply_acc(self.tank.weapon.is_shotgun_mag, "dozer")
	apply_acc(self.tank.weapon.is_rifle, "dozer")
end)

Hooks:PostHook(CharacterTweakData, "_set_overkill_290", "sydchSO", function(self)
	if sydchSO.settings.streamLINED == 3 then
		self.gangster.HEALTH_INIT = 10.0
		self.gangster.headshot_dmg_mul = 2
		self.biker.HEALTH_INIT = 10.0
		self.biker.headshot_dmg_mul = 2
		self.captain.HEALTH_INIT = 10.0
		self.captain.headshot_dmg_mul = 2
		self.biker_escape.HEALTH_INIT = 10.0
		self.biker_escape.headshot_dmg_mul = 2
		self.mobster.HEALTH_INIT = 10.0
		self.mobster.headshot_dmg_mul = 2
		self.bolivian.HEALTH_INIT = 10.0
		self.bolivian.headshot_dmg_mul = 2
		self.bolivian_indoors.HEALTH_INIT = 10.0
		self.bolivian_indoors.headshot_dmg_mul = 2
		self.security.HEALTH_INIT = 10.0
		self.security.headshot_dmg_mul = 2
		self.security_undominatable.HEALTH_INIT = 10.0
		self.security_undominatable.headshot_dmg_mul = 2
		self.mute_security_undominatable.HEALTH_INIT = 10.0
		self.mute_security_undominatable.headshot_dmg_mul = 2
		self.gensec.HEALTH_INIT = 11.0
		self.gensec.headshot_dmg_mul = 2
		self.cop.HEALTH_INIT = 10.0
		self.cop.headshot_dmg_mul = 2
		self.cop_scared.HEALTH_INIT = 10.0
		self.cop_scared.headshot_dmg_mul = 2
		self.cop_female.HEALTH_INIT = 10.0
		self.cop_female.headshot_dmg_mul = 2
		self.fbi.HEALTH_INIT = 11.0
		self.fbi.headshot_dmg_mul = 2
		self.swat.HEALTH_INIT = 20.0
		self.swat.headshot_dmg_mul = 2
		self.fbi_swat.HEALTH_INIT = 21.0
		self.fbi_swat.headshot_dmg_mul = 2
		self.city_swat.HEALTH_INIT = 22.0
		self.city_swat.headshot_dmg_mul = 2
		self.city_swat.damage.hurt_severity = city_swat_hurts
		self.heavy_swat.HEALTH_INIT = 27.0
		self.heavy_swat.headshot_dmg_mul = 1.80
		self.fbi_heavy_swat.HEALTH_INIT = 39.0
		self.fbi_heavy_swat.headshot_dmg_mul = 2.00
		self.fbi_heavy_swat.damage.hurt_severity = heavy_swat_hurts

		self.shield.HEALTH_INIT = 14.0
		self.shield.headshot_dmg_mul = 1.75
		self.sniper.HEALTH_INIT = 10.0
		self.sniper.headshot_dmg_mul = 2
		self.taser.HEALTH_INIT = 45.5
		self.taser.headshot_dmg_mul = 1.75
		self.medic.HEALTH_INIT = 45.0
		self.medic.headshot_dmg_mul = 1.75
		self.spooc.HEALTH_INIT = 60.0
		self.spooc.headshot_dmg_mul = 4
		self.tank.HEALTH_INIT = 1125.0
		self.tank.headshot_dmg_mul = 15
		self.tank.critical_hits = {damage_mul = 3}
		self.tank_medic.HEALTH_INIT = 1125.0
		self.tank_medic.headshot_dmg_mul = 15
		self.tank_medic.critical_hits = {damage_mul = 3}
		self.tank_mini.HEALTH_INIT = 1125.0 * 1.25
		self.tank_mini.headshot_dmg_mul = 15
		self.tank_mini.critical_hits = {damage_mul = 3}

		self.phalanx_minion.HEALTH_INIT = 70.0
		self.phalanx_minion.headshot_dmg_mul = 2
		self.phalanx_minion.damage.explosion_damage_mul = 0.2
		self.phalanx_minion.DAMAGE_CLAMP_BULLET = 100.0
		self.phalanx_minion.DAMAGE_CLAMP_EXPLOSION = 100.0
		self.phalanx_vip.HEALTH_INIT = 225.0
		self.phalanx_vip.headshot_dmg_mul = 2
		self.phalanx_vip.damage.explosion_damage_mul = 0.2
		self.phalanx_vip.DAMAGE_CLAMP_BULLET = 200.0
		self.phalanx_vip.DAMAGE_CLAMP_EXPLOSION = 200.0

		self.mobster_boss.HEALTH_INIT = 700.0
		self.mobster_boss.headshot_dmg_mul = 2
		self.biker_boss.HEALTH_INIT = 700.0
		self.biker_boss.headshot_dmg_mul = 2
		self.chavez_boss.HEALTH_INIT = 700.0
		self.chavez_boss.headshot_dmg_mul = 2
		self.hector_boss.HEALTH_INIT = 700.0
		self.hector_boss.headshot_dmg_mul = 2
		self.drug_lord_boss.HEALTH_INIT = 700.0
		self.drug_lord_boss.headshot_dmg_mul = 2
	end

	if sydchSO.settings.streamLINED == 2 then
		self.swat.weapon.is_smg.FALLOFF[1].dmg_mul = 4.0
		self.swat.weapon.is_smg.FALLOFF[2].dmg_mul = 4.0
		self.swat.weapon.is_smg.FALLOFF[3].dmg_mul = 3.0
		self.swat.weapon.is_smg.FALLOFF[4].dmg_mul = 2.0
		self.swat.weapon.is_smg.FALLOFF[5].dmg_mul = 1.0
		self.fbi_swat.weapon.is_rifle = deep_clone(self.city_swat.weapon.is_rifle)
		self.city_swat.weapon.is_smg = deep_clone(self.swat.weapon.is_smg)

		self.heavy_swat.weapon.is_rifle.focus_delay = 2
		self.heavy_swat.weapon.is_rifle.FALLOFF[1].dmg_mul = 6.0 
		self.heavy_swat.weapon.is_rifle.FALLOFF[2].dmg_mul = 6.0 
		self.heavy_swat.weapon.is_rifle.FALLOFF[3].dmg_mul = 5.5 
		self.heavy_swat.weapon.is_rifle.FALLOFF[4].dmg_mul = 5.0 
		self.heavy_swat.weapon.is_rifle.FALLOFF[5].dmg_mul = 4.0 
		self.heavy_swat.weapon.is_rifle.FALLOFF[6].dmg_mul = 3.0 

		self.fbi_heavy_swat.weapon.is_rifle.focus_delay = 2
		self.fbi_heavy_swat.weapon.is_rifle.FALLOFF[1].dmg_mul = 6.0 
		self.fbi_heavy_swat.weapon.is_rifle.FALLOFF[2].dmg_mul = 6.0 
		self.fbi_heavy_swat.weapon.is_rifle.FALLOFF[3].dmg_mul = 5.0 
		self.fbi_heavy_swat.weapon.is_rifle.FALLOFF[4].dmg_mul = 4.0 
		self.fbi_heavy_swat.weapon.is_rifle.FALLOFF[5].dmg_mul = 3.0 

		self.shield.weapon.is_smg.focus_delay = 2
		self.shield.weapon.is_smg.FALLOFF[1].dmg_mul = 5.0 
		self.shield.weapon.is_smg.FALLOFF[2].dmg_mul = 5.0 
		self.shield.weapon.is_smg.FALLOFF[3].dmg_mul = 4.0 
		self.shield.weapon.is_smg.FALLOFF[4].dmg_mul = 3.0 
		self.shield.weapon.is_smg.FALLOFF[5].dmg_mul = 1.5 

		self.shield.weapon.is_pistol.focus_delay = 2
		self.shield.weapon.is_pistol.FALLOFF[1].dmg_mul = 5.0 
		self.shield.weapon.is_pistol.FALLOFF[2].dmg_mul = 5.0 
		self.shield.weapon.is_pistol.FALLOFF[3].dmg_mul = 4.0 
		self.shield.weapon.is_pistol.FALLOFF[4].dmg_mul = 3.0 
		self.shield.weapon.is_pistol.FALLOFF[5].dmg_mul = 1.5 

		self.taser.weapon.is_rifle.focus_delay = 2
		self.taser.weapon.is_rifle.FALLOFF[1].dmg_mul = 7.0 
		self.taser.weapon.is_rifle.FALLOFF[2].dmg_mul = 7.0 
		self.taser.weapon.is_rifle.FALLOFF[3].dmg_mul = 6.0 
		self.taser.weapon.is_rifle.FALLOFF[4].dmg_mul = 5.0 
		self.taser.weapon.is_rifle.FALLOFF[5].dmg_mul = 4.0 

		self.tank.weapon.is_shotgun_mag.focus_delay = 2
		self.tank.weapon.is_shotgun_mag.FALLOFF[1].dmg_mul = 5.0
		self.tank.weapon.is_shotgun_mag.FALLOFF[2].dmg_mul = 5.0
		self.tank.weapon.is_shotgun_mag.FALLOFF[3].dmg_mul = 4.5
		self.tank.weapon.is_shotgun_mag.FALLOFF[4].dmg_mul = 4.0
		self.tank.weapon.is_shotgun_mag.FALLOFF[5].dmg_mul = 2.5
		self.tank.weapon.is_shotgun_mag.FALLOFF[6] = deep_clone(self.tank.weapon.is_shotgun_mag.FALLOFF[5])
		self.tank.weapon.is_shotgun_mag.FALLOFF[6].dmg_mul = 1.5
		self.tank.weapon.is_shotgun_mag.FALLOFF[6].r = 6000

		self.tank.weapon.is_rifle.focus_delay = 2
		self.tank.weapon.is_rifle.FALLOFF[1].dmg_mul = 5.0 
		self.tank.weapon.is_rifle.FALLOFF[2].dmg_mul = 5.0 
		self.tank.weapon.is_rifle.FALLOFF[3].dmg_mul = 4.0 
		self.tank.weapon.is_rifle.FALLOFF[4].dmg_mul = 3.0 
		self.tank.weapon.is_rifle.FALLOFF[5].dmg_mul = 1.5 

		self.tank_mini.weapon.mini.FALLOFF[1].dmg_mul = 5.0 
		self.tank_mini.weapon.mini.FALLOFF[2].dmg_mul = 5.0 
		self.tank_mini.weapon.mini.FALLOFF[3].dmg_mul = 4.0 
		self.tank_mini.weapon.mini.FALLOFF[4].dmg_mul = 3.0 
		self.tank_mini.weapon.mini.FALLOFF[5].dmg_mul = 1.5 
	end

	apply_acc(self.swat.weapon.is_smg, "standard")
	apply_acc(self.heavy_swat.weapon.is_rifle, "standard")
	apply_acc(self.fbi_heavy_swat.weapon.is_rifle, "standard")
	apply_acc(self.shield.weapon.is_smg, "shield")
	apply_acc(self.shield.weapon.is_pistol, "shield")
	apply_acc(self.taser.weapon.is_rifle, "standard")
	apply_acc(self.tank.weapon.is_shotgun_mag, "dozer")
	apply_acc(self.tank.weapon.is_rifle, "dozer")
end)

Hooks:PostHook(CharacterTweakData, "_set_sm_wish", "sydchSO", function(self)
	if sydchSO.settings.streamLINED == 2 then
		self:_multiply_all_speeds(1/4.05, 1/4.1)
		self:_multiply_weapon_delay(self.presets.weapon.sniper, 1/3)
		self:_set_overkill_290()
	end
end)

if sydchSO.settings.streamLINED == 3 then
	Hooks:PostHook(CharacterTweakData, "_init_fbi_heavy_swat", "inf_chartweak_init_tan_bodyarmor", function(self)
		self.fbi_heavy_swat.body_armor_dmg_penalty = 0.9
		self.fbi_heavy_swat.headgear_dmg_penalty = 0.75
		self.fbi_heavy_swat.headgear_flyoff_chance = 0.35
	end)
end