local data = InteractionTweakData.init
function InteractionTweakData:init(tweak_data)
    data(self, tweak_data)
	self.first_aid_kit = {
		icon = "equipment_first_aid_kit",
		text_id = "debug_interact_doctor_bag_heal",
		contour = "deployable",
		timer = 1,
		blocked_hint = "full_health",
		sound_start = "bar_helpup",
		sound_interupt = "bar_helpup_cancel",
		sound_done = "bar_helpup_finished",
		action_text_id = "hud_action_healing",
		upgrade_timer_multipliers = {
			{
				upgrade = "interaction_speed_multiplier",
				category = "doctor_bag"
			},
			{
				upgrade = "deploy_interact_faster",
				category = "player"
			}
		}
	}
	self.grenade_briefcase.requires_mask_off_upgrade = {
			category = "player",
			upgrade = "mask_off_pickup"
		}
	self.gen_pku_thermite.requires_mask_off_upgrade = {
			category = "player",
			upgrade = "mask_off_pickup"
		}
	self.gen_pku_thermite_paste.requires_mask_off_upgrade = {
			category = "player",
			upgrade = "mask_off_pickup"
		}
	self.gen_pku_thermite_paste_not_deployable.requires_mask_off_upgrade = {
			category = "player",
			upgrade = "mask_off_pickup"
		}
	self.ecm_jammer.timer = 3
	self.requires_ecm_jammer_atm.timer = 6
	self.requires_ecm_jammer_double = {
		icon = "equipment_ecm_jammer",
		contour = "interactable_icon",
		text_id = "hud_int_use_ecm_jammer",
		required_deployable = "ecm_jammer",
		deployable_consume = true,
		timer = 2,
		sound_start = "bar_c4_apply",
		sound_interupt = "bar_c4_apply_cancel",
		sound_done = "bar_c4_apply_finished",
		action_text_id = "hud_action_placing_ecm_jammer",
		upgrade_timer_multiplier = {
			upgrade = "equipment_hack_speed_multiplier",
			category = "player"
		},
		requires_upgrade = {
			upgrade = "can_open_sec_doors",
			category = "ecm_jammer"
		}
	}
	self.bodybags_bag = {
		icon = "equipment_ammo_bag",
		text_id = "debug_interact_bodybags_bag_take_bodybag",
		contour = "deployable",
		timer = 1,
		blocked_hint = "full_bodybags",
		sound_start = "bar_bag_generic",
		sound_interupt = "bar_bag_generic_cancel",
		sound_done = "bar_bag_generic_finished",
		action_text_id = "hud_action_grabbing_bag"
	}
-----------------------------------------------------------
-- ENGINEER INTERACTION TWEAKS --
-----------------------------------------------------------
	self.c4 = {
		icon = "equipment_c4",
		text_id = "debug_interact_c4",
		timer = 2,
		sound_start = "bar_c4_apply",
		sound_interupt = "bar_c4_apply_cancel",
		sound_done = "bar_c4_apply_finished",
		upgrade_timer_multiplier = {
			upgrade = "trip_mine_deploy_time_multiplier",
			category = "player"
		},					
		action_text_id = "hud_action_placing_c4"
	}	
	self.c4_mission_door = deep_clone(self.c4)
	self.c4_mission_door.special_equipment = "c4"
	self.c4_mission_door.equipment_text_id = "debug_interact_equipment_c4"
	self.c4_mission_door.equipment_consume = true		
	self.c4_special = {
		icon = "equipment_c4",
		text_id = "debug_interact_c4",
		equipment_text_id = "debug_interact_equipment_c4",
		equipment_consume = true,
		timer = 2,
		sound_start = "bar_c4_apply",
		sound_interupt = "bar_c4_apply_cancel",
		sound_done = "bar_c4_apply_finished",
		axis = "z",
		upgrade_timer_multiplier = {
			upgrade = "trip_mine_deploy_time_multiplier",
			category = "player"
		},			
		action_text_id = "hud_action_placing_c4"
	}
	self.c4_bag = {
		text_id = "debug_interact_c4_bag",
		timer = 4,
		contour = "interactable",
		axis = "z",
		sound_start = "bar_bag_generic",
		sound_interupt = "bar_bag_generic_cancel",
		upgrade_timer_multiplier = {
			upgrade = "trip_mine_deploy_time_multiplier",
			category = "player"
		},			
		sound_done = "bar_bag_generic_finished"
	}
	self.c4_x1_bag = {
		text_id = "debug_interact_c4_bag",
		timer = 4,
		contour = "interactable",
		sound_start = "bar_bag_generic",
		sound_interupt = "bar_bag_generic_cancel",
		upgrade_timer_multiplier = {
			upgrade = "trip_mine_deploy_time_multiplier",
			category = "player"
		},					
		sound_done = "bar_bag_generic_finished"
	}		
	self.shape_charge_plantable = {
		text_id = "debug_interact_c4",
		action_text_id = "hud_action_placing_c4",
		equipment_text_id = "debug_interact_equipment_c4",
		special_equipment = "c4",
		equipment_consume = true,
		axis = "z",
		timer = 2,
		sound_start = "bar_c4_apply",
		sound_interupt = "bar_c4_apply_cancel",
		upgrade_timer_multiplier = {
			upgrade = "trip_mine_deploy_time_multiplier",
			category = "player"
		},			
		sound_done = "bar_c4_apply_finished"
	}		
	self.shape_charge_plantable_c4_1 = deep_clone(self.shape_charge_plantable)
	self.shape_charge_plantable_c4_1.special_equipment = "c4_1"
	self.shape_charge_plantable_c4_x1 = deep_clone(self.shape_charge_plantable)
	self.shape_charge_plantable_c4_x1.special_equipment = "c4_x1"
	self.shape_charge_plantable_c4_x1.interact_distance = 500	
	self.c4_x10 = deep_clone(self.c4_mission_door)
	self.c4_x10.special_equipment = "c4_x10"
	self.c4_x10.axis = "z"	
	self.c4_consume = deep_clone(self.c4_special)
	self.c4_consume.special_equipment = "c4"
	self.c4_consume.equipment_consume = true	
	self.c4_consume_x1 = deep_clone(self.c4_special)
	self.c4_consume_x1.special_equipment = "c4_x1"
	self.c4_consume_x1.equipment_consume = true		
	self.c4_consume_x3 = deep_clone(self.c4_special)
	self.c4_consume_x3.special_equipment = "c4_x3"
	self.c4_consume_x3.equipment_consume = true
	self.disarm_bomb = {
		text_id = "hud_int_hold_disarm_bomb",
		action_text_id = "hud_action_disarm_bomb",
		start_active = false,
		timer = 2.5,
		sound_start = "bar_disarm_c4_loop_start",
		sound_interupt = "bar_disarm_c4_loop_cancel",
		upgrade_timer_multiplier = {
			upgrade = "trip_mine_deploy_time_multiplier",
			category = "player"
		},
		sound_done = "bar_disarm_c4_loop_finished"
	}
	self.fex_hold_assemble_bomb = {
		text_id = "hud_hold_assemble_bomb",
		action_text_id = "hud_action_assembling_bomb",
		sound_start = "bar_assemble_fertbomb_loop_start",
		sound_interupt = "bar_assemble_fertbomb_loop_cancel",
		sound_done = "bar_assemble_fertbomb_loop_finished",
		interact_distance = 200,
		timer = 5,
		upgrade_timer_multiplier = {
			upgrade = "trip_mine_deploy_time_multiplier",
			category = "player"
		},
		start_active = false
	}
	self.c4_stackable.upgrade_timer_multiplier = {
		upgrade = "trip_mine_deploy_time_multiplier",
		category = "player"
	}
-----------------------------------------------------------
-- HACKER INTERACTION TWEAKS --
-----------------------------------------------------------
	self.hack_ipad = {
		icon = "equipment_hack_ipad",
		text_id = "debug_interact_hack_ipad",
		timer = 3,
		sound_start = "bar_drill_apply",
		sound_interupt = "bar_drill_apply_cancel",
		sound_done = "bar_drill_apply_finished",
		upgrade_timer_multiplier = {
			upgrade = "equipment_hack_speed_multiplier",
			category = "player"
		},
		axis = "x"
	}
	self.hack_ipad_jammed = {
		icon = "equipment_hack_ipad",
		text_id = "debug_interact_hack_ipad_jammed",
		timer = 10,
		sound_start = "bar_drill_fix",
		sound_interupt = "bar_drill_fix_cancel",
		upgrade_timer_multiplier = {
			upgrade = "equipment_hack_speed_multiplier",
			category = "player"
		},
		sound_done = "bar_drill_fix_finished"
	}
	self.hack_suburbia = {
		icon = "equipment_hack_ipad",
		text_id = "debug_interact_hack_ipad",
		timer = 5,
		sound_start = "bar_keyboard",
		sound_interupt = "bar_keyboard_cancel",
		sound_done = "bar_keyboard_finished",
		axis = "y",
		upgrade_timer_multiplier = {
			upgrade = "equipment_hack_speed_multiplier",
			category = "player"
		},
		contour = "contour_off"
	}
	self.hack_suburbia_outline = {
		icon = "equipment_hack_ipad",
		text_id = "debug_interact_hack_ipad",
		timer = 5,
		sound_start = "bar_keyboard",
		sound_interupt = "bar_keyboard_cancel",
		sound_done = "bar_keyboard_finished",
		upgrade_timer_multiplier = {
			upgrade = "equipment_hack_speed_multiplier",
			category = "player"
		},
		axis = "y"
	}
	self.hack_suburbia_jammed = {
		icon = "equipment_hack_ipad",
		text_id = "debug_interact_hack_ipad_jammed",
		timer = 5,
		sound_start = "bar_keyboard",
		sound_interupt = "bar_keyboard_cancel",
		upgrade_timer_multiplier = {
			upgrade = "equipment_hack_speed_multiplier",
			category = "player"
		},
		sound_done = "bar_keyboard_finished"
	}
	self.security_station = {
		icon = "equipment_hack_ipad",
		text_id = "debug_interact_security_station",
		timer = 3,
		sound_start = "bar_drill_apply",
		sound_interupt = "bar_drill_apply_cancel",
		sound_done = "bar_drill_apply_finished",
		axis = "z",
		start_active = false,
		sound_start = "bar_keyboard",
		sound_interupt = "bar_keyboard_cancel",
		upgrade_timer_multiplier = {
			upgrade = "equipment_hack_speed_multiplier",
			category = "player"
		},
		sound_done = "bar_keyboard_finished"
	}
	self.security_station_keyboard = {
		icon = "interaction_keyboard",
		text_id = "debug_interact_security_station",
		timer = 6,
		axis = "z",
		start_active = false,
		interact_distance = 150,
		sound_start = "bar_keyboard",
		sound_interupt = "bar_keyboard_cancel",
		upgrade_timer_multiplier = {
			upgrade = "equipment_hack_speed_multiplier",
			category = "player"
		},
		sound_done = "bar_keyboard_finished"
	}
	self.big_computer_hackable = {
		icon = "interaction_keyboard",
		text_id = "hud_int_big_computer_hackable",
		timer = 6,
		start_active = false,
		interact_distance = 200,
		sound_start = "bar_keyboard",
		sound_interupt = "bar_keyboard_cancel",
		upgrade_timer_multiplier = {
			upgrade = "equipment_hack_speed_multiplier",
			category = "player"
		},
		sound_done = "bar_keyboard_finished"
	}
	self.big_computer_hackable_axis = {
		icon = "interaction_keyboard",
		text_id = "hud_int_big_computer_hackable",
		timer = 6,
		axis = "z",
		start_active = false,
		interact_distance = 200,
		sound_start = "bar_keyboard",
		sound_interupt = "bar_keyboard_cancel",
		upgrade_timer_multiplier = {
			upgrade = "equipment_hack_speed_multiplier",
			category = "player"
		},
		sound_done = "bar_keyboard_finished"
	}
	self.big_computer_not_hackable = {
		icon = "interaction_keyboard",
		text_id = "hud_int_big_computer_hackable",
		timer = 6,
		start_active = false,
		interact_distance = 200,
		sound_start = "bar_keyboard",
		sound_interupt = "bar_keyboard_cancel",
		sound_done = "bar_keyboard_finished",
		equipment_text_id = "hud_int_big_computer_unhackable",
		upgrade_timer_multiplier = {
			upgrade = "equipment_hack_speed_multiplier",
			category = "player"
		},
		special_equipment = "nothing"
	}
	self.security_station_jammed = {
		icon = "interaction_keyboard",
		text_id = "debug_interact_security_station_jammed",
		timer = 10,
		sound_start = "bar_drill_fix",
		sound_interupt = "bar_drill_fix_cancel",
		sound_done = "bar_drill_fix_finished",
		upgrade_timer_multiplier = {
			upgrade = "equipment_hack_speed_multiplier",
			category = "player"
		},
		axis = "z"
	}
	self.hack_numpad = {
		text_id = "hud_int_hold_hack_numpad",
		action_text_id = "hud_action_hacking_numpad",
		start_active = false,
		upgrade_timer_multiplier = {
			upgrade = "equipment_hack_speed_multiplier",
			category = "player"
		},
		timer = 15
	}
	self.votingmachine2 = {
		text_id = "debug_interact_hack_ipad",
		timer = 5,
		sound_start = "bar_keyboard",
		sound_interupt = "bar_keyboard_cancel",
		upgrade_timer_multiplier = {
			upgrade = "equipment_hack_speed_multiplier",
			category = "player"
		},
		sound_done = "bar_keyboard_finished"
	}
	self.votingmachine2_jammed = {
		text_id = "debug_interact_hack_ipad_jammed",
		timer = 5,
		sound_start = "bar_keyboard",
		sound_interupt = "bar_keyboard_cancel",
		upgrade_timer_multiplier = {
			upgrade = "equipment_hack_speed_multiplier",
			category = "player"
		},
		sound_done = "bar_keyboard_finished"
	}
	self.sc_tape_loop = {
		icon = "interaction_help",
		text_id = "hud_int_tape_loop",
		start_active = true,
		interact_distance = 150,
		no_contour = true,
		timer = 4,
		action_text_id = "hud_action_tape_looping",
		upgrade_timer_multiplier = {
			upgrade = "equipment_hack_speed_multiplier",
			category = "player"
		},
		requires_upgrade = {
			upgrade = "tape_loop_duration",
			category = "player"
		}
	}
	self.hack_electric_box = {
		text_id = "hud_int_hack_box",
		action_text_id = "hud_action_hack_box",
		timer = 6,
		start_active = false,
		axis = "y",
		sound_start = "bar_hack_fuse_box",
		sound_interupt = "bar_hack_fuse_box_cancel",
		upgrade_timer_multiplier = {
			upgrade = "equipment_hack_speed_multiplier",
			category = "player"
		},
		sound_done = "bar_hack_fuse_box_finished"
	}
	self.hack_ship_control = {
		icon = "interaction_keyboard",
		text_id = "hud_hack_ship_control",
		action_text_id = "hud_hacking_ship_control",
		timer = 6,
		axis = "z",
		start_active = false,
		interact_distance = 150,
		sound_start = "bar_keyboard",
		sound_interupt = "bar_keyboard_cancel",
		upgrade_timer_multiplier = {
			upgrade = "equipment_hack_speed_multiplier",
			category = "player"
		},
		sound_done = "bar_keyboard_finished"
	}
	self.timelock_hack = {
		text_id = "hud_int_hack_timelock",
		action_text_id = "hud_action_hack_timelock",
		timer = 6,
		start_active = false,
		axis = "y",
		sound_start = "bar_hack_fuse_box",
		sound_interupt = "bar_hack_fuse_box_cancel",
		upgrade_timer_multiplier = {
			upgrade = "equipment_hack_speed_multiplier",
			category = "player"
		},
		sound_done = "bar_hack_fuse_box_finished"
	}
	self.mcm_laptop = {
		text_id = "hud_int_hack_laptop",
		action_text_id = "hud_action_hack_laptop",
		timer = 3,
		sound_start = "bar_keyboard",
		sound_interupt = "bar_keyboard_cancel",
		upgrade_timer_multiplier = {
			upgrade = "equipment_hack_speed_multiplier",
			category = "player"
		},
		sound_done = "bar_keyboard_finished"
	}
	self.mcm_laptop_code = {
		text_id = "hud_int_grab_code",
		action_text_id = "hud_action_grab_code",
		timer = 2,
		sound_start = "bar_keyboard",
		sound_interupt = "bar_keyboard_cancel",
		upgrade_timer_multiplier = {
			upgrade = "equipment_hack_speed_multiplier",
			category = "player"
		},
		sound_done = "bar_keyboard_finished"
	}
	self.hack_skylight_barrier = {
		text_id = "hud_hack_skylight_barrier",
		action_text_id = "hud_action_hack_skylight_barrier",
		timer = 6,
		start_active = false,
		axis = "y",
		sound_start = "bar_hack_fuse_box",
		sound_interupt = "bar_hack_fuse_box_cancel",
		upgrade_timer_multiplier = {
			upgrade = "equipment_hack_speed_multiplier",
			category = "player"
		},
		sound_done = "bar_hack_fuse_box_finished"
	}
	self.drk_hold_hack_computer = {
		text_id = "hud_int_big_computer_hackable",
		action_text_id = "hud_action_hacking_computer",
		timer = 10,
		axis = "y",
		start_active = false,
		sound_start = "bar_train_panel_hacking",
		sound_interupt = "bar_train_panel_hacking_cancel",
		upgrade_timer_multiplier = {
			upgrade = "equipment_hack_speed_multiplier",
			category = "player"
		},
		sound_done = "bar_train_panel_hacking_finished"
	}
	self.hold_start_scan = {
		text_id = "hud_hold_start_scanning",
		action_text_id = "hud_action_start_scanning",
		interact_distance = 150,
		timer = 3,
		start_active = false,
		force_update_position = true,
		sound_start = "bar_train_panel_hacking",
		sound_interupt = "bar_train_panel_hacking_cancel",
		upgrade_timer_multiplier = {
			upgrade = "equipment_hack_speed_multiplier",
			category = "player"
		},
		sound_done = "bar_train_panel_hacking_finished"
	}
	self.hold_new_hack = {
		text_id = "hud_int_hold_start_new_hack",
		action_text_id = "hud_action_starting_new_hack",
		start_active = false,
		timer = 3,
		sound_start = "bar_keyboard",
		sound_interupt = "bar_keyboard_cancel",
		upgrade_timer_multiplier = {
			upgrade = "equipment_hack_speed_multiplier",
			category = "player"
		},
		sound_done = "bar_keyboard_finished"
	}
	self.hold_type_in_password = {
		text_id = "hud_int_type_in_password",
		action_text_id = "hud_action_typing_in_password",
		timer = 5,
		interact_distance = 200,
		start_active = false,
		sound_start = "bar_keyboard",
		sound_interupt = "bar_keyboard_cancel",
		upgrade_timer_multiplier = {
			upgrade = "equipment_hack_speed_multiplier",
			category = "player"
		},
		sound_done = "bar_keyboard_finished"
	}
	self.chca_hold_disable_firewall = {
		text_id = "hud_int_pku_disable_firewall",
		action_text_id = "hud_action_pkuing_disable_firewall",
		timer = 5,
		start_active = true,
		interact_distance = 200,
		upgrade_timer_multiplier = {
			upgrade = "equipment_hack_speed_multiplier",
			category = "player"
		},
		axis = "y"
	}
	self.chca_start_hacking = {
		text_id = "hud_int_hold_start_hack",
		action_text_id = "hud_action_starting_hack",
		interact_distance = 200,
		start_active = false,
		timer = 3,
		upgrade_timer_multiplier = {
			upgrade = "equipment_hack_speed_multiplier",
			category = "player"
		},
		axis = "y"
	}
	self.chca_place_bug = {
		text_id = "hud_int_hold_place_bug",
		action_text_id = "hud_action_placeing_bug",
		interact_distance = 200,
		start_active = false,
		timer = 5,
		upgrade_timer_multiplier = {
			upgrade = "equipment_hack_speed_multiplier",
			category = "player"
		},
		axis = "x"
	}
	self.trai_connect_locke = {
		text_id = "hud_int_trai_connect_locke",
		action_text_id = "hud_action_trai_connect_locke",
		interact_distance = 200,
		timer = 1,
		start_active = true,
		upgrade_timer_multiplier = {
			upgrade = "equipment_hack_speed_multiplier",
			category = "player"
		},
		axis = "z"
	}
	self.trai_connect_locke_walkietalkie = {
		text_id = "hud_int_trai_connect_locke_walkietalkie",
		action_text_id = "hud_action_trai_connect_locke_walkietalkie",
		interact_distance = 150,
		timer = 2,
		upgrade_timer_multiplier = {
			upgrade = "equipment_hack_speed_multiplier",
			category = "player"
		},
		start_active = true
	}
	self.trai_hold_access_console = {
		text_id = "hud_int_trai_hold_access_console",
		action_text_id = "hud_action_trai_hold_access_console",
		interact_distance = 150,
		timer = 5,
		upgrade_timer_multiplier = {
			upgrade = "equipment_hack_speed_multiplier",
			category = "player"
		},
		axis = "x"
	}
	self.hack_trai_outline = {
		icon = "equipment_hack_ipad",
		text_id = "debug_interact_hack_ipad",
		action_text_id = "hud_action_hacking_computer",
		interact_distance = 200,
		timer = 5,
		start_active = true,
		axis = "y",
		sound_start = "bar_keyboard",
		sound_interupt = "bar_keyboard_cancel",
		upgrade_timer_multiplier = {
			upgrade = "equipment_hack_speed_multiplier",
			category = "player"
		},
		sound_done = "bar_keyboard_finished"
	}
	self.corp_hack_email = {
		icon = "equipment_hack_ipad",
		text_id = "corp_hold_computer_email",
		interact_distance = 200,
		timer = 2,
		start_active = true,
		axis = "y",
		sound_start = "bar_keyboard",
		sound_interupt = "bar_keyboard_cancel",
		upgrade_timer_multiplier = {
			upgrade = "equipment_hack_speed_multiplier",
			category = "player"
		},
		sound_done = "bar_keyboard_finished"
	}
	self.corp_hack_lead_email = deep_clone(self.corp_hack_email)
	self.corp_hack_lead_email.text_id = "corp_hold_computer_lead_schedule"
	self.corp_download_email = {
		icon = "equipment_hack_ipad",
		text_id = "corp_hold_computer_download_email",
		interact_distance = 200,
		timer = 2,
		start_active = true,
		axis = "y",
		sound_start = "bar_keyboard",
		sound_interupt = "bar_keyboard_cancel",
		upgrade_timer_multiplier = {
			upgrade = "equipment_hack_speed_multiplier",
			category = "player"
		},
		sound_done = "bar_keyboard_finished"
	}
	self.corp_achievement_usb_laptop = {
		icon = "develop",
		text_id = "hud_hold_use_achievement_laptop",
		timer = 0.5,
		start_active = true,
		interact_distance = 150,
		special_equipment = "trai_usb_key",
		equipment_text_id = "hud_equipment_corp_achievement_need_usb",
		equipment_consume = true,
		upgrade_timer_multiplier = {
			upgrade = "equipment_hack_speed_multiplier",
			category = "player"
		},
		dont_need_equipment = false
	}
	self.deep_hold_control_panel = {
		text_id = "deep_hold_control_lever",
		action_text_id = "deep_action_control_lever",
		interact_distance = 150,
		timer = 3,
		start_active = true,
		upgrade_timer_multiplier = {
			upgrade = "equipment_hack_speed_multiplier",
			category = "player"
		},
		axis = "x"
	}
-----------------------------------------------------------
-- CASING MODE FEATURES --
-----------------------------------------------------------
	self.invisible_interaction_open = {
		icon = "develop",
		text_id = "hud_int_invisible_interaction_open",
		requires_mask_off_upgrade = {
			upgrade = "mask_off_pickup",
			category = "player"
		}
	}
	self.open_from_inside = {
		text_id = "hud_int_invisible_interaction_open",
		start_active = true,
		interact_distance = 100,
		axis = "x",
		requires_mask_off_upgrade = {
			upgrade = "mask_off_pickup",
			category = "player"
		}
	}
	self.push_button = {
		text_id = "hud_int_push_button",
		axis = "z",
		requires_mask_off_upgrade = {
			upgrade = "mask_off_pickup",
			category = "player"
		}
	}
	self.hold_push_button = {
		text_id = "hud_int_push_button",
		action_text_id = "hud_action_pushing_button",
		axis = "z",
		requires_mask_off_upgrade = {
			upgrade = "mask_off_pickup",
			category = "player"
		}
	}
	self.open_trunk = {
		icon = "develop",
		text_id = "debug_interact_open_trunk",
		axis = "x",
		action_text_id = "hud_action_opening_trunk",
		requires_mask_off_upgrade = {
			upgrade = "mask_off_pickup",
			category = "player"
		}
	}
	self.open_door = {
		icon = "interaction_open_door",
		text_id = "debug_interact_open_door",
		interact_distance = 200,
		requires_mask_off_upgrade = {
			upgrade = "mask_off_pickup",
			category = "player"
		}
	}
	self.take_keys = {
		text_id = "hud_int_take_keys",
		requires_mask_off_upgrade = {
			upgrade = "mask_off_pickup",
			category = "player"
		}
	}
	self.timelock_panel = {
		icon = "equipment_bank_manager_key",
		text_id = "hud_int_timelock_panel",
		equipment_text_id = "hud_int_equipment_no_keycard",
		special_equipment = "bank_manager_key",
		equipment_consume = true,
		start_active = false,
		axis = "y",
		requires_mask_off_upgrade = {
			upgrade = "mask_off_pickup",
			category = "player"
		}
	}
	self.mex_red_door = {
		icon = "equipment_bank_manager_key",
		text_id = "hud_cas_open_door",
		equipment_text_id = "hud_action_try_keys_no_key",
		special_equipment = "keychain",
		sound_start = "bar_unlock_grate_door",
		sound_interupt = "bar_unlock_grate_door_cancel",
		sound_done = "bar_unlock_grate_door_finished",
		equipment_consume = true,
		interact_distance = 150,
		requires_mask_off_upgrade = {
			upgrade = "mask_off_pickup",
			category = "player"
		}
	}
	self.bex_take_record_tape = {
		text_id = "hud_int_take_record_tape",
		action_text_id = "hud_action_take_record_tape",
		interact_distance = 200,
		start_active = true,
		requires_mask_off_upgrade = {
			upgrade = "mask_off_pickup",
			category = "player"
		}
	}
	self.gage_assignment = {
		icon = "develop",
		text_id = "debug_interact_gage_assignment_take",
		start_active = true,
		timer = 0,
		action_text_id = "hud_action_taking_gage_assignment",
		blocked_hint = "hint_gage_mods_dlc_block",
		requires_mask_off_upgrade = {
			upgrade = "mask_off_pickup",
			category = "player"
		}
	}
	self.red_open_shutters = {
		text_id = "hud_int_hold_open_shutters",
		axis = "y",
		requires_mask_off_upgrade = {
			upgrade = "mask_off_pickup",
			category = "player"
		}
	}
	self.red_close_shutters = {
		text_id = "hud_int_hold_close_shutters",
		axis = "y",
		requires_mask_off_upgrade = {
			upgrade = "mask_off_pickup",
			category = "player"
		}
	}
	self.cas_button_01.requires_mask_off_upgrade = {
			upgrade = "mask_off_pickup",
			category = "player"
		}
	self.cas_button_02.requires_mask_off_upgrade = {
			upgrade = "mask_off_pickup",
			category = "player"
		}
	self.cas_button_03.requires_mask_off_upgrade = {
			upgrade = "mask_off_pickup",
			category = "player"
		}
	self.cas_button_04.requires_mask_off_upgrade = {
			upgrade = "mask_off_pickup",
			category = "player"
		}
	self.cas_button_05.requires_mask_off_upgrade = {
			upgrade = "mask_off_pickup",
			category = "player"
		}
	self.cas_button_06.requires_mask_off_upgrade = {
			upgrade = "mask_off_pickup",
			category = "player"
		}
	self.cas_button_07.requires_mask_off_upgrade = {
			upgrade = "mask_off_pickup",
			category = "player"
		}
	self.cas_button_08.requires_mask_off_upgrade = {
			upgrade = "mask_off_pickup",
			category = "player"
		}
	self.cas_button_09.requires_mask_off_upgrade = {
			upgrade = "mask_off_pickup",
			category = "player"
		}
	self.cas_button_0.requires_mask_off_upgrade = {
			upgrade = "mask_off_pickup",
			category = "player"
		}
	self.cas_button_clear.requires_mask_off_upgrade = {
			upgrade = "mask_off_pickup",
			category = "player"
		}
	self.cas_button_enter.requires_mask_off_upgrade = {
			upgrade = "mask_off_pickup",
			category = "player"
		}
	self.cas_button_0.interact_distance = 80
	self.cas_button_clear.interact_distance = 80
	self.cas_button_enter.interact_distance = 80
	self.circuit_breaker.requires_mask_off_upgrade = {
			upgrade = "mask_off_pickup",
			category = "player"
		}
	self.circuit_breaker_off.requires_mask_off_upgrade = {
			upgrade = "mask_off_pickup",
			category = "player"
		}
	self.numpad.requires_mask_off_upgrade = {
			upgrade = "mask_off_pickup",
			category = "player"
		}
	self.access_camera.requires_mask_off_upgrade = {
			upgrade = "mask_off_pickup",
			category = "player"
		}
	self.access_camera_x_axis.requires_mask_off_upgrade = {
			upgrade = "mask_off_pickup",
			category = "player"
		}
	self.access_camera_y_axis.requires_mask_off_upgrade = {
			upgrade = "mask_off_pickup",
			category = "player"
		}
-----------------------------------------------------------
-- PICKLOCK INTERACTION TWEAKS --
-----------------------------------------------------------
	self.pick_lock_30 = {
		contour = "interactable_icon",
		icon = "equipment_bank_manager_key",
		text_id = "hud_int_pick_lock",
		start_active = true,
		timer = 30,
		requires_upgrade = {
			upgrade = "pick_lock_hard",
			category = "player"
		},
		action_text_id = "hud_action_picking_lock",
		sound_start = "bar_pick_lock",
		sound_interupt = "bar_pick_lock_cancel",
		sound_done = "bar_pick_lock_finished",
		upgrade_timer_multipliers = {
			{
				upgrade = "pick_lock_easy_speed_multiplier",
				category = "player"
			},
			{
				upgrade = "pick_lock_speed_multiplier",
				category = "player"
			}
		},
		is_lockpicking = true
	}
	self.pick_lock_easy = {
		contour = "interactable_icon",
		icon = "equipment_bank_manager_key",
		text_id = "hud_int_pick_lock",
		start_active = true,
		timer = 10,
		interact_distance = 100,
		requires_upgrade = {
			upgrade = "pick_lock_easy",
			category = "player"
		},
		upgrade_timer_multipliers = {
			{
				upgrade = "pick_lock_easy_speed_multiplier",
				category = "player"
			},
			{
				upgrade = "pick_lock_speed_multiplier",
				category = "player"
			}
		},
		action_text_id = "hud_action_picking_lock",
		sound_start = "bar_pick_lock",
		sound_interupt = "bar_pick_lock_cancel",
		sound_done = "bar_pick_lock_finished",
		is_lockpicking = true
	}
	self.pick_lock_easy_no_skill = {
		contour = "interactable_icon",
		icon = "equipment_bank_manager_key",
		text_id = "hud_int_pick_lock",
		start_active = true,
		timer = 7,
		upgrade_timer_multipliers = {
			{
				upgrade = "pick_lock_easy_speed_multiplier",
				category = "player"
			},
			{
				upgrade = "pick_lock_speed_multiplier",
				category = "player"
			}
		},
		action_text_id = "hud_action_picking_lock",
		interact_distance = 100,
		sound_start = "bar_pick_lock",
		sound_interupt = "bar_pick_lock_cancel",
		sound_done = "bar_pick_lock_finished",
		is_lockpicking = true
	}
	self.fex_pick_lock_easy_no_skill = {
		contour = "interactable_icon",
		icon = "equipment_bank_manager_key",
		text_id = "hud_int_pick_lock",
		start_active = true,
		timer = 2,
		action_text_id = "hud_action_picking_lock",
		interact_distance = 150,
		sound_start = "bar_pick_lock",
		sound_interupt = "bar_pick_lock_cancel",
		upgrade_timer_multipliers = {
			{
				upgrade = "pick_lock_easy_speed_multiplier",
				category = "player"
			},
			{
				upgrade = "pick_lock_speed_multiplier",
				category = "player"
			}
		},
		sound_done = "bar_pick_lock_finished",
		is_lockpicking = true
	}
	self.chas_pick_lock_easy_no_skill = {
		contour = "interactable_icon",
		icon = "equipment_bank_manager_key",
		text_id = "hud_int_pick_lock",
		start_active = true,
		timer = 7,
		axis = "y",
		action_text_id = "hud_action_picking_lock",
		interact_distance = 100,
		sound_start = "bar_pick_lock",
		sound_interupt = "bar_pick_lock_cancel",
		upgrade_timer_multipliers = {
			{
				upgrade = "pick_lock_easy_speed_multiplier",
				category = "player"
			},
			{
				upgrade = "pick_lock_speed_multiplier",
				category = "player"
			}
		},
		sound_done = "bar_pick_lock_finished",
		is_lockpicking = true
	}
	self.open_door_with_keys = {
		contour = "interactable_icon",
		icon = "equipment_bank_manager_key",
		text_id = "hud_int_try_keys",
		start_active = false,
		timer = 5,
		action_text_id = "hud_action_try_keys",
		interact_distance = 100,
		sound_start = "bar_unlock_grate_door",
		sound_interupt = "bar_unlock_grate_door_cancel",
		sound_done = "bar_unlock_grate_door_finished",
		upgrade_timer_multipliers = {
			{
				upgrade = "pick_lock_easy_speed_multiplier",
				category = "player"
			},
			{
				upgrade = "pick_lock_speed_multiplier",
				category = "player"
			}
		},
		special_equipment = "keychain",
		equipment_text_id = "hud_action_try_keys_no_key",
		is_lockpicking = true
	}
	self.hold_unlock_car = {
		text_id = "hud_int_hold_unlock_car",
		action_text_id = "hud_unlocking_car",
		timer = 1,
		equipment_text_id = "hud_equipment_need_car_keys",
		special_equipment = "c_keys",
		upgrade_timer_multipliers = {
			{
				upgrade = "pick_lock_easy_speed_multiplier",
				category = "player"
			},
			{
				upgrade = "pick_lock_speed_multiplier",
				category = "player"
			}
		},
		equipment_consume = true
	}
	self.fake_pick_lock_easy_no_skill = {
		text_id = "hud_int_pick_lock",
		start_active = true,
		upgrade_timer_multipliers = {
			{
				upgrade = "pick_lock_easy_speed_multiplier",
				category = "player"
			},
			{
				upgrade = "pick_lock_speed_multiplier",
				category = "player"
			}
		},
		interact_distance = 100
	}
	self.chca_force_open_vent = {
		text_id = "hud_int_pku_force_open_vent",
		action_text_id = "hud_action_pkuing_force_open_vent",
		timer = 1,
		start_active = true,
		upgrade_timer_multipliers = {
			{
				upgrade = "pick_lock_easy_speed_multiplier",
				category = "player"
			},
			{
				upgrade = "pick_lock_speed_multiplier",
				category = "player"
			}
		},
		interact_distance = 150,
		axis = "x"
	}
	self.chca_hold_open_safe = {
		text_id = "hud_int_open_safe",
		action_text_id = "hud_action_opening_safe",
		timer = 5,
		axis = "y",
		special_equipment = "keychain",
		equipment_text_id = "hud_equipment_need_keychain",
		upgrade_timer_multipliers = {
			{
				upgrade = "pick_lock_easy_speed_multiplier",
				category = "player"
			},
			{
				upgrade = "pick_lock_speed_multiplier",
				category = "player"
			}
		},
		equipment_consume = true
	}
	self.pick_lock_easy_no_skill_pent = {
		contour = "interactable_icon",
		icon = "equipment_bank_manager_key",
		text_id = "hud_int_pick_lock",
		start_active = true,
		timer = 10,
		upgrade_timer_multipliers = {
			{
				upgrade = "pick_lock_easy_speed_multiplier",
				category = "player"
			},
			{
				upgrade = "pick_lock_speed_multiplier",
				category = "player"
			}
		},
		action_text_id = "hud_action_picking_lock",
		interact_distance = 100,
		sound_start = "bar_pick_lock",
		sound_interupt = "bar_pick_lock_cancel",
		sound_done = "security_box_open",
		is_lockpicking = true,
		axis = "x"
	}
	self.pent_pick_lock = {
		text_id = "hud_int_pick_lock",
		action_text_id = "hud_action_picking_lock",
		interact_distance = 160,
		timer = 5,
		upgrade_timer_multipliers = {
			{
				upgrade = "pick_lock_easy_speed_multiplier",
				category = "player"
			},
			{
				upgrade = "pick_lock_speed_multiplier",
				category = "player"
			}
		},
		start_active = true,
		sound_start = "bar_pick_lock",
		sound_interupt = "bar_pick_lock_cancel",
		sound_done = "bar_pick_lock_finished"
	}
	self.trai_hold_picklock_toolsafe = {
		icon = "equipment_bank_manager_key",
		text_id = "hud_int_trai_toolsafe_lockpick",
		action_text_id = "hud_action_trai_toolsafe_lockpick",
		interact_distance = 150,
		timer = 7,
		start_active = true,
		sound_start = "bar_pick_lock",
		sound_interupt = "bar_pick_lock_cancel",
		sound_done = "bar_pick_lock_finished",
		upgrade_timer_multipliers = {
			{
				upgrade = "pick_lock_easy_speed_multiplier",
				category = "player"
			},
			{
				upgrade = "pick_lock_speed_multiplier",
				category = "player"
			}
		},
		is_lockpicking = true
	}
-----------------------------------------------------------
-- HARDWARE STUFF --
-----------------------------------------------------------
	self.answer_call = {
		text_id = "hud_int_hold_answer_call",
		action_text_id = "hud_action_answering_call",
		start_active = false,
		requires_mask_off_upgrade = {
			category = "player",
			upgrade = "mask_off_pickup"
		}
	}
	self.computer_test = {
		icon = "develop",
		text_id = "debug_interact_computer_test",
		start_active = false,
		requires_mask_off_upgrade = {
			category = "player",
			upgrade = "mask_off_pickup"
		}
	}
	self.hospital_phone = {
		icon = "interaction_answerphone",
		text_id = "debug_interact_hospital_phone",
		start_active = false,
		requires_mask_off_upgrade = {
			category = "player",
			upgrade = "mask_off_pickup"
		}
	}
	self.bus_wall_phone = {
		text_id = "hud_int_use_phone_signal_bus",
		start_active = false,
		requires_mask_off_upgrade = {
			category = "player",
			upgrade = "mask_off_pickup"
		}
	}
end	