dofile(ModPath .. "lua/core/sydchSO.lua")

function PlayerTweakData:_set_easy()
	self.damage.automatic_respawn_time = 90
	self.damage.MIN_DAMAGE_INTERVAL = 0.3
	self.damage.MIN_DAMAGE_THRESHOLD = 3.9
	self.damage.INCAP_DAMAGE = 5.2
	self.damage.REVIVE_HEALTH_STEPS = {0.8}
	--self.suppression.max_penalty = 1
	self.suppression.too_soon = 14
end

function PlayerTweakData:_set_normal()
	self.damage.automatic_respawn_time = 120
	self.damage.MIN_DAMAGE_INTERVAL = 0.3
	self.damage.MIN_DAMAGE_THRESHOLD = 3.1
	self.damage.INCAP_DAMAGE = 5.2
	self.damage.REVIVE_HEALTH_STEPS = {0.8}
	self.damage.REVIVE_HEALTH_STEPS_W_SKILL = {0.9}
	--self.suppression.max_penalty = 1.1
	self.suppression.too_soon = 14
end

function PlayerTweakData:_set_hard()
	self.damage.automatic_respawn_time = 220
	self.damage.DOWNED_TIME_DEC = 7
	self.damage.DOWNED_TIME_MIN = 5
	self.damage.MIN_DAMAGE_INTERVAL = 0.3
	self.damage.MIN_DAMAGE_THRESHOLD = 2.9
	self.damage.INCAP_DAMAGE = 5.2
	self.damage.REVIVE_HEALTH_STEPS = {0.8}
	self.damage.REVIVE_HEALTH_STEPS_W_SKILL = {0.9}
	--self.suppression.max_penalty = 1.1
	self.suppression.too_soon = 14
end

function PlayerTweakData:_set_overkill()
	self.damage.DOWNED_TIME_DEC = 10
	self.damage.DOWNED_TIME_MIN = 5
	self.damage.MIN_DAMAGE_INTERVAL = 0.25
	self.damage.MIN_DAMAGE_THRESHOLD = 2.3
	self.damage.INCAP_DAMAGE = 5.2
	self.damage.REVIVE_HEALTH_STEPS = {0.4}
	self.damage.REVIVE_HEALTH_STEPS_W_SKILL = {0.5}
	--self.suppression.max_penalty = 1.15
	self.suppression.too_soon = 14
end

function PlayerTweakData:_set_overkill_145()
	self.damage.DOWNED_TIME_DEC = 15
	self.damage.DOWNED_TIME_MIN = 1
	self.damage.MIN_DAMAGE_INTERVAL = 0.25
	self.damage.MIN_DAMAGE_THRESHOLD = 2.1
	self.damage.INCAP_DAMAGE = 5.2
	self.damage.REVIVE_HEALTH_STEPS = {0.4}
	self.damage.REVIVE_HEALTH_STEPS_W_SKILL = {0.5}
	--self.suppression.max_penalty = 1.15
	self.suppression.too_soon = 14
end

function PlayerTweakData:_set_easy_wish()
	self.damage.DOWNED_TIME_DEC = 20
	self.damage.DOWNED_TIME_MIN = 1
	self.suspicion.max_value = 12
	self.suspicion.range_mul = 1.4
	self.suspicion.buildup_mul = 1.4
	self.damage.BLEED_OT_TIME = 10
	self.damage.LIVES_INIT = 4
	self.damage.MIN_DAMAGE_INTERVAL = 0.2
	self.damage.MIN_DAMAGE_THRESHOLD = 1.9
	self.damage.INCAP_DAMAGE = 5.2
	self.damage.REVIVE_HEALTH_STEPS = {0.2}
	self.damage.REVIVE_HEALTH_STEPS_W_SKILL = {0.3}
	--self.suppression.max_penalty = 1.15
	self.suppression.too_soon = 9
end

function PlayerTweakData:_set_overkill_290()
	self.damage.DOWNED_TIME_DEC = 20
	self.damage.DOWNED_TIME_MIN = 1
	self.suspicion.max_value = 12
	self.suspicion.range_mul = 1.4
	self.suspicion.buildup_mul = 1.4
	self.damage.BLEED_OT_TIME = 10
	self.damage.LIVES_INIT = 4
	self.damage.MIN_DAMAGE_INTERVAL = 0.2
	self.damage.MIN_DAMAGE_THRESHOLD = 1.3
	self.damage.INCAP_DAMAGE = 5.2
	self.damage.REVIVE_HEALTH_STEPS = {0.2}
	self.damage.REVIVE_HEALTH_STEPS_W_SKILL = {0.3}
	--self.suppression.max_penalty = 1.3
	self.suppression.too_soon = 9
end

function PlayerTweakData:_set_sm_wish()
	self.damage.DOWNED_TIME_DEC = 20
	self.damage.DOWNED_TIME_MIN = 1
	self.suspicion.max_value = 12
	self.suspicion.range_mul = 1.4
	self.suspicion.buildup_mul = 1.4
	self.damage.BLEED_OT_TIME = 10
	self.damage.LIVES_INIT = 4
	self.damage.MIN_DAMAGE_INTERVAL = 0.15
	self.damage.MIN_DAMAGE_THRESHOLD = 1.1
	self.damage.INCAP_DAMAGE = 7.8
	self.damage.REVIVE_HEALTH_STEPS = {0.1}
	self.damage.REVIVE_HEALTH_STEPS_W_SKILL = {0.2}
	--self.suppression.max_penalty = 1.3
	self.suppression.too_soon = 9
end

function PlayerTweakData:_set_singleplayer()
	self.damage.REGENERATE_TIME = 2.45
end

Hooks:PostHook(PlayerTweakData, "init", "sydchSO", function(self, tweak_data)
	if is_console then
		self.damage.REGENERATE_TIME = 2.35
	else
		self.damage.REGENERATE_TIME = 2.65
	end
	
	self.suppression = {
		receive_mul = 3,
		decay_start_delay = 1,
		spread_mul = 1,
		tolerance = 1,
		max_value = 20,
		autohit_chance_mul = 1
	}
	self.damage.TASED_TIME = 8
	self.damage.TASED_RECOVER_TIME = 2
	self.put_on_mask_time = 1
	self.omniscience = {
		start_t = 2,
		interval_t = 1,
		sense_radius = 900,
		target_resense_t = 15
	}
	self.movement_state.stamina.STAMINA_REGEN_RATE = 3
	self.movement_state.stamina.STAMINA_DRAIN_RATE = 2
	self.movement_state.stamina.STAMINA_DRAIN_RATE_WARP = 3
	self.movement_state.stamina.REGENERATE_TIME = 2 --why are you running, why are you running?
	self.movement_state.stamina.MIN_STAMINA_THRESHOLD = 15 --roughly 30%
	self.movement_state.stamina.JUMP_STAMINA_DRAIN = 2
	self.movement_state.stamina.MELEE_STAMINA_DRAIN = 4
	if is_vr then
		self.damage.HEALTH_INIT = 21
	else
		self.damage.HEALTH_INIT = 21
	end
	self.damage.BLEED_OUT_HEALTH_INIT = 8.4
	self.crew_omniscience = {
		sense_radius = 1800,
		target_resense_t = 15
	}
end)

Hooks:PostHook(PlayerTweakData, "_init_new_stances", "sydchSO", function(self)
   for wep_id, i in pairs(self.stances) do
		if self.stances[wep_id] and not sydchSO.settings.weaponINERTIA_mode == 1 then
            for stance_id, v in pairs(self.stances[wep_id]) do
                if stance_id == "standard" or stance_id == "crouched" or stance_id == "steelsight" then
					if sydchSO.settings.weaponINERTIA_mode == 4 then
						self.stances[wep_id][stance_id].vel_overshot.yaw_neg = 0
						self.stances[wep_id][stance_id].vel_overshot.yaw_pos = 0
						self.stances[wep_id][stance_id].vel_overshot.pitch_neg = 0
						self.stances[wep_id][stance_id].vel_overshot.pitch_pos = 0
					else
						if sydchSO.settings.weaponINERTIA_init == true then
							if sydchSO.settings.weaponINERTIA_mode == 2 then
								self.stances[wep_id][stance_id].vel_overshot.yaw_neg = math.max(-10, (self.stances[wep_id][stance_id].vel_overshot.yaw_neg - 9))
								self.stances[wep_id][stance_id].vel_overshot.yaw_pos = math.min(10, (self.stances[wep_id][stance_id].vel_overshot.yaw_pos + 9))
								self.stances[wep_id][stance_id].vel_overshot.pitch_neg = math.min(20, (self.stances[wep_id][stance_id].vel_overshot.pitch_neg + 6))
								self.stances[wep_id][stance_id].vel_overshot.pitch_pos = math.max(-20, (self.stances[wep_id][stance_id].vel_overshot.yaw_neg - 9))
							elseif sydchSO.settings.weaponINERTIA_mode == 3 then
								self.stances[wep_id][stance_id].vel_overshot.yaw_neg = math.min(20, (self.stances[wep_id][stance_id].vel_overshot.yaw_neg + 9))
								self.stances[wep_id][stance_id].vel_overshot.yaw_pos = math.max(-20, (self.stances[wep_id][stance_id].vel_overshot.yaw_pos - 9))
								self.stances[wep_id][stance_id].vel_overshot.pitch_neg = math.max(-20, (self.stances[wep_id][stance_id].vel_overshot.pitch_neg - 6))
								self.stances[wep_id][stance_id].vel_overshot.pitch_pos = math.min(20, (self.stances[wep_id][stance_id].vel_overshot.yaw_neg + 9))
							end
						elseif sydchSO.settings.weaponINERTIA_init == false then
							if sydchSO.settings.weaponINERTIA_mode == 2 then
								self.stances[wep_id][stance_id].vel_overshot.yaw_neg = -9
								self.stances[wep_id][stance_id].vel_overshot.yaw_pos = 9
								self.stances[wep_id][stance_id].vel_overshot.pitch_neg = 6
								self.stances[wep_id][stance_id].vel_overshot.pitch_pos = -9
							elseif sydchSO.settings.weaponINERTIA_mode == 3 then
								self.stances[wep_id][stance_id].vel_overshot.yaw_neg = 9
								self.stances[wep_id][stance_id].vel_overshot.yaw_pos = -9
								self.stances[wep_id][stance_id].vel_overshot.pitch_neg = -6
								self.stances[wep_id][stance_id].vel_overshot.pitch_pos = 9
							end
						end
					end
                end
            end
        end
    end
end)

local old_init = PlayerTweakData.init
function PlayerTweakData:init(...)
	old_init(self, ...)
	for k, v in pairs(self.stances) do
		v.standard.shakers.breathing.amplitude = 0.2
		v.crouched.shakers.breathing.amplitude = 0.1
		v.steelsight.shakers.breathing.amplitude = 0.001
	end
end

if sydchSO.settings.vocalHEISTERS == 1 or sydchSO.settings.vocalHEISTERS == 2 then
	return
end

local job = Global.level_data and Global.level_data.level_id
if job ~= "chill" and job ~= "chill_combat" then
	PackageManager:load( "levels/narratives/vlad/ukrainian_job/world_sounds" )
	PackageManager:load( "levels/narratives/vlad/jewelry_store/world_sounds" )
	PackageManager:load( "levels/narratives/h_firestarter/stage_3/world_sounds" )
	PackageManager:load( "levels/narratives/elephant/mad/world_sounds" )
end