dofile(ModPath .. "lua/core/sydchSO.lua")

if Network:is_client() or sydchSO.settings.holdoutRETUNE == false then
	return
end

function SkirmishTweakData:_init_special_unit_spawn_limits()
	self.special_unit_spawn_limits = {{
		shield = 2,
		medic = 2,
		taser = 1,
		tank = 1,
		spooc = 1
	},
	{
		shield = 2,
		medic = 2,
		taser = 1,
		tank = 1,
		spooc = 1
	},
	{
		shield = 2,
		medic = 2,
		taser = 1,
		tank = 1,
		spooc = 1
	},
	{
		shield = 3,
		medic = 2,
		taser = 1,
		tank = 1,
		spooc = 1
	},
	{
		shield = 3,
		medic = 2,
		taser = 1,
		tank = 1,
		spooc = 1
	},
	{
		shield = 4,
		medic = 2,
		taser = 2,
		tank = 2,
		spooc = 1
	},
	{
		shield = 4,
		medic = 2,
		taser = 2,
		tank = 2,
		spooc = 1
	},
	{
		shield = 4,
		medic = 2,
		taser = 2,
		tank = 2,
		spooc = 1
	},
	{
		shield = 4,
		medic = 2,
		taser = 2,
		tank = 2,
		spooc = 1
	},
	{
		shield = 4,
		medic = 2,
		taser = 2,
		tank = 2,
		spooc = 1
	},
	{
		shield = 5,
		medic = 2,
		taser = 2,
		tank = 3,
		spooc = 1
	},
	{
		shield = 5,
		medic = 2,
		taser = 2,
		tank = 3,
		spooc = 1
	},
	{
		shield = 5,
		medic = 2,
		taser = 2,
		tank = 3,
		spooc = 1
	},
	{
		shield = 6,
		medic = 2,
		taser = 2,
		tank = 3,
		spooc = 1
	},
	{
		shield = 6,
		medic = 3,
		taser = 2,
		tank = 3,
		spooc = 1
	},
	{
		shield = 6,
		medic = 3,
		taser = 2,
		tank = 4,
		spooc = 1
	},
	{
		shield = 6,
		medic = 3,
		taser = 2,
		tank = 4,
		spooc = 1
	},
	{
		shield = 6,
		medic = 3,
		taser = 2,
		tank = 4,
		spooc = 1
	},
	{
		shield = 7,
		medic = 3,
		taser = 2,
		tank = 5,
		spooc = 1
	},
	{
		shield = 7,
		medic = 3,
		taser = 2,
		tank = 5,
		spooc = 1
	},
	{
		shield = 8,
		medic = 4,
		taser = 2,
		tank = 5,
		spooc = 1
	}}
end

function SkirmishTweakData:_init_wave_phase_durations(tweak_data)
	local skirmish_data = tweak_data.group_ai.skirmish
	skirmish_data.assault.anticipation_duration = {
		{
			7.5,
			1
		}
	}
	skirmish_data.assault.build_duration = 7.5
	skirmish_data.assault.sustain_duration_min = {
		40,
		40,
		40
	}
	skirmish_data.assault.sustain_duration_max = {
		60,
		60,
		60
	}
	skirmish_data.assault.sustain_duration_balance_mul = {
		1,
		1,
		1,
		1
	}
	skirmish_data.assault.fade_duration = 5
	skirmish_data.assault.delay = {
		12.5,
		12.5,
		12.5
	}
end

function SkirmishTweakData:_init_wave_modifiers()
	self.wave_modifiers = {}
	local health_damage_multipliers = {
		{
			damage = 2.5,
			health = 2.75
		},
		{
			damage = 2.75,
			health = 3.5
		},
		{
			damage = 3,
			health = 3.25
		},
		{
			damage = 3.25,
			health = 3.5
		},
		{
			damage = 3.5,
			health = 4.25
		},
		{
			damage = 3.75,
			health = 4.5
		},
		{
			damage = 5,
			health = 6
		},
		{
			damage = 5.25,
			health = 6.5
		},
		{
			damage = 5.5,
			health = 6.75
		},
		{
			damage = 6,
			health = 7.5
		},
		{
			damage = 6.5,
			health = 8.25
		},
		{
			damage = 7,
			health = 9
		},
		{
			damage = 1.9,
			health = 1.9
		},
		{
			damage = 1.975,
			health = 1.975
		},
		{
			damage = 2.05,
			health = 2.05
		},
		{
			damage = 2.125,
			health = 2.125
		},
		{
			damage = 2.2,
			health = 2.2
		},
		{
			damage = 2.275,
			health = 2.275
		},
		{
			damage = 2.35,
			health = 2.35
		},
		{
			damage = 2.425,
			health = 2.425
		},
		{
			damage = 2.5,
			health = 2.5
		}
	}
	self.wave_modifiers[1] = {
		{
			class = "ModifierEnemyHealthAndDamageByWave",
			data = {
				waves = health_damage_multipliers,
				excluded_enemies = {
					damage = {
						"sniper",
						"heavy_swat_sniper"
					},
					health = {
						"tank_medic",
						"medic"
					}
				}
			}
		},
		{
			class = "ModifierCloakerArrest"
		}
	}
	self.wave_modifiers[3] = {{class = "ModifierSkulldozers"}}
	self.wave_modifiers[5] = {
		{
			class = "ModifierHeavySniper",
			data = {spawn_chance = 5}
		},
		{
			class = "ModifierHeavies"
		}
	}
	self.wave_modifiers[7] = {{class = "ModifierDozerMedic"}}
	self.wave_modifiers[9] = {{class = "ModifierDozerMinigun"}}
end