function TweakDataVR:init_specializations(tweak_data)
local addon_indices = {
		"health",
		"health",
		"armor",
		"dodge",
		"armor",
		"armor",
		"dodge",
		"armor",
		"armor",
		"health",
		"health",
		"armor",
		"health",
		"armor",
		"armor_lite",
		"armor",
		"armor",
		"dodge",
		"health",
		"health",
		"dodge",
		"health",
		"health"
}
local addons = {
	health = {
		{
			desc_id = "menu_warp_health_init_desc",
			upgrades = {
				"player_warp_health_1"
		}},
		[3] = {
			desc_id = "menu_warp_health_inc_desc",
			upgrades = {
				"player_warp_health_2"
		}},
		[5] = {
			desc_id = "menu_warp_health_inc_desc",
			upgrades = {
				"player_warp_health_3"
		}},
		[7] = {
			desc_id = "menu_warp_health_inc_desc",
			upgrades = {
				"player_warp_health_4"
		}},
		[9] = {
			desc_id = "menu_warp_health_inc_desc",
			upgrades = {
				"player_warp_health_5"
		}}},
	armor = {
		{
			desc_id = "menu_warp_armor_init_desc",
			upgrades = {
				"player_warp_armor_1"
		}},
		[3] = {
			desc_id = "menu_warp_armor_inc_desc",
			upgrades = {
				"player_warp_armor_2"
		}},
		[5] = {
			desc_id = "menu_warp_armor_inc_desc",
			upgrades = {
				"player_warp_armor_3"
		}},
		[7] = {
			desc_id = "menu_warp_armor_inc_desc",
			upgrades = {
				"player_warp_armor_4"
		}},
		[9] = {
			desc_id = "menu_warp_armor_inc_desc",
			upgrades = {
				"player_warp_armor_5"
		}}},
	dodge = {
		{
			desc_id = "menu_warp_dodge_init_desc",
			upgrades = {
				"player_warp_dodge_1"
		}},
		[3] = {
			desc_id = "menu_warp_dodge_inc_desc",
			upgrades = {
				"player_warp_dodge_2"
		}},
		[5] = {
			desc_id = "menu_warp_dodge_inc_desc",
			upgrades = {
				"player_warp_dodge_3"
		}},
		[7] = {
			desc_id = "menu_warp_dodge_inc_desc",
			upgrades = {
				"player_warp_dodge_4"
		}},
		[9] = {
			desc_id = "menu_warp_dodge_inc_desc",
			upgrades = {
				"player_warp_dodge_5"
		}}},
	armor_lite = {
		{
			desc_id = "menu_warp_armor_init_desc",
			upgrades = {
				"player_warp_armor_lite_1"
		}},
		[3] = {
			desc_id = "menu_warp_armor_inc_desc",
			upgrades = {
				"player_warp_armor_lite_2"
		}},
		[5] = {
			desc_id = "menu_warp_armor_inc_desc",
			upgrades = {
				"player_warp_armor_lite_3"
		}},
		[7] = {
			desc_id = "menu_warp_armor_inc_desc",
			upgrades = {
				"player_warp_armor_lite_4"
		}},
		[9] = {
			desc_id = "menu_warp_armor_inc_desc",
			upgrades = {
				"player_warp_armor_lite_5"
		}}}}
	self.specialization_addons = {}

	for index, addon in ipairs(addon_indices) do
		self.specialization_addons[index] = addons[addon]
	end

	self.specialization_descs_addons = {}

	for index, addon in ipairs(addon_indices) do
		self.specialization_descs_addons[index] = {}
		local addon_data = addons[addon] or {}

		for deck_index, data in pairs(addon_data) do
			local desc_data = {
				desc_id = data.desc_id
			}
			local macros = {}
			local data_index = (deck_index + 1) / 2

			if addon == "health" then
				local min, max, total_amount, time = unpack(tweak_data.upgrades.values.player.warp_health[data_index])
				macros.min = min * 10
				macros.max = max * 10
				macros.amount = total_amount * 10
				macros.time = time
			elseif addon == "armor" then
				local min, max, max_restores, time = unpack(tweak_data.upgrades.values.player.warp_armor[data_index])
				macros.min = min * 10
				macros.max = max * 10
				macros.restores = max_restores
				macros.time = time
			elseif addon == "dodge" then
				local min, max, time = unpack(tweak_data.upgrades.values.player.warp_dodge[data_index])
				macros.min = tostring(min * 100) .. "%"
				macros.max = tostring(max * 100) .. "%"
				macros.time = time
			elseif addon == "armor_lite" then
				local min, max, max_restores, time = unpack(tweak_data.upgrades.values.player.warp_armor_lite[data_index])
				macros.min = min * 10
				macros.max = max * 10
				macros.restores = max_restores
				macros.time = time
			end

			desc_data.macros = macros
			self.specialization_descs_addons[index][deck_index] = desc_data
		end
	end

	if _G.IS_VR then
		for index, specialization in ipairs(tweak_data.skilltree.specializations) do
			for deck_index, deck in ipairs(specialization) do
				if self.specialization_addons[index] and self.specialization_addons[index][deck_index] then
					table.list_append(deck.upgrades, self.specialization_addons[index][deck_index].upgrades)
				end
			end
		end
	end
end

local old_init = TweakDataVR.init
function TweakDataVR:init_skills(tweak_data)
	self.post_warp = {
		min = 1,
		max = 5
	}
	self.steelsight_stamina_regen = 0.02

	if _G.IS_VR then
		table.insert(tweak_data.skilltree.skills.stable_shot[2].upgrades, "player_stamina_ammo_refill_single")
		table.insert(tweak_data.skilltree.skills.rifleman[1].upgrades, "player_stamina_ammo_refill_single")
		table.insert(tweak_data.skilltree.skills.sharpshooter[1].upgrades, "player_stamina_ammo_refill_single")
		table.insert(tweak_data.skilltree.skills.shotgun_impact[1].upgrades, "player_post_warp_suppression")
		table.insert(tweak_data.skilltree.skills.shotgun_impact[2].upgrades, "player_stamina_ammo_refill_auto")
		table.insert(tweak_data.skilltree.skills.awareness[1].upgrades, "player_post_warp_reload_speed")
		table.insert(tweak_data.skilltree.skills.sprinter[2].upgrades, "player_run_dodge_chance_vr")
	end

	local stamina_regen_macro = tostring(self.steelsight_stamina_regen * 100) .. "%"
	self.skill_descs_addons = {
		stable_shot = {
			text_id = "menu_vr_addon_stable_shot",
			macros = {
				stamina_percentage = stamina_regen_macro,
				stamina = tweak_data.upgrades.values.player.stamina_ammo_refill_single[1][1],
				ammo = tostring(tweak_data.upgrades.values.player.stamina_ammo_refill_auto[1][2] * 100) .. "%",
				min = self.post_warp.min,
				max = self.post_warp.max
			}
		},
		spotter_teamwork = {
			text_id = "menu_vr_addon_single_shot_tier",
			macros = {
				min = self.post_warp.min,
				max = self.post_warp.max
			}
		},
		speedy_reload = {
			text_id = "menu_vr_addon_single_shot_tier",
			macros = {
				min = self.post_warp.min,
				max = self.post_warp.max
			}
		},
		shotgun_cqb = {
			text_id = "menu_vr_addon_shotgun_cqb",
			macros = {
				stamina = stamina_regen_macro
			}
		},
		shotgun_impact = {
			text_id = "menu_vr_addon_shotgun_impact",
			macros = {
				chance = "100%",
				distance = tweak_data.upgrades.values.player.post_warp_suppression[1][1] / 100,
				min = tweak_data.upgrades.values.player.post_warp_suppression[1][2],
				max = tweak_data.upgrades.values.player.post_warp_suppression[1][3],
				--min = tostring(tweak_data.upgrades.values.player.post_warp_reload_speed[1][1] * 100) .. "%",
				--max = tostring(tweak_data.upgrades.values.player.post_warp_reload_speed[1][2] * 100) .. "%",
				stamina = tweak_data.upgrades.values.player.stamina_ammo_refill_auto[1][1],
				ammo = tostring(tweak_data.upgrades.values.player.stamina_ammo_refill_auto[1][2] * 100) .. "%"
			}
		},
		pack_mule = {
			text_id = "menu_vr_addon_pack_mule",
			macros = {
				min = self.post_warp.min,
				max = self.post_warp.max
			}
		},
		sprinter = {
			text_id = "menu_vr_addon_sprinter",
			macros = {
				min = self.post_warp.min,
				max = self.post_warp.max
			}
		},
		awareness = {
			text_id = "menu_vr_addon_awareness",
			macros = {
				min = tostring(tweak_data.upgrades.values.player.post_warp_reload_speed[1][1] * 100) .. "%",
				max = tostring(tweak_data.upgrades.values.player.post_warp_reload_speed[1][2] * 100) .. "%"
			}
		},
		unseen_strike = {
			text_id = "menu_vr_addon_unseen_strike",
			macros = {
				stamina = stamina_regen_macro
			}
		}
	}
end