dofile(ModPath .. "lua/core/sydchSO.lua")

if sydchSO.settings.skillOVERHAUL == 2 then
function UpgradesTweakData:_init_value_tables()
	self.values = {
		player = {},
		carry = {},
		trip_mine = {},
		ammo_bag = {},
		ecm_jammer = {},
		sentry_gun = {},
		doctor_bag = {},
		cable_tie = {},
		bodybags_bag = {},
		first_aid_kit = {},
		weapon = {},
		pistol = {},
		assault_rifle = {},
		smg = {},
		shotgun = {},
		grenade_launcher = {},
		rocket_launcher = {},
		bow = {},
		flamethrower = {},
		saw = {},
		lmg = {},
		snp = {},
		akimbo = {},
		minigun = {},
		unique = {},
		primary = {},
		secondary = {},
		full_auto = {},
		single_fire = {},
		one_shot = {},
		magazine = {},
		revolver = {},
		shell = {},
		pump_action = {},
		cartridge = {},
		melee = {},
		temporary = {},
		cooldown = {},
		team = {}
	}
	self.values.team.player = {}
	self.values.team.weapon = {}
	self.values.team.pistol = {}
	self.values.team.akimbo = {}
	self.values.team.xp = {}
	self.values.team.armor = {}
	self.values.team.stamina = {}
	self.values.team.health = {}
	self.values.team.cash = {}
	self.values.team.damage_dampener = {}
end
end

local old_init = UpgradesTweakData.init
function UpgradesTweakData:init(tweak_data)
	old_init(self, tweak_data)
------------------------------
-- LEVELING TABLE
------------------------------
	if sydchSO.settings.skillOVERHAUL == 2 then
	self.level_tree = {
		[0] = {
			upgrades = {
				--"xmas_snowball",
				--"money",
				"frag",
				"dynamite",
				"molotov",
				"wpn_dallas_mask",
				"corgi",
				"clean",
				"aziz"
		}},
		{
			name_id = "body_armor",
			upgrades = {
				"body_armor2",
				"ak74",
				"frag_com",
				"nin",
				"concussion",
				"fir_com",
				"dada_com"
		}},
		{
			name_id = "weapons",
			upgrades = {
				"colt_1911",
				"mac10",
				"hajk",
				"spoon"
		}},
		{
			name_id = "weapons",
			upgrades = {
				"spatula",
				"fork",
				"boot"
		}},
		{
			name_id = "weapons",
			upgrades = {
				"new_m4",
				"shovel"
		}},
		[6] = {
			name_id = "weapons",
			upgrades = {
				"new_raging_bull",
				"b92fs",
				"m1911",
				"vityaz"
		}},
		[7] = {
			name_id = "body_armor",
			upgrades = {
				"body_armor1",
				"moneybundle"
		}},
		[8] = {
			name_id = "weapons",
			upgrades = {
				"r870",
				"aug",
				"fight"
		}},
		[10] = {
			name_id = "lvl_10",
			upgrades = {
				"rep_upgrade1",
				"cutters",
				"shawn"
		}},
		[12] = {
			name_id = "body_armor3",
			upgrades = {
				"body_armor3",
				"cobray",
				"boxcutter",
				"m590",
				"groza",
				"maxim9"
		}},
		[13] = {
			name_id = "weapons",
			upgrades = {
				"new_mp5",
				"serbu",
				"microphone",
				"selfie",
				"sko12"
		}},
		[14] = {
			name_id = "weapons",
			upgrades = {
				"bayonet",
				"m1928",
				"sparrow",
				"gator",
				"pl14"
		}},
		[15] = {
			name_id = "weapons",
			upgrades = {
				"msr",
				"benelli",
				"sub2000",
				"road",
				"legacy",
				"fmg9"
		}},
		[16] = {
			name_id = "weapons",
			upgrades = {
				"akm",
				"g36",
				"iceaxe",
				"zeus",
				"flint",
				"oxide",
				"sword"
		}},
		[17] = {
			name_id = "weapons",
			upgrades = {
				"akm_gold",
				"baton",
				"slot_lever",
				"chac",
				"pm9"
		}},
		[18] = {
			name_id = "weapons",
			upgrades = {
				"baseballbat",
				"scorpion",
				"oldbaton",
				"hockey",
				"meter",
				"hauteur",
				"shock",
				"fear"
		}},
		[19] = {
			name_id = "weapons",
			upgrades = {
				"olympic",
				"mp9",
				"baka",
				"pugio",
				"ballistic",
				"scout",
				"korth"
		}},
		[20] = {
			name_id = "lvl_20",
			upgrades = {
				"rep_upgrade2",
				"schakal",
				"agave",
				"happy",
				"shepheard"
		}},
		[21] = {
			name_id = "body_armor4",
			upgrades = {
				"body_armor4",
				"kampfmesser",
				"buck",
				"tecci",
				"wing"
		}},
		[22] = {
			name_id = "community_item",
			upgrades = {
				"g22c",
				"ksg",
				"branding_iron",
				"detector",
				"croupier_rake"
		}},
		[23] = {
			name_id = "weapons",
			upgrades = {
				"bullseye",
				"c96",
				"par",
				"m37",
				"rota",
				"cs",
				"brick",
				"ostry",
				"r700"
		}},
		[24] = {
			name_id = "weapons",
			upgrades = {
				"model24",
				"l85a2",
				"scalper",
				"switchblade",
				"type54"
		}},
		[25] = {
			name_id = "weapons",
			upgrades = {
				"boxing_gloves",
				"meat_cleaver",
				"wpn_prj_four",
				"sr2",
				"grip",
				"push",
				"breech",
				"ching",
				"erma",
				"sap"
		}},
		[26] = {
			name_id = "weapons",
			upgrades = {
				"new_m14",
				"saiga",
				"sandsteel",
				"packrat",
				"lemming",
				"rsh12",
				"chinchilla",
				"model3",
				"sbl",
				"m1897"
		}},
		[27] = {
			name_id = "weapons",
			upgrades = {
				"famas",
				"g26",
				"twins",
				"pitchfork",
				"shrew",
				"basset"
		}},
		[28] = {
			name_id = "weapons",
			upgrades = {
				"hs2000",
				"vhs",
				"bowie",
				"micstand",
				"qbu88",
				"awp"
		}},
		[29] = {
			name_id = "weapons",
			upgrades = {
				"akmsu",
				"glock_18c",
				"asval",
				"beer",
				"czech",
				"stech",
				"supernova"
		}},
		[30] = {
			name_id = "lvl_30",
			upgrades = {
				"rep_upgrade3",
				"holt"
		}},
		[31] = {
			name_id = "body_armor5",
			upgrades = {
				"body_armor5",
				"chef",
				"peacemaker",
				"wpn_prj_ace"
		}},
		[32] = {
			name_id = "weapons",
			upgrades = {
				"x46",
				"tec9",
				"tiger",
				"model70"
		}},
		[33] = {
			name_id = "weapons",
			upgrades = {
				"ak5",
				"striker",
				"wa2000",
				"beardy",
				"catch",
				"m60"
		}},
		[34] = {
			name_id = "weapons",
			upgrades = {
				"galil",
				"cleaver",
				"mateba",
				"taser",
				"desertfox",
				"wpn_prj_target",
				"tti",
				"ultima",
				"victor"
		}},
		[35] = {
			name_id = "weapons",
			upgrades = {
				"r93",
				"judge",
				"mining_pick",
				"wing"
		}},
		[36] = {
			name_id = "weapons",
			upgrades = {
				"p90",
				"deagle",
				"winchester1874"
		}},
		[37] = {
			name_id = "weapons",
			upgrades = {
				"shillelagh",
				"hammer",
				"stick"
		}},
		[38] = {
			name_id = "weapons",
			upgrades = {
				"scoutknife",
				"komodo",
				"hk51b"
		}},
		[39] = {
			name_id = "weapons",
			upgrades = {
				"m16",
				"huntsman",
				"polymer"
		}},
		[40] = {
			name_id = "lvl_40",
			upgrades = {
				"rep_upgrade4",
				"shak12"
		}},
		[41] = {
			name_id = "weapons",
			upgrades = {
				"gerber",
				"fairbair",
				"wpn_prj_jav",
				"wpn_prj_hur",
				"contraband"
		}},
		[42] = {
			name_id = "weapons",
			upgrades = {
				"fal",
				"tomahawk",
				"coal",
				"kacchainsaw"
		}},
		[43] = {
			name_id = "weapons",
			upgrades = {
				"b682",
				"morning",
				"coach"
		}},
		[44] = {
			name_id = "weapons",
			upgrades = {
				"poker"
		}},
		[45] = {
			name_id = "weapons",
			upgrades = {
				"m249",
				"barbedwire"
		}},
		[46] = {
			name_id = "weapons",
			upgrades = {
				"great",
				"siltstone"
		}},
		[47] = {
			name_id = "weapons",
			upgrades = {
				"freedom",
				"whiskey"
		}},
		[48] = {
			name_id = "weapons",
			upgrades = {
				"dingdong",
				"tenderizer",
				"hcar"
		}},
		[50] = {
			name_id = "lvl_50",
			upgrades = {
				"rep_upgrade5"
		}},
		[51] = {
			name_id = "weapons",
			upgrades = {
				"machete",
				"sterling"
		}},
		[52] = {
			name_id = "weapons",
			upgrades = {
				"g3",
				"aa12"
		}},
		[54] = {
			name_id = "weapons",
			upgrades = {
				"becker",
				"mosin",
				"cqc"
		}},
		[55] = {
			name_id = "weapons",
			upgrades = {
				"uzi"
		}},
		[60] = {
			name_id = "lvl_60",
			upgrades = {
				"rep_upgrade6"
		}},
		[61] = {
			name_id = "weapons",
			upgrades = {
				"rambo"
		}},
		[65] = {
			name_id = "weapons",
			upgrades = {
				"m95"
		}},
		[70] = {
			name_id = "lvl_70",
			upgrades = {
				"rep_upgrade7"
		}},
		[71] = {
			name_id = "weapons",
			upgrades = {
				"fireaxe",
				"mg42"
		}},
		[75] = {
			name_id = "weapons",
			upgrades = {
				"hk21"
		}},
		[80] = {
			name_id = "lvl_80",
			upgrades = {
				"rep_upgrade8"
		}},
		[90] = {
			name_id = "lvl_90",
			upgrades = {
				"rep_upgrade9"
		}},
		[100] = {
			name_id = "lvl_100",
			upgrades = {
				"rep_upgrade10"
	}}}
	end
------------------------------
-- VARIOUS STATS
------------------------------
	self.weapon_movement_penalty = {
		lmg = 0.9,
		minigun = 0.8,
		rocket_launcher = 0.8
	}
	self.values.weapon.passive_damage_multiplier = {
		1.1
	}
	self.values.weapon.passive_headshot_damage_multiplier = {
		1.3
	}
	self.values.weapon.special_damage_taken_multiplier = {
		1.2
	}
	self.values.player.marked_enemy_damage_mul = 1.1
	self.values.weapon.armor_piercing_chance = {0.34}
	self.values.player.armor_piercing_chance = {
		0.2,
		0.5
	}
	self.values.weapon.armor_piercing_chance_2 = {0.5}
	self.values.player.body_armor = {
		armor = {
			0,
			3,
			4,
			5,
			7,
			9,
			14
		},
		movement = {
			0.945,
			0.893,
			0.842,
			0.824,
			0.787,
			0.756,
			0.686
		},
		concealment = {
			30,
			26,
			23,
			21,
			18,
			12,
			1
		},
		dodge = {
			0.05,
			-0.1,
			-0.15,
			-0.2,
			-0.25,
			-0.3,
			-0.4
		},
		damage_shake = {
			1,
			0.96,
			0.92,
			0.85,
			0.8,
			0.6,
			0.4
		},
		stamina = {
			1.2,
			1.15,
			1.1,
			1.05,
			1,
			0.95,
			0.9
		},
		durability = {
			1,
			1,
			2,
			2,
			4,
			4,
			5
		}
	}
	self.values.player.tier_armor_multiplier = {
		1.2,
		1.3,
		1.4,
		1.5,
		1.6,
		1.7
	}
	self.values.player.body_armor.skill_ammo_mul = {
		1.02,
		1.04,
		1.05,
		1.06,
		1.09,
		1.11,
		1.17
	}
	self.values.player.body_armor.skill_max_health_store = {
		14,
		12,
		11,
		10,
		14,
		8,
		6
	}
	self.values.player.body_armor.skill_kill_change_regenerate_speed = {
		14,
		13.5,
		12.5,
		12,
		10.5,
		9.5,
		4
	}
	self.values.player.passive_dodge_chance = {
		0.05, 
		0.1, 
		0.15 
	}
	self.values.player.tier_dodge_chance = {
		0.05,
		0.1,
		0.15
	}
	self.values.player.passive_health_multiplier = {
		1.2, 
		1.3, 
		1.4,
		1.5,
		1.6  
	}
	self.values.player.level_2_dodge_addend = {
		0.05,
		0.1,
		0.15,
		0.2
	}
	self.values.player.level_3_dodge_addend = {
		0.05,
		0.1,
		0.15,
		0.2
	}
	self.values.player.level_4_dodge_addend = {
		0.05,
		0.1,
		0.15,
		0.2
	}
	self.values.player.level_2_less_dodge_penalty_sicario = {0.05}
	self.values.player.level_2_less_dodge_penalty = {0.1}
	self.values.player.level_3_less_dodge_penalty = {0.1}
	self.values.player.level_4_less_dodge_penalty = {0.1}
	self.values.doctor_bag.cupcake = 0.06
	self.values.doctor_bag.cupcake_tick = 5
	self.values.doctor_bag.cupcake_duration = 90
	------------------------------------------------------------------
	-- SKILLS
	------------------------------------------------------------------
	if sydchSO.settings.skillOVERHAUL == 2 then
	self.values.temporary.armor_break_invulnerable = {{
			2,
			18
	}}
	self.values.temporary.armor_break_chaos = {{
			2,
			9
	}}
	self.values.player.panic_when_chaos = {{
		area = 800,
		chance = 1,
		amount = 400
	}}
	self.values.player.throwables_multiplier = {3}
	self.values.player.stamina_to_dodge = {0.2}
	self.values.player.dodge_shot_gain = {{
			0.05,
			1
	}}
	self.values.player.dodge_replenish_stamina = {20}
	self.values.player.critical_hit_chance = { 
		0.1,
		0.5
	}
	self.values.player.detection_risk_add_crit_chance = {{
			0.02,
			3,
			"below",
			35,
			0.2
		},
		{
			0.02,
			1,
			"below",
			35,
			0.2
	}}
	self.revive_health_multiplier = {0.2}
	self.values.player.health_multiplier = {1.2}
	self.values.player.revive_interaction_speed_multiplier = {
		0.67,
		0.67
	}
	self.values.cooldown.long_dis_revive = {{
			1,
			90
	}}
	self.values.player.empowered_intimidation_mul = {1.3}
	self.values.player.minion_master_health_multiplier = {1}
	self.values.player.ap_bullets = {true}
	self.values.player.double_drop = {4}
	self.values.player.head_shot_ammo_return = {
		{
			ammo = 1,
			time = 9223372036854775807,
			headshots = 3
		},
		{
			ammo = 2,
			time = 9223372036854775807,
			headshots = 3
		}
	}
	self.values.carry.movement_penalty_nullifier = {true}
	self.values.player.revive_reload = {true}
	self.values.carry.interact_speed_multiplier = {
		0.75,
		0.3
	}
	self.values.player.ballistic_vest_concealment = {2}
	self.values.player.headshot_regen_armor_bonus = {
		1.0,
		2.0
	}
	self.on_headshot_dealt_cooldown = 3
	self.values.player.lethal_headshot_regen_armor_extra = {2.0}
	self.values.player.automatic_faster_reload = {{
			min_reload_increase = 1.3,
			penalty = 1,
			target_enemies = 5,
			min_bullets = 20,
			max_reload_increase = 1.3
	}}
	self.values.weapon.automatic_head_shot_add = {0, 0.5}
	self.values.player.pick_up_ammo_multiplier = {1}
	self.values.player.pick_up_ammo_multiplier_2 = {1.7}
	self.values.player.extra_ammo_multiplier = {1.3}
	self.values.player.on_zipline_dodge_chance = {0.05}
	self.values.player.run_dodge_chance = {0.05}
	self.values.player.vehicle_dodge_chance = {0.05}
	self.values.player.moving_dodge_chance = {0.1}
	self.values.player.distance_dodge_chance = {0.1}
	self.values.player.dodge_low_revives = {0.05}
	self.values.player.cheat_death_once = {true}
	self.values.player.cheat_death_chance = {0.2}
	self.values.temporary.unseen_strike = {
		{
			1.2,
			9
		},
		{
			1.2,
			9
		}
	}
	self.values.weapon.fire_rate_multiplier = {1.1}
	self.values.akimbo.fire_rate_multiplier = {0.8, 0.9}
	self.values.player.unseen_increased_crit_chance = { 
		{
			min_time = 4,
			max_duration = 5,
			crit_chance = 1.2
		},
		{
			min_time = 4,
			max_duration = 9,
			crit_chance = 1.2
		}
	}
	self.values.trip_mine.marked_enemy_extra_damage = {true}
	self.values.weapon.silencer_damage_multiplier = {
		1.1,
		1.3
	}
	self.values.weapon.silencer_instant_kill = {true}
	self.values.player.melee_instant_kill = {true}
	--self.values.weapon.silencer_damage_multiplier = {1.3}
	self.values.weapon.silencer_enter_steelsight_speed_multiplier = {1.2}
	self.values.player.threat_intimidate = {true}
	self.values.temporary.dmg_absorption_outnumbered = {{
			0.6,
			9
	}}
	self.values.temporary.dmg_dodge_outnumbered = {{
			0.1,
			9
	}}
	self.values.temporary.dmg_dampener_outnumbered = {{
			0.95,
			9
	}}
	self.values.temporary.dmg_multiplier_outnumbered = {{
			1.05,
			9
	}}
	self.values.weapon.armor_piercing_chance_silencer = {
		0.9,
		1
	}
	self.values.player.trip_mine_deploy_time_multiplier = {
		0.7,
		0.7
	}
	self.values.player.drill_fix_interaction_speed_multiplier = {0.7}
	self.values.player.drill_autorepair_1 = {0.2}
	self.values.player.drill_autorepair_2 = {0.3}
	self.values.player.panic_when_kill = {{
		area = 800,
		chance = 0.6,
		amount = 400
	}}
	self.values.trip_mine.fire_trap = {{
			10,
			2
		},
		{
			20,
			2
	}}
	self.values.shape_charge.quantity = {
		2,
		5
	}
	self.values.trip_mine.explosion_size_multiplier_1 = {1.5}
	self.values.trip_mine.explosion_size_multiplier_2 = {2}
	self.values.player.hip_fire_accuracy_inc = {5}
	self.values.player.weapon_movement_stability = {1}
	self.values.player.stability_increase_bonus_1 = {1}			--placeholder
	self.values.player.stability_increase_bonus_2 = {1}			--16 stability
	self.values.player.weapon_accuracy_increase = {1}			--4 accuracy
	self.values.player.not_moving_accuracy_increase = {2}		--8 accuracy total of 12 accuracy
	self.values.assault_rifle.move_spread_index_addend = {1}	--somehow it gives 8 overkill says so
	self.values.snp.move_spread_index_addend = {1}
	self.values.smg.move_spread_index_addend = {1}
	self.values.weapon.single_spread_index_addend = {1}
	self.values.pistol.damage_multiplier = {1.4}
	self.values.pistol.damage_addend = {
		1.5,
		5.0
	}
	--self.values.akimbo.damage_addend = {
	--	1.5,
	--	5.0
	--}
	self.values.pistol.last_bullet_refill_chance = {true}
	self.values.pistol.magazine_capacity_inc = {5}
	self.values.magazine.reload_speed_multiplier = {1.2}
	self.values.revolver.reload_speed_multiplier = {1.2}
	self.values.pistol.reload_speed_multiplier = {1.3}
	self.values.pistol.spread_index_addend = {2}
	self.values.team.pistol.recoil_index_addend = {2}
	self.values.weapon.silencer_recoil_index_addend = {3}
	self.values.pistol.extra_ammo_multiplier = {1.1}
	self.values.player.armor_multiplier = {1.4}
	self.sentry_gun_base_armor = 40
	self.sentry_gun_base_ammo = 180
	self.values.sentry_gun.armor_piercing_chance_2 = {1}
	self.values.sentry_gun.damage_multiplier = {1}
	self.values.sentry_gun.fire_rate_reduction = {2}
	self.values.sentry_gun.can_mark_enemy = {true}
	self.values.sentry_gun.marked_enemy_damage_bonus = {true}
	self.values.pistol.fire_rate_multiplier = {1.3}
	self.values.shotgun.reload_speed_multiplier = {
		1.15,
		1.3
	}
	self.values.shell.reload_speed_multiplier = {1.3}
	self.values.player.gangster_damage_dampener = {0.76}
	self.values.player.pick_lock_arrested_speed_multiplier = {0.5}
	self.values.cable_tie.pickup_chance = {true}
	self.values.weapon.swap_speed_multiplier = {1.4}
	self.values.weapon.enter_steelsight_speed_multiplier = {1.6}
	self.values.pistol.swap_speed_multiplier = {1.9}
	self.values.akimbo.swap_speed_multiplier = {1.9}
	self.values.shotgun.swap_speed_multiplier = {1.4}
	self.values.pump_action.fire_rate_multiplier = {1.2}
	self.values.saw.fire_rate_multiplier = {1.2, 1.3}
	self.values.player.automatic_mag_increase = {10}
	self.values.shotgun.magazine_capacity_inc = {10}
	self.values.weapon.clip_ammo_increase = {10, 20}
	self.values.shell.clip_ammo_increase = {3}
	self.values.magazine.clip_ammo_increase = {15}
	self.values.team.xp.multiplier = {1.4}
	self.values.player.xp_multiplier = {1.2}
	self.values.player.passive_xp_multiplier = {1.2}
	self.values.assault_rifle.reload_speed_multiplier = {1.2}
	self.values.snp.reload_speed_multiplier = {1.2}
	self.values.lmg.reload_speed_multiplier = {
		1.2,
		1.4
	}
	self.values.smg.reload_speed_multiplier = {
		1.2,
		1.4
	}	
	self.values.akimbo.reload_speed_multiplier = {
		1.2,
		1.5
	}	
	self.values.pump_action.extra_rays = {5}
	self.values.lmg.fire_rate_multiplier = {1.1}
	self.values.smg.fire_rate_multiplier = {1.1}
	self.values.player.level_interaction_timer_multiplier = {0.9}
	self.values.shotgun.ignore_shields = {250}
	self.values.player.overkill_close_range = {75}
	self.values.temporary.overkill_damage_multiplier = {{
		1.5,
		12
	}}
	self.values.player.equipment_hack_speed_multiplier = {0.2}	
	self.values.player.melee_blunt_knockdown_mul = {1.4}
	self.values.player.melee_knockdown_mul = {1.5}
	self.values.player.melee_sharp_damage_multiplier = {1.3}
	self.values.player.passive_armor_movement_penalty_multiplier = {0.8}
	self.values.player.detection_risk_add_movement_speed = {{
		0.01,
		1,
		"below",
		35,
		0.1
	}}
	self.values.weapon.exit_run_speed_multiplier = {1.4}
	self.values.player.backstab_crit = {1.9}
	self.values.player.damage_absorption_low_revives = {0.2}
	self.values.player.armor_absorption = {0.02}
	self.values.team.damage = {
		hostage_absorption = {0.5},
		hostage_absorption_limit = 1
	}
	self.values.player.perk_armor_regen_timer_multiplier = { 
		0.9,
		0.8,
		0.7,
		0.6,
		0.5
	}
	self.values.player.armor_regen_timer_multiplier_passive = {1}
	self.values.player.armor_regen_timer_stand_still_multiplier = {
		0.9,
		0.8
	}
	self.values.player.bleed_out_health_multiplier = {2}
	self.values.player.messiah_revive_from_bleed_out = {1}
	self.values.player.infinite_messiah = {true}
	self.values.player.infinite_messiah_faster = {true}
	self.values.weapon.full_auto_free_ammo = {5}
	self.values.shotgun.consume_no_ammo_chance = {
		0.05,
		0.7
	}
	self.values.akimbo.recoil_index_addend = {
		-7,
		-6,
		-5,
		-4,
		-3
	}
	self.values.akimbo.extra_ammo_multiplier = {
		1.1,
		1.6
	}
	self.values.saw.enemy_slicer = {0.4}
	self.values.saw.rip_and_tear = {true}
	self.values.player.saw_speed_multiplier = {
		0.4,
		0.4
	}
	self.values.saw.lock_damage_multiplier = {
		1.6,
		1.6
	}
	self.values.saw.steelsight_accuracy_inc = {0.5}
	self.values.shotgun.steelsight_accuracy_inc = {0.5}
	self.values.saw.armor_piercing_chance = {1}
	self.values.saw.enter_steelsight_speed_multiplier = {2.25}
	self.values.saw.consume_no_ammo_chance = {0.05}
	self.values.saw.extra_ammo_multiplier = {2}
	self.values.saw.reload_speed_multiplier = {1.3}
	self.values.rocket_launcher.extra_ammo_multiplier = {1.5}
	self.values.player.movement_speed_multiplier = {1.1}
	self.values.carry.movement_speed_multiplier = {1.6}
	self.values.player.walk_speed_multiplier = {1.15} --1.25
	self.values.player.climb_speed_multiplier = { --1.2, 1.75
		1.15,
		1.2
	}
	self.values.player.run_speed_multiplier = {1.15} --1.25
	self.values.player.buy_cost_multiplier = {
		0.9,
		0.6
	}
	self.values.player.sell_cost_multiplier = {1.4}
	self.values.player.crafting_weapon_multiplier = {0.8}
	self.values.player.crafting_mask_multiplier = {0.8}
	self.values.player.passive_crafting_weapon_multiplier = {
		0.8,
		0.7,
		0.6
	}
	self.values.player.crafting_mask_multiplier = {0.6}
	self.values.player.passive_crafting_mask_multiplier = {
		0.8,
		0.7,
		0.6
	}
	self.values.player.dye_pack_cash_loss_multiplier = {0.6}
	self.values.player.assets_cost_multiplier = {0.6}
	self.values.player.premium_contract_cost_multiplier = {0.6}
	self.values.player.passive_assets_cost_multiplier = {0.6}
	self.values.player.assets_cost_multiplier_b = {0.6}
	self.values.player.crime_net_deal = {
		0.8,
		0.6
	}
	self.values.player.cleaner_cost_multiplier = {0.6}
	self.values.player.suspicion_multiplier = {0.65}
	self.values.team.stamina.passive_multiplier = {
		1.2,
		1.4
	}
	self.values.team.stamina.multiplier = {1.5}
	self.values.player.stamina_multiplier = {1.15}
	self.values.player.health_damage_reduction = {
		0.9,
		0.8
	}
	self.values.temporary.dodge = {{
		0.1,
		20
	}}
	self.values.temporary.combat_medic_damage_multiplier = {{
		1.1,
		40
	},
	{
		1.8,
		40
	}}
	self.values.temporary.combat_medic_enter_steelsight_speed_multiplier = {{
		1.5,
		40
	}}
	self.values.temporary.combat_medic_swap_speed_multiplier = {{
		1.1,
		40
	}}
	self.values.temporary.combat_medic_reload_speed_multiplier = {{
		1.1,
		40
	}}
	self.values.temporary.first_aid_damage_reduction = {{
		0.9,
		90
	}}
	self.values.temporary.passive_revive_damage_reduction = {{
		0.92,
		40
	},
	{
		0.92,
		40
	}}
	self.values.temporary.revive_damage_reduction = {{
		0.92,
		40
	}}
	self.values.player.revive_damage_reduction = {0.92}
	self.morale_boost_time = 40
	self.morale_boost_reload_speed_bonus = 1.1
	self.morale_boost_speed_bonus = 1.1
	self.morale_boost_suppression_resistance = 1.2
	self.values.player.passive_suppression_multiplier = {
		1.1,
		1.2
	}
	self.values.player.suppression_multiplier = {1.2}
	self.values.player.stamina_regen_timer_multiplier = {0.7}
	self.values.player.stamina_regen_multiplier = {1.3}
	self.values.cable_tie.interact_speed_multiplier = {0.5}
	self.values.player.passive_convert_enemies_health_multiplier = {
		0.5,
		0.1
	}
	self.values.player.convert_enemies_damage_multiplier = {
		1,
		1.1
	}
	self.values.player.convert_enemies_interaction_speed_multiplier = {0.5}
	self.values.player.hostage_health_regen_addend = {
		0.02,
		0.04
	}
	self.values.temporary.reload_fire_rate = {
		1.2,
		10
	}
	self.values.weapon.half_magazine_fire_rate = {1.2}
	self.values.weapon.single_shot_fire_rate = {1.15}
	self.values.smg.zoom_increase = {2}
	self.values.assault_rifle.zoom_increase = {2}
	self.values.lmg.zoom_increase = {2}
	self.values.snp.zoom_increase = {2}
	self.values.pistol.zoom_increase = {2}
	self.values.shotgun.enter_steelsight_speed_multiplier = {2}
	self.values.player.flashbang_multiplier = {
		0.6,
		0.6
	}
	self.values.player.armor_regen_time_mul = {0.8}
	self.values.team.armor.regen_time_multiplier = {0.8}
	self.values.player.fall_damage_multiplier = {0.4}
	self.values.temporary.damage_speed_multiplier = {{
		1.2,
		12
	}}
	self.values.temporary.team_damage_speed_multiplier_received = {{
		1.1,
		12
	}}
	self.values.player.armor_depleted_stagger_shot = {
		0,
		12
	}
	self.values.temporary.revived_damage_resist = {{
		0.86,
		40
	}}
	self.values.temporary.health_regen = {{
		0.04,
		40,
		5
	}}
	self.values.temporary.fall_damage_regen = {{
		0.001,
		34,
		0.5
	}}
	self.values.temporary.increased_movement_speed = {{
		1.1,
		90
	}}
	self.values.temporary.swap_weapon_faster = {{
		1.1,
		90
	}}
	self.values.temporary.steelsight_weapon_faster = {{
		1.1,
		90
	}}
	self.values.temporary.reload_weapon_faster = {{
		1.1,
		90
	}}
	self.berserker_movement_speed_multiplier = 0.3
	self.values.temporary.berserker_damage_multiplier = {{
			1,
			4
		},
		{
			1,
			4
	}}
	self.values.player.melee_damage_health_ratio_multiplier = {0.9}
	self.values.player.damage_health_ratio_multiplier = {0.9}
	self.player_damage_health_ratio_threshold = 1
	self.values.player.melee_damage_stacking = {{
		max_multiplier = 0.9,
		melee_multiplier = 0.45,
		max_time = 4
	}}
	self.values.player.melee_kill_increase_reload_speed = {{
		1.4,
		12
	}}	
	self.values.temporary.melee_kill_stacking_hit_damage_multiplier = {{
		1,
		4
	}}
	self.values.melee.stacking_hit_damage_multiplier = {
		1.3,
		1.3
	}
	self.max_melee_weapon_dmg_mul_stacks = 9223372036854775807
	self.max_weapon_dmg_mul_stacks = 9223372036854775807
	self.values.melee.stacking_hit_expire_t = {9223372036854775807}
	self.values.player.melee_swing_multiplier_delay = {0.3}
	self.values.player.non_special_melee_multiplier = {1.9}
	self.values.player.melee_damage_multiplier = {1.9}
	self.values.player.electrocution_resistance_multiplier = {0.3}
	self.values.player.passive_extend_critical_hit = {true}
	self.values.player.dodge_replenish_health = {2.2}
	self.values.player.dodge_grace = {true}
	self.values.player.interacting_damage_multiplier = {0.94}
	self.values.player.marked_inc_dmg_distance = {{
			800,
			1.3
	}}
	self.values.player.passive_intimidate_range_mul = {1.3}
	self.values.pistol.stacking_hit_damage_multiplier = {{
			max_stacks = 9223372036854775807,
			max_time = 4,
			damage_bonus = 1.02
		},
		{
			max_stacks = 9223372036854775807,
			max_time = 9,
			damage_bonus = 1.02
	}}
	self.values.player.stacking_hit_expire_t = {
		4,
		4
	}
	self.values.player.stacked_accuracy_bonus = {{
			max_stacks = 6,
			accuracy_bonus = 0.95,
			max_time = 9
	}}
	self.values.temporary.gun_kata_onenemykilled = {{
			1.3,
			6
	}}
	self.values.temporary.gun_kata_onplayerdodge = {{
			1.3,
			6
	}}
	self.values.temporary.dodge_movement_speed = {{
			1.1,
			6
	}}
	self.values.player.uncover_multiplier = {1.3}
	self.values.player.camouflage_multiplier = {0.85}
	self.values.player.stand_still_crouch_camouflage_bonus = {
		0.9,
		0.85,
		0.7
	}
	self.values.player.camouflage_bonus = {
		0.9,
		0.8
	}
	self.values.team.damage_dampener.team_damage_reduction = {0.92}
	self.values.team.damage_dampener.hostage_multiplier = {0.86}
	self.values.team.armor.multiplier = {1.2}
	self.values.team.health.hostage_multiplier = {1.08}
	self.values.team.stamina.hostage_multiplier = {1.05}
	self.values.player.intimidate_aura = {1000}
	self.values.team.player.civ_intimidation_mul = {1.5}
	self.values.team.health.passive_multiplier = {1.1}
	self.values.team.armor.multiplier = {1.05}
	self.values.player.revived_health_regain = {1.2, 1.5}
	self.values.player.passive_health_regen = {0.08}
	self.values.temporary.passive_armor_regen = {{
		1, 6
	}}
	self.values.player.regain_throwable_from_ammo = {{
			chance = 0.05,
			chance_inc = 0.05
	}}
	self.values.player.level_2_armor_multiplier = {
		1.1,
		1.3,
		1.6
	}
	self.values.player.level_3_armor_multiplier = {
		1.1,
		1.3,
		1.6
	}
	self.values.player.level_4_armor_multiplier = {
		1.1,
		1.3,
		1.6
	}
	self.values.temporary.melee_life_leech = {{
		0.12,
		4,
		1
	}}
	self.values.temporary.dmg_dampener_outnumbered_strong = {
		{
			0.78,
			9
		}
	}
	self.values.temporary.dmg_dampener_close_contact = {
		{
			0.9,
			9
		},
		{
			0.9,
			9
		},
		{
			0.9,
			9
		}
	}
	self.values.temporary.dmg_dodge_close_contact = {{
		0.2,
		9
	}}
	self.values.player.resistance_damage_health_ratio_multiplier = {0.3}
	self.values.player.armor_regen_damage_health_ratio_multiplier = {
		0.3,
		0.5,
		0.7
	}
	self.on_killshot_cooldown = 0
	self.values.player.melee_kill_life_leech = {5}
	self.values.player.killshot_regen_armor_bonus = {1}
	self.values.player.killshot_close_regen_armor_bonus = {2}
	self.values.player.killshot_close_panic_chance = {0.8}
	self.values.player.killshot_combo_meter = {true}
	self.values.player.killshot_combo_regen_armor = {true}
	self.values.player.killshot_combo_regen_health = {0.14}
	self.values.temporary.killshot_combo_regen_dodge = {{
		0.02,
		9
	}}
	self.loose_ammo_restore_health_values = {
		base = 6,
 		cd = 0,
 		multiplier = 0.2,
		{0, 2},
		{0, 4},
		{0, 6}
 	}
	self.values.player.loose_ammo_give_armor = {true}
	self.values.player.loose_ammo_damage_absorption = {1}
	self.loose_ammo_give_team_health_ratio = 0.4
	self.loose_ammo_give_team_ratio = 0.4
	self.values.player.gain_life_per_players = {0.1}
	self.values.temporary.loose_ammo_restore_health = {}	
	
	for i, data in ipairs(self.loose_ammo_restore_health_values) do
		local base = self.loose_ammo_restore_health_values.base

		table.insert(self.values.temporary.loose_ammo_restore_health, {
			{
				base + data[1],
				base + data[2]
			},
			self.loose_ammo_restore_health_values.cd
		})
	end
	
	self.values.temporary.loose_ammo_give_team = {{
		true,
		0
	}}
	self.values.player.loose_ammo_restore_health_give_team = {true}
	self.values.player.loose_ammo_no_restriction = {1}
	self.values.player.increased_pickup_area = {1.4}
	self.values.ammo_bag.take_less_from_ammo_bag = {0.9}
	self.damage_to_hot_data = {
		armors_allowed = {"level_1", "level_2", "level_5"},
		works_with_armor_kit = true,
		tick_time = 1,
		total_ticks = 4,
		max_stacks = false,
		stacking_cooldown = 1,
		add_stack_sources = {
			bullet = true,
			explosion = true,
			melee = true,
			taser_tased = true,
			poison = true,
			fire = true,
			swat_van = true,
			civilian = false
		}
	}
	self.values.player.damage_to_hot = {
		0.2,
		0.3,
		0.4,
		0.6
	}
	self.values.player.armor_health_store_amount = {
		0.4,
		0.8,
		1.6
	}
	self.values.player.damage_to_hot_extra_ticks = {2}
	self.values.player.damage_absorption_addend = {0.8}
	self.cocaine_stacks_convert_levels = {
		100,
		50
	}
	self.cocaine_stacks_dmg_absorption_value = 0.15
	self.cocaine_stacks_tick_t = 1
	self.max_cocaine_stacks_per_tick = 100
	self.max_total_cocaine_stacks = 800
	self.cocaine_stacks_decay_t = 9
	self.cocaine_stacks_decay_amount_per_tick = 800
	self.cocaine_stacks_decay_percentage_per_tick = false
	self.values.player.cocaine_stacking = {1}
	self.values.player.sync_cocaine_stacks = {true}
	self.values.player.cocaine_stacks_decay_multiplier = {700}
	self.values.player.sync_cocaine_upgrade_level = {2}
	self.values.player.cocaine_stack_absorption_multiplier = {1.5}
	self.values.player.cocaine_armor_regen_timer = {true}
	self.values.player.health_decrease = {0.5}
	self.values.player.armor_increase = {
		9,
		21
	}
	self.values.player.armor_grinding = {{
	--[[
		ANARCHIST ARMORS TIER ONE - LIGHTWEIGHT
		Armor bonuses will increase by 0.5 for each armor
		Time to get will increase by 1 seconds for each armor
	--]]
		{	-- Two-Piece Suit--
			2,
			2,
			9
		},
		{	-- Light Ballistic --
			2,
			2,
			9
		},
		{	-- Middle Ballistic --
			2,
			2,
			9
		},
		{	-- Heavy Ballistic --
			2,
			2,
			9
		},
	--[[
		ANARCHIST ARMORS TIER TWO - MEDIUMWEIGHT
		Doubles the last bonus from tier, which is 2.5, multiplies with 2
		Armor bonuses will increase by 1 for each armor
		Also only for this deck - shoot to gain armor effects will be doubled
	--]]
		{	-- Flak Jacket --
			2,
			2,
			9
		},
		{	-- Combined Tactical --
			2,
			2,
			9
		},
	--[[
		ANARCHIST ARMORS TIER THREE - HEAVYWEIGHT
		Instead of 1, last armor get 3 armor
	--]]
		{	-- Improved Tactical --
			2,
			2,
			9
		}
	}}
	self.values.player.damage_to_chaos = {{
		{	-- Suit --
			0,
			1,
			9
		},
		{	-- Light Ballistic --
			0,
			1,
			9
		},
		{	-- Middle Ballistic --
			0,
			1,
			9
		},
		{	-- Heavy Ballistic --
			0,
			1,
			9
		},
		{	-- Flak Jacket --
			0,
			1,
			9
		},
		{	-- Combined Tactical --
			0,
			1,
			9
		},
		{	-- Improved Tactical --
			0,
			1,
			9
		}
	}}
	self.values.player.alarm_pager_speed_multiplier = {0.8}
	self.values.player.crouch_speed_multiplier = {
		1.1,
		1.2
	}
	self.values.player.crouch_dodge_chance = {
		0.1,
		0.25
	}
	self.wild_trigger_time = 1
	self.wild_max_triggers_per_time = 1
	self.values.player.wild_health_amount = {0.4}
	self.values.player.wild_armor_amount = {0.4}
	self.values.player.less_health_wild_armor = {{
		0.05,
		0.1
	}}
	self.values.player.less_armor_wild_health = {{
		0.05,
		0.1
	}}
	self.values.player.wild_damage = {
		2,
		4
	}
	self.values.player.wild_invulnerable = {true}
	self.values.temporary.wild_dis_revive = {
		1,
		1
	}
	self.values.temporary.chico_injector = {{
		0.9,
		4
	}}
	self.values.player.chico_armor_multiplier = {
		1.05,
		1.1,
		1.15
	}
	self.values.player.chico_preferred_target = {true}
	self.values.player.chico_injector_low_health_multiplier = {{
		1,
		0.1
	}}
	self.values.player.chico_injector_health_to_speed = {{
		5,
		1
	}}
	self.values.player.tag_team_base = {{
		kill_health_gain = 1.8,
		radius = 0.6,
		distance = 36,
		kill_extension = 1.0,
		duration = 20,
		tagged_health_gain_ratio = 1
	}}
	self.values.player.tag_team_cooldown_drain = {{
			tagged = 0,
			owner = 0
		},
		{
			tagged = 1,
			owner = 0
	}}
	self.values.player.tag_team_damage_absorption = {{
		kill_gain = 0.1,
		max = 0.8
	}}
	self.values.player.tag_team_end_damage_absorption_user = {true}
	self.values.temporary.damage_absorption = {{
		0.4,
		50
	}}
	self.values.player.smoke_screen_ally_dodge_bonus = {0.2}
	self.values.player.passive_replenish_armor = {{
		{
			1,
			2
		},
		{
			1,
			2
		},
		{
			1,
			2
		},
		{
			1,
			2
		},
		{
			1,
			2
		},
		{
			1,
			2
		},
		{
			1,
			2
		}
	}}
	self.values.player.damage_control_passive = {{
			70,
			9
	}}
	self.values.player.damage_control_cooldown_drain = {{
			99,
			1
		},
		{
			99,
			1
	}}
	self.values.player.pocket_ecm_jammer_base = {{
		affects_cameras = true,
		affects_pagers = true,
		cooldown_drain = 4,
		feedback_interval = 1,
		duration = 6,
		feedback_range = 2500
	}}
	self.values.player.pocket_ecm_heal_on_kill = {4}
	self.values.team.pocket_ecm_heal_on_kill = {4}
	self.values.temporary.pocket_ecm_kill_dodge = {{
			0.2,
			30,
			1
	}}
	self.values.temporary.pocket_ecm_activate_dodge = {{
			0.15,
			90,
			1
	}}
	self.copr_specialization_tree_id = 22
	self.copr_teammate_heal_count_multipliers = {
		1,
		0.5,
		0.35,
		0.25
	}
	self.copr_ability_cooldown = 30
	self.copr_risen_cooldown_add = 60
	self.values.temporary.copr_risen = {{
		1,
		9
	}}
	self.copr_high_damage_multiplier = {
		20,
		1
	}
	self.values.temporary.copr_ability = {
		{
			true,
			9
		},
		{
			true,
			9
		}
	}
	self.values.player.copr_static_damage_ratio = {
		0.058,
		0.058
	}
	self.values.player.copr_kill_life_leech = {
		1,
		1
	}
	self.values.player.copr_activate_bonus_health_ratio = {0.174}
	self.values.player.copr_out_of_health_move_slow = {1}
	self.values.player.copr_speed_up_on_kill = {1}
	self.values.player.copr_teammate_heal = {
		0.01,
		0.02
	}
	self.values.player.activate_ability_downed = {true}
	self.values.player.survive_one_hit = {true}
	self.values.survive_one_hit_armor = {2.0}
	self.values.survive_one_hit_health = {0.01}
	self.values.player.tape_spotter = {true}
	self.values.player.tape_loop_duration = {
		5,
		20
	}
	self.values.player.immune_to_suppression = {true}
	self.values.player.graze_damage = {true}
	self.values.player.graze_shave = {8}
	self.values.carry.no_cooldown = {true}
	self.values.player.alarm_pager_interrupt = {true}
	self.values.player.health_addend = {50}
	self.values.player.level_1_armor_addend = {3}
	self.values.player.level_2_armor_addend = {3}
	self.values.player.level_3_armor_addend = {3}
	self.values.player.level_4_armor_addend = {3}
	self.values.player.level_5_armor_addend = {3}
	self.values.player.level_6_armor_addend = {3}
	self.values.player.level_7_armor_addend = {3}
	self.values.player.special_double_drop = {true}
	self.values.player.hostage_dodge_chance = {0.1}
	self.values.player.wildcard_hotandarmor = {true}
	self.values.player.armor_ricochet_bullets = {true}
	self.values.player.dodge_ricochet_bullets = {{
			0.7,
			1
	}}
	self.values.player.passive_damage_reduction = {0.9}
	self.values.player.dmg_dampener_hostage_taker = {0.9}
	self.values.player.passive_always_regen_armor = {2}
	self.values.player.damage_addend = {30}
	self.values.player.damage_dampener = {0.88}
	self.values.player.suppressed_health_ratio_multiplier = {0.6}
	self.values.player.dmg_interval_health_ratio_multiplier = {2}
	self.values.player.dmg_interval_upgrade = {1.35}
	self.values.player.dmg_interval_perk = {1.4}
	self.values.player.hostage_interval_multiplier = {
		1.6,
		1
	}
	self.values.player.damage_shake_multiplier = {0.6}
	self.values.player.suppressed_multiplier = {0.6}
	self.values.player.damage_armor_gating = {true}
	self.values.player.primary_reload_secondary = {9}
	self.values.player.secondary_reload_primary = {7}
	
	--[[if sydchSO.settings.skillOVERHAUL == 2 then
	self.values.player.passive_dodge_chance = {
		0.15, 
		0.3, 
		0.45
	}
	self.values.player.tier_armor_multiplier = {
		1.05,
		1.1,
		1.2,
		1.3,
		1.35,
		1.35
	}
	self.values.player.level_2_dodge_addend = {
		0.05,
		0.15,
		0.25,
		0.3
	}
	self.values.player.level_3_dodge_addend = {
		0.05,
		0.15,
		0.25,
		0.3
	}
	self.values.player.level_4_dodge_addend = {
		0.05,
		0.15,
		0.25,
		0.3
	}
	end]]--
	end
------------------------------------------------------------------
-- DEFINITIONS
------------------------------------------------------------------
-- Player
	if sydchSO.settings.skillOVERHAUL == 2 then
	self.definitions.player_killshot_combo_meter = {
		name_id = "menu_player_killshot_combo_meter",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "killshot_combo_meter",
			category = "player"
		}
	}
	self.definitions.player_killshot_combo_regen_armor = {
		name_id = "menu_player_killshot_combo_regen_armor",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "killshot_combo_regen_armor",
			category = "player"
		}
	}
	self.definitions.player_killshot_combo_regen_health = {
		name_id = "menu_player_killshot_combo_regen_health",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "killshot_combo_regen_health",
			category = "player"
		}
	}
	self.definitions.temporary_killshot_combo_regen_dodge = {
		name_id = "menu_temporary_killshot_combo_regen_dodge",
		category = "temporary",
		upgrade = {
			value = 1,
			upgrade = "killshot_combo_regen_dodge",
			category = "temporary"
		}
	}
	self.definitions.player_pocket_ecm_activate_dodge = {
		name_id = "menu_player_pocket_ecm_activate_dodge",
		category = "temporary",
		upgrade = {
			value = 1,
			upgrade = "pocket_ecm_activate_dodge",
			category = "temporary"
		}
	}
	self.definitions.player_damage_absorption_outnumbered = {
		name_id = "menu_player_dmg_absorption_outnumbered",
		category = "temporary",
		upgrade = {
			value = 1,
			upgrade = "dmg_absorption_outnumbered",
			category = "temporary"
		}
	}
	self.definitions.player_damage_dodge_close_contact = {
		name_id = "menu_player_dmg_dodge_close_contact",
		category = "temporary",
		upgrade = {
			value = 1,
			upgrade = "dmg_dodge_close_contact",
			category = "temporary"
		}
	}
	self.definitions.player_damage_dodge_outnumbered = {
		name_id = "menu_player_dmg_dodge_outnumbered",
		category = "temporary",
		upgrade = {
			value = 1,
			upgrade = "dmg_dodge_outnumbered",
			category = "temporary"
		}
	}
	self.definitions.player_hostage_dodge_chance = {
		name_id = "menu_player_hostage_dodge_chance",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "hostage_dodge_chance",
			category = "player"
		}
	}	
	self.definitions.player_dmg_interval_upgrade = {
		name_id = "menu_player_dmg_interval_upgrade",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "dmg_interval_upgrade",
			category = "player"
		}
	}
	self.definitions.player_dmg_interval_perk = {
		name_id = "menu_player_dmg_interval_perk",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "dmg_interval_perk",
			category = "player"
		}
	}
	self.definitions.player_dmg_interval_health_ratio_multiplier = {
		name_id = "menu_player_dmg_interval_health_ratio_multiplier",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "dmg_interval_health_ratio_multiplier",
			category = "player"
		}
	}
	self.definitions.player_hostage_interval_multiplier = {
		name_id = "menu_player_hostage_interval_multiplier",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "hostage_interval_multiplier",
			category = "player"
		}
	}
	self.definitions.player_damage_armor_gating = {
		name_id = "menu_player_damage_armor_gating",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "damage_armor_gating",
			category = "player"
		}
	}
	self.definitions.temporary_combat_medic_enter_steelsight_speed_multiplier = {
		name_id = "menu_temporary_combat_medic_enter_steelsight_speed_multiplier",
		category = "temporary",
		upgrade = {
			value = 1,
			upgrade = "combat_medic_enter_steelsight_speed_multiplier",
			category = "temporary"
		}
	}
	self.definitions.temporary_combat_medic_swap_speed_multiplier = {
		name_id = "menu_temporary_combat_medic_swap_speed_multiplier",
		category = "temporary",
		upgrade = {
			value = 1,
			upgrade = "combat_medic_swap_speed_multiplier",
			category = "temporary"
		}
	}
	self.definitions.temporary_combat_medic_reload_speed_multiplier = {
		name_id = "menu_temporary_combat_medic_reload_speed_multiplier",
		category = "temporary",
		upgrade = {
			value = 1,
			upgrade = "combat_medic_reload_speed_multiplier",
			category = "temporary"
		}
	}
	self.definitions.player_temp_steelsight_weapon_faster_1 = {
		name_id = "menu_player_temp_steelsight_weapon_faster",
		category = "temporary",
		upgrade = {
			value = 1,
			upgrade = "steelsight_weapon_faster",
			category = "temporary"
		}
	}
	self.definitions.player_dmg_dampener_hostage_taker = {
		name_id = "menu_player_dmg_dampener_hostage_taker",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "dmg_dampener_hostage_taker",
			category = "player"
		}
	}
	self.definitions.temporary_gun_kata_onenemykilled = {
		name_id = "menu_temporary_gun_kata_onenemykilled",
		category = "temporary",
		upgrade = {
			value = 1,
			upgrade = "gun_kata_onenemykilled",
			category = "temporary"
		}
	}
	self.definitions.temporary_gun_kata_onplayerdodge = {
		name_id = "menu_temporary_gun_kata_onplayerdodge",
		category = "temporary",
		upgrade = {
			value = 1,
			upgrade = "gun_kata_onplayerdodge",
			category = "temporary"
		}
	}
	self.definitions.temporary_dodge_movement_speed = {
		name_id = "menu_temporary_dodge_movement_speed",
		category = "temporary",
		upgrade = {
			value = 1,
			upgrade = "dodge_movement_speed",
			category = "temporary"
		}
	}
	self.definitions.temporary_armor_break_invulnerable = {
		name_id = "menu_player_health_multiplier",
		category = "temporary",
		upgrade = {
			value = 1,
			upgrade = "armor_break_invulnerable",
			category = "temporary"
		}
	}
	self.definitions.player_armor_increase_1 = {
		name_id = "menu_player_health_to_armor_conversion",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "armor_increase",
			category = "player"
		}
	}
	self.definitions.player_armor_increase_2 = {
		name_id = "menu_player_health_to_armor_conversion",
		category = "feature",
		upgrade = {
			value = 2,
			upgrade = "armor_increase",
			category = "player"
		}
	}
	self.definitions.temporary_armor_break_chaos = {
		name_id = "menu_temporary_armor_break_chaos",
		category = "temporary",
		upgrade = {
			value = 1,
			upgrade = "armor_break_chaos",
			category = "temporary"
		}
	}
	self.definitions.player_panic_when_chaos = {
		name_id = "menu_player_panic_when_chaos",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "panic_when_chaos",
			category = "player"
		}
	}
	self.definitions.player_dodge_replenish_health = {
		name_id = "menu_player_dodge_replenish_health",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "dodge_replenish_health",
			category = "player"
		}
	}
	self.definitions.player_passive_replenish_armor = {
		name_id = "menu_player_passive_replenish_armor",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "passive_replenish_armor",
			category = "player"
		}
	}
	self.definitions.player_dodge_grace = {
		name_id = "menu_player_dodge_grace",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "dodge_grace",
			category = "player"
		}
	}
	self.definitions.player_pick_up_ammo_multiplier = {
		name_id = "menu_player_pick_up_ammo_multiplier",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "pick_up_ammo_multiplier",
			category = "player"
		}
	}
	self.definitions.player_pick_up_ammo_multiplier_2 = {
		name_id = "menu_player_pick_up_ammo_multiplier_2",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "pick_up_ammo_multiplier_2",
			category = "player"
		}
	}
	self.definitions.player_special_double_drop = {
		name_id = "menu_player_special_double_drop",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "special_double_drop",
			category = "player"
		}
	}
	self.definitions.player_health_addend = {
		name_id = "menu_player_health_addend",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "health_addend",
			category = "player"
		}
	}
	self.definitions.player_level_2_less_dodge_penalty_sicario = {
		incremental = true,
		name_id = "menu_player_level_2_less_dodge_penalty_sicario",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "level_2_less_dodge_penalty_sicario",
			category = "player"
		}
	}
	self.definitions.player_level_2_less_dodge_penalty = {
		incremental = true,
		name_id = "menu_player_level_2_less_dodge_penalty",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "level_2_less_dodge_penalty",
			category = "player"
		}
	}
	self.definitions.player_level_3_less_dodge_penalty = {
		incremental = true,
		name_id = "menu_player_level_3_less_dodge_penalty",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "level_3_less_dodge_penalty",
			category = "player"
		}
	}
	self.definitions.player_level_4_less_dodge_penalty = {
		incremental = true,
		name_id = "menu_player_level_2_less_dodge_penalty",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "level_2_less_dodge_penalty",
			category = "player"
		}
	}
	self.definitions.player_level_2_dodge_addend_4 = {
		incremental = true,
		name_id = "menu_player_level_2_dodge_addend",
		category = "feature",
		upgrade = {
			value = 4,
			upgrade = "level_2_dodge_addend",
			category = "player"
		}
	}
	self.definitions.player_level_3_dodge_addend_4 = {
		incremental = true,
		name_id = "menu_player_level_3_dodge_addend",
		category = "feature",
		upgrade = {
			value = 4,
			upgrade = "level_3_dodge_addend",
			category = "player"
		}
	}
	self.definitions.player_level_4_dodge_addend_4 = {
		incremental = true,
		name_id = "menu_player_level_4_dodge_addend",
		category = "feature",
		upgrade = {
			value = 4,
			upgrade = "level_4_dodge_addend",
			category = "player"
		}
	}
	self.definitions.player_level_1_armor_addend = {
		name_id = "menu_player_level_1_armor_addend",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "level_1_armor_addend",
			category = "player"
		}
	}
	self.definitions.player_level_5_armor_addend = {
		name_id = "menu_player_level_5_armor_addend",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "level_5_armor_addend",
			category = "player"
		}
	}
	self.definitions.player_level_6_armor_addend = {
		name_id = "menu_player_level_6_armor_addend",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "level_6_armor_addend",
			category = "player"
		}
	}
	self.definitions.player_level_7_armor_addend = {
		name_id = "menu_player_level_7_armor_addend",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "level_7_armor_addend",
			category = "player"
		}
	}
	self.definitions.player_immune_to_suppression = {
		name_id = "menu_player_immune_to_suppression",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "immune_to_suppression",
			category = "player"
		}
	}
	self.definitions.player_throwables_multiplier = {
		name_id = "menu_player_throwables_multiplier",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "throwables_multiplier",
			category = "player"
		}
	}
	self.definitions.player_tape_spotter = {
		name_id = "menu_player_tape_spotter",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "tape_spotter",
			category = "player"
		}
	}
	self.definitions.player_passive_extend_critical_hit = {
		name_id = "player_passive_extend_critical_hit",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "passive_extend_critical_hit",
			category = "player"
		}
	}	
	self.definitions.temporary_passive_armor_regen = {
		name_id = "temporary_passive_armor_regen",
		category = "temporary",
		upgrade = {
			value = 1,
			upgrade = "passive_armor_regen",
			category = "temporary"
		}
	}
	self.definitions.temporary_melee_life_leech = {
		name_id = "menu_temporary_melee_life_leech",
		category = "temporary",
		upgrade = {
			value = 1,
			upgrade = "melee_life_leech",
			category = "temporary"
		}
	}
	self.definitions.player_melee_swing_multiplier_delay = {
		category = "feature",
		name_id = "menu_melee_swing_multiplier_delay",
		upgrade = {
			value = 1,
			upgrade = "melee_swing_multiplier_delay",
			category = "player"
		}
	}
	self.definitions.player_panic_when_kill = {
		name_id = "menu_player_panic_when_kill",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "panic_when_kill",
			category = "player"
		}
	}
	self.definitions.player_temp_fall_damage_regen = {
		name_id = "menu_player_temp_fall_damage_regen",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "fall_damage_regen",
			category = "temporary"
		}
	}
	self.definitions.player_temp_health_regen = {
		name_id = "menu_player_temp_health_regen",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "health_regen",
			category = "temporary"
		}
	}
	self.definitions.player_temp_health_multiplier = {
		name_id = "menu_player_temp_health_multiplier",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "health_multiplier",
			category = "temporary"
		}
	}
	self.definitions.player_temp_dodge = {
		name_id = "menu_player_temp_dodge",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "dodge",
			category = "temporary"
		}
	}
	self.definitions.player_stamina_to_dodge = {
		name_id = "menu_player_stamina_to_dodge",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "stamina_to_dodge",
			category = "player"
		}
	}
	self.definitions.player_dodge_replenish_stamina = {
		name_id = "menu_player_dodge_replenish_stamina",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "dodge_replenish_stamina",
			category = "player"
		}
	}
	self.definitions.player_lethal_headshot_regen_armor_extra = {
		name_id = "menu_player_lethal_headshot_regen_armor_extra",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "lethal_headshot_regen_armor_extra",
			category = "player"
		}
	}
	self.definitions.ammo_bag_take_less_from_ammo_bag = {
		name_id = "menu_ammo_bag_take_less_from_ammo_bag",
		category = "equipment_upgrade",
		upgrade = {
			value = 1,
			upgrade = "take_less_from_ammo_bag",
			category = "ammo_bag"
		}
	}
	self.definitions.player_health_decrease = {
		name_id = "menu_player_health_decrease",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "health_decrease",
			category = "player"
		}
	}
	self.definitions.player_damage_to_chaos = {
		name_id = "menu_player_damage_to_chaos",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "damage_to_chaos",
			category = "player"
		}
	}
	self.definitions.player_resistance_damage_health_ratio_multiplier = {
		name_id = "menu_player_resistance_damage_health_ratio_multiplier",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "resistance_damage_health_ratio_multiplier",
			category = "player"
		}
	}
	self.definitions.player_suppressed_health_ratio_multiplier = {
		name_id = "menu_player_suppressed_health_ratio_multiplier",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "suppressed_health_ratio_multiplier",
			category = "player"
		}
	}
	self.definitions.player_loose_ammo_give_armor = {
		name_id = "menu_player_loose_ammo_give_armor",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "loose_ammo_give_armor",
			category = "player"
		}
	}
	self.definitions.player_loose_ammo_damage_absorption = {
		name_id = "menu_player_loose_ammo_damage_absorption",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "loose_ammo_damage_absorption",
			category = "player"
		}
	}
	self.definitions.player_loose_ammo_no_restriction = {
		name_id = "menu_player_loose_ammo_no_restriction",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "loose_ammo_no_restriction",
			category = "player"
		}
	}
	self.definitions.player_melee_blunt_knockdown_mul = {
		name_id = "menu_player_melee_blunt_knockdown_mul",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "melee_blunt_knockdown_mul",
			category = "player"
		}
	}
	self.definitions.player_detection_risk_add_movement_speed = {
		category = "feature",
		name_id = "menu_player_detection_risk_add_movement_speed",
		upgrade = {
			value = 1,
			category = "player",
			upgrade = "detection_risk_add_movement_speed"
		}
	}
	self.definitions.player_passive_armor_movement_penalty_multiplier = {
		name_id = "menu_passive_armor_movement_penalty_multiplier",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "passive_armor_movement_penalty_multiplier",
			category = "player"
		}
	}
	self.definitions.player_threat_intimidate = {
		category = "feature",
		name_id = "menu_player_threat_intimidate",
		upgrade = {
			category = "player",
			upgrade = "threat_intimidate",
			value = 1
		}
	}
	self.definitions.player_revive_reload = {
		category = "feature",
		name_id = "menu_player_revive_reload",
		upgrade = {
			category = "player",
			upgrade = "revive_reload",
			value = 1
		}
	}
	self.definitions.player_revive_interaction_speed_multiplier_1 = {
		name_id = "menu_player_revive_interaction_speed_multiplier",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "revive_interaction_speed_multiplier",
			category = "player"
		}
	}
	self.definitions.player_revive_interaction_speed_multiplier_2 = {
		name_id = "menu_player_revive_interaction_speed_multiplier",
		category = "feature",
		upgrade = {
			value = 2,
			upgrade = "revive_interaction_speed_multiplier",
			category = "player"
		}
	}
	self.definitions.player_survive_one_hit = {
		name_id = "menu_player_survive_one_hit",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "survive_one_hit",
			category = "player"
		}
	}
	self.definitions.player_vehicle_dodge_chance = {
		category = "feature",
		name_id = "menu_player_vehicle_dodge_chance",
		upgrade = {
			category = "player",
			upgrade = "vehicle_dodge_chance",
			value = 1
		}
	}
	self.definitions.player_moving_dodge_chance = {
		category = "feature",
		name_id = "menu_player_moving_dodge_chance",
		upgrade = {
			category = "player",
			upgrade = "moving_dodge_chance",
			value = 1
		}
	}
	self.definitions.player_distance_dodge_chance = {
		category = "feature",
		name_id = "menu_player_distance_dodge_chance",
		upgrade = {
			category = "player",
			upgrade = "distance_dodge_chance",
			value = 1
		}
	}
	self.definitions.player_dodge_low_revives = {
		category = "feature",
		name_id = "menu_player_dodge_low_revives",
		upgrade = {
			category = "player",
			upgrade = "dodge_low_revives",
			value = 1
		}
	}
	self.definitions.player_revived_health_regain_1 = {
		name_id = "menu_revived_health_regain",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "revived_health_regain",
			category = "player"
		}
	}
	self.definitions.player_revived_health_regain_2 = {
		name_id = "menu_revived_health_regain",
		category = "feature",
		upgrade = {
			value = 2,
			upgrade = "revived_health_regain",
			category = "player"
		}
	}
	self.definitions.player_equipment_hack_speed_multiplier = {
		name_id = "menu_player_equipment_hack_speed_multiplier",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "equipment_hack_speed_multiplier",
			category = "player"
		}
	}
	self.definitions.player_backstab_crit = {
		name_id = "menu_player_backstab_crit",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "backstab_crit",
			category = "player"
		}
	}
	self.definitions.player_armor_absorption = {
		name_id = "menu_player_armor_absorption",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "armor_absorption",
			category = "player"
		}
	}
	self.definitions.player_damage_absorption_addend = {
		name_id = "menu_player_damage_absorption_addend",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "damage_absorption_addend",
			category = "player"
		}
	}
	self.definitions.player_damage_absorption_low_revives = {
		name_id = "menu_player_damage_absorption_low_revives",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "damage_absorption_low_revives",
			category = "player"
		}
	}
	self.definitions.player_infinite_messiah = {
		name_id = "menu_player_infinite_messiah",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "infinite_messiah",
			category = "player"
		}
	}
	self.definitions.player_infinite_messiah_faster = {
		name_id = "menu_player_infinite_messiah_faster",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "infinite_messiah_faster",
			category = "player"
		}
	}
	self.definitions.player_gangster_damage_dampener = {
		category = "feature",
		name_id = "menu_player_gangster_damage_dampener",
		upgrade = {
			category = "player",
			upgrade = "gangster_damage_dampener",
			value = 1
		}
	}
	self.definitions.player_armor_regen_timer_stand_still_multiplier_1 = {
		name_id = "menu_player_armor_regen_timer_stand_still_multiplier",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "armor_regen_timer_stand_still_multiplier",
			category = "player"
		}
	}
	self.definitions.player_armor_regen_timer_stand_still_multiplier_2 = {
		name_id = "menu_player_armor_regen_timer_stand_still_multiplier",
		category = "feature",
		upgrade = {
			value = 2,
			upgrade = "armor_regen_timer_stand_still_multiplier",
			category = "player"
		}
	}
	self.definitions.player_pick_lock_arrested_speed_multiplier = {
		name_id = "menu_player_pick_lock_arrested_speed_multiplier",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "pick_lock_arrested_speed_multiplier",
			category = "player"
		}
	}
	self.definitions.player_cheat_death_once = {
		name_id = "menu_player_cheat_death_once",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "cheat_death_once",
			category = "player"
		}
	}
	self.definitions.player_cheat_death_chance = {
		name_id = "menu_player_cheat_death_chance",
		category = "feature",
		upgrade = {
			value = 2,
			upgrade = "cheat_death_chance",
			category = "player"
		}
	}
	self.definitions.player_graze_damage = {
		name_id = "menu_player_graze_damage",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "graze_damage",
			category = "player"
		}
	}
	self.definitions.player_graze_shave = {
		name_id = "menu_player_graze_shave",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "graze_shave",
			category = "player"
		}
	}
	self.definitions.temporary_wild_dis_revive = {
		name_id = "menu_temporary_wild_dis_revive",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "wild_dis_revive",
			category = "temporary"
		}
	}
	self.definitions.player_wild_damage_1 = {
		name_id = "menu_player_wild_damage",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "wild_damage",
			category = "player"
		}
	}
	self.definitions.player_wild_invulnerable = {
		name_id = "menu_player_wild_invulnerable",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "wild_invulnerable",
			category = "player"
		}
	}
	self.definitions.player_wild_damage_2 = {
		name_id = "menu_player_wild_damage",
		category = "feature",
		upgrade = {
			value = 2,
			upgrade = "wild_damage",
			category = "player"
		}
	}
	self.definitions.pistol_stacking_hit_damage_multiplier = {
		name_id = "menu_pistol_stacking_hit_damage_multiplier",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "stacking_hit_damage_multiplier",
			category = "pistol"
		}
	}
	self.definitions.player_stacked_accuracy_bonus = {
		name_id = "menu_player_stacked_accuracy_bonus",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "stacked_accuracy_bonus",
			category = "player"
		}
	}
	self.definitions.player_alarm_pager_interrupt = {
		name_id = "menu_player_alarm_pager_interrupt",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "alarm_pager_interrupt",
			category = "player"
		}
	}
	self.definitions.player_cocaine_armor_regen_timer = {
		name_id = "menu_player_cocaine_armor_regen_timer",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "cocaine_armor_regen_timer",
			category = "player"
		}
	}
	self.definitions.player_tag_team_end_damage_absorption_user = {
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "tag_team_end_damage_absorption_user",
			category = "player"
		}
	}
	self.definitions.temporary_damage_absorption = {
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "damage_absorption",
			category = "temporary"
		}
	}
	self.definitions.temporary_copr_risen = {
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "copr_risen",
			category = "temporary"
		}
	}
-- Equipment Definitions
	self.definitions.sentry_gun_can_mark_enemy = {
		name_id = "menu_sentry_gun_can_mark_enemy",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "can_mark_enemy",
			category = "sentry_gun"
		}
	}	
	self.definitions.sentry_gun_marked_enemy_damage_bonus = {
		name_id = "menu_sentry_gun_marked_enemy_damage_bonus",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "marked_enemy_damage_bonus",
			category = "sentry_gun"
		}
	}
	self.definitions.trip_mine_marked_enemy_extra_damage = {
		category = "feature",
		name_id = "menu_trip_mine_marked_enemy_extra_damage",
		upgrade = {
			category = "trip_mine",
			upgrade = "marked_enemy_extra_damage",
			value = 1
		}
	}
	self.definitions.cable_tie_pickup_chance = {
		name_id = "menu_cable_tie_pickup_chance",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "pickup_chance",
			category = "cable_tie"
		}
	}
	self.definitions.carry_no_cooldown = {
		name_id = "menu_carry_no_cooldown",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "no_cooldown",
			category = "carry"
		}
	}
-- Weapon Definitions
	self.definitions.player_primary_reload_secondary = {
		name_id = "menu_player_primary_reload_secondary",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "primary_reload_secondary",
			category = "player"
		}
	}
	self.definitions.player_secondary_reload_primary = {
		name_id = "menu_player_secondary_reload_primary",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "secondary_reload_primary",
			category = "player"
		}
	}
	self.definitions.player_damage_addend = {
		name_id = "menu_player_damage_addend",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "damage_addend",
			category = "player"
		}
	}
	self.definitions.weapon_single_shot_fire_rate = {
		name_id = "menu_weapon_single_shot_fire_rate",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "single_shot_fire_rate",
			category = "weapon"
		}
	}
	self.definitions.temporary_reload_fire_rate = {
		name_id = "menu_temporary_reload_fire_rate",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "reload_fire_rate",
			category = "temporary"
		}
	}
	self.definitions.weapon_half_magazine_fire_rate = {
		name_id = "menu_weapon_half_magazine_fire_rate",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "half_magazine_fire_rate",
			category = "weapon"
		}
	}
	self.definitions.akimbo_damage_addend_1 = {
		name_id = "menu_akimbo_damage_addend",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "damage_addend",
			category = "akimbo"
		}
	}
	self.definitions.akimbo_damage_addend_2 = {
		name_id = "menu_akimbo_damage_addend",
		category = "feature",
		upgrade = {
			value = 2,
			upgrade = "damage_addend",
			category = "akimbo"
		}
	}
	self.definitions.weapon_silencer_damage_multiplier_1 = {
		category = "feature",
		name_id = "silencer_damage_multiplier",
		upgrade = {
			category = "weapon",
			upgrade = "silencer_damage_multiplier",
			value = 1
		}
	}
	self.definitions.weapon_silencer_damage_multiplier_2 = {
		category = "feature",
		name_id = "silencer_damage_multiplier",
		upgrade = {
			category = "weapon",
			upgrade = "silencer_damage_multiplier",
			value = 2
		}
	}
	self.definitions.weapon_silencer_instant_kill = {
		category = "feature",
		name_id = "silencer_instant_kill",
		upgrade = {
			category = "weapon",
			upgrade = "silencer_instant_kill",
			value = 1
		}
	}
	self.definitions.player_melee_instant_kill = {
		category = "feature",
		name_id = "melee_instant_kill",
		upgrade = {
			category = "player",
			upgrade = "melee_instant_kill",
			value = 1
		}
	}
	self.definitions.temporary_melee_kill_stacking_hit_damage_multiplier = {
		category = "feature",
		name_id = "melee_kill_stacking_hit_damage_multiplier",
		upgrade = {
			category = "temporary",
			upgrade = "melee_kill_stacking_hit_damage_multiplier",
			value = 1
		}
	}
	--self.definitions.weapon_special_silencer_damage_multiplier = {
	--	category = "feature",
	--	name_id = "special_silencer_damage_multiplier",
	--	upgrade = {
	--		category = "weapon",
	--		upgrade = "special_silencer_damage_multiplier",
	--		value = 1
	--	}
	--}
	self.definitions.weapon_exit_run_speed_multiplier = {
		name_id = "menu_exit_run_speed_multiplier",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "exit_run_speed_multiplier",
			category = "weapon"
		}
	}
	self.definitions.weapon_full_auto_free_ammo = {
		category = "feature",
		name_id = "menu_weapon_full_auto_free_ammo",
		upgrade = {
			category = "weapon",
			upgrade = "full_auto_free_ammo",
			value = 1
		}
	}
-- Category Definitions
	self.definitions.magazine_reload_speed_multiplier = {
		name_id = "menu_magazine_reload_speed",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "reload_speed_multiplier",
			category = "magazine"
		}
	}
	self.definitions.revolver_reload_speed_multiplier = {
		name_id = "menu_revolver_reload_speed",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "reload_speed_multiplier",
			category = "revolver"
		}
	}
	self.definitions.akimbo_reload_speed_multiplier = {
		name_id = "menu_akimbo_reload_speed",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "reload_speed_multiplier",
			category = "akimbo"
		}
	}
	self.definitions.pistol_last_bullet_refill_chance = {
		name_id = "menu_pistol_last_bullet_refill_chance",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "last_bullet_refill_chance",
			category = "pistol"
		}
	}
	self.definitions.pistol_extra_ammo_multiplier = {
		incremental = true,
		name_id = "menu_pistol_extra_ammo_multiplier",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "extra_ammo_multiplier",
			category = "pistol"
		}
	}
	self.definitions.lmg_fire_rate_multiplier = {
		category = "feature",
		name_id = "menu_lmg_fire_rate_multiplier",
		upgrade = {
			category = "lmg",
			upgrade = "fire_rate_multiplier",
			value = 1
		}
	}
	self.definitions.akimbo_fire_rate_multiplier_1 = {
		category = "feature",
		name_id = "menu_akimbo_fire_rate_multiplier",
		upgrade = {
			category = "akimbo",
			upgrade = "fire_rate_multiplier",
			value = 1
		}
	}
	self.definitions.akimbo_fire_rate_multiplier_2 = {
		category = "feature",
		name_id = "menu_akimbo_fire_rate_multiplier",
		upgrade = {
			category = "akimbo",
			upgrade = "fire_rate_multiplier",
			value = 2
		}
	}
	self.definitions.lmg_reload_speed_multiplier_2 = {
		category = "feature",
		name_id = "menu_lmg_reload_speed_multiplier",
		upgrade = {
			category = "lmg",
			upgrade = "reload_speed_multiplier",
			value = 2
		}
	}
	self.definitions.smg_reload_speed_multiplier_2 = {
		category = "feature",
		name_id = "menu_smg_reload_speed_multiplier",
		upgrade = {
			category = "smg",
			upgrade = "reload_speed_multiplier",
			value = 2
		}
	}
	self.definitions.akimbo_swap_speed_multiplier = {
		name_id = "menu_akimbo_swap_speed_multiplier",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "swap_speed_multiplier",
			category = "akimbo"
		}
	}	
	self.definitions.shell_clip_ammo_increase = {
		name_id = "menu_shell_clip_ammo_increase",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "clip_ammo_increase",
			category = "shell"
		}
	}
	self.definitions.shotgun_swap_speed_multiplier = {
		name_id = "menu_shotgun_swap_speed_multiplier",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "swap_speed_multiplier",
			category = "shotgun"
		}
	}
	self.definitions.player_overkill_close_range = {
		name_id = "menu_player_overkill_close_range",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "overkill_close_range",
			category = "player"
		}
	}
	self.definitions.shotgun_ignore_shields = {
		name_id = "menu_shotgun_ignore_shields",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "ignore_shields",
			category = "shotgun"
		}
	}
	self.definitions.pump_action_fire_rate_multiplier = {
		category = "feature",
		name_id = "menu_pump_action_fire_rate_multiplier",
		upgrade = {
			category = "pump_action",
			upgrade = "fire_rate_multiplier",
			value = 1
		}
	}
	self.definitions.pump_action_extra_rays = {
		name_id = "menu_pump_action_extra_rays",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "extra_rays",
			category = "pump_action"
		}
	}
-- Specifical Definitions
	self.definitions.saw_rip_and_tear = {
		name_id = "menu_saw_rip_and_tear",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "rip_and_tear",
			category = "saw"
		}
	}
	self.definitions.saw_consume_no_ammo_chance = {
		name_id = "menu_saw_consume_no_ammo_chance",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "consume_no_ammo_chance",
			category = "saw"
		}
	}
	self.definitions.saw_enter_steelsight_speed_multiplier = {
		name_id = "menu_aw_enter_steelsight_speed_multiplier",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "enter_steelsight_speed_multiplier",
			category = "saw"
		}
	}
	self.definitions.rocket_launcher_extra_ammo_multiplier = {
	name_id = "menu_rocket_launcher_extra_ammo_multiplier",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "extra_ammo_multiplier",
			category = "rocket_launcher"
		}
	}
	self.definitions.shell_reload_speed_multiplier = {
	name_id = "menu_shell_reload_speed_multiplier",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "reload_speed_multiplier",
			category = "shell"
		}
	}
	self.definitions.magazine_clip_ammo_increase = {
		name_id = "menu_magazine_clip_ammo_increase_1",
		category = "feature",
		upgrade = {
			value = 1,
			upgrade = "clip_ammo_increase",
			category = "magazine"
		}
	}
	end
-- AI Definitions
	self.crew_skill_definitions.crew_motivated = {
		name_id = "menu_crew_motivated",
		icon = "skill_4",
		upgrades = {
			{
				value = 1,
				upgrade = "crew_add_stamina",
				category = "team"
			}
		}
	}
	self.crew_skill_definitions.crew_eager = {
		name_id = "menu_crew_eager",
		icon = "skill_8",
		upgrades = {
			{
				value = 1,
				upgrade = "crew_faster_reload",
				category = "team"
			}
		}
	}
	self.crew_skill_definitions.crew_tier = {
		name_id = "menu_crew_tier",
		icon = "skill_9",
		upgrades = {
			{
				value = 1,
				upgrade = "crew_tier",
				category = "team"
			}
		}
	}
	self.crew_skill_definitions.crew_absorption = {
		name_id = "menu_crew_absorption",
		icon = "skill_10",
		upgrades = {
			{
				value = 1,
				upgrade = "crew_absorption",
				category = "team"
			}
		}
	}
	self.crew_skill_definitions.crew_hard = {
		name_id = "menu_crew_hard",
		icon = "skill_11",
		upgrades = {
			{
				value = 1,
				upgrade = "crew_hard",
				category = "team"
			}
		}
	}
	self.crew_skill_definitions.crew_reduce_speed_penalty = {
		name_id = "menu_crew_reduce_speed_penalty",
		icon = "skill_12",
		upgrades = {
			{
				value = 1,
				upgrade = "crew_reduce_speed_penalty",
				category = "team"
			}
		}
	}
	self.crew_skill_definitions.crew_faster_swap = {
		name_id = "menu_crew_faster_swap",
		icon = "skill_13",
		upgrades = {
			{
				value = 1,
				upgrade = "crew_faster_swap",
				category = "team"
			}
		}
	}
	self.crew_skill_definitions.crew_aimer = {
		name_id = "menu_crew_aimer",
		icon = "skill_14",
		upgrades = {
			{
				value = 1,
				upgrade = "crew_aimer",
				category = "team"
			}
		}
	}
	self.crew_skill_definitions.crew_melee_multiplier = {
		name_id = "menu_crew_melee_multiplier",
		icon = "skill_15",
		upgrades = {
			{
				value = 1,
				upgrade = "crew_melee_multiplier",
				category = "team"
			}
		}
	}
	self.crew_skill_definitions.crew_stabilizer = {
		name_id = "menu_crew_stabilizer",
		icon = "skill_16",
		upgrades = {
			{
				value = 1,
				upgrade = "crew_stabilizer",
				category = "team"
			}
		}
	}
	self.crew_ability_definitions.crew_inspire = {
		name_id = "menu_crew_inspire",
		icon = "ability_1"
	}
	self.crew_ability_definitions.crew_scavenge = {
		name_id = "menu_crew_scavenge",
		icon = "ability_2"
	}
	self.crew_ability_definitions.crew_interact = {
		name_id = "menu_crew_interact",
		icon = "ability_3"
	}
	self.crew_ability_definitions.crew_ai_ap_ammo = {
		name_id = "menu_crew_ai_ap_ammo",
		icon = "ability_4"
	}
		self.crew_ability_definitions.crew_shock_n_awe = {
		name_id = "menu_crew_shock_n_awe",
		icon = "ability_5"
	}
	self.crew_ability_definitions.crew_die_hard = {
		name_id = "menu_crew_die_hard",
		icon = "ability_6"
	}
	self.crew_ability_definitions.crew_heavy_impact = {
		name_id = "menu_crew_heavy_impact",
		icon = "ability_7"
	}
	self.crew_ability_definitions.crew_feign_death = {
		name_id = "menu_crew_feign_death",
		icon = "ability_8"
	}
	self.crew_ability_definitions.crew_sixth_sense = {
		name_id = "menu_crew_sixth_sense",
		icon = "ability_9"
	}
	self.crew_ability_definitions.crew_cable_guy = {
		name_id = "menu_crew_cable_guy",
		icon = "ability_10"
	}
	self.crew_ability_definitions.crew_nine_lives = {
		name_id = "menu_crew_nine_lives",
		icon = "ability_11"
	}
	self.crew_ability_definitions.crew_fully_loaded = {
		name_id = "menu_crew_fully_loaded",
		icon = "ability_12"
	}
	self.crew_ability_definitions.crew_thick_skin = {
		name_id = "menu_crew_thick_skin",
		icon = "ability_13"
	}
	self.crew_ability_definitions.crew_kickstarter = {
		name_id = "menu_crew_kickstarter",
		icon = "ability_14"
	}
	self.crew_ability_definitions.crew_control_freak = {
		name_id = "menu_crew_control_freak",
		icon = "ability_15"
	}
	self.crew_ability_definitions.crew_pack_mule = {
		name_id = "menu_crew_pack_mule",
		icon = "ability_16"
	}
------------------------------------------------------------------
-- CREW MANAGEMENT
------------------------------------------------------------------
	self.values.team.crew_active = {
		1,
		2,
		3
	}
	--
	self.values.team.crew_add_health = {5}
	self.values.team.crew_add_armor = {3}
	self.values.team.crew_add_dodge = {0.05}
	self.values.team.crew_add_concealment = {3}
	self.values.team.crew_add_stamina = {30}
	self.values.team.crew_faster_reload = {1.1}
	self.values.team.crew_throwable_regen = {20}
	self.values.team.crew_health_regen = {0.8}
	--
	self.values.team.crew_tier = {90}
	self.values.team.crew_absorption = {0.2}
	self.values.team.crew_hard = {0.95}
	self.values.team.crew_reduce_speed_penalty = {0.2}
	self.values.team.crew_faster_swap = {1.3}
	self.values.team.crew_aimer = {1.5}
	self.values.team.crew_melee_multiplier = {1.1}
	self.values.team.crew_stabilizer = {0.8}
	--
	self.values.team.crew_inspire = {{
			230,
			160,
			120
	}}
	self.values.team.crew_scavenge = {{
			0.4,
			0.5,
			0.6
	}}
	self.values.team.crew_interact = {{
			0.8,
			0.6,
			0.4
	}}
	self.values.team.crew_ai_ap_ammo = {true}
	--
	self.values.team.crew_cable_guy = {{
			true,
			true,
			true
	}}
	self.values.team.crew_control_freak = {{
			1,
			2,
			2
	}}
	self.values.team.crew_pack_mule = {{
			false,
			true,
			true
	}}
	self.values.team.crew_feign_death = {{
			230,
			160,
			120
	}}
	self.values.team.crew_sixth_sense = {{
			90,
			75,
			60
	}}
	self.values.team.crew_shock_n_awe = {{
			1.2,
			1.3,
			1.4
	}}
	self.values.team.crew_die_hard = {{
			0.9,
			0.85,
			0.8
	}}
	self.values.team.crew_nine_lives = {true}
	self.values.team.crew_thick_skin = {{
			1,
			1.05,
			1.05
	}}
	self.values.team.crew_fully_loaded = {true}
	self.values.team.crew_heavy_impact = {{
			90,
			70,
			50
	}}
	self.values.team.crew_kickstarter = {true}
------------------------------------------------------------------
-- DISCIPLE ADDITIONS
------------------------------------------------------------------
	if sydchSO.settings.skillOVERHAUL == 2 then
		self.definitions.player_armor_ricochet_bullets = {
			name_id = "menu_player_armor_ricochet_bullets",
			category = "feature",
			upgrade = {
				value = 1,
				upgrade = "armor_ricochet_bullets",
				category = "player"
			}
		}
		self.definitions.player_wildcard_hotandarmor = {
			name_id = "menu_player_wildcard_hotandarmor",
			category = "feature",
			upgrade = {
				value = 1,
				upgrade = "wildcard_hotandarmor",
				category = "player"
			}
		}
		self.values.temporary.mrwi_health_invulnerable = {{
				0.5,
				2,
				30
		}}
	end
------------------------------------------------------------------
-- VR ADDITIONS
------------------------------------------------------------------
	if _G.IS_VR then
		--self.values.player.fall_damage_multiplier = {0.2}
		self.values.carry.movement_speed_multiplier = {1.9}
		self.values.player.non_special_melee_multiplier = {1.9}
		self.values.player.melee_damage_multiplier = {1.9}
	end
end

local _weapon_definitions_original = UpgradesTweakData._weapon_definitions
function UpgradesTweakData:_weapon_definitions(...)
  _weapon_definitions_original(self, ...)
  self.values.snp.graze_damage = {
    {
      radius = 400,
      times = 3,
      damage_factor = 1,
      damage_factor_kill = 1
    },
    {
      radius = 400,
      times = 7,
      damage_factor = 1,
      damage_factor_kill = 1
    }
  }
end