if blt.xaudio then
	blt.xaudio.setup()
else
	return
end

dofile(ModPath .. "lua/core/sydchSO.lua")

local sydchSOid = Idstring(sydchSO._path):key()
local msgr1 = "F"..Idstring("msgr1::"..sydchSOid):key()

local function ratio(max, val)
	return max ~= 0 and val / max or 0
end

local PlayerDamage_restore_health = PlayerDamage.restore_health
function PlayerDamage:restore_health(health_restored, ...)
	local max_health = self:_max_health()
	if self:get_real_health() > (max_health * self._healing_reduction * 0.99) then
		return
	end
	if health_restored * self._healing_reduction == 0 then
		return
	end
	return PlayerDamage_restore_health(self, health_restored, ...)
end

Hooks:PostHook(PlayerDamage, "init", "sydchSO", function(self, unit)
	self._dodge_entropy = 0	
	self._damage_ricochet_bullets_time = 0	
	self._evade_chance = 1	
	self._suppression_max = 0	
	self._chk_suppression_too_soon_max = 0	
	self._distortion_t = 0	
	self._distortion_av = 2.15
	self._chaos_stacks = 1
	self._chaos_t = 0
		
	local interval_upgrade = managers.player:upgrade_value("player", "dmg_interval_upgrade", 1)	
	local interval_perk = managers.player:upgrade_value("player", "dmg_interval_perk", 1)	
	local interval_health_ratio_multiplier = managers.player:upgrade_value("player", "dmg_interval_health_ratio_multiplier", 1) - self:health_ratio()	
	self._dmg_interval = tweak_data.player.damage.MIN_DAMAGE_INTERVAL * interval_upgrade	
	if managers.player:has_category_upgrade("player", "dmg_interval_health_ratio_multiplier") then	
		self._dmg_interval = self._dmg_interval + interval_health_ratio_multiplier	
	end	
	if managers.player:has_category_upgrade("player", "dmg_interval_perk") then	
		self._dmg_interval = self._dmg_interval * interval_perk	
	end	
	self._dmg_interval = self._dmg_interval * managers.player:crew_ability_upgrade_value("crew_thick_skin", 1)
	self._dmg_interval = managers.modifiers:modify_value("PlayerDamage:DamageInterval", self._dmg_interval)
	
	self._can_survive_one_hit = managers.player:has_category_upgrade("player", "survive_one_hit")	
	self._can_keep_health  = false
	self._cheat_death_done = false
	self._cheat_death_done_2 = false
	self._preserve_cheat = false
	self._auto_revive_timer_2 = nil
	self._wild_revive_done = false
	self._block_revive = 0	
	
	self._reinforced_armor = managers.player:has_category_upgrade("player", "armor_regen_timer_multiplier_passive")	
	managers.player:set_damage_absorption("absorption_addend", managers.player:upgrade_value("player", "damage_absorption_addend", 0))	
	managers.player:set_damage_absorption("armor_absorption", managers.player:upgrade_value("player", "armor_absorption", 0) * self:_max_armor())	
	managers.player:set_damage_absorption("crew_absorption", managers.player:upgrade_value("team", "crew_absorption", 0))	
		
	if managers.player:has_activate_temporary_upgrade("temporary", "dmg_absorption_outnumbered", 1) then	
		managers.player:set_damage_absorption("absorption_outnumbered", managers.player:upgrade_value("temporary", "dmg_absorption_outnumbered", 0))	
	elseif managers.player:has_inactivate_temporary_upgrade("temporary", "dmg_absorption_outnumbered", 1) then	
		managers.player:set_damage_absorption("absorption_outnumbered", 0)	
	end	
		
	if sydchSO.settings.skillOVERHAUL == 2 then
		if managers.player:has_activate_temporary_upgrade("temporary", "damage_absorption", 1) then	
			managers.player:set_damage_absorption("absorption_temporary", managers.player:upgrade_value("temporary", "damage_absorption", 0))	
		elseif managers.player:has_inactivate_temporary_upgrade("temporary", "damage_absorption", 1) then	
			managers.player:set_damage_absorption("absorption_temporary", 0)	
		end
		
		if managers.player:has_category_upgrade("player", "damage_to_chaos") then
		local damage_to_chaos_data = managers.player:upgrade_value("player", "damage_to_chaos", nil)
		local armor_data = tweak_data.blackmarket.armors[managers.blackmarket:equipped_armor(true, true)]

			if damage_to_chaos_data and armor_data then
				local idx = armor_data.upgrade_level
				self._damage_to_chaos = {
					armor_value = damage_to_chaos_data[idx][1],
					target_tick = damage_to_chaos_data[idx][2],
					maximum_stack = damage_to_chaos_data[idx][3],
					elapsed = 0
				}
				local elapsed = 0
				local time = Application:time()
	
				local function on_damage(damage_info)
					local attacker_unit = damage_info and damage_info.attacker_unit
	
					if alive(attacker_unit) and attacker_unit:base() and attacker_unit:base().thrower_unit then
						attacker_unit = attacker_unit:base():thrower_unit()
					end
	
					if self._unit == attacker_unit then
						local time = Application:time()
	
						if 1 < time - elapsed then
							elapsed = time
							self._chaos_stacks = self._chaos_stacks + 1
							--managers.chat:send_message(1, "ANARCHIST SYSTEM", "GANIED A DAMAGE STACK.")
						end
					end
				end
				
				CopDamage.register_listener("on_damage", {"on_damage"}, on_damage)
			end
		end
	end
	
	local current_health = self:get_real_health()	
	local max_health = self:_max_health()	
	local health_full = max_health > 0 and max_health == current_health	
	local wildcard = managers.player:has_category_upgrade("player", "wildcard_hotandarmor") and health_full
	
	if managers.player:has_category_upgrade("temporary", "passive_armor_regen") then	
		self._passive_armor_regen_t = 1
	end
	
	if sydchSO.settings.soundIMMERSION == true then
	managers.player:unregister_message(Message.OnPlayerDodge, msgr1)
	managers.player:register_message(Message.OnPlayerDodge, msgr1, function()
		local sydchSOPath
		local random = math.random(1, 90)
		local basePath = "assets/soundbanks/left/dodge"
		local suffix = ""

		if random <= 13 then
			suffix = tostring(random)
		elseif random <= 26 then
			suffix = "high/dodge" .. tostring(random - 13)
		elseif random <= 39 then
			suffix = "low/dodge" .. tostring(random - 26)
		elseif random <= 52 then
			basePath = "assets/soundbanks/right/dodge"
			suffix = tostring(random - 39)
		elseif random <= 65 then
			basePath = "assets/soundbanks/right/high/dodge"
			suffix = tostring(random - 52)
		elseif random <= 78 then
			basePath = "assets/soundbanks/right/low/dodge"
			suffix = tostring(random - 65)
		else
			sydchSOPath = "assets/soundbanks/silence.ogg"
		end

		if sydchSOPath == nil then
			sydchSOPath = "assets/soundbanks/" .. basePath .. suffix .. ".ogg"
		end

		if io.file_is_readable(sydchSO._path .. sydchSOPath) then
			XAudio.UnitSource:new(XAudio.PLAYER, XAudio.Buffer:new(sydchSO._path .. sydchSOPath))
		end
	end)
	end
end)

Hooks:PreHook(PlayerDamage, "pre_destroy", "sydchSO", function(self)
	managers.player:unregister_message(Message.OnPlayerDodge, msgr1)
end)

if sydchSO.settings.skillOVERHAUL == 2 then
function PlayerDamage:_init_armor_grinding_data()
	local armor_grinding_data = managers.player:upgrade_value("player", "armor_grinding", nil) or managers.player:upgrade_value("player", "passive_replenish_armor", nil)

	if armor_grinding_data and armor_grinding_data ~= 0 then
		local armor_data = tweak_data.blackmarket.armors[managers.blackmarket:equipped_armor(true, true)]
		local idx = armor_data.upgrade_level
		self._armor_grinding = {
			armor_value = armor_grinding_data[idx][1],
			target_tick = armor_grinding_data[idx][2],
			maximum_stack = armor_grinding_data[idx][3],
			elapsed = 0
		}

		return true
	end

	return false
end

function PlayerDamage:_update_armor_grinding(t, dt)
	self._armor_grinding.elapsed = self._armor_grinding.elapsed + dt
	if self._armor_grinding.target_tick <= self._armor_grinding.elapsed then
		self._armor_grinding.elapsed = 0
		if self._chaos_stacks > 0 or managers.player:has_category_upgrade("player", "passive_replenish_armor") then
			self:change_armor(self._armor_grinding.armor_value)
			self._chaos_stacks = self._chaos_stacks - 1
			self._next_allowed_dmg_t = Application:digest_value(managers.player:player_timer():time() + self._dmg_interval, true)
		end
	end
end
end

function PlayerDamage:_on_use_armor_bag_event()
	self:_init_armor_grinding_data()
	self:_regenerate_armor()
	
	self:set_health(self:_max_health())
	self:_send_set_health()
	self:_set_health_effect()
	
	for id,weapon in pairs(managers.player:player_unit():inventory():available_selections()) do
		if alive(weapon.unit) then
			weapon.unit:base():replenish()
			managers.hud:set_ammo_amount(id, weapon.unit:base():ammo_info())
		end
		local max_grenades = managers.player:get_max_grenades()
		managers.player:add_grenade_amount(max_grenades)
		managers.player:add_cable_ties(2)
	end
end

function PlayerDamage:_on_damage_event()
	self:set_regenerate_timer_to_max()

	local armor_broken = self:_max_armor() > 0 and self:get_real_armor() <= 0

	if armor_broken and self._has_damage_speed then
		managers.player:activate_temporary_upgrade("temporary", "damage_speed_multiplier")
		if self._has_damage_speed_team then
			managers.player:send_activate_temporary_team_upgrade_to_peers("temporary", "team_damage_speed_multiplier_received")
			self._unit:movement():_change_stamina(10)
		end
	end
	
	if managers.player:has_category_upgrade("player", "wild_invulnerable") then
		self._can_take_dmg_timer = 1
	end
end

function PlayerDamage:on_copr_killshot()
	self._next_allowed_dmg_t = Application:digest_value(managers.player:player_timer():time() + self._dmg_interval, true)
	self._last_received_dmg = self:_max_health()
end

function PlayerDamage:band_aid_health()
	if managers.platform:presence() == "Playing" and (self:arrested() or self:need_revive()) then
		return
	end

	self:change_health(self:_max_health() * self._healing_reduction)
	self._can_take_dmg_timer = 1
	--managers.player:activate_cupcake()
	self._said_hurt = false

	if math.rand(1) < managers.player:upgrade_value("first_aid_kit", "downs_restore_chance", 0) then
		self._revives = Application:digest_value(math.min(self._lives_init + managers.player:upgrade_value("player", "additional_lives", 0), Application:digest_value(self._revives, false) + 1), true)
		self._revive_health_i = math.max(self._revive_health_i - 1, 1)

		managers.environment_controller:set_last_life(Application:digest_value(self._revives, false) <= 1)
	end
end

function PlayerDamage:recover_health()
	if managers.platform:presence() == "Playing" and (self:arrested() or self:need_revive()) then
		self:revive(true)
	end

	self._said_hurt = false
	self._revives = Application:digest_value(self._lives_init + managers.player:upgrade_value("player", "additional_lives", 0), true)
	self._revive_health_i = 1
	self._down_time = tweak_data.player.damage.DOWNED_TIME
	
	managers.environment_controller:set_last_life(false)
	managers.player:activate_cupcake()
	managers.hud:set_player_health({
		current = self:get_real_health(),
		total = self:_max_health(),
		revives = Application:digest_value(self._revives, false)
	})
end

function PlayerDamage:is_friendly_fire(unit)
	if not unit then
		return false
	end
	
	local attacker_mov_ext = alive(unit) and unit:movement()

	if not attacker_mov_ext or attacker_mov_ext:team() ~= self._unit:movement():team() and attacker_mov_ext:friendly_fire() then
		return false
	end

	local my_team = self._unit:movement():team()
	local attacker_team = attacker_mov_ext:team()

	if attacker_team ~= my_team and attacker_mov_ext:friendly_fire() then
		return false
	end

	local friendly_fire = attacker_team and not attacker_team.foes[my_team.id]
	friendly_fire = managers.mutators:modify_value("PlayerDamage:FriendlyFire", friendly_fire)

	return friendly_fire
end

function PlayerDamage:damage_incap(damage)
	damage = damage + tweak_data.player.damage.INCAP_DAMAGE * managers.player:upgrade_value("player", "gangster_damage_dampener", 1)
	local damage_absorption = managers.player:damage_absorption()
	if damage_absorption > 0 then
		damage = math.max(0.1, damage - damage_absorption)
	end
	self:change_health(-1.0 * damage or 0.0)
	if self:get_real_health() == 0 then
		self:change_health(0.1)
	end
	self._can_keep_health = true
end

function PlayerDamage:damage_bullet(attack_data)
	if not self:_chk_can_take_dmg() then
		return
	end

	local pm = managers.player
	local damage_info = {
		result = {variant = "bullet", type = "hurt"},
		attacker_unit = attack_data.attacker_unit}

	if self._god_mode then
		if attack_data.damage > 0 then
			self:_send_damage_drama(attack_data, attack_data.damage)
		end
		self:_call_listeners(damage_info)
		return
	elseif self._invulnerable or self._mission_damage_blockers.invulnerable then
		self:_call_listeners(damage_info)
		return
	elseif self:incapacitated() then
		return
	elseif self:is_friendly_fire(attack_data.attacker_unit) then
		return
	elseif self:_chk_dmg_too_soon(attack_data.damage) then
		return
	elseif self._unit:movement():current_state().immortal then
		return
	elseif self._revive_miss and math.random() < self._revive_miss then
		self:play_whizby(attack_data.col_ray.position)
		return
	end
	
    local distance = mvector3.distance(self._unit:position(), attack_data.attacker_unit:position())
    local damage_falloff = attack_data.damage
    if attack_data.damage == 22.5 and (sydchSO.settings.streamLINED == 2 or sydchSO.settings.streamLINED == 3) then
        damage_falloff = self:heavy_swat_damage(distance)
    end
    if attack_data.damage == 6.75 and (sydchSO.settings.streamLINED == 2 or sydchSO.settings.streamLINED == 3) then
        damage_falloff = self:light_swat_damage(distance)
    end
    attack_data.damage = damage_falloff
	
	self._last_received_dmg = attack_data.damage
	self._next_allowed_dmg_t = Application:digest_value(pm:player_timer():time() + self._dmg_interval, true)
	self._last_hit_time = pm:player_timer():time()
	
	local max_armor = self:_max_armor()
	local damage_absorption = pm:damage_absorption()
	local dmg_mul = pm:damage_reduction_skill_multiplier("bullet")
	local durability = pm:body_armor_value("durability")
	local calc_shot_value = ((max_armor / durability) * dmg_mul) - (damage_absorption)
	
	if attack_data.damage > calc_shot_value and not attack_data.attacker_unit:base()._tweak_table == "sniper" and (sydchSO.settings.streamLINED == 2 or sydchSO.settings.streamLINED == 3) then
		attack_data.damage = math.min(attack_data.damage, calc_shot_value)
	end
	
	if CopDamage.is_gangster(attack_data.attacker_unit:base()._tweak_table) then
		dmg_mul = dmg_mul * managers.player:upgrade_value("player", "gangster_damage_dampener", 1)
	end
	if managers.player:current_state() == "bipod" then
		attack_data.damage = attack_data.damage * managers.player:upgrade_value("player", "interacting_damage_multiplier", 1)
	end
	attack_data.damage = attack_data.damage * dmg_mul
	attack_data.damage = managers.mutators:modify_value("PlayerDamage:TakeDamageBullet", attack_data.damage)
	attack_data.damage = managers.modifiers:modify_value("PlayerDamage:TakeDamageBullet", attack_data.damage, attack_data.attacker_unit:base()._tweak_table)
	
	if _G.IS_VR then
		if tweak_data.vr.long_range_damage_reduction_distance[1] < distance then
			local step = math.clamp(distance / tweak_data.vr.long_range_damage_reduction_distance[2], 0, 1)
			local mul = 1 - math.step(tweak_data.vr.long_range_damage_reduction[1], tweak_data.vr.long_range_damage_reduction[2], step)
			attack_data.damage = attack_data.damage * mul
		end
	end
	
	self:copr_update_attack_data(attack_data)
	
	self:_check_dodge(self._dodge_entropy)
	local dodge_roll = math.random()
	local dodge_chance = self._dodge_chance
	self._do_dodge = false
	self._keep_entropy = false
	
	local max_health = self:_max_health()
	local max_ehp = ((max_health + max_armor) / dmg_mul) + (damage_absorption)
	local threshold = (max_ehp * tweak_data.player.damage.MIN_DAMAGE_THRESHOLD) / 100
	local evade_value = distance / 100
	local evade_roll = math.rand(0, 100)
	evade_value = evade_value * self._evade_chance
	
	if not attack_data.attacker_unit:base()._tweak_table == "sniper" and evade_roll < evade_value and (sydchSO.settings.streamLINED == 2 or sydchSO.settings.streamLINED == 3) then
		self._dodge_bullet = true
	end
	
	if self._dodge_bullet then
		if attack_data.damage > 0 then
			self:_send_damage_drama(attack_data, 0)
		end
		self:_call_listeners(damage_info)
		self:play_whizby(attack_data.col_ray.position)
		self:_hit_direction(attack_data.attacker_unit:position())
		if managers.player:has_category_upgrade("player", "dodge_grace") then
			self._next_allowed_dmg_t = Application:digest_value(pm:player_timer():time() + self._dmg_interval, true)
		end
		self._last_received_dmg = attack_data.damage
		managers.player:send_message(Message.OnPlayerDodge)
		if managers.player:has_category_upgrade("player", "dodge_ricochet_bullets") then
			self:_damage_ricochet_bullets(attack_data)
			managers.player:register_message(Message.OnPlayerDodge, "dodge_ricochet_bullets", on_player_dodged)
		else
			managers.player:unregister_message(Message.OnPlayerDodge, "dodge_ricochet_bullets")
		end
	end
	
	local is_berserker_active = managers.player:has_activate_temporary_upgrade("temporary", "berserker_damage_multiplier")
	if not is_berserker_active then
		if self._dodge_entropy <= 1 then
			self._do_dodge = true
			self._keep_entropy = false
			return
		elseif dodge_roll < dodge_chance then
			self._do_dodge = true
			self._keep_entropy = true
		end
		
		if self._do_dodge then
			if sydchSO.settings.mugshotICON == true then
				managers.hud:set_teammate_condition(HUDManager.PLAYER_PANEL, "mugshot_dodge", "DODGE")
			end
			self._dodge_bullet = true
			return
		else
			if sydchSO.settings.mugshotICON == true then
				managers.hud:set_teammate_condition(HUDManager.PLAYER_PANEL, "mugshot_normal", "STANDARD")
			end
			self._dodge_bullet = false
			if not self._keep_entropy then
				self._dodge_entropy = self._dodge_entropy - 1
			else
				self._keep_entropy = false
			end
		end
	end
	
	if damage_absorption > 0 then
		attack_data.damage = math.max(0, attack_data.damage - damage_absorption)
	end
	-- forget to say this is from crackdown
	if managers.player:has_category_upgrade("player", "wild_damage") then
	local m_head_pos = managers.player:local_player():movement():m_head_pos()
	local weap_unit = managers.player:get_current_state()._equipped_unit
	local enemies = World:find_units_quick(self._unit, "sphere", self._unit:position(), 400, managers.slot:get_mask("enemies"))
	local wild_damage = managers.player:upgrade_value("player", "wild_damage", 0)
	
	for i = 1, #enemies do
		local enemy = enemies[i]
		local dmg_ext = enemy:character_damage()

		if dmg_ext and dmg_ext.damage_simple then
			local center_of_mass = enemy:movement():m_com()
			local attack_dir = center_of_mass - m_head_pos
			mvector3.normalize(attack_dir)

			local attack_data = {
				damage = wild_damage,
				attacker_unit = self._unit,
				no_weapon_stats = true,
				stagger = true,
				pos = center_of_mass,
				attack_dir = attack_dir,
				weapon_unit = weap_unit
			}

			dmg_ext:damage_simple(attack_data)
		end
	end
	end
	
	if attack_data.attacker_unit:base()._tweak_table == "tank" then
		managers.achievment:set_script_data("dodge_this_fail", true)
	end

	if self:get_real_armor() > 0 then
		self._unit:sound():play("player_hit")
	else
		self._unit:sound():play("player_hit_permadamage")
	end

	local shake_armor_multiplier = pm:body_armor_value("damage_shake") * pm:upgrade_value("player", "damage_shake_multiplier", 1) * pm:upgrade_value("team", "crew_stabilizer", 1)
	local gui_shake_number = tweak_data.gui.armor_damage_shake_base / shake_armor_multiplier
	gui_shake_number = gui_shake_number + pm:upgrade_value("player", "damage_shake_addend", 0)
	shake_armor_multiplier = tweak_data.gui.armor_damage_shake_base / gui_shake_number
	local shake_multiplier = math.clamp(attack_data.damage, 0.2, 2) * shake_armor_multiplier

	self._unit:camera():play_shaker("player_bullet_damage", 1 * shake_multiplier)

	if not _G.IS_VR then
		managers.rumble:play("damage_bullet")
	end

	self:_hit_direction(attack_data.attacker_unit:position())
	pm:check_damage_carry(attack_data)

	if sydchSO.settings.streamLINED == 2 or sydchSO.settings.streamLINED == 3 then
		attack_data.damage = math.max(attack_data.damage, threshold)
	else
		attack_data.damage = math.max(attack_data.damage, 0)
	end
	
	attack_data.damage = managers.player:modify_value("damage_taken", attack_data.damage, attack_data)

	if self._bleed_out then
		self:_bleed_out_damage(attack_data)

		return
	end

	if not attack_data.ignore_suppression and not self:is_suppressed() then
		return
	end

	if not self:is_friendly_fire(attack_data.attacker_unit) then
		self:_check_chico_heal(attack_data)
	end

	local armor_reduction_multiplier = 0

	if self:get_real_armor() <= 0 then
		armor_reduction_multiplier = 1
	end

	local health_subtracted = self:_calc_armor_damage(attack_data)

	if attack_data.armor_piercing and not self._reinforced_armor then
		attack_data.damage = attack_data.damage - health_subtracted
	else
		attack_data.damage = attack_data.damage * armor_reduction_multiplier
	end

	health_subtracted = health_subtracted + self:_calc_health_damage(attack_data)

	if not self._bleed_out and health_subtracted > 0 then
		self:_send_damage_drama(attack_data, health_subtracted)
	elseif self._bleed_out then
		self:chk_queue_taunt_line(attack_data)
	end
	
	pm:send_message(Message.OnPlayerDamage, nil, attack_data)
	self:_call_listeners(damage_info)
end

function PlayerDamage:heavy_swat_damage(distance)
    local damage_falloff = 0
    if distance <= 500 then
        damage_falloff = 10
    elseif distance <= 1000 then
        damage_falloff = 7.5
    elseif distance <= 2000 then
        damage_falloff = 7
    elseif distance <= 3000 then
        damage_falloff = 6.8
    elseif distance <= 6000 then
        damage_falloff = 5.2
    else
        damage_falloff = 4.8
    end
    return damage_falloff
end

function PlayerDamage:light_swat_damage(distance)
    local damage_falloff = 0
    if distance <= 500 then
        damage_falloff = 7.5
    elseif distance <= 1000 then
        damage_falloff = 6
    elseif distance <= 2000 then
        damage_falloff = 4.8
    elseif distance <= 3000 then
        damage_falloff = 4.2
    elseif distance <= 4500 then
        damage_falloff = 3.7
    else
        damage_falloff = 3
    end
    return damage_falloff
end

function PlayerDamage:_check_dodge()
    local dodge_value = tweak_data.player.damage.DODGE_INIT or 0
    local armor_dodge_chance = managers.player:body_armor_value("dodge")
    local skill_dodge_chance = managers.player:skill_dodge_chance(self._unit:movement():running(), self._unit:movement():crouching(), self._unit:movement():zipline_unit())
    dodge_value = dodge_value + armor_dodge_chance + skill_dodge_chance
    if managers.player:has_category_upgrade("player", "dodge_low_revives") then
		dodge_value = dodge_value + managers.player:upgrade_value("player", "dodge_low_revives", 0) * self:get_missing_revives()
	end
	local state_dodge_chance = (math.max(0.5, (self._unit:movement():stamina() / tweak_data.player.movement_state.stamina.STAMINA_INIT) - managers.player:player_unit():character_damage():effective_suppression_ratio()))
	dodge_value = dodge_value / 2 * (1 + state_dodge_chance)
    if not self._dodge_entropy or (self._last_hit_time and managers.player:player_timer():time() - self._last_hit_time >= 10) then
        self._dodge_entropy = math.rand(0, 1)
    end
    if self._temporary_dodge_t and TimerManager:game():time() < self._temporary_dodge_t then
        dodge_value = dodge_value + self._temporary_dodge
    end
    local smoke_dodge = 0
    for _, smoke_screen in ipairs(managers.player._smoke_screen_effects or {}) do
        if smoke_screen:is_in_smoke(self._unit) then
            smoke_dodge = tweak_data.projectiles.smoke_screen_grenade.dodge_chance
            break
        end
    end
    dodge_value = 1 - (1 - dodge_value) * (1 - smoke_dodge)
    self._dodge_entropy = self._dodge_entropy + 1 - dodge_value
	-- To trigger chance based dodge anyways.
	self._dodge_chance = dodge_value
	-- And also, dodgers are more safe at a distance.
    self._evade_chance = math.max(1, (1 + dodge_value))
end

function PlayerDamage:_damage_ricochet_bullets(attack_data)
	local hit_chance = managers.player:upgrade_value("player", "dodge_ricochet_bullets")[1]
	local cooldown = managers.player:upgrade_value("player", "dodge_ricochet_bullets")[2]
	local from = Vector3()
	local to = Vector3()
	local dir = Vector3()

	if managers.player:has_category_upgrade("player", "armor_ricochet_bullets") then
		local hit_chance = 1
		local cooldown = 1
	end
	
	local t = TimerManager:game():time()
	local attacker_unit = attack_data.attacker_unit

	if t > self._damage_ricochet_bullets_time + cooldown then
		local player_unit = managers.player:local_player()
		if not attack_data.col_ray or (not alive(attacker_unit) or not attacker_unit:character_damage() or attacker_unit:character_damage():dead() or not attacker_unit:character_damage().damage_simple) then
			return
		end

		mvector3.set(dir, attack_data.col_ray.ray)
		mvector3.negate(dir)
		mvector3.set(to, attack_data.col_ray.position)
		mvector3.set(from, dir)
		mvector3.multiply(from, attack_data.col_ray.distance or 20000)
		mvector3.add(from, to)
		math.point_on_line(from, to, player_unit:movement():m_head_pos(), to)
		mvector3.direction(dir, to, from)
		mvector3.set(from, to)
		mvector3.set(to, dir)
		mvector3.spread(to, 3)
		mvector3.multiply(to, 20000)
		mvector3.add(to, from)

		local ray_hits = RaycastWeaponBase.collect_hits(from, to, {
			ignore_unit = {
				player_unit
			}
		})
		local hit_dmg_ext = nil

		for _, col_ray in ipairs(ray_hits) do
			hit_dmg_ext = col_ray.unit:character_damage()

			if hit_dmg_ext and hit_dmg_ext.damage_simple then
				hit_dmg_ext:damage_simple({
					variant = "bullet",
					damage = attack_data.damage,
					attacker_unit = player_unit,
					pos = col_ray.position,
					attack_dir = dir
				})
				managers.game_play_central:play_impact_flesh({
					col_ray = col_ray
				})
			end

			managers.game_play_central:play_impact_sound_and_effects({
				col_ray = col_ray
			})
		end

		local furthest_hit = ray_hits[#ray_hits]

		if furthest_hit and furthest_hit.distance > 600 or not furthest_hit then
			local trail_effect_table = {
				effect = RaycastWeaponBase.TRAIL_EFFECT,
				normal = dir,
				position = from
			}
			local trail = World:effect_manager():spawn(trail_effect_table)

			if furthest_hit then
				World:effect_manager():set_remaining_lifetime(trail, math.clamp((furthest_hit.distance - 600) / 10000, 0, furthest_hit.distance))
			end
		end
	end
end

local damage_killzone_original = PlayerDamage.damage_killzone
function PlayerDamage:damage_killzone(attack_data)
	if not Global.game_settings.one_down and sydchSO.settings.restorePROJOB == false then
		return damage_killzone_original(self, attack_data)
	end
	local damage_info = {
		result = {
			variant = "killzone",
			type = "hurt"
		}
	}

	if self._god_mode or self._invulnerable or self._mission_damage_blockers.invulnerable then
		self:_call_listeners(damage_info)
		return
	elseif self:incapacitated() or self._unit:movement():current_state().immortal then
		return
	end

	self._unit:sound():play("player_hit")

	if attack_data.instant_death then
		self:set_armor(0)
		self:set_health(0)
		self:_send_set_armor()
		self:_send_set_health()
		managers.hud:set_player_health({
			current = self:get_real_health(),
			total = self:_max_health(),
			revives = Application:digest_value(self._revives, false)
		})
		self:_set_health_effect()
		self:_damage_screen()
		self:_check_bleed_out(nil)
	else
		self:_hit_direction(attack_data.col_ray.origin, attack_data.col_ray.ray)

		if self._bleed_out then
			return
		end

		attack_data.damage = managers.player:modify_value("damage_taken", attack_data.damage, attack_data)
		self:_check_chico_heal(attack_data)
		self:_calc_health_damage(attack_data)
	end

	self:_call_listeners(damage_info)
end

function PlayerDamage:damage_fall(data)
	local damage_info = {
		result = {
			variant = "fall",
			type = "hurt"
		}
	}

	if self._god_mode or self._invulnerable or self._mission_damage_blockers.invulnerable then
		self:_call_listeners(damage_info)

		return
	elseif self:incapacitated() then
		return
	elseif self._unit:movement():current_state().immortal then
		return
	elseif self._mission_damage_blockers.damage_fall_disabled then
		return
	end
	
	local height_limit = 300
	local death_limit = 631

	if _G.IS_VR and managers.player:has_category_upgrade("temporary", "fall_damage_regen") then
		local height_limit = 400
		local death_limit = 731
	end

	if data.height < height_limit then
		return
	end

	local die = death_limit < data.height

	self._unit:sound():play("player_hit")
	managers.environment_controller:hit_feedback_down()
	managers.hud:on_hit_direction(Vector3(0, 0, 0), die and HUDHitDirection.DAMAGE_TYPES.HEALTH or HUDHitDirection.DAMAGE_TYPES.ARMOUR, 0)

	if self._bleed_out and self._unit:movement():current_state_name() ~= "jerry1" then
		return
	end

	local health_damage_multiplier = 0

	if die then
		self._can_survive_one_hit = false
		self._check_berserker_done = false
		
		managers.player:force_end_copr_ability()

		self:set_health(0)

		if self._unit:movement():current_state_name() == "jerry1" then
			self._revives = Application:digest_value(1, true)
		end
	else
		health_damage_multiplier = managers.player:upgrade_value("player", "fall_damage_multiplier", 1) * managers.player:upgrade_value("player", "fall_health_damage_multiplier", 1)
		self:change_health(-(tweak_data.player.fall_health_damage * health_damage_multiplier))
		if managers.player:has_category_upgrade("temporary", "fall_damage_regen") then
			managers.player:activate_temporary_upgrade("temporary", "fall_damage_regen")
		end
	end

	if die or health_damage_multiplier > 0 then
		local alert_rad = tweak_data.player.fall_damage_alert_size or 500
		local new_alert = {
			"vo_cbt",
			self._unit:movement():m_head_pos(),
			alert_rad,
			self._unit:movement():SO_access(),
			self._unit
		}

		managers.groupai:state():propagate_alert(new_alert)
	end

	local max_armor = self:_max_armor()

	if die then
		self._can_survive_one_hit = false
		self:set_armor(0)
	else
		self:change_armor(-max_armor * managers.player:upgrade_value("player", "fall_damage_multiplier", 1))
	end

	SoundDevice:set_rtpc("shield_status", 0)
	self:_send_set_armor()

	self._bleed_out_blocked_by_movement_state = nil

	managers.hud:set_player_health({
		current = self:get_real_health(),
		total = self:_max_health(),
		revives = Application:digest_value(self._revives, false)
	})
	self:_send_set_health()
	self:_set_health_effect()
	self:_damage_screen()
	self:_check_bleed_out(nil, true)
	self:_call_listeners(damage_info)

	return true
end

-- Hoppip's reduced I-frame formula
function PlayerDamage:_chk_dmg_too_soon(damage, ...)
	local next_allowed_dmg_t = type(self._next_allowed_dmg_t) == "number" and self._next_allowed_dmg_t or Application:digest_value(self._next_allowed_dmg_t, false)
	local t = managers.player:player_timer():time()
	if damage <= self._last_received_dmg + 0.01 and next_allowed_dmg_t > t then
		return true
	end
	if next_allowed_dmg_t > t then
		self._old_last_received_dmg = nil
		self._old_next_allowed_dmg_t = nil
	end
end

function PlayerDamage:_calc_armor_damage(attack_data)
	attack_data.damage = attack_data.damage - (self._old_last_received_dmg or 0)
	self._next_allowed_dmg_t = self._old_next_allowed_dmg_t and Application:digest_value(self._old_next_allowed_dmg_t, true) or self._next_allowed_dmg_t
	self._old_last_received_dmg = nil
	self._old_next_allowed_dmg_t = nil
	
	if self._unit:key() == managers.player:player_unit():key() then
		local melee_entry = managers.blackmarket:equipped_melee_weapon()
		if managers.player:player_unit():movement():current_state():_is_meleeing() and tweak_data.blackmarket.melee_weapons[melee_entry].block then
			attack_data.damage = attack_data.damage * tweak_data.blackmarket.melee_weapons[melee_entry].block_shots
		end
	end
	
	local health_subtracted = 0
	if self:get_real_armor() > 0 then
		health_subtracted = self:get_real_armor()
		self:change_armor(-attack_data.damage)
		health_subtracted = health_subtracted - self:get_real_armor()

		self:_damage_screen()
		SoundDevice:set_rtpc("shield_status", self:armor_ratio() * 100)
		self:_send_set_armor()

		if self:get_real_armor() <= 0 then
			local pm = managers.player
			if pm:has_category_upgrade("player", "armor_ricochet_bullets") then
				self:_damage_ricochet_bullets(attack_data)
			end
			self._unit:sound():play("player_armor_gone_stinger")
			managers.hint:show_hint("damage_pad")
			if attack_data.armor_piercing then
				self._unit:sound():play("player_sniper_hit_armor_gone")
			end
			self:_start_regen_on_the_side(pm:upgrade_value("player", "passive_always_regen_armor", 0))
			if pm:has_inactivate_temporary_upgrade("temporary", "armor_break_invulnerable") then
				pm:activate_temporary_upgrade("temporary", "armor_break_invulnerable")
				self._can_take_dmg_timer = pm:temporary_upgrade_value("temporary", "armor_break_invulnerable", 0)
			end
			if pm:has_inactivate_temporary_upgrade("temporary", "armor_break_chaos") then
				pm:activate_temporary_upgrade("temporary", "armor_break_chaos")
				self:change_armor(self._armor_grinding.armor_value * self._chaos_stacks)
				self._chaos_stacks = 0
				self._next_allowed_dmg_t = Application:digest_value(managers.player:player_timer():time() + self._dmg_interval, true)
				if sydchSO.settings.vocalHEISTERS > 1 then
					self._unit:sound():say("g60")
				end
				--managers.chat:send_message(1, "ANARCHIST SYSTEM", "BURNED ALL STACKS.")
			end
		end
	end
	
	local had_armor = self:get_real_armor() > 0
	if health_subtracted > 0 and had_armor and self:get_real_armor() <= 0 and self._can_take_dmg_timer <= 0 and (sydchSO.settings.streamLINED == 2 or sydchSO.settings.streamLINED == 3) then
		self._can_take_dmg_timer = self._dmg_interval + 0.5
	end

	managers.hud:damage_taken()
	return health_subtracted
end

Hooks:PostHook(PlayerDamage, "_send_damage_drama", "sydchSO", function (self, attack_data, health_subtracted)
	if health_subtracted == 0 and self._can_take_dmg_timer and self._can_take_dmg_timer <= 0 and (sydchSO.settings.streamLINED == 2 or sydchSO.settings.streamLINED == 3) then
		self._can_take_dmg_timer = self._dmg_interval + 0.1
	end
end)

function PlayerDamage:_calc_health_damage(attack_data, ...)
	if attack_data.weapon_unit then
		local weap_base = alive(attack_data.weapon_unit) and attack_data.weapon_unit:base()
		local weap_tweak_data = weap_base and weap_base.weapon_tweak_data and weap_base:weapon_tweak_data()

		if weap_tweak_data and weap_tweak_data.slowdown_data then
			self:apply_slowdown(weap_tweak_data.slowdown_data)
		end
	end
	
	if managers.player:has_activate_temporary_upgrade("temporary", "mrwi_health_invulnerable") then
		return 0
	end
	
	attack_data.damage = attack_data.damage - (self._old_last_received_dmg or 0)
	self._next_allowed_dmg_t = self._old_next_allowed_dmg_t and Application:digest_value(self._old_next_allowed_dmg_t, true) or self._next_allowed_dmg_t
	self._old_last_received_dmg = nil
	self._old_next_allowed_dmg_t = nil
	
	if self._unit:key() == managers.player:player_unit():key() then
		local melee_entry = managers.blackmarket:equipped_melee_weapon()
		if managers.player:player_unit():movement():current_state():_is_meleeing() and tweak_data.blackmarket.melee_weapons[melee_entry].block then
			attack_data.damage = attack_data.damage * tweak_data.blackmarket.melee_weapons[melee_entry].block_shots
		end
	end

	local health_subtracted = 0
	health_subtracted = self:get_real_health()
	self:change_health(-attack_data.damage)
	health_subtracted = health_subtracted - self:get_real_health()
	
	if managers.player:has_activate_temporary_upgrade("temporary", "copr_ability") and health_subtracted > 0 then
		local teammate_heal_level = managers.player:upgrade_level_nil("player", "copr_teammate_heal")

		if teammate_heal_level and self:get_real_health() > 0 then
			self._unit:network():send("copr_teammate_heal", teammate_heal_level)
		end
	end
	
	if self._has_mrwi_health_invulnerable then
		local health_threshold = self._mrwi_health_invulnerable_threshold or 0.5
		local is_cooling_down = managers.player:get_temporary_property("mrwi_health_invulnerable", false)

		if self:health_ratio() <= health_threshold and not is_cooling_down then
			local cooldown_time = self._mrwi_health_invulnerable_cooldown or 10

			managers.player:activate_temporary_upgrade("temporary", "mrwi_health_invulnerable")
			managers.player:activate_temporary_property("mrwi_health_invulnerable", cooldown_time, true)
		end
	end
	
	local trigger_skills = table.contains({
		"bullet",
		"explosion",
		"melee",
		"delayed_tick"
	}, attack_data.variant)

	if self:get_real_health() == 0 and trigger_skills then
		self:_chk_cheat_death()
	end

	self:_damage_screen()
	self:_check_bleed_out(trigger_skills)
	managers.hud:set_player_health({
		current = self:get_real_health(),
		total = self:_max_health(),
		revives = Application:digest_value(self._revives, false)
	})
	self:_send_set_health()
	self:_set_health_effect()
	managers.statistics:health_subtracted(health_subtracted)
	return health_subtracted
end

function PlayerDamage:build_suppression(amount)
	if self:_chk_suppression_too_soon(amount) then
		return
	end

	local data = self._supperssion_data
	amount = amount * managers.player:upgrade_value("player", "suppressed_multiplier", 1)
	local morale_boost_bonus = self._unit:movement():morale_boost()

	if morale_boost_bonus then
		amount = amount * morale_boost_bonus.suppression_resistance
	end
	
	if managers.player:has_category_upgrade("player", "suppressed_health_ratio_multiplier") then
		amount = amount * (1 - managers.player:upgrade_value("player", "suppressed_health_ratio_multiplier", 1) * (1 - self:health_ratio()))
	end
	
	amount = amount * tweak_data.player.suppression.receive_mul
	data.value = math.min(tweak_data.player.suppression.max_value, (data.value or 0) + amount * tweak_data.player.suppression.receive_mul)
	self._last_received_sup = amount
	self._next_allowed_sup_t = managers.player:player_timer():time() + self._dmg_interval
	data.decay_start_t = managers.player:player_timer():time() + tweak_data.player.suppression.decay_start_delay
	
	self._distortion_t = self._distortion_t + self._dmg_interval
end

function PlayerDamage:_upd_suppression(t, dt)
	local data = self._supperssion_data
	local immune = managers.player:has_category_upgrade("player", "immune_to_suppression")

	if data.value then
		if data.decay_start_t < t then
			data.value = data.value - dt

			if data.value <= 0 then
				data.value = nil
				data.decay_start_t = nil

				managers.environment_controller:set_suppression_value(0, 0)
			end
		elseif data.value == tweak_data.player.suppression.max_value and self._regenerate_timer and not immune then
			if self._suppression_max == 0 then
				self._listener_holder:call("suppression_max")
				self._suppression_max = self._suppression_max + 1
				local mul = (2 - managers.player:upgrade_value("player", "suppressed_multiplier", 1))
				if managers.player:has_category_upgrade("player", "suppressed_health_ratio_multiplier") then
					mul = mul + (2 - managers.player:upgrade_value("player", "suppressed_health_ratio_multiplier", 1) * (1 - self:health_ratio()))
				end
				local morale_boost_bonus = self._unit:movement():morale_boost()
				if morale_boost_bonus then
					mul = mul * morale_boost_bonus.suppression_resistance
				end
				self._chk_suppression_too_soon_max = managers.player:player_timer():time() + self._dmg_interval + (tweak_data.player.suppression.too_soon * mul)
				self._distortion_av = self._distortion_av + 2
			end
		end

		if data.value then
			managers.environment_controller:set_suppression_value(self:effective_suppression_ratio(), self:suppression_ratio())
		end	
	end
end

function PlayerDamage:reset_suppression()
	self._supperssion_data.value = nil
	self._supperssion_data.decay_start_t = nil
end

function PlayerDamage:_chk_suppression_too_soon(amount)
	if managers.player:player_timer():time() < self._chk_suppression_too_soon_max then
		return true
	end
	
	if amount <= self._last_received_sup and managers.player:player_timer():time() < self._next_allowed_sup_t then
		return true
	end
end

function PlayerDamage:set_regenerate_timer_to_max()
	local mul = managers.player:body_armor_regen_multiplier(alive(self._unit) and self._unit:movement():current_state()._moving, self:health_ratio())
	self._regenerate_timer = tweak_data.player.damage.REGENERATE_TIME * mul 
	self._regenerate_timer = self._regenerate_timer * (1 + managers.player:player_unit():character_damage():effective_suppression_ratio())
	self._regenerate_timer = self._regenerate_timer * managers.player:upgrade_value("player", "armor_regen_time_mul", 1)
	
	--if self._suppression_max then
	--	self._regenerate_timer = self._regenerate_timer * tweak_data.player.suppression.max_penalty
	--end

	self._regenerate_speed = self._regenerate_speed or 1
	self._current_state = self._update_regenerate_timer
end

function PlayerDamage:on_copr_ability_deactivated()
	self._armor_change_blocked = false

	self:set_armor(self:_max_armor())
	self:_send_set_armor()
	
	managers.hud:set_player_health({
		current = self:get_real_health(),
		total = self:_max_health(),
		revives = Application:digest_value(self._revives, false)
	})
end

function PlayerDamage:_regenerate_armor(no_sound)
	if self._unit:sound() and not no_sound then
		self._unit:sound():play("shield_full_indicator")
	end

	self._regenerate_speed = nil

	self:set_armor(self:_max_armor())
	self:_send_set_armor()
	
	if self._suppression_max == 1 then
		self._suppression_max = self._suppression_max - 1
		self._distortion_av = self._distortion_av - 2
		self._chk_suppression_too_soon_max = managers.player:player_timer():time()
	end

	self._current_state = nil
end

local function get_heartbeat_value(t)
    local speed = 550
    local val = math.sin(t * speed)

    if val < 0 then
        val = -math.clamp(math.sin(t * speed + speed / 5), -1, 0)
    end

    return val < 0.4 and 0 or val
end

function PlayerDamage:update(unit, t, dt)
	if _G.IS_VR and self._heartbeat_t and t < self._heartbeat_t then
		local intensity_mul = 1 - (t - self._heartbeat_start_t) / (self._heartbeat_t - self._heartbeat_start_t)
		local controller = self._unit:base():controller():get_controller("vr")

		for i = 0, 1 do
			local intensity = get_heartbeat_value(t)
			intensity = intensity * (1 - math.clamp(self:health_ratio() / 0.3, 0, 1))
			intensity = intensity * intensity_mul

			controller:trigger_haptic_pulse(i, 0, intensity * 900)
		end
	end

	self:_check_update_max_health()
	self:_check_update_max_armor()
	self:_update_can_take_dmg_timer(dt)
	self:_update_regen_on_the_side(dt)
	self:_update_slowdowns(dt)
	local is_berserker_active = managers.player:has_activate_temporary_upgrade("temporary", "berserker_damage_multiplier")
	
	if self._uppers and self._uppers_t and self._uppers_t < t then
		if sydchSO.settings.moreHINTS == true then	
			managers.hud:show_hint({text ="You can now survive with a First Aid Kit."})
		end
		self._uppers = false
	end
	
	if self:is_downed() and self._cheat_death and not self:incapacitated() then
		if sydchSO.settings.moreHINTS == true then	
			managers.hud:show_hint({text ="You will be revived once bleedout time expires."})
		end
		self._block_revive = 1
		self:_block_revive_ability()
		self._cheat_death = false
	end
	
	if managers.player:has_category_upgrade("player", "hostage_interval_multiplier") then
		local hostage_count = managers.groupai and managers.groupai:state():hostage_count() or 0
		local hostage_multiplier = managers.player:upgrade_value("player", "hostage_interval_multiplier", 1)
		local max_multiplier = managers.player:upgrade_value("player", "hostage_interval_multiplier", 2)
		hostage_multiplier = hostage_multiplier - 1
		self._dmg_interval = self._dmg_interval + hostage_multiplier * math.min(max_multiplier, hostage_count)
	end

	if not self._armor_stored_health_max_set then
		self._armor_stored_health_max_set = true

		self:update_armor_stored_health()
	end

	if managers.player:has_activate_temporary_upgrade("temporary", "chico_injector") then
		self._chico_injector_active = true
		local total_time = managers.player:upgrade_value("temporary", "chico_injector")[2]
		local current_time = managers.player:get_activate_temporary_expire_time("temporary", "chico_injector") - t

		managers.hud:set_player_ability_radial({
			current = current_time,
			total = total_time
		})
	elseif self._chico_injector_active then
		managers.hud:set_player_ability_radial({
			current = 0,
			total = 1
		})

		self._chico_injector_active = nil
	end

	if self._check_berserker_done then
		if is_berserker_active then
			if self._unit:movement():tased() then
				self._tased_during_berserker = true
			else
				self._tased_during_berserker = false
			end
			self._can_survive_one_hit = false
		end

		if not is_berserker_active then
			if self._unit:movement():tased() then
				self._bleed_out_blocked_by_tased = true
			else
				self._bleed_out_blocked_by_tased = false
				self._check_berserker_done = nil

				--managers.hud:set_teammate_condition(HUDManager.PLAYER_PANEL, "mugshot_normal", "")
				managers.hud:set_player_custom_radial({
					current = 0,
					total = self:_max_health(),
					revives = Application:digest_value(self._revives, false)
				})
				self:force_into_bleedout()

				if not self._bleed_out then
					self._disable_next_swansong = true
				end
			end
		else
			local expire_time = managers.player:get_activate_temporary_expire_time("temporary", "berserker_damage_multiplier")
			local total_time = managers.player:upgrade_value("temporary", "berserker_damage_multiplier")
			total_time = total_time and total_time[2] or 0
			local delta = 0
			local max_health = self:_max_health()

			if total_time ~= 0 then
				delta = math.clamp((expire_time - Application:time()) / total_time, 0, 1)
			end

			managers.hud:set_player_custom_radial({
				current = delta * max_health,
				total = max_health,
				revives = Application:digest_value(self._revives, false)
			})
			managers.network:session():send_to_peers("sync_swansong_timer", self._unit, delta * max_health, max_health, Application:digest_value(self._revives, false), managers.network:session():local_peer():id())
		end
	end

	if self._bleed_out_blocked_by_zipline and not self._unit:movement():zipline_unit() then
		self:force_into_bleedout(true)

		self._bleed_out_blocked_by_zipline = nil
	end

	if self._bleed_out_blocked_by_movement_state and not self._unit:movement():current_state():bleed_out_blocked() then
		self:force_into_bleedout()

		self._bleed_out_blocked_by_movement_state = nil
	end

	if self._bleed_out_blocked_by_tased and not self._tased_during_berserker and not self._unit:movement():tased() then
		self:force_into_bleedout()

		self._bleed_out_blocked_by_tased = nil
	end

	if not self._armor_change_blocked and self._current_state then
		 self:_current_state(t, dt)
	end
	
	if sydchSO.settings.skillOVERHAUL == 2 then
	local armor_grinding_data = managers.player:has_category_upgrade("player", "armor_grinding")
		if armor_grinding_data and self._chaos_stacks <= 9 then
			if Application:time() > self._chaos_t then
				self._chaos_stacks = self._chaos_stacks + 1
				self._chaos_t = Application:time() + 1
				--managers.chat:send_message(1, "ANARCHIST SYSTEM", "GAINED A PASSIVE STACK.")
				if self._chaos_stacks >= 9 then			
					self:change_armor(self._armor_grinding.armor_value * self._chaos_stacks)
					self._chaos_stacks = 0
					self._next_allowed_dmg_t = Application:digest_value(managers.player:player_timer():time() + self._dmg_interval, true)
					--managers.chat:send_message(1, "ANARCHIST SYSTEM", "LIMIT REACHED. BURNED ALL STACKS.")
				end
			end
		end
	end
	self:_update_armor_hud(t, dt)

	if self._tinnitus_data then
		self._tinnitus_data.intensity = (self._tinnitus_data.end_t - t) / self._tinnitus_data.duration

		if self._tinnitus_data.intensity <= 0 then
			SoundDevice:set_rtpc("downed_state_progression", math.max(self._downed_progression or 0, 0))
			self:_stop_tinnitus(true)
		else
			SoundDevice:set_rtpc("downed_state_progression", math.max(self._downed_progression or 0, self._tinnitus_data.intensity * 100))
		end
	end

	if self._concussion_data then
		self._concussion_data.intensity = (self._concussion_data.end_t - t) / self._concussion_data.duration

		if self._concussion_data.intensity <= 0 then
			SoundDevice:set_rtpc("concussion_effect", 0)
			self:_stop_concussion(true)
		else
			SoundDevice:set_rtpc("concussion_effect", self._concussion_data.intensity * 100)
		end
	end

	if not self._downed_timer and self._downed_progression then
		self._downed_progression = math.max(0, self._downed_progression - dt * 50)

		if not _G.IS_VR then
			managers.environment_controller:set_downed_value(self._downed_progression)
		end

		SoundDevice:set_rtpc("downed_state_progression", self._downed_progression)

		if self._downed_progression == 0 then
			self._unit:sound():play("critical_state_heart_stop")

			self._downed_progression = nil
		end
	end

	if self._auto_revive_timer then
		if not managers.platform:presence() == "Playing" or not self._bleed_out or self._dead or self:incapacitated() or self:arrested() or self._check_berserker_done then
			self._auto_revive_timer = nil
		else
			self._auto_revive_timer = self._auto_revive_timer - dt

			if self._auto_revive_timer <= 0 then
				self:revive(true)
				self._unit:sound_source():post_event("nine_lives_skill")
				self._cheat_death_done = true
				self._auto_revive_timer = nil
			end
		end
	end
	
	if self._auto_revive_timer_2 then
		if not managers.platform:presence() == "Playing" or not self._bleed_out or self._dead or self:incapacitated() or self:arrested() or self._check_berserker_done then
			self._auto_revive_timer_2 = nil
		else
			self._auto_revive_timer_2 = self._auto_revive_timer_2 - dt

			if self._auto_revive_timer_2 <= 0 then
				self:revive(true)
				self._unit:sound_source():post_event("nine_lives_skill")
				self._cheat_death_done_2 = true
				self._auto_revive_timer_2 = nil
			end
		end
	end

	if self._revive_miss then
		self._revive_miss = self._revive_miss - dt

		if self._revive_miss <= 0 then
			self._revive_miss = nil
		end
	end

	if not self._dodge_bullet then
		self:_upd_suppression(t, dt)
	end

	if not self._dead and not self._bleed_out and not self._check_berserker_done then
		self:_upd_health_regen(t, dt)
	end

	if not self:is_downed() then
		self:_update_delayed_damage(t, dt)
	end
	
	if self._distortion_t >= 0 and sydchSO.settings.improveVISUALS == true then
		self._distortion_t = self._distortion_t - dt
		local amount = self._distortion_av * ratio(self._dmg_interval, self._distortion_t)
		managers.environment_controller:set_base_chromatic_amount(amount > 0.15 and amount or 0.15)
	end
end

function PlayerDamage:stop_vr_heartbeat()
    self._heartbeat_t = nil
end

function PlayerDamage:_max_health()
	local max_health = self:_raw_max_health()

	if managers.player:has_category_upgrade("player", "armor_to_health_conversion") then
		local max_armor = self:_raw_max_armor()
		local conversion_factor = managers.player:upgrade_value("player", "armor_to_health_conversion") * 0.01
		max_health = max_health + max_armor * conversion_factor * 0.9
	end

	return max_health
end

function PlayerDamage:set_armor(armor)
	self:_check_update_max_armor()

	armor = math.clamp(armor, 0, self:_max_armor())

	if self._armor then
		local current_armor = self:get_real_armor()

		if current_armor == 0 and armor ~= 0 then
			self:consume_armor_stored_health()
		elseif current_armor ~= 0 and armor == 0 and self._dire_need then
			local function clbk()
				return self:is_regenerating_armor()
			end
			managers.player:add_coroutine(PlayerAction.DireNeed, PlayerAction.DireNeed, clbk, managers.player:upgrade_value("player", "armor_depleted_stagger_shot", 0))
		end
	end

	self._armor = Application:digest_value(armor, true)
end

Hooks:PreHook(PlayerDamage, "_check_bleed_out", "sydchskilloverhaul", function(self, can_activate_berserker, ignore_movement_state)
	if self._check_berserker_done or managers.player:is_copr_died() then
		if self._can_survive_one_hit then
			self._can_survive_one_hit = false
		end
	end
	if self:get_real_health() == 0 and not self._check_berserker_done then
		local pm = managers.player
		if self._can_survive_one_hit then
			self._can_survive_one_hit = false
			self:change_health(0.1)
			--self:restore_armor(tweak_data.upgrades.values.survive_one_hit_armor[1])
			self._can_take_dmg_timer = self._dmg_interval
			if sydchSO.settings.vocalHEISTERS > 1 then
				self._unit:sound():say("g29")
			end
		else
			self._can_survive_one_hit = pm:has_category_upgrade("player", "survive_one_hit")
		end
		local t = Application:time()
		if not self._block_medkit_auto_revive and t > self._uppers_elapsed + self._UPPERS_COOLDOWN then
			local auto_recovery_kit = FirstAidKitBase.GetFirstAidKit(self._unit:position())
			if auto_recovery_kit then
				self._uppers_t = Application:time() + 20
				self._can_take_dmg_timer = 1
				self._uppers = true
			end
		end
	elseif not self._said_hurt and self:get_real_health() / self:_max_health() < 0.2 and not self._can_survive_one_hit then
		self._said_hurt = true
		PlayerStandard.say_line(self, "g80x_plu")
	end
end)

Hooks:PostHook(PlayerDamage, "on_downed", "sydchSO", function(self, no_messiah)
	managers.player:set_damage_absorption("down_absorption", 0)
	if not no_messiah then
		managers.player:refill_messiah_charges()
	end
	if sydchSO.settings.improveVISUALS == true then
	managers.environment_controller:set_base_chromatic_amount(0.15)
	end
end)

Hooks:PostHook(PlayerDamage, "_regenerated" , "sydchSO" , function(self, no_messiah)
	if no_messiah then
		managers.player:refill_messiah_charges()
	end
	self._cheat_death_done_2 = false
end)

function PlayerDamage:consume_messiah_charge()
	if managers.player:has_category_upgrade("player", "infinite_messiah") then
		return true
	elseif self:got_messiah_charges() then
		self._messiah_charges = self._messiah_charges - 1
		return true
	end
	return false
end

function PlayerDamage:exit_custody(down_timer)
	self._revives = Application:digest_value(tweak_data.player.damage.CUSTODY_LIVES, true)
	self._down_time = down_timer
	self._messiah_charges = managers.player:upgrade_value("player", "pistol_revive_from_bleed_out", 0)
	managers.player:refill_messiah_charges()
	managers.player:set_damage_absorption("down_absorption", managers.player:upgrade_value("player", "damage_absorption_low_revives", 0) * self:get_missing_revives())
	managers.hud:set_player_health({
		current = self:get_real_health(),
		total = self:_max_health(),
		revives = Application:digest_value(self._revives, false)
	})
end

if sydchSO.settings.skillOVERHAUL == 2 then
function PlayerDamage:_chk_cheat_death()
    if managers.player:has_category_upgrade("player", "cheat_death_once") and not self._check_berserker_done then
		if not self._cheat_death_done or managers.player:upgrade_value("player", "cheat_death_chance", 0) then
			if Application:digest_value(self._revives, false) > 4 or (Global.game_settings.one_down and Application:digest_value(self._revives, false) > 2) or self._preserve_cheat then
				self._auto_revive_timer = 28
				self._cheat_death = true
			end
		end
	end
	if not self._cheat_death_done_2 and managers.player:has_activate_temporary_upgrade("temporary", "revive_cheat_death") then
		self._auto_revive_timer_2 = 1
	end
end
end

function PlayerDamage:on_arrested()
	self._bleed_out = false
	self._arrested_timer = tweak_data.player.damage.ARRESTED_TIME * managers.player:upgrade_value("player", "pick_lock_arrested_speed_multiplier", 1)
	self._arrested_paused_counter = 0

	managers.hud:pd_start_timer({
		time = self._arrested_timer
	})
	managers.hud:on_arrested()
end

function PlayerDamage:revive(silent)
	if Application:digest_value(self._revives, false) == 0 then
		self._revive_health_multiplier = nil

		return
	end

	local arrested = self:arrested()
	managers.player:set_player_state("standard")

	if not silent then
		PlayerStandard.say_line(self, "s05x_sin")
	end

	self._bleed_out = false
	self._incapacitated = nil
	self._downed_timer = nil
	self._downed_start_time = nil
	
	if managers.player:has_category_upgrade("player", "cheat_death_once") and self._auto_revive_timer and sydchSO.settings.skillOVERHAUL == 2 then
		if self._auto_revive_timer >= 1 then
			self._cheat_death = false
			self._preserve_cheat = true
			self._auto_revive_timer = nil
		else
			self._preserve_cheat = false
			self._cheat_death = false
		end
	end

	if not arrested and not self._can_keep_health and not managers.player:has_activate_temporary_upgrade("temporary", "copr_risen") then
		if managers.player:has_category_upgrade("team", "crew_nine_lives") then
			self:set_health(self:_max_health() * tweak_data.player.damage.REVIVE_HEALTH_STEPS_W_SKILL[self._revive_health_i] + (self._revive_health_multiplier or 0) * managers.player:upgrade_value("player", "revived_health_regain", 1))
			self:set_armor(self:_max_armor())
	
			self._revive_health_i = math.min(#tweak_data.player.damage.REVIVE_HEALTH_STEPS_W_SKILL, self._revive_health_i + 1)
			self._revive_miss = 2
		else
			self:set_health(self:_max_health() * tweak_data.player.damage.REVIVE_HEALTH_STEPS[self._revive_health_i] + (self._revive_health_multiplier or 0) * managers.player:upgrade_value("player", "revived_health_regain", 1))
			self:set_armor(self:_max_armor())
	
			self._revive_health_i = math.min(#tweak_data.player.damage.REVIVE_HEALTH_STEPS, self._revive_health_i + 1)
			self._revive_miss = 2
		end
	end
	
	self._can_keep_health = false
	self:_regenerate_armor()
	managers.hud:set_player_health({
		current = self:get_real_health(),
		total = self:_max_health(),
		revives = Application:digest_value(self._revives, false)
	})
	self:_send_set_health()
	self:_set_health_effect()
	managers.hud:pd_stop_progress()
	
	self._block_revive = 0
	self:_block_revive_ability()

	self._revive_health_multiplier = nil

	self._listener_holder:call("on_revive")

	if managers.player:has_inactivate_temporary_upgrade("temporary", "revived_damage_resist") then
		managers.player:activate_temporary_upgrade("temporary", "revived_damage_resist")
	end

	if managers.player:has_inactivate_temporary_upgrade("temporary", "increased_movement_speed") then
		managers.player:activate_temporary_upgrade("temporary", "increased_movement_speed")
	end

	if managers.player:has_inactivate_temporary_upgrade("temporary", "swap_weapon_faster") then
		managers.player:activate_temporary_upgrade("temporary", "swap_weapon_faster")
	end
	
	if managers.player:has_inactivate_temporary_upgrade("temporary", "steelsight_weapon_faster") then
		managers.player:activate_temporary_upgrade("temporary", "steelsight_weapon_faster")
	end

	if managers.player:has_inactivate_temporary_upgrade("temporary", "reload_weapon_faster") then
		managers.player:activate_temporary_upgrade("temporary", "reload_weapon_faster")
	end
	
	if managers.player:has_category_upgrade("temporary", "health_regen") and managers.player:has_inactivate_temporary_upgrade("temporary", "health_regen") then
		managers.player:activate_temporary_upgrade("temporary", "health_regen")
	end
	
	if managers.player:has_category_upgrade("temporary", "health_multiplier") and managers.player:has_inactivate_temporary_upgrade("temporary", "health_multiplier") then
		managers.player:activate_temporary_upgrade("temporary", "health_multiplier")
	end
	
	if managers.player:has_category_upgrade("temporary", "dodge") and managers.player:has_inactivate_temporary_upgrade("temporary", "dodge") then
		managers.player:activate_temporary_upgrade("temporary", "dodge")
	end
	
	if managers.player:has_category_upgrade("player", "revive_reload") then
		managers.player:reload_weapons()
	end
	
	managers.player:set_damage_absorption("down_absorption", managers.player:upgrade_value("player", "damage_absorption_low_revives", 0) * self:get_missing_revives())
	if sydchSO.settings.streamLINED == 2 or sydchSO.settings.streamLINED == 3 then
		self._can_take_dmg_timer = self._dmg_interval + 0.3
	end
end

function PlayerDamage:_block_revive_ability()
	if self._block_revive and self._block_revive > 0 then
		return true
	else
		return false
	end
end

function PlayerDamage:get_missing_revives()
	return self._lives_init + managers.player:upgrade_value("player", "additional_lives", 0) - self:get_revives()
end

function PlayerDamage:consume_armor_stored_health(amount)
	local health_restored = 0
	if self._armor_stored_health and not self._dead and not self._bleed_out and not self._check_berserker_done then
	local health_before = self:get_real_health()
		self:change_health(self._armor_stored_health)
		health_restored = self:get_real_health() - health_before
	end
	self._armor_stored_health = math.max(self._armor_stored_health - health_restored, 0)
	if managers.hud then
		managers.hud:set_stored_health(self._armor_stored_health / self:_max_health())
	end
end

local old_set_revive_boost = PlayerDamage.set_revive_boost
function PlayerDamage:set_revive_boost(revive_health_level)
	if not managers.player:has_category_upgrade("player", "damage_health_ratio_multiplier") or not managers.player:has_category_upgrade("player", "movement_speed_damage_health_ratio_multiplier") then
		old_set_revive_boost(self, revive_health_level)
	end
end

function PlayerDamage:_bleed_out_damage(attack_data)
	local health_subtracted = Application:digest_value(self._bleed_out_health, false)
	local bleedout_upgrade = managers.player:upgrade_value("player", "bleed_out_health_multiplier")
	self._bleed_out_health = Application:digest_value(math.max(0, health_subtracted - attack_data.damage), true)
	health_subtracted = health_subtracted - Application:digest_value(self._bleed_out_health, false)
	self._next_allowed_dmg_t = Application:digest_value(managers.player:player_timer():time() + self._dmg_interval + bleedout_upgrade, true)
	self._last_received_dmg = health_subtracted

	if Application:digest_value(self._bleed_out_health, false) <= 0 then
		managers.player:set_player_state("fatal")
	end

	if health_subtracted > 0 then
		self:_send_damage_drama(attack_data, health_subtracted)
	end
end

function PlayerDamage:apply_slowdown(slowdown_data)
	local applied_data = self._slowdowns[slowdown_data.id]

	if applied_data then
		if applied_data.add_mul then
			applied_data.mul = math.max(applied_data.max_mul or 0, applied_data.mul - applied_data.add_mul)
		end

		applied_data.current_mul = applied_data.mul
		applied_data.current_duration = applied_data.duration
		applied_data.current_decay_t = applied_data.decay_t

		self:_update_slowdowns_state()
	else
		self._slowdowns[slowdown_data.id] = {
			mul = slowdown_data.mul,
			add_mul = slowdown_data.add_mul,
			max_mul = slowdown_data.max_mul,
			current_mul = slowdown_data.mul,
			duration = slowdown_data.duration,
			current_duration = slowdown_data.duration,
			decay_t = slowdown_data.decay_time,
			current_decay_t = slowdown_data.decay_time,
			prevents_running = slowdown_data.prevents_running
		}
	end

	self:_update_slowdowns_state()
end

function PlayerDamage:get_current_slowdown()
	local lowest_mul = nil
	local prevents_running = false

	for id, data in pairs(self._slowdowns) do
		prevents_running = prevents_running or data.prevents_running

		if not lowest_mul or data.current_mul < lowest_mul then
			lowest_mul = data.current_mul
		end
	end

	return lowest_mul, prevents_running
end

function PlayerDamage:_update_slowdowns_state()
	local slow_mul, prevents_running = self:get_current_slowdown()

	if self._unit:movement():current_state().apply_slowdown then
		self._unit:movement():current_state():apply_slowdown(slow_mul, prevents_running)
	end
end

function PlayerDamage:_update_slowdowns(dt)
	if not next(self._slowdowns) then
		return
	end

	for id, data in pairs(self._slowdowns) do
		data.current_duration = data.current_duration - dt

		if data.current_duration > 0 then
			if data.current_decay_t then
				data.current_decay_t = data.current_decay_t - dt

				if data.current_decay_t <= 0 then
					data.current_mul = math.lerp(1, data.mul, math.min(data.current_duration + data.decay_t, data.duration) / data.duration)
				end
			end
		else
			self._slowdowns[id] = nil
		end
	end

	self:_update_slowdowns_state()
end

-- i really don't know how this disabled, so

if sydchSO.settings.improveVISUALS == true then
local _original_hit_direction = PlayerDamage._hit_direction
function PlayerDamage:_hit_direction(position_vector, ...)
	managers.hud:on_hit_direction(position_vector, self:get_real_armor() > 0 and HUDHitDirection.DAMAGE_TYPES.ARMOUR or HUDHitDirection.DAMAGE_TYPES.HEALTH)
	if position_vector then
		local dir = (self._unit:camera():position() - position_vector):normalized()
		local infront = math.dot(self._unit:camera():forward(), dir)
		
		if infront < -0.9 then
			managers.environment_controller:hit_feedback_front()
		elseif infront > 0.9 then
			managers.environment_controller:hit_feedback_back()
		else
			local polar = self._unit:camera():forward():to_polar_with_reference(-dir, Vector3(0, 0, 1))
			local direction = Vector3(polar.spin, polar.pitch, 0):normalized()
			if math.abs(direction.x) > math.abs(direction.y) then
				if 0 > direction.x then
					managers.environment_controller:hit_feedback_left()
				else
					managers.environment_controller:hit_feedback_right()
				end
			elseif 0 > direction.y then
				managers.environment_controller:hit_feedback_up()
			else
				managers.environment_controller:hit_feedback_down()
			end
		end
		
	end
	return _original_hit_direction(self, position_vector, ...)
end
end

Hooks:PostHook(PlayerDamage, "_upd_health_regen", "sydchSO", function(self, t, dt)
	if not self._health_regen_update_timer then
		local max_health = self:_max_health()
	
		if self:get_real_health() < max_health then
			self:restore_health(managers.player:health_regen(), false)
			self:restore_health(managers.player:fixed_health_regen(self:health_ratio()), true)
	
			self._health_regen_update_timer = 4
		end
	end
	if self._doctor_bag_cupcake_tick then
		self._doctor_bag_cupcake_tick = self._doctor_bag_cupcake_tick - dt
		if self._doctor_bag_cupcake_tick <= 0 then
			self._doctor_bag_cupcake_tick = nil
		end
	end
	if self._temp_health_regen_timer then
		self._temp_health_regen_timer = self._temp_health_regen_timer - dt
		if self._temp_health_regen_timer <= 0 then
			self._temp_health_regen_timer = nil
		end
	end
	if self._fall_damage_regen_timer then
		self._fall_damage_regen_timer = self._fall_damage_regen_timer - dt
		if self._fall_damage_regen_timer <= 0 then
			self._fall_damage_regen_timer = nil
		end
	end
	if managers.player:is_cupcake_active() then
		if not self._doctor_bag_cupcake_tick then
			self:restore_health(tweak_data.upgrades.values.doctor_bag.cupcake, false)
			--self:restore_health(managers.player:fixed_health_regen(self:health_ratio()), true)
			self._doctor_bag_cupcake_tick = tweak_data.upgrades.values.doctor_bag.cupcake_tick
		end
	end
	if managers.player:has_activate_temporary_upgrade("temporary", "health_regen") then
		if not self._temp_health_regen_timer then
			if self:get_real_health() < self:_max_health() then
				local upgrade_value = managers.player:upgrade_value("temporary", "health_regen") or {0, 0, 0}
				self:restore_health(upgrade_value[1], false)
				self._temp_health_regen_timer = upgrade_value[3]
			end
		end
	end
	if managers.player:has_activate_temporary_upgrade("temporary", "fall_damage_regen") then
		if not self._fall_damage_regen_timer then
			if self:get_real_health() < self:_max_health() then
				local upgrade_value = managers.player:upgrade_value("temporary", "fall_damage_regen") or {0, 0, 0}
				self:restore_health(upgrade_value[1], false)
				self._fall_damage_regen_timer = upgrade_value[3]
			end
		end
	end
	if managers.player:has_activate_temporary_upgrade("temporary", "melee_life_leech") then
		if not self._temp_health_regen_timer then
			if self:get_real_health() < self:_max_health() then
				local upgrade_value = managers.player:upgrade_value("temporary", "melee_life_leech") or {0, 0, 0}
				self:restore_health(upgrade_value[1], false)
				self._temp_health_regen_timer = upgrade_value[3]
			end
		end
	end
	if managers.player:has_activate_temporary_upgrade("temporary", "passive_armor_regen") and self._passive_armor_regen_t and t > self._passive_armor_regen_t and self:get_real_armor() < self:_max_armor() then
		self._passive_armor_regen_t = t + 1
		self:restore_armor(1)
	end
end)

Hooks:PostHook(PlayerDamage, "damage_melee", "sydchSO", function (self, attack_data)
	if sydchSO.settings.weaponOVERHAUL == true then
		local melee_entry = managers.blackmarket:equipped_melee_weapon()
		local can_parry = tweak_data.blackmarket.melee_weapons[melee_entry].deflect
		if can_parry and self._unit:movement():current_state().in_melee and self._unit:movement():current_state():in_melee() then
			self._unit:movement():current_state():discharge_melee()
			self._unit:sound():play("deflect")
			return "countered"
		end
	end
	if sydchSO.settings.copBEHAVIOR == true then
		local damage_melee_original = PlayerDamage.damage_melee
		function PlayerDamage:damage_melee(attack_data)
	
			local result = sydchSO.CopUtils:CheckLocalMeleeDamageArrest(self._unit, attack_data.attacker_unit, true)
	
			if result == "countered" then
				return sydchSO.CopUtils:CounterArrestAttacker(self._unit, attack_data.attacker_unit)
			elseif result == "arrested" then
				self._unit:movement():on_cuffed()
				attack_data.attacker_unit:sound():say("i03", true, false)
				return
			else
				return damage_melee_original(self, attack_data)
			end
		end
	end
end)

if sydchSO.settings.vocalHEISTERS == 1 or sydchSO.settings.vocalHEISTERS == 2 then
	return
end

Hooks:PostHook(PlayerDamage, "on_flashbanged", "sydchSO_playerdamage_flashbanged", function(self)
    DelayedCalls:Add("sydchSO_playerdamage_commentflashbang", math.random() + 0.5, function()
        sydchSO:Say("g41x_any")
    end)
end)

local last_being_revived_speak_time = 0
Hooks:PostHook(PlayerDamage, "pause_downed_timer", "sydchSO_playerdamage_pausedowntimer_playreviveline", function(self)
    if (os.clock() - last_being_revived_speak_time) > 10 then
        DelayedCalls:Add("sydchSO_playerdamage_commentgetrevived", 1, function()
            local line_to_play = "s05a_sin"
            if math.random() > 0.5 then
                line_to_play = "s05b_sin"
            end
            sydchSO:_say_line_thirdperson(line_to_play)
            last_being_revived_speak_time = os.clock()
        end)
    end
end)