dofile(ModPath .. "lua/core/sydchSO.lua")

function PlayerBleedOut:_long_dis_revive(t)
	local voice_type, plural, prime_target = self:_get_unit_intimidation_action(true, true, true, false, true, nil, nil, nil)
	if voice_type == "come" or voice_type == "revive" then
		local is_human_player, record = false, {}
		record = managers.groupai:state():all_criminals()[prime_target.unit:key()]
		if record.ai then
			if not prime_target.unit:brain():player_ignore() then
				prime_target.unit:movement():set_cool(false)
				prime_target.unit:brain():on_long_dis_interacted(0, self._unit, false)
			end
		else
			is_human_player = true
		end
 
		local amount = 0
		local rally_skill_data = self._ext_movement:rally_skill_data()
		if rally_skill_data and rally_skill_data.range_sq > mvector3.distance_sq(self._pos, record.m_pos) then
			local needs_revive, is_arrested, action_stop
			if prime_target.unit:base().is_husk_player then
				is_arrested = prime_target.unit:movement():current_state_name() == "arrested"
				needs_revive = prime_target.unit:interaction():active() and prime_target.unit:movement():need_revive() and not is_arrested
			else
				is_arrested = prime_target.unit:character_damage():arrested()
				needs_revive = prime_target.unit:character_damage():need_revive()
			end
			if needs_revive and managers.player:has_enabled_cooldown_upgrade("cooldown", "long_dis_revive") then
				voice_type = "revive"
				managers.player:disable_cooldown_upgrade("cooldown", "long_dis_revive")
			elseif not is_arrested and not needs_revive and rally_skill_data.morale_boost_delay_t and managers.player:player_timer():time() > rally_skill_data.morale_boost_delay_t then
				voice_type = "boost"
				amount = 1
			end
 
			if is_human_player then
				prime_target.unit:network():send_to_unit({"long_dis_interaction", prime_target.unit, amount, self._unit, false})
			end
			
			if not voice_type then
				voice_type = "ai_stay" and "come"
			end
 
			plural = false			
			if voice_type == "revive" then
				local static_data = managers.criminals:character_static_data_by_unit(prime_target.unit)
				if not static_data then
					return
				end
				if math.random() < self._ext_movement:rally_skill_data().revive_chance then
					prime_target.unit:interaction():interact(self._unit)
				end
				self._ext_movement:rally_skill_data().morale_boost_delay_t = managers.player:player_timer():time() + (self._ext_movement:rally_skill_data().morale_boost_cooldown_t or 3.5)
				self:_do_action_intimidate(t, "cmd_get_up", "f36x_any", false)
				return true
			end
		end
	end
	return false
end
 
function PlayerBleedOut:_check_action_interact(t, input)
	if input.btn_interact_press and (not self._intimidate_t or t - self._intimidate_t > tweak_data.player.movement_state.interaction_delay) then
		if _G.IS_VR then
			self._interact_hand = input.btn_interact_left_press and PlayerHand.LEFT or PlayerHand.RIGHT
		end
		if not self._intimidate_t or tweak_data.player.movement_state.interaction_delay < t - self._intimidate_t then
			self._intimidate_t = t
			if not PlayerArrested.call_teammate(self, "f11", t) then
				self:call_civilian("f11", t, false, true, self._revive_SO_data)
			end
		end
	end
end

function PlayerBleedOut:on_civ_revive_completed(revive_SO_data, sympathy_civ)
	if sympathy_civ ~= revive_SO_data.sympathy_civ then
		debug_pause_unit(sympathy_civ, "[PlayerBleedOut:on_civ_revive_completed]", sympathy_civ)
		return
	end

	revive_SO_data.sympathy_civ = nil
	revive_SO_data.unit:character_damage():revive(sympathy_civ)

	if sydchSO.settings.moreHINTS == true then
		managers.hud:show_hint({text = "You have been helped up by a civilian!"})
	end
	if managers.player:has_category_upgrade("player", "civilian_gives_ammo") then
		managers.game_play_central:spawn_pickup({
			name = "ammo",
			position = sympathy_civ:position(),
			rotation = Rotation()
		})
	end
end

if not Network:is_server() or not sydchSO.settings.expandedCREW == 3 then
	return
end

-- AI IMPROVEMENTS: don't drop the bag on revive
local old_on_rescue_SO_administered = PlayerBleedOut.on_rescue_SO_administered
function PlayerBleedOut:on_rescue_SO_administered(revive_SO_data, receiver_unit, ...)
	local movement = receiver_unit:movement()
	local bag = movement._carry_unit
	local can_run = bag and movement:carry_tweak() and movement:carry_tweak().can_run

	old_on_rescue_SO_administered(self, revive_SO_data, receiver_unit, ...)

	if bag and can_run and not movement:carrying_bag() then
		bag:carry_data():link_to(receiver_unit, false)
		movement:set_carrying_bag(bag)
	end
end