dofile(ModPath .. "lua/core/sydchSO.lua")

sydchSOberserkerbool = 0
sydchSOberserkerhealth_last = 0

local old_init = PlayerStandard.init
function PlayerStandard:init(...)
	old_init(self, ...)
	self._crew_cable_guy = managers.player:crew_ability_upgrade_value("crew_cable_guy", 1)
	self._crew_pack_mule = managers.player:crew_ability_upgrade_value("crew_pack_mule", 1)
	self._melee_instant_kill_chance = 0
	self._last_threat_intimidate_t = 0
	self._last_leech_t = 0
	
	self._last_snd_slide_t = 0
	self._last_jump_t = 0
	self._last_slide_time = 0
	self._last_sprint_t = 0
	
	local slot_manager = managers.slot
	self._slotmask_enemies = slot_manager:get_mask("enemies")

	if blt and blt.xaudio then
		self._using_superblt = true
	end
	if self._using_superblt then
		self._inf_sound = SoundDevice:create_source("inf_sounds")
	end
end

local _determine_move_direction = PlayerStandard._determine_move_direction
function PlayerStandard:_determine_move_direction()
	local _cam_fwd = self._cam_fwd
	local _cam_fwd_flat = self._cam_fwd_flat

	local rotation = self._ext_camera:rotation()
	self._cam_fwd = Rotation(rotation:yaw(), rotation:pitch(), 0):y()
	self._cam_fwd_flat = mvector3.copy(self._cam_fwd)
	mvector3.set_z(self._cam_fwd_flat, 0)
	mvector3.normalize(self._cam_fwd_flat)

	_determine_move_direction(self)

	self._cam_fwd = _cam_fwd
	self._cam_fwd_flat = _cam_fwd_flat
end

Hooks:PostHook(PlayerStandard, "update", "sydchSO", function(self, t, dt)
	if self._long_dis_revive and self._long_dis_revive_t and self._long_dis_revive_t < t then
		if sydchSO.settings.moreHINTS == true then
			managers.hud:show_hint({text ="You can now revive someone with a shout."})
		end
		self._long_dis_revive = false
	end
	
	self._last_t = t
	self._last_dt = dt
	
	if sydchSO.settings.buffEFFECTS == 3 then
		local _health_ratio = self._ext_damage:health_ratio() or 0
		if _health_ratio > 0 and _health_ratio < 0.5 and managers.player:has_category_upgrade("player", "melee_damage_health_ratio_multiplier") then
			sydchSOberserkerbool = math.clamp(_health_ratio*1.3, 0.01, 0.99)
		else
			sydchSOberserkerbool = 0
		end
		if sydchSOberserkerhealth_last == _health_ratio then
			return
		end
		sydchSOberserkerhealth_last = _health_ratio
		if not managers.hud then
			return
		end
		local hud = managers.hud:script(PlayerBase.PLAYER_INFO_HUD_FULLSCREEN_PD2)
		if not hud then
			return
		end
		local berserker_left = hud.panel:child("berserker_left")
		if sydchSOberserkerbool > 0 and berserker_left then
			berserker_left:set_visible(true)
			local hudinfo = managers.hud:script(PlayerBase.PLAYER_INFO_HUD_PD2)
			berserker_left:animate(hudinfo.flash_icon, 4000000000)
			berserker_left:set_color(Color(0.8, 0.8, 0.8))
			berserker_left:set_alpha(1 - (sydchSOberserkerbool * 2.1))
		elseif hud.panel:child("berserker_left") then
			berserker_left:stop()
			berserker_left:set_visible(false)
		end
		if berserker_left and sydchSOberserkerbool <= 0 then
			berserker_left:set_visible(false)
		end
	end
end)

function PlayerStandard:_update_crew_management(t, dt)
	if managers.player:has_category_upgrade("team", "crew_cable_guy", 1) and self._crew_cable_guy and not self._crew_cable_guy_is_used then
		managers.player:add_cable_ties(3)
		self._crew_cable_guy_is_used = true
	end
	
	if self._crew_pack_mule then
		local pack_mule = {
			bank_manager_key = 2,
			lance_part = 2,
			boards = 2,
			planks = 2,
			thermite_paste = 2,
			gas = 2,
			acid = 2,
			caustic_soda = 2,
			hydrogen_chloride = 2,
			evidence = 2,
			blood_sample = 2,
			blood_sample_verified = 2,
			printer_ink = 2,
			paper_roll = 2,
			liquid_nitrogen = 2,
			compound_a = 2,
			compound_b = 2,
			compound_c = 2,
			compound_d = 2
		}
		for name, quantity in pairs(pack_mule) do
			tweak_data.equipments.specials[name].quantity = 1
			tweak_data.equipments.specials[name].max_quantity = quantity
		end
		self._crew_pack_mule = false
	end
	
	self._state_data.tier_t = self._state_data.tier_t or t
	if self._state_data.tier_t <= t and managers.player:has_category_upgrade("team", "crew_tier", 1) then
		managers.player:add_cable_ties(1)
		self._state_data.tier_t = t + managers.player:upgrade_value("team", "crew_tier", 1)
	end
end

Hooks:PostHook(PlayerStandard, "_update_fwd_ray", "sydchSO", function(self)
    if self._state_data.in_steelsight or self:_is_using_bipod() then 
		if self._fwd_ray and self._fwd_ray.unit then
			local aggressor = managers.player:has_category_upgrade("player", "intimidate_enemies")
			local threaten = managers.player:has_category_upgrade("player", "threat_intimidate")
			local assault = managers.groupai:state():get_assault_mode()
			local stealth = managers.groupai:state():whisper_mode()
			local special = managers.groupai:state():is_enemy_special(self._fwd_ray.unit)
			local suppression_ratio = math.floor(self._equipped_unit:base()._suppression)
			if threaten and not stealth and not special then
				if not self._fwd_ray.unit:unit_data().attempted_auto_intimidate and self._fwd_ray.unit:brain() and self._fwd_ray.unit:brain()._logics and self._fwd_ray.unit:brain()._logics.intimidated then
					if not assault or aggressor then
						if Application:time() > self._last_threat_intimidate_t and suppression_ratio > math.random(5, 50) then
							self._fwd_ray.unit:brain():set_logic("intimidated")
							local reveal = World:find_units_quick("all", 3, 16, 21, managers.slot:get_mask("enemies"))
							for _, unit in ipairs(reveal) do
								if alive(unit) and not unit:base():char_tweak().is_escort then
									self._last_threat_intimidate_t = Application:time() + 4
									if sydchSO.settings.vocalHEISTERS > 1 then
										self._unit:sound():say("f46x_any")
									end
									managers.game_play_central:auto_highlight_enemy(unit, true)
								end
							end
						end
					end
				self._fwd_ray.unit:unit_data().attempted_auto_intimidate = true
				end
			end
		end
	end
	local can_highlight = managers.player:has_category_upgrade("weapon", "steelsight_highlight_specials")
	if alive(self._equipped_unit) and self:_is_using_bipod() and self._fwd_ray and self._fwd_ray.unit and self._equipped_unit:base().check_highlight_unit and can_highlight then
		self._equipped_unit:base():check_highlight_unit(self._fwd_ray.unit)
	end
end)

function PlayerStandard:_update_omniscience(t, dt)
	local action_forbidden = not managers.player:has_category_upgrade("player", "standstill_omniscience") or self._ext_movement:has_carry_restriction() or self:_on_zipline() or self._moving or self:running() or self:in_air() or not tweak_data.player.omniscience
	if action_forbidden then
		if self._state_data.omniscience_t then
			self._state_data.omniscience_t = nil
		end

		return
	end

	self._state_data.omniscience_t = self._state_data.omniscience_t or t + tweak_data.player.omniscience.start_t

	if self._state_data.omniscience_t <= t then
		local sensed_targets = World:find_units_quick("sphere", self._unit:movement():m_pos(), tweak_data.player.omniscience.sense_radius, managers.slot:get_mask("trip_mine_targets"))

		for _, unit in ipairs(sensed_targets) do
			if alive(unit) and not unit:base():char_tweak().is_escort then
				print(unit:base():char_tweak().is_escort)
				self._state_data.omniscience_units_detected = self._state_data.omniscience_units_detected or {}

				if not self._state_data.omniscience_units_detected[unit:key()] or self._state_data.omniscience_units_detected[unit:key()] <= t then
					self._state_data.omniscience_units_detected[unit:key()] = t + tweak_data.player.omniscience.target_resense_t

					managers.game_play_central:auto_highlight_enemy(unit, true)

					break
				end
			end
		end

		self._state_data.omniscience_t = t + tweak_data.player.omniscience.interval_t
	end
	
	local crew_omniscience = managers.player:has_category_upgrade("team", "crew_sixth_sense")
	if not crew_omniscience or managers.player:current_state() == "civilian" then
		return
	end
	if self._state_data.crew_omniscience_t and self._state_data.crew_omniscience_t > t then
		return
	end

	local units_detected = self._state_data.omniscience_units_detected or {}
	self._state_data.omniscience_units_detected = units_detected
	local position = self._unit:movement():m_pos()
	local radius = tweak_data.player.crew_omniscience.sense_radius
	local mask = managers.slot:get_mask("trip_mine_targets")
	local targets = World:find_units_quick("sphere", position, radius, mask)

	for _, unit in pairs(targets) do
		if alive(unit) and not unit:base():char_tweak().is_escort then
			local key = unit:key()
			if not units_detected[key] or units_detected[key] <= t then
				units_detected[key] = t + tweak_data.player.crew_omniscience.target_resense_t
				managers.game_play_central:auto_highlight_enemy(unit, true)
				break
			end
		end
	end

	self._state_data.crew_omniscience_t = t + managers.player:crew_ability_upgrade_value("crew_sixth_sense", 1)
end

function PlayerStandard:_get_swap_speed_multiplier()
	local multiplier = 1
	local weapon_tweak_data = self._equipped_unit:base():weapon_tweak_data()
	multiplier = multiplier * managers.player:upgrade_value("weapon", "swap_speed_multiplier", 1)
	multiplier = multiplier * managers.player:upgrade_value("weapon", "passive_swap_speed_multiplier", 1)

	for _, category in ipairs(weapon_tweak_data.categories) do
		multiplier = multiplier * managers.player:upgrade_value(category, "swap_speed_multiplier", 1)
	end

	multiplier = multiplier * managers.player:upgrade_value("team", "crew_faster_swap", 1)

	if managers.player:has_activate_temporary_upgrade("temporary", "swap_weapon_faster") then
		multiplier = multiplier * managers.player:temporary_upgrade_value("temporary", "swap_weapon_faster", 1)
	end
	
	if managers.player:has_activate_temporary_upgrade("temporary", "combat_medic_reload_speed_multiplier") then
		multiplier = multiplier + 1 - managers.player:temporary_upgrade_value("temporary", "combat_medic_reload_speed_multiplier", 1)
	end
	
	--if managers.player:has_activate_temporary_upgrade("temporary", "gun_kata_onenemykilled") then
	--	multiplier = multiplier * managers.player:temporary_upgrade_value("temporary", "gun_kata_onenemykilled", 1)
	--end
	
	if managers.player:has_activate_temporary_upgrade("temporary", "gun_kata_onplayerdodge") then
		multiplier = multiplier * managers.player:temporary_upgrade_value("temporary", "gun_kata_onplayerdodge", 1)
	end

	multiplier = managers.modifiers:modify_value("PlayerStandard:GetSwapSpeedMultiplier", multiplier)
	multiplier = multiplier * managers.player:upgrade_value("weapon", "mrwi_swap_speed_multiplier", 1)

	return multiplier
end

function PlayerStandard:_get_intimidation_action(prime_target, char_table, amount, primary_only, detect_only, secondary)
	local voice_type, new_action, plural = nil
	local unit_type_enemy = 0
	local unit_type_civilian = 1
	local unit_type_teammate = 2
	local unit_type_camera = 3
	local unit_type_turret = 4
	local is_whisper_mode = managers.groupai:state():whisper_mode()

	if prime_target then
		if prime_target.unit_type == unit_type_teammate then
			local is_human_player, record = nil

			if not detect_only then
				record = managers.groupai:state():all_criminals()[prime_target.unit:key()]

				if record.ai then
					if not prime_target.unit:brain():player_ignore() then
						prime_target.unit:movement():set_cool(false)
						prime_target.unit:brain():on_long_dis_interacted(0, self._unit, secondary)
					end
				else
					is_human_player = true
				end
			end

			local amount = 0
			local current_state_name = self._unit:movement():current_state_name()

			local is_berserker = self._unit:character_damage():is_berserker()
			if not is_berserker then
				if current_state_name ~= "arrested" and current_state_name ~= "fatal" and current_state_name ~= "incapacitated" then
					local rally_skill_data = self._ext_movement:rally_skill_data()
	
					if rally_skill_data and mvector3.distance_sq(self._pos, record.m_pos) < rally_skill_data.range_sq then
						local needs_revive, is_arrested, action_stop = nil
	
						if not secondary then
							if prime_target.unit:base().is_husk_player then
								is_arrested = prime_target.unit:movement():current_state_name() == "arrested"
								needs_revive = prime_target.unit:interaction():active() and prime_target.unit:movement():need_revive() and not is_arrested
							else
								is_arrested = prime_target.unit:character_damage():arrested()
								needs_revive = prime_target.unit:character_damage():need_revive()
							end
	
							if needs_revive and managers.player:has_enabled_cooldown_upgrade("cooldown", "long_dis_revive") then
								voice_type = "revive"
								managers.player:disable_cooldown_upgrade("cooldown", "long_dis_revive")
								self._long_dis_revive_t = Application:time() + 90
								self._long_dis_revive = true
							elseif not is_arrested and not needs_revive and rally_skill_data.morale_boost_delay_t and rally_skill_data.morale_boost_delay_t < managers.player:player_timer():time() then
								voice_type = "boost"
								amount = 1
							end
						end
					end
				end
			end

			if is_human_player and not is_berserker then
				prime_target.unit:network():send_to_unit({
					"long_dis_interaction",
					prime_target.unit,
					amount,
					self._unit,
					secondary or false
				})
			end

			voice_type = voice_type or secondary and "ai_stay" or "come"
			plural = false
		else
			local prime_target_key = prime_target.unit:key()

			if prime_target.unit_type == unit_type_enemy then
				plural = false

				if prime_target.unit:anim_data().hands_back then
					voice_type = "cuff_cop"
				elseif prime_target.unit:anim_data().surrender then
					voice_type = "down_cop"
				elseif is_whisper_mode and prime_target.unit:movement():cool() and prime_target.unit:base():char_tweak().silent_priority_shout then
					voice_type = "mark_cop_quiet"
				elseif prime_target.unit:base():char_tweak().priority_shout then
					voice_type = "mark_cop"
				else
					voice_type = "stop_cop"
				end
			elseif prime_target.unit_type == unit_type_camera then
				if not prime_target.unit or not prime_target.unit:base() or not prime_target.unit:base().is_friendly then
					plural = false
					voice_type = "mark_camera"
				end
			elseif prime_target.unit_type == unit_type_turret then
				plural = false
				voice_type = "mark_turret"
			elseif prime_target.unit:base():char_tweak().is_escort then
				plural = false
				local e_guy = prime_target.unit

				if e_guy:anim_data().move then
					voice_type = "escort_keep"
				elseif e_guy:anim_data().panic then
					voice_type = "escort_go"
				else
					voice_type = prime_target.unit:base():char_tweak().speech_escort or "escort"
				end
			else
				if prime_target.unit:movement():stance_name() == "cbt" and prime_target.unit:anim_data().stand then
					voice_type = "come"
				elseif prime_target.unit:anim_data().move then
					voice_type = "stop"
				elseif prime_target.unit:anim_data().drop then
					voice_type = "down_stay"
				else
					voice_type = "down"
				end

				local num_affected = 0

				for _, char in pairs(char_table) do
					if char.unit_type == unit_type_civilian then
						if voice_type == "stop" and char.unit:anim_data().move then
							num_affected = num_affected + 1
						elseif voice_type == "down_stay" and char.unit:anim_data().drop then
							num_affected = num_affected + 1
						elseif voice_type == "down" and not char.unit:anim_data().move and not char.unit:anim_data().drop then
							num_affected = num_affected + 1
						end
					end
				end

				if num_affected > 1 then
					plural = true
				else
					plural = false
				end
			end

			local max_inv_wgt = 0

			for _, char in pairs(char_table) do
				if max_inv_wgt < char.inv_wgt then
					max_inv_wgt = char.inv_wgt
				end
			end

			if max_inv_wgt < 1 then
				max_inv_wgt = 1
			end

			if detect_only then
				voice_type = "come"
			else
				for _, char in pairs(char_table) do
					if char.unit_type ~= unit_type_camera and char.unit_type ~= unit_type_teammate and (not is_whisper_mode or not char.unit:movement():cool()) then
						if char.unit_type == unit_type_civilian then
							amount = (amount or tweak_data.player.long_dis_interaction.intimidate_strength) * managers.player:upgrade_value("player", "civ_intimidation_mul", 1) * managers.player:team_upgrade_value("player", "civ_intimidation_mul", 1)
						end

						if prime_target_key == char.unit:key() then
							voice_type = char.unit:brain():on_intimidated(amount or tweak_data.player.long_dis_interaction.intimidate_strength, self._unit) or voice_type
						elseif not primary_only and char.unit_type ~= unit_type_enemy then
							char.unit:brain():on_intimidated((amount or tweak_data.player.long_dis_interaction.intimidate_strength) * char.inv_wgt / max_inv_wgt, self._unit)
						end
					end
				end

				local target_unit = prime_target.unit
				local get_civilians = target_unit:find_units_quick("sphere", target_unit:position(), 800, managers.slot:get_mask("civilians"))

				for i = 1, #get_civilians do
					local canary = get_civilians[i]

					if not is_whisper_mode or not canary:movement():cool() then
						if not canary:anim_data().long_dis_interact_disabled then
							canary:brain():on_intimidated((amount or tweak_data.player.long_dis_interaction.intimidate_strength), self._unit)
						end
					end
				end
			end
		end
	end

	return voice_type, plural, prime_target
end

function PlayerStandard:_get_unit_intimidation_action(intimidate_enemies, intimidate_civilians, intimidate_teammates, only_special_enemies, intimidate_escorts, intimidation_amount, primary_only, detect_only, secondary)
	local char_table = {}
	local unit_type_enemy = 0
	local unit_type_civilian = 1
	local unit_type_teammate = 2
	local unit_type_camera = 3
	local unit_type_turret = 4
	local cam_fwd = self._ext_camera:forward()
	local my_head_pos = self._ext_movement:m_head_pos()

	if _G.IS_VR then
		local hand_unit = self._unit:hand():hand_unit(self._interact_hand)

		if hand_unit:raycast("ray", hand_unit:position(), my_head_pos, "slot_mask", 1) then
			return
		end

		cam_fwd = hand_unit:rotation():y()
		my_head_pos = hand_unit:position()
	end

	local spotting_mul = managers.player:upgrade_value("player", "marked_distance_mul", 1)
	local range_mul = managers.player:upgrade_value("player", "intimidate_range_mul", 1) * managers.player:upgrade_value("player", "passive_intimidate_range_mul", 1)
	local intimidate_range_civ = tweak_data.player.long_dis_interaction.intimidate_range_civilians * range_mul
	local intimidate_range_ene = tweak_data.player.long_dis_interaction.intimidate_range_enemies * range_mul
	local highlight_range = tweak_data.player.long_dis_interaction.highlight_range * range_mul * spotting_mul
	local intimidate_range_teammates = tweak_data.player.long_dis_interaction.intimidate_range_teammates

	if intimidate_enemies then
		local enemies = managers.enemy:all_enemies()

		for u_key, u_data in pairs(enemies) do
			if self._unit:movement():team().foes[u_data.unit:movement():team().id] and not u_data.unit:anim_data().hands_tied and not u_data.unit:anim_data().long_dis_interact_disabled and (not u_data.unit:character_damage() or not u_data.unit:character_damage():dead()) and (u_data.char_tweak.priority_shout or not only_special_enemies) then
				if managers.groupai:state():whisper_mode() then
					if u_data.char_tweak.silent_priority_shout and u_data.unit:movement():cool() then
						self:_add_unit_to_char_table(char_table, u_data.unit, unit_type_enemy, highlight_range, false, false, 0.01, my_head_pos, cam_fwd)
					elseif not u_data.unit:movement():cool() then
						self:_add_unit_to_char_table(char_table, u_data.unit, unit_type_enemy, intimidate_range_ene, false, false, 100, my_head_pos, cam_fwd, nil, "ai_vision mover")
					end
				elseif u_data.char_tweak.priority_shout then
					self:_add_unit_to_char_table(char_table, u_data.unit, unit_type_enemy, highlight_range, false, false, 0.01, my_head_pos, cam_fwd)
				else
					self:_add_unit_to_char_table(char_table, u_data.unit, unit_type_enemy, intimidate_range_ene, false, false, 100, my_head_pos, cam_fwd, nil, "ai_vision mover")
				end
			end
		end
	end

	if intimidate_civilians then
		local civilians = managers.enemy:all_civilians()

		for u_key, u_data in pairs(civilians) do
			if alive(u_data.unit) and u_data.unit:in_slot(21) and not u_data.unit:movement():cool() and not u_data.unit:anim_data().long_dis_interact_disabled then
				local is_escort = u_data.char_tweak.is_escort

				if not is_escort or intimidate_escorts then
					local dist = is_escort and 300 or intimidate_range_civ
					local prio = is_escort and 100000 or 0.001

					self:_add_unit_to_char_table(char_table, u_data.unit, unit_type_civilian, dist, false, false, prio, my_head_pos, cam_fwd)
				end
			end
		end
	end

	if intimidate_teammates and not managers.groupai:state():whisper_mode() then
		local criminals = managers.groupai:state():all_char_criminals()

		for u_key, u_data in pairs(criminals) do
			local added = nil

			if u_key ~= self._unit:key() then
				local rally_skill_data = self._ext_movement:rally_skill_data()

				if rally_skill_data and rally_skill_data.long_dis_revive and mvector3.distance_sq(self._pos, u_data.m_pos) < rally_skill_data.range_sq then
					local needs_revive = nil

					if u_data.unit:base().is_husk_player then
						needs_revive = u_data.unit:interaction():active() and u_data.unit:movement():need_revive() and u_data.unit:movement():current_state_name() ~= "arrested"
					else
						needs_revive = u_data.unit:character_damage():need_revive()
					end

					if needs_revive then
						if mvector3.distance_sq(self._pos, u_data.m_pos) < rally_skill_data.force_sq then
							added = true
							self:_add_unit_to_char_table(char_table, u_data.unit, unit_type_teammate, intimidate_range_teammates, true, true, 5000, my_head_pos, cam_fwd)
						else
							added = true
							self:_add_unit_to_char_table(char_table, u_data.unit, unit_type_teammate, intimidate_range_teammates, false, true, 5000, my_head_pos, cam_fwd)
						end
					end
				end
			end

			if not added and not u_data.is_deployable and not u_data.unit:movement():downed() and not u_data.unit:base().is_local_player and not u_data.unit:anim_data().long_dis_interact_disabled then
				self:_add_unit_to_char_table(char_table, u_data.unit, unit_type_teammate, intimidate_range_teammates, true, not secondary, 0.01, my_head_pos, cam_fwd)
			end
		end
	end

	if intimidate_enemies and intimidate_teammates then
		local enemies = managers.enemy:all_enemies()

		for u_key, u_data in pairs(enemies) do
			if u_data.unit:movement():team() and u_data.unit:movement():team().id == "criminal1" and not u_data.unit:movement():cool() and not u_data.unit:anim_data().long_dis_interact_disabled then
				local is_escort = u_data.char_tweak.is_escort

				if not is_escort or intimidate_escorts then
					local dist = is_escort and 300 or intimidate_range_civ
					local prio = is_escort and 100000 or 0.001

					self:_add_unit_to_char_table(char_table, u_data.unit, unit_type_civilian, dist, false, false, prio, my_head_pos, cam_fwd)
				end
			end
		end
	end

	if intimidate_enemies then
		if managers.groupai:state():whisper_mode() then
			for _, unit in ipairs(SecurityCamera.cameras) do
				if alive(unit) and unit:enabled() and not unit:base():destroyed() then
					local dist = 2000
					local prio = 0.001

					self:_add_unit_to_char_table(char_table, unit, unit_type_camera, dist, false, false, prio, my_head_pos, cam_fwd, {
						unit
					})
				end
			end
		end

		local turret_units = managers.groupai:state():turrets()

		if turret_units then
			for _, unit in pairs(turret_units) do
				if alive(unit) and unit:movement():team().foes[self._ext_movement:team().id] then
					self:_add_unit_to_char_table(char_table, unit, unit_type_turret, 2000, false, false, 0.01, my_head_pos, cam_fwd, {
						unit
					})
				end
			end
		end
	end

	local prime_target = self:_get_interaction_target(char_table, my_head_pos, cam_fwd)

	return self:_get_intimidation_action(prime_target, char_table, intimidation_amount, primary_only, detect_only, secondary)
end

function PlayerStandard:clbk_sprint_delay_expire()
	self._sprint_delay = nil
	if self._running and not self._end_running_expire_t and not self:_is_reloading() and not self._shooting and not self._camera_unit:base()._melee_item_units then
		self._ext_camera:play_redirect(self:get_animation("start_running"))
	end
end

function PlayerStandard:_start_action_running(t)
	if not self._equipped_unit:base():run_and_shoot_allowed() and self:_is_meleeing() then
		self:_interupt_action_melee(t)
		self:_interupt_action_charging_weapon(t)
		
		self._state_data.melee_hit_ray = nil
		self._state_data.melee_charge_wanted = nil
		self._state_data.melee_expire_t = nil
		self._state_data.melee_repeat_expire_t = nil
		self._state_data.melee_attack_allowed_t = nil
		self._state_data.melee_damage_delay_t = nil
		self._state_data.meleeing = nil

		self._ext_camera:play_redirect(self:get_animation("equip"))
		self._equipped_unit:base():tweak_data_anim_stop("unequip")
		self._equipped_unit:base():tweak_data_anim_play("equip")
		self._camera_unit:base():unspawn_melee_item()
		self._camera_unit:base():show_weapon()
	end
	if not self._move_dir or self:on_ladder() or self:_on_zipline() or not self:_can_run_directional() or managers.player:get_player_rule("no_run") or not self._unit:movement():is_above_stamina_threshold() then
		self._running_wanted = true
		return
	end
	if (self._shooting or self:_is_meleeing()) and not self._equipped_unit:base():run_and_shoot_allowed() or self:_changing_weapon() or self._use_item_expire_t or self._state_data.in_air or self:_is_throwing_projectile() or self._state_data.ducking and not self:_can_stand() then
		self._running_wanted = true
		return
	end	
	self._running_wanted = false
	if (not self._state_data.shake_player_start_running or not self._ext_camera:shaker():is_playing(self._state_data.shake_player_start_running)) and managers.user:get_setting("use_headbob") then
		self._state_data.shake_player_start_running = self._ext_camera:play_shaker("player_start_running", 0.75)
	end		
	self:set_running(true)
	self._end_running_expire_t = nil
	self._start_running_t = t
	if not self:_is_charging_weapon() and (not self:_is_meleeing() or not self._equipped_unit:base():run_and_shoot_allowed()) and (not self:_is_reloading() or not self.RUN_AND_RELOAD) then
		self._ext_camera:play_redirect(self:get_animation("start_running"))	
	end
	if not self.RUN_AND_RELOAD then
		self:_interupt_action_reload(t)
	end		
	self:_interupt_action_steelsight(t)
	self:_interupt_action_ducking(t)
	if self._running and not self._end_running_expire_t then
		if (not self:_is_reloading() or not self.RUN_AND_RELOAD) and not self._camera_unit:base()._melee_item_units then
			if not self.RUN_AND_SHOOT then
				self._ext_camera:play_redirect(self:get_animation("idle"))
			end
		end
	
		if self._sprint_delay then
			managers.enemy:reschedule_delayed_clbk(self._sprint_delay.id, managers.player:player_timer():time() + 0.5)
			self._last_sprint_t = managers.player:player_timer():time() + 0.6
		else
			self._sprint_delay = {
				id = "SSOSD"
			}
			managers.enemy:add_delayed_clbk(self._sprint_delay.id, callback(self, self, "clbk_sprint_delay_expire"), managers.player:player_timer():time() + 0.25)
			self._last_sprint_t = managers.player:player_timer():time() + 0.35
		end
	end
end

function PlayerStandard:_end_action_running(t)
	if not self._end_running_expire_t then
		local speed_multiplier = self._equipped_unit:base():exit_run_speed_multiplier()
		self._end_running_expire_t = t + 0.4 / speed_multiplier
		local stop_running = not self:_is_charging_weapon() and not self:_is_meleeing() and (not self.RUN_AND_RELOAD or not self:_is_reloading())

		if stop_running then
			self._ext_camera:play_redirect(self:get_animation("stop_running"), speed_multiplier)
		end
	end
	
	if self._sprint_delay and not self._camera_unit:base()._melee_item_units then
		self._ext_camera:play_redirect(self:get_animation("idle"))
	end
end

function PlayerStandard:_update_running_timers(t)
	if self._end_running_expire_t then
		if self._end_running_expire_t <= t then
			self._end_running_expire_t = nil

			self:set_running(false)
		end
	--elseif self._running and (self._unit:movement():is_stamina_drained() or not self:_can_run_directional()) then
	elseif self._running and not self:_can_run_directional() then
		self:_interupt_action_running(t)
	end
end

function PlayerStandard:_check_action_reload(t, input)
	local new_action = nil
	local action_wanted = input.btn_reload_press
	local current_time = managers.player:player_timer():time()

	if action_wanted and current_time > self._last_sprint_t then
		local action_forbidden = self:_is_reloading() or self:_changing_weapon() or self:_is_meleeing() or self._use_item_expire_t or self:_interacting() or self:_is_throwing_projectile()
		action_forbidden = action_forbidden or self:is_shooting_count()

		if not action_forbidden and self._equipped_unit and not self._equipped_unit:base():clip_full() then
			self:_start_action_reload_enter(t)
			new_action = true
		end
	end

	return new_action
end

function PlayerStandard:_calc_melee_hit_ray(t, sphere_cast_radius)
	local melee_entry = managers.blackmarket:equipped_melee_weapon()
	local range = tweak_data.blackmarket.melee_weapons[melee_entry].stats.range or 175
	if sydchSO.settings.weaponOVERHAUL == true and tweak_data.blackmarket.melee_weapons[melee_entry].ranged then
		range = 3000 + range
	end

	local from = self._unit:movement():m_head_pos()
	local to = from + self._unit:movement():m_head_rot():y() * range
	
	return self._unit:raycast("ray", from, to, "slot_mask", self._slotmask_bullet_impact_targets, "sphere_cast_radius", sphere_cast_radius, "ray_type", "body melee")
end

function PlayerStandard:_do_action_melee(t, input, skip_damage)
	self._state_data.meleeing = nil
	local melee_entry = managers.blackmarket:equipped_melee_weapon()
	local instant_hit = tweak_data.blackmarket.melee_weapons[melee_entry].instant
	local pre_calc_hit_ray = tweak_data.blackmarket.melee_weapons[melee_entry].hit_pre_calculation
	local melee_damage_delay = tweak_data.blackmarket.melee_weapons[melee_entry].melee_damage_delay or 0
	local charge_lerp_value = instant_hit and 0 or self:_get_melee_charge_lerp_value(t)
	local charge_bonus_start = tweak_data.blackmarket.melee_weapons[melee_entry].charge_bonus_start or 2
	local charge_bonus_speed = tweak_data.blackmarket.melee_weapons[melee_entry].charge_bonus_speed or 1
	local speed = tweak_data.blackmarket.melee_weapons[melee_entry].speed_mult or 1
	local anim_speed = tweak_data.blackmarket.melee_weapons[melee_entry].anim_speed_mult or 1
	speed = speed * anim_speed
	speed = speed * (1 + managers.player:upgrade_value("player", "melee_swing_multiplier_delay", 1))
	melee_damage_delay = melee_damage_delay * managers.player:upgrade_value("player", "melee_swing_multiplier_delay", 1)
	local melee_expire_t = tweak_data.blackmarket.melee_weapons[melee_entry].expire_t or 0
	local melee_repeat_expire_t = tweak_data.blackmarket.melee_weapons[melee_entry].repeat_expire_t or 0
	melee_damage_delay = math.min(melee_damage_delay, tweak_data.blackmarket.melee_weapons[melee_entry].repeat_expire_t)
	local primary = managers.blackmarket:equipped_primary()
	local primary_id = primary.weapon_id
	local bayonet_id = managers.blackmarket:equipped_bayonet(primary_id)
	local bayonet_melee = false
	
	self._unit:movement():subtract_stamina(tweak_data.player.movement_state.stamina.MELEE_STAMINA_DRAIN)
	self._unit:movement():_restart_stamina_regen_timer()

	if bayonet_id and self._equipped_unit:base():selection_index() == 2 then
		bayonet_melee = true
	end
	
	if charge_lerp_value and charge_lerp_value > charge_bonus_start then
		speed = math.max(speed, speed * (charge_lerp_value * charge_bonus_speed))
		melee_damage_delay = math.min(melee_damage_delay, melee_damage_delay / (charge_lerp_value * charge_bonus_speed))
		melee_expire_t = math.min(melee_expire_t, melee_expire_t / (charge_lerp_value * charge_bonus_speed))
		melee_repeat_expire_t = math.min(melee_repeat_expire_t, melee_repeat_expire_t / (charge_lerp_value * charge_bonus_speed))
	end
	
	self._state_data.melee_expire_t = t + melee_expire_t
	self._state_data.melee_repeat_expire_t = t + math.min(melee_repeat_expire_t, melee_expire_t)
	if not instant_hit and not skip_damage then
		self._state_data.melee_damage_delay_t = t + melee_damage_delay

		if pre_calc_hit_ray then
			self._state_data.melee_hit_ray = self:_calc_melee_hit_ray(t, 20) or true
		else
			self._state_data.melee_hit_ray = nil
		end
	end

	local send_redirect = instant_hit and (bayonet_melee and "melee_bayonet" or "melee") or "melee_item"

	if instant_hit then
		managers.network:session():send_to_peers_synched("play_distance_interact_redirect", self._unit, send_redirect)
	else
		self._ext_network:send("sync_melee_discharge")
	end

	if self._state_data.melee_charge_shake then
		self._ext_camera:shaker():stop(self._state_data.melee_charge_shake)

		self._state_data.melee_charge_shake = nil
	end

	self._melee_attack_var = 0

	if instant_hit then
		local hit = skip_damage or self:_do_melee_damage(t, bayonet_melee)

		if hit then
			self._ext_camera:play_redirect(bayonet_melee and self:get_animation("melee_bayonet") or self:get_animation("melee"))
		else
			self._ext_camera:play_redirect(bayonet_melee and self:get_animation("melee_miss_bayonet") or self:get_animation("melee_miss"))
		end
	else
		local anim_attack_vars = tweak_data.blackmarket.melee_weapons[melee_entry].anim_attack_vars
		local anim_attack_charged_amount = tweak_data.blackmarket.melee_weapons[melee_entry].anim_attack_charged_amount or 0.5
		local anim_attack_charged_vars = tweak_data.blackmarket.melee_weapons[melee_entry].anim_attack_charged_vars
		local anim_attack_left_vars = tweak_data.blackmarket.melee_weapons[melee_entry].anim_attack_left_vars
		local anim_attack_right_vars = tweak_data.blackmarket.melee_weapons[melee_entry].anim_attack_right_vars
		local timing_fix = tweak_data.blackmarket.melee_weapons[melee_entry].timing_fix
		local timing_fix_speed_mult = tweak_data.blackmarket.melee_weapons[melee_entry].timing_fix_speed_mult or 1
		self._melee_attack_var = anim_attack_vars and math.random(#anim_attack_vars)

		self:_play_melee_sound(melee_entry, "hit_air", self._melee_attack_var)

		local melee_item_tweak_anim = "attack"
		local melee_item_prefix = ""
		local melee_item_suffix = ""
		local anim_attack_param = anim_attack_vars and anim_attack_vars[self._melee_attack_var]
		
		if anim_attack_charged_vars and charge_lerp_value >= anim_attack_charged_amount then
			self._melee_attack_var = anim_attack_charged_vars and math.random(#anim_attack_charged_vars)
			anim_attack_param = anim_attack_charged_vars and anim_attack_charged_vars[self._melee_attack_var]
		elseif self._stick_move then
			local angle = mvector3.angle(self._stick_move, math.X)
			if anim_attack_left_vars and angle and (angle <= 180) and (angle >= 135) then
				self._melee_attack_var = anim_attack_left_vars and math.random(#anim_attack_left_vars)
				anim_attack_param = anim_attack_left_vars and anim_attack_left_vars[self._melee_attack_var]
			elseif anim_attack_right_vars and angle and (angle <= 45) and (angle >= 0) then
				self._melee_attack_var = anim_attack_right_vars and math.random(#anim_attack_right_vars)
				anim_attack_param = anim_attack_right_vars and anim_attack_right_vars[self._melee_attack_var]
			end
		end
		local fix_anim_timer = anim_attack_param and timing_fix and table.contains(timing_fix, anim_attack_param)
		if fix_anim_timer then
			speed = speed * timing_fix_speed_mult
		end
		local state = self._ext_camera:play_redirect(self:get_animation("melee_attack"), speed)
		if anim_attack_param then
			self._camera_unit:anim_state_machine():set_parameter(state, anim_attack_param, 1)

			melee_item_prefix = anim_attack_param .. "_"
		end

		if self._state_data.melee_hit_ray and self._state_data.melee_hit_ray ~= true then
			self._camera_unit:anim_state_machine():set_parameter(state, "hit", 1)

			melee_item_suffix = "_hit"
		end

		melee_item_tweak_anim = melee_item_prefix .. melee_item_tweak_anim .. melee_item_suffix

		self._camera_unit:base():play_anim_melee_item(melee_item_tweak_anim)
	end
end

function PlayerStandard:_get_interaction_speed()
	local dt = managers.player:player_timer():delta_time()
	
	local morale_boost_bonus = self._ext_movement:morale_boost()
	if morale_boost_bonus then
		dt = dt * morale_boost_bonus.move_speed_bonus
	end
	
	return dt
end

local melee_vars = {
	"player_melee",
	"player_melee_var2"
}

function sydchSO:_check_breach(unit)
	local n = unit:name():t()
	local breachunits = {
	"@ID08a33537c9d0673a@",
	"@ID18a7caca12899b38@",
	"@ID851f3239dec9d210@",
	"@ID622b34ce3cd1d3bb@",
	"@ID1d283db01fc4a72b@",
	"@IDcffcea35596d6b53@",
	"@IDb55faf1195846400@",
	"@IDb524e472a247f6ff@",
	"@IDb71bf75755b6181b@",
	"@IDe86b68a126c540da@",
	"@ID945dcbc3586178cd@"
	}
	
	for k , v in ipairs(breachunits) do
		if v == n then return true end
	end
end

function PlayerStandard:_do_melee_damage(t, bayonet_melee, melee_hit_ray, melee_entry, hand_id)
	if sydchSO.settings.weaponOVERHAUL == true then
		local limbmap = {
		leftarm = {
			[Idstring("hit_leftarm"):key()] = true,
			[Idstring("hit_leftforearm"):key()] = true,
			[Idstring("rag_leftarm"):key()] = true,
			[Idstring("rag_leftforearm"):key()] = true
		},
		rightarm = {
			[Idstring("hit_rightarm"):key()] = true,
			[Idstring("hit_rightforearm"):key()] = true,
			[Idstring("rag_rightarm"):key()] = true,
			[Idstring("rag_rightforearm"):key()] = true
		},
		leftleg = {
			[Idstring("leftupleg"):key()] = true,
			[Idstring("leftleg"):key()] = true,
			[Idstring("rag_leftupleg"):key()] = true,
			[Idstring("rag_leftleg"):key()] = true
		},
		rightleg = {
			[Idstring("rightupleg"):key()] = true,
			[Idstring("rightleg"):key()] = true,
			[Idstring("rag_rightupleg"):key()] = true,
			[Idstring("rag_rightleg"):key()] = true
		}}
		
		local bodyparts = {
		ileftarm = {"leftarm", "leftforearm", "lefthand"},
		irightarm = {"rightarm", "rightforearm", "righthand"},
		ileftleg = {"leftleg", "leftfoot"},
		irightleg = {"rightleg", "rightfoot"}}
		
		local function getlimbname(limbid)
			for limbname, mappings in pairs(limbmap) do
				if mappings[limbid] then
					return limbname
				end
			end
			return nil
		end
		
		local melee_entry = managers.blackmarket:equipped_melee_weapon()
		local spherecastradius = 20
		local colray = melee_hit_ray and (melee_hit_ray ~= true and melee_hit_ray or nil) or self:_calc_melee_hit_ray(t, spherecastradius)
		local deep_wound = tweak_data.blackmarket.melee_weapons[melee_entry].deep_wound
		local execution = tweak_data.blackmarket.melee_weapons[melee_entry].execution
		
		if colray and alive(colray.unit) then
			local unit = colray.unit
			local damage = unit:character_damage()
			local body = colray.body
		
			if damage and damage:dead() and body and body:name() and (deep_wound or execution) then
				local limbid = body:name():key()
				local limbname = getlimbname(limbid)
		
				if limbname then
					for _, part in ipairs(bodyparts["i" .. limbname]) do
						unit:body(unit:get_object(Idstring(part))):set_enabled(false)
					end
					unit:movement():add_dismemberment(limbname)
					unit:sound():play("split_gen_body")
				end
			end
			
			managers.game_play_central:play_impact_sound_and_effects({
				col_ray = colray,
				decal = "bullet_hit",
				no_sound = true
			})
		end
	end
	
	melee_entry = melee_entry or managers.blackmarket:equipped_melee_weapon()
	local instant_hit = tweak_data.blackmarket.melee_weapons[melee_entry].instant
	local melee_damage_delay = tweak_data.blackmarket.melee_weapons[melee_entry].melee_damage_delay or 0
	local charge_lerp_value = instant_hit and 0 or self:_get_melee_charge_lerp_value(t, melee_damage_delay)
	if sydchSO.settings.weaponOVERHAUL == true then	
		self._state_data.chainsaw_t = nil
		local sphere_cast_radius = 20
		local col_ray
		
		if melee_hit_ray then
			col_ray = melee_hit_ray ~= true and melee_hit_ray or nil
		else
			col_ray = self:_calc_melee_hit_ray(t, sphere_cast_radius)
		end
		
		if col_ray and alive(col_ray.unit) and tweak_data.blackmarket.melee_weapons[melee_entry].saw_breach and self:_get_melee_charge_lerp_value(t) >= 0.99 then
			if col_ray.unit:damage() and col_ray.body:extension() and col_ray.body:extension().damage then
				local _, damage = managers.blackmarket:equipped_melee_weapon_damage_info(charge_lerp_value)
				damage = damage * math.max(managers.player:upgrade_value("player", "melee_knockdown_mul", 1), managers.player:upgrade_value(self._equipped_unit:base():weapon_tweak_data().category, "melee_knockdown_mul", 1))
				local hit, _ = col_ray.body:extension().damage:damage_lock(managers.player:player_unit(), col_ray.normal, col_ray.position, col_ray.ray, 8)
				
				if hit then
					managers.hud:on_crit_confirmed()

					if col_ray.unit:id() ~= -1 then
						managers.network:session():send_to_peers_synched("sync_body_damage_lock", col_ray.body, 8)
					end
					
					managers.game_play_central:play_impact_sound_and_effects({
						col_ray	= col_ray,
						decal 	= "saw"
					})
				end
			end
		end
		
		if managers.interaction:active_unit() then
			local int = managers.interaction:active_unit():interaction().tweak_data
			local cable = {
				"security_cable_grey",
				"hospital_security_cable",
				"hospital_security_cable_red",
				"hospital_security_cable_blue",
				"hospital_security_cable_green",
				"hospital_security_cable_yellow",
				"corp_prop_celing_wires_cut",
				"hold_cut_wires"
			}
			local lock = {
				"pick_lock_easy",
				"pick_lock_easy_no_skill",
				"pick_lock_easy_hard",
				"pick_lock_easy_hard_no_skill",
				"pick_lock_deposit_transport",
				"lockpick_locker",
				"pick_lock_30",
				"man_trunk_picklock",
				"trai_hold_picklock_toolsafe",
				"pick_lock_x_axis",
				"pick_lock_hard_no_skill_deactivated",
				"pex_pick_lock_easy_no_skill",
				"fex_pick_lock_easy_no_skill",
				"chas_pick_lock_easy_no_skill",
				"fake_pick_lock_easy_no_skill",
				"pick_lock_easy_no_skill_pent",
				"pent_pick_lock",
				"trai_hold_picklock_toolsafe"
			}
			if tweak_data.blackmarket.melee_weapons[melee_entry].fence_interaction_speed then
				if managers.interaction:active_unit():interaction().tweak_data == "cut_fence" or managers.interaction:active_unit():interaction().tweak_data.sound_start == "bar_use_bolt_cutter" then
					managers.interaction:active_unit():interaction():interact(managers.player:player_unit())
				end
			elseif tweak_data.blackmarket.melee_weapons[melee_entry].repair_interaction then
				if int == "repair_wheel" or int == "hlm_motor_start" or int == "suburbia_drill_jammed" or int == "pent_motor_start" then
					managers.interaction:active_unit():interaction():interact(managers.player:player_unit())
				end
			elseif tweak_data.blackmarket.melee_weapons[melee_entry].cable_interaction then
				if table.contains(cable, int) then
					managers.interaction:active_unit():interaction():interact(managers.player:player_unit())
				end
			elseif tweak_data.blackmarket.melee_weapons[melee_entry].breach then
				if table.contains(lock, int) then
					managers.interaction:active_unit():interaction():interact(managers.player:player_unit())
					self._unit:sound():play("breach")
				end
			end
		end
		
		if tweak_data.blackmarket.melee_weapons[melee_entry].revive_on_hit then
			melee_entry = melee_entry or managers.blackmarket:equipped_melee_weapon()
			local instant_hit = tweak_data.blackmarket.melee_weapons[melee_entry].instant
			local melee_damage_delay = tweak_data.blackmarket.melee_weapons[melee_entry].melee_damage_delay or 0
			local charge_lerp_value = instant_hit and 0 or self:_get_melee_charge_lerp_value(t, melee_damage_delay)
			local sphere_cast_radius = 20
			local col_ray = nil
			if melee_hit_ray then
				col_ray = melee_hit_ray ~= true and melee_hit_ray or nil
			else
				local range = tweak_data.blackmarket.melee_weapons[melee_entry].stats.range or 175
				local from = self._unit:movement():m_head_pos()
				local to = from + self._unit:movement():m_head_rot():y() * range
				col_ray = self._unit:raycast("ray", from, to, "slot_mask", self._slotmask_long_distance_interaction, "sphere_cast_radius", sphere_cast_radius)
			end
			if col_ray and alive(col_ray.unit) and managers.groupai:state():all_char_criminals()[col_ray.unit:key()] then
				r_unit = col_ray.unit
				if r_unit:interaction() then
					if r_unit:interaction():active() then
						r_unit:interaction():interact(r_unit)
					end
				elseif r_unit:character_damage() and (r_unit:character_damage():need_revive() or r_unit:character_damage():arrested()) then
					r_unit:character_damage():revive(r_unit)
				end
				return
			end
		end
		
		if tweak_data.blackmarket.melee_weapons[melee_entry].panic and not managers.groupai:state():whisper_mode() then
			local sphere_cast_radius = 20
			local col_ray
			
			if melee_hit_ray then
				col_ray = melee_hit_ray ~= true and melee_hit_ray or nil
			else
				col_ray = self:_calc_melee_hit_ray(t, sphere_cast_radius)
			end
			
			if col_ray and alive(col_ray.unit) and (tweak_data.blackmarket.melee_weapons[melee_entry].panic_on_hit > math.random()) then
				local targets = World:find_units_quick("sphere", self._unit:movement():m_pos(), 1500, managers.slot:get_mask("trip_mine_targets"))
				for _, unit in ipairs(targets) do
					if alive(unit) and not managers.enemy:is_civilian(self._unit) and not unit:character_damage()._invulnerable then
						local action_data = {
							variant 		= "counter_spooc",
							damage 			= 0,
							damage_effect 	= 1,
							attacker_unit 	= self._unit,
							col_ray 		= {
												body 		= unit:body("body"),
												position 	= unit:position() + math.UP * 100
											},
							attack_dir 		= self._unit:movement():m_head_rot():y()
						}
						unit:character_damage():damage_melee(action_data)
					end
				end
			end
		end
	end
	self._ext_camera:play_shaker(melee_vars[math.random(#melee_vars)], math.max(0.3, charge_lerp_value))

	local sphere_cast_radius = 20
	local col_ray = nil

	if melee_hit_ray then
		col_ray = melee_hit_ray ~= true and melee_hit_ray or nil
	else
		col_ray = self:_calc_melee_hit_ray(t, sphere_cast_radius)
	end

	if col_ray and alive(col_ray.unit) then
		local damage, damage_effect = managers.blackmarket:equipped_melee_weapon_damage_info(charge_lerp_value)
		local damage_effect_mul = math.max(managers.player:upgrade_value("player", "melee_knockdown_mul", 1), managers.player:upgrade_value(self._equipped_unit:base():weapon_tweak_data().categories and self._equipped_unit:base():weapon_tweak_data().categories[1], "melee_knockdown_mul", 1))
		damage = damage * managers.player:get_melee_dmg_multiplier()
		damage_effect = damage_effect * damage_effect_mul
		
		if sydchSO.settings.weaponOVERHAUL == true and (tweak_data.blackmarket.melee_weapons[melee_entry].knockdown or tweak_data.blackmarket.melee_weapons[melee_entry].sucker_punch) then
			damage_effect = damage_effect * 10
		end
		
		col_ray.sphere_cast_radius = sphere_cast_radius
		local hit_unit = col_ray.unit

		if hit_unit:character_damage() then
			if bayonet_melee then
				self._unit:sound():play("fairbairn_hit_body", nil, false)
			else
				local hit_sfx = "hit_body"

				if hit_unit:character_damage() and hit_unit:character_damage().melee_hit_sfx then
					hit_sfx = hit_unit:character_damage():melee_hit_sfx()
				end

				self:_play_melee_sound(melee_entry, hit_sfx, self._melee_attack_var)
			end

			if not hit_unit:character_damage()._no_blood then
				managers.game_play_central:play_impact_flesh({
					col_ray = col_ray
				})
				managers.game_play_central:play_impact_sound_and_effects({
					no_decal = true,
					no_sound = true,
					col_ray = col_ray
				})
			end
			
			self._camera_unit:base():play_anim_melee_item("hit_body")
		else
			if self._on_melee_restart_drill and hit_unit:base() and (hit_unit:base().is_drill or hit_unit:base().is_saw) then
				hit_unit:base():on_melee_hit(managers.network:session():local_peer():id())
			end

			if bayonet_melee then
				self._unit:sound():play("knife_hit_gen", nil, false)
			else
				self:_play_melee_sound(melee_entry, "hit_gen", self._melee_attack_var)
			end

			self._camera_unit:base():play_anim_melee_item("hit_gen")
			managers.game_play_central:play_impact_sound_and_effects({
				no_decal = true,
				no_sound = true,
				col_ray = col_ray,
				effect = Idstring("effects/payday2/particles/impacts/fallback_impact_pd2")
			})
		end

		local custom_data = nil

		if _G.IS_VR and hand_id then
			custom_data = {
				engine = hand_id == 1 and "right" or "left"
			}
		end

		managers.rumble:play("melee_hit", nil, nil, custom_data)
		managers.game_play_central:physics_push(col_ray)

		local character_unit, shield_knock = nil
		local can_shield_knock = true

		if can_shield_knock and hit_unit:in_slot(8) and alive(hit_unit:parent()) then
			shield_knock = true
			character_unit = hit_unit:parent()
		end

		character_unit = character_unit or hit_unit

		if character_unit:character_damage() and character_unit:character_damage().damage_melee then
			local dmg_multiplier = 1

			if not managers.enemy:is_civilian(character_unit) and not managers.groupai:state():is_enemy_special(character_unit) then
				dmg_multiplier = dmg_multiplier * managers.player:upgrade_value("player", "non_special_melee_multiplier", 1)
			else
				dmg_multiplier = dmg_multiplier * managers.player:upgrade_value("player", "melee_damage_multiplier", 1)
			end

			if managers.player:has_category_upgrade("player", "melee_instant_kill") then
				if math.random() <= 0.1 or self._melee_instant_kill_chance > 4 then
					dmg_multiplier = dmg_multiplier * (4 * 3)
					if sydchSO.settings.buffEFFECTS == 2 or sydchSO.settings.buffEFFECTS == 3 then
						managers.environment_controller:set_buff_effect(0.2)
					end
				else
					self._melee_instant_kill_chance = self._melee_instant_kill_chance + 1
				end
			end
			
			if sydchSO.settings.weaponOVERHAUL == true and tweak_data.blackmarket.melee_weapons[melee_entry].randomizer then
				dmg_multiplier = dmg_multiplier * math.random(0.5,2)
			end
			
			dmg_multiplier = dmg_multiplier * managers.player:upgrade_value("player", "melee_" .. tostring(tweak_data.blackmarket.melee_weapons[melee_entry].stats.weapon_type) .. "_damage_multiplier", 1)

			if managers.player:has_activate_temporary_upgrade("temporary", "melee_kill_stacking_hit_damage_multiplier") then
				self._state_data.stacking_dmg_mul = self._state_data.stacking_dmg_mul or {}
				self._state_data.stacking_dmg_mul.melee = self._state_data.stacking_dmg_mul.melee or {
					nil,
					0
				}
				local stack = self._state_data.stacking_dmg_mul.melee

				if stack[1] and t < stack[1] then
					dmg_multiplier = dmg_multiplier * (1.3 * stack[2])
				else
					stack[2] = 0
				end
			end

			local health_ratio = self._ext_damage:health_ratio()
			local damage_health_ratio = managers.player:get_damage_health_ratio(health_ratio, "melee")

			if damage_health_ratio > 0 then
				local damage_ratio = damage_health_ratio
				dmg_multiplier = dmg_multiplier * (1 + managers.player:upgrade_value("player", "melee_damage_health_ratio_multiplier", 0) * damage_ratio)
			end

			dmg_multiplier = dmg_multiplier * managers.player:temporary_upgrade_value("temporary", "berserker_damage_multiplier", 1)
			local target_dead = character_unit:character_damage().dead and not character_unit:character_damage():dead()
			local target_hostile = managers.enemy:is_enemy(character_unit) and not tweak_data.character[character_unit:base()._tweak_table].is_escort and character_unit:brain():is_hostile()
			local life_leach_available = managers.player:has_category_upgrade("temporary", "melee_life_leech") and managers.player:has_inactivate_temporary_upgrade("temporary", "melee_life_leech")

			if target_dead and target_hostile and life_leach_available and Application:time() > self._last_leech_t then
				managers.player:activate_temporary_upgrade("temporary", "melee_life_leech")
				self._last_leech_t = Application:time() + 12
			end

			local action_data = {
				variant = "melee"
			}

			if _G.IS_VR and melee_entry == "weapon" and not bayonet_melee then
				dmg_multiplier = 0.1
			end

			action_data.damage = shield_knock and 0 or damage * dmg_multiplier
			action_data.damage_effect = damage_effect
			action_data.attacker_unit = self._unit
			action_data.col_ray = col_ray

			if shield_knock then
				action_data.shield_knock = can_shield_knock
			end

			action_data.name_id = melee_entry
			action_data.charge_lerp_value = charge_lerp_value

			if managers.player:has_activate_temporary_upgrade("temporary", "melee_kill_stacking_hit_damage_multiplier") then
				self._state_data.stacking_dmg_mul = self._state_data.stacking_dmg_mul or {}
				self._state_data.stacking_dmg_mul.melee = self._state_data.stacking_dmg_mul.melee or {
					nil,
					0
				}
				local stack = self._state_data.stacking_dmg_mul.melee

				if character_unit:character_damage().dead and not character_unit:character_damage():dead() then
					stack[1] = t + 4
					stack[2] = math.min(stack[2] + 1, tweak_data.upgrades.max_melee_weapon_dmg_mul_stacks or 5)
				else
					stack[1] = nil
					stack[2] = 0
				end
			end

			local defense_data = character_unit:character_damage():damage_melee(action_data)

			self:_check_melee_dot_damage(col_ray, defense_data, melee_entry)
			self:_check_melee_special_damage(col_ray, character_unit, defense_data, melee_entry)
			self:_perform_sync_melee_damage(hit_unit, col_ray, action_data.damage)

			if tweak_data.blackmarket.melee_weapons[melee_entry].tase_data and character_unit:character_damage().damage_tase then
				local action_data = {
					variant = tweak_data.blackmarket.melee_weapons[melee_entry].tase_data.tase_strength,
					damage = 0,
					attacker_unit = self._unit,
					col_ray = col_ray
				}

				character_unit:character_damage():damage_tase(action_data)
			end

			if tweak_data.blackmarket.melee_weapons[melee_entry].fire_dot_data and character_unit:character_damage().damage_fire then
				local action_data = {
					variant = "fire",
					damage = 0,
					attacker_unit = self._unit,
					col_ray = col_ray,
					fire_dot_data = tweak_data.blackmarket.melee_weapons[melee_entry].fire_dot_data
				}

				character_unit:character_damage():damage_fire(action_data)
			end
			
			if sydchSO.settings.weaponOVERHAUL == true then
				if tweak_data.blackmarket.melee_weapons[melee_entry].multiply then
					local swing_range = tweak_data.blackmarket.melee_weapons[melee_entry].multiply_range
					local units = World:find_units("sphere", self._unit:position(), swing_range, self._slotmask_enemies)
			
					for _, unit in ipairs(units) do
						unit:character_damage():damage_simple({
							variant = "melee",
							damage = damage * dmg_multiplier * 0.7,
							attacker_unit = self._unit,
							col_ray = col_ray
						})
					end
				end
			end

			return defense_data
		else
			self:_perform_sync_melee_damage(hit_unit, col_ray, damage)
		end
	end

	if managers.player:has_activate_temporary_upgrade("temporary", "melee_kill_stacking_hit_damage_multiplier") then
		self._state_data.stacking_dmg_mul = self._state_data.stacking_dmg_mul or {}
		self._state_data.stacking_dmg_mul.melee = self._state_data.stacking_dmg_mul.melee or {
			nil,
			0
		}
		local stack = self._state_data.stacking_dmg_mul.melee
		stack[1] = nil
		stack[2] = 0
	end
	
	return col_ray
end

function PlayerStandard:_check_melee_special_damage(col_ray, character_unit, defense_data, melee_entry)
	if not defense_data or defense_data.type == "death" then
		return
	end

	local melee_tweak = tweak_data.blackmarket.melee_weapons[melee_entry]
	local char_damage = character_unit:character_damage()

	if melee_tweak.random_special_effects then
		local selector = WeightedSelector:new()

		for _, effect in pairs(melee_tweak.random_special_effects) do
			selector:add(effect, effect.weight)
		end

		melee_tweak = selector:select()
	end

	if melee_tweak.tase_data and char_damage.damage_tase then
		local action_data = {
			variant = melee_tweak.tase_data.tase_strength,
			damage = 0,
			attacker_unit = self._unit,
			col_ray = col_ray
		}

		char_damage:damage_tase(action_data)
	end

	if melee_tweak.fire_dot_data and char_damage.damage_fire then
		local action_data = {
			variant = "fire",
			damage = 0,
			attacker_unit = self._unit,
			col_ray = col_ray,
			fire_dot_data = melee_tweak.fire_dot_data
		}

		char_damage:damage_fire(action_data)
	end

	if melee_tweak.instant_kill and char_damage.damage_mission then
		local action_data = {
			variant = "melee",
			attacker_unit = self._unit,
			col_ray = col_ray,
			name_id = melee_entry,
			damage = char_damage._HEALTH_INIT,
			damage_effect = 1
		}

		char_damage:damage_melee(action_data)
	end
end

function PlayerStandard:_check_melee_dot_damage(col_ray, defense_data, melee_entry)
	if not defense_data or defense_data.type == "death" then
		return
	end

	local dot_data = tweak_data.blackmarket.melee_weapons[melee_entry].dot_data

	if not dot_data then
		return
	end

	local data = managers.dot:create_dot_data(dot_data.type, dot_data.custom_data)
	local damage_class = CoreSerialize.string_to_classtable(data.damage_class)

	damage_class:start_dot_damage(col_ray, nil, data, melee_entry)
end

Hooks:PostHook(PlayerStandard, "_get_melee_charge_lerp_value", "sydchSO", function (self, t, offset)
	local multiplier = managers.player:upgrade_value("player", "melee_swing_multiplier_delay", 1)

	if not self._state_data.melee_start_t or multiplier == 1 then
		return
	end

	offset = offset or 0
	local melee_entry = managers.blackmarket:equipped_melee_weapon()
	local max_charge_time = tweak_data.blackmarket.melee_weapons[melee_entry].stats.charge_time * multiplier

	return math.clamp(t - self._state_data.melee_start_t - offset, 0, max_charge_time) / max_charge_time
end)

Hooks:PostHook(PlayerStandard, "_start_action_reload", "sydchSO", function (t)
	if weapon and weapon:can_reload() then
		managers.player:activate_temporary_upgrade("temporary", "reload_fire_rate")
	end
end)

Hooks:PostHook(PlayerStandard, "_interupt_action_reload", "sydchSO", function (t)
	managers.player:deactivate_temporary_upgrade("temporary", "reload_fire_rate")
end)

--Advanced Movement by Solo Queue Pixy, Rokk
function PlayerStandard:running()
	return self._running or self._is_dashing or self._is_sliding
end

function PlayerStandard:ducking()
	return self._state_data and self._state_data.ducking or self._is_sliding
end

function PlayerStandard:_stance_entered(unequipped)
	local stance_standard = tweak_data.player.stances.default[managers.player:current_state()] or tweak_data.player.stances.default.standard
	local head_stance = self._state_data.ducking and tweak_data.player.stances.default.crouched.head or stance_standard.head
	local stance_id = nil
	local stance_mod = {
		translation = Vector3(0, 0, 0),
		rotation = Rotation(0, 0, 0)
	}
	
	local duration = tweak_data.player.TRANSITION_DURATION + (self._equipped_unit:base():transition_duration() or 0)
	local duration_multiplier = self._state_data.in_steelsight and 1 / self._equipped_unit:base():enter_steelsight_speed_multiplier() or 1

	if not unequipped then
		stance_id = self._equipped_unit:base():get_stance_id()

		if self._state_data.in_steelsight and self._equipped_unit:base().stance_mod then
			stance_mod = self._equipped_unit:base():stance_mod() or stance_mod
		end
	end
	
	if sydchSO.settings.stepSLIDE and sydchSO.settings.stepSLIDE > 1 then
		local equipped_melee_weapon = tweak_data.blackmarket.melee_weapons[managers.blackmarket:equipped_melee_weapon()]
		if self._state_data.meleeing and equipped_melee_weapon.stance_mod then
			if equipped_melee_weapon.stance_mod.translation then
				stance_mod.translation = stance_mod.translation + equipped_melee_weapon.stance_mod.translation
			end
			if equipped_melee_weapon.stance_mod.rotation then
				stance_mod.rotation = stance_mod.rotation * equipped_melee_weapon.stance_mod.rotation
			end
		end
		
		local reload_timed_stance_mod = self._equipped_unit:base()._reload_timed_stance_mod
		if self:_is_reloading() and reload_timed_stance_mod and self._flipturn_reload_state then
			local empty = 0
			local values = reload_timed_stance_mod.not_empty
			if self._flipturn_reload_state > 99 then
				empty = 100
				values = reload_timed_stance_mod.empty
			end
			if values then
				if self:in_steelsight() then
					values = values.ads
				else
					values = values.hip
				end
			end
			local flipturn_index = self._flipturn_reload_state - empty
			if values and values[flipturn_index] then
				if values[flipturn_index].translation then
					stance_mod.translation = stance_mod.translation + values[flipturn_index].translation
				end
				if values[flipturn_index].rotation then
					stance_mod.rotation = stance_mod.rotation * values[flipturn_index].rotation
				end
				if values[flipturn_index].sound and (flipturn_index > self._last_flipturn_sound) then
					self._unit:sound():_play(values[flipturn_index].sound)
					self._last_flipturn_sound = flipturn_index
				end
				duration_multiplier = duration_multiplier / (values[flipturn_index].speed or 1)
				duration_multiplier = duration_multiplier / (self._equipped_unit:base():reload_speed_multiplier()/self._equipped_unit:base():standard_reload_speed_multiplier())
			end
		end
		
		local shotgun_ammo_stance_mod = self._equipped_unit:base()._shotgun_ammo_stance_mod
		if self:_is_reloading() and shotgun_ammo_stance_mod then
			local values = shotgun_ammo_stance_mod
			if values then
				if self:in_steelsight() then
					values = values.ads
				else
					values = values.hip
				end
			end
			local ammovalue = self._equipped_unit:base():get_ammo_remaining_in_clip() + 1
			if values and values[ammovalue] then
				if values[ammovalue].translation then
					stance_mod.translation = stance_mod.translation + values[ammovalue].translation
				end
				if values[ammovalue].rotation then
					stance_mod.rotation = stance_mod.rotation * values[ammovalue].rotation
				end
				if values[ammovalue].sound and (ammovalue > self._last_flipturn_sound) then
					self._unit:sound():_play(values[ammovalue].sound)
					self._last_flipturn_sound = ammovalue
				end
				duration_multiplier = duration_multiplier / (values[ammovalue].speed or 1)
				duration_multiplier = duration_multiplier / (self._equipped_unit:base():reload_speed_multiplier()/self._equipped_unit:base():standard_reload_speed_multiplier())
			end
		end
		
		local fire_timed_stance_mod = self._equipped_unit:base()._fire_timed_stance_mod
		if fire_timed_stance_mod and not self:_is_reloading() then
			if self:in_steelsight() then
				fire_timed_stance_mod = fire_timed_stance_mod.ads
			else
				fire_timed_stance_mod = fire_timed_stance_mod.hip
			end
			if fire_timed_stance_mod[self._shootturn_state] then
				if fire_timed_stance_mod[self._shootturn_state].translation then
					stance_mod.translation = stance_mod.translation + fire_timed_stance_mod[self._shootturn_state].translation
				end
				if fire_timed_stance_mod[self._shootturn_state].rotation then
					stance_mod.rotation = stance_mod.rotation * fire_timed_stance_mod[self._shootturn_state].rotation
				end
				if fire_timed_stance_mod[self._shootturn_state].sound and (self._shootturn_state > self._last_shootturn_sound) then
					self._unit:sound():_play(fire_timed_stance_mod[self._shootturn_state].sound)
					self._last_shootturn_sound = self._shootturn_state
				end
				duration_multiplier = duration_multiplier / (fire_timed_stance_mod[self._shootturn_state].speed or 1)
				if self._shootturn_state == #fire_timed_stance_mod then
					self._shootturn_state = nil
					self._last_shootturn_sound = 0
				end
			end
			duration_multiplier = duration_multiplier / (self._equipped_unit:base():fire_rate_multiplier())
		end
		
		if self._equipped_unit:base()._reload_stance_mod and self:_is_reloading() then
			if self._state_data.in_steelsight and self._equipped_unit:base()._reload_stance_mod.ads then
				if self._equipped_unit:base()._reload_stance_mod.ads.translation then
					stance_mod.translation = stance_mod.translation + self._equipped_unit:base()._reload_stance_mod.ads.translation
				end
				if self._equipped_unit:base()._reload_stance_mod.ads.rotation then
					stance_mod.rotation = stance_mod.rotation * self._equipped_unit:base()._reload_stance_mod.ads.rotation
				end
			elseif self._equipped_unit:base()._reload_stance_mod.hip then
				if self._equipped_unit:base()._reload_stance_mod.hip.translation then
					stance_mod.translation = stance_mod.translation + self._equipped_unit:base()._reload_stance_mod.hip.translation
				end
				if self._equipped_unit:base()._reload_stance_mod.hip.rotation then
					stance_mod.rotation = stance_mod.rotation * self._equipped_unit:base()._reload_stance_mod.hip.rotation
				end
			end
		end
	
		if self._equipped_unit:base()._equip_stance_mod and self:is_equipping() then
			if self._equipped_unit:base()._equip_stance_mod.ads and self._state_data.in_steelsight then
				if self._equipped_unit:base()._equip_stance_mod.ads.translation then
					stance_mod.translation = stance_mod.translation + self._equipped_unit:base()._equip_stance_mod.ads.translation
				end
				if self._equipped_unit:base()._equip_stance_mod.ads.rotation then
					stance_mod.rotation = stance_mod.rotation * self._equipped_unit:base()._equip_stance_mod.ads.rotation
				end
			elseif self._equipped_unit:base()._equip_stance_mod.hip then
				if self._equipped_unit:base()._equip_stance_mod.hip.translation then
					stance_mod.translation = stance_mod.translation + self._equipped_unit:base()._equip_stance_mod.hip.translation
				end
				if self._equipped_unit:base()._equip_stance_mod.hip.rotation then
					stance_mod.rotation = stance_mod.rotation * self._equipped_unit:base()._equip_stance_mod.hip.rotation
				end
			end
		end
	
		if self._is_sliding and not self._state_data.in_steelsight then
			stance_mod.translation = stance_mod.translation + Vector3(0, -3, 0)
			--stance_mod.rotation = stance_mod.rotation * Rotation(0, 0, sydchSO.settings.slideangle)
			stance_mod.rotation = stance_mod.rotation * Rotation(0, 0, 10)
		end
		
		if timemult then
			duration_multiplier = duration_multiplier * timemult
		end
	end

	local stances = nil
	stances = (self:_is_meleeing() or self:_is_throwing_projectile()) and tweak_data.player.stances.default or tweak_data.player.stances[stance_id] or tweak_data.player.stances.default
	local misc_attribs = stances.standard
	
	if sydchSO.settings.stepSLIDE and sydchSO.settings.stepSLIDE > 1 then
		misc_attribs = self:_is_using_bipod() and not self:_is_throwing_projectile() and stances.bipod or self._state_data.in_steelsight and stances.steelsight or self._state_data.ducking and stances.crouched or stances.standard
		local duration = tweak_data.player.TRANSITION_DURATION + (self._equipped_unit:base():transition_duration() or 0)
		local duration_multiplier = self._state_data.in_steelsight and 1 / self._equipped_unit:base():enter_steelsight_speed_multiplier() or 1
	else
		misc_attribs = (not self:_is_using_bipod() or self:_is_throwing_projectile() or stances.bipod) and (self._state_data.in_steelsight and stances.steelsight or self._state_data.ducking and stances.crouched or stances.standard)
	end
	
	local new_fov = self:get_zoom_fov(misc_attribs) + 0
	self._camera_unit:base():clbk_stance_entered(misc_attribs.shoulders, head_stance, misc_attribs.vel_overshot, new_fov, misc_attribs.shakers, stance_mod, duration_multiplier, duration)
	managers.menu:set_mouse_sensitivity(self:in_steelsight())
end

function PlayerStandard:_get_max_walk_speed(t, force_run)
	local speed_tweak = self._tweak_data.movement.speed
	local movement_speed = speed_tweak.STANDARD_MAX
	local speed_state = "walk"

	if self._is_sliding then
		movement_speed = self._slide_speed
		speed_state = "run"
	elseif self._state_data.in_steelsight and not managers.player:has_category_upgrade("player", "steelsight_normal_movement_speed") and not self:_is_reloading() and not _G.IS_VR then
		movement_speed = speed_tweak.STEELSIGHT_MAX
		speed_state = "steelsight"
	elseif self:on_ladder() then
		movement_speed = speed_tweak.CLIMBING_MAX
		speed_state = "climb"
	elseif self._state_data.ducking then
		movement_speed = speed_tweak.CROUCHING_MAX
		speed_state = "crouch"
	elseif self._state_data.in_air then
		movement_speed = speed_tweak.INAIR_MAX
		speed_state = nil
	elseif self._running or force_run then
		movement_speed = speed_tweak.RUNNING_MAX
		speed_state = "run"
	end

	movement_speed = managers.modifiers:modify_value("PlayerStandard:GetMaxWalkSpeed", movement_speed, self._state_data, speed_tweak)
	local morale_boost_bonus = self._ext_movement:morale_boost()
	local multiplier = managers.player:movement_speed_multiplier(speed_state, speed_state and morale_boost_bonus and morale_boost_bonus.move_speed_bonus, nil, self._ext_damage:health_ratio())
	multiplier = multiplier * (self._tweak_data.movement.multiplier[speed_state] or 1)
	local apply_weapon_penalty = true

	if self:_is_meleeing() then
		local melee_entry = managers.blackmarket:equipped_melee_weapon()
		apply_weapon_penalty = not tweak_data.blackmarket.melee_weapons[melee_entry].stats.remove_weapon_movement_penalty
	end

	if alive(self._equipped_unit) and apply_weapon_penalty then
		multiplier = multiplier * self._equipped_unit:base():movement_penalty()
		multiplier = multiplier * managers.player:upgrade_value(self._equipped_unit:base():get_name_id(), "increased_movement_speed", 1)
	end

	if managers.player:has_activate_temporary_upgrade("temporary", "increased_movement_speed") then
		multiplier = multiplier * managers.player:temporary_upgrade_value("temporary", "increased_movement_speed", 1)
	end
	
	if managers.player:has_activate_temporary_upgrade("temporary", "copr_ability") then
		local out_of_health = self._unit:character_damage():health_ratio() + 0.01 < managers.player:upgrade_value("player", "copr_static_damage_ratio", 0)

		if out_of_health then
			multiplier = multiplier * managers.player:upgrade_value("player", "copr_out_of_health_move_slow", 1)
		end
	end
	
	if self._slowdown_mul then
		multiplier = multiplier * self._slowdown_mul
	end

	local final_speed = movement_speed * multiplier
	self._cached_final_speed = self._cached_final_speed or 0

	if final_speed ~= self._cached_final_speed then
		self._cached_final_speed = final_speed

		self._ext_network:send("action_change_speed", final_speed)
	end

	return final_speed
end

function PlayerStandard:_get_modified_move_speed(state)
	local speed_tweak = self._tweak_data.movement.speed
	local movement_speed = 0
	local final_speed = 0

	if speed_tweak then
		movement_speed = speed_tweak.STANDARD_MAX
		local speed_state = "walk"

		if state == "crouch" then
			movement_speed = speed_tweak.CROUCHING_MAX
			speed_state = "crouch"
		elseif state == "run" then
			movement_speed = speed_tweak.RUNNING_MAX
			speed_state = "run"
		end

		movement_speed = managers.modifiers:modify_value("PlayerStandard:GetMaxWalkSpeed", movement_speed, self._state_data, speed_tweak)
		local morale_boost_bonus = self._ext_movement:morale_boost()
		local multiplier = managers.player:movement_speed_multiplier(speed_state, speed_state and morale_boost_bonus and morale_boost_bonus.move_speed_bonus, nil, nil)
		multiplier = multiplier * (self._tweak_data.movement.multiplier[speed_state] or 1)

		if self:_is_meleeing() then
			local melee_entry = managers.blackmarket:equipped_melee_weapon()
			apply_weapon_penalty = not tweak_data.blackmarket.melee_weapons[melee_entry].stats.remove_weapon_movement_penalty
		end
		
		if alive(self._equipped_unit) then
			multiplier = multiplier * self._equipped_unit:base():movement_penalty()
			multiplier = multiplier * managers.player:upgrade_value(self._equipped_unit:base():get_name_id(), "increased_movement_speed", 1)
		end
		
		if managers.player:has_activate_temporary_upgrade("temporary", "increased_movement_speed") then
			multiplier = multiplier * managers.player:temporary_upgrade_value("temporary", "increased_movement_speed", 1)
		end
		
		if managers.player:has_activate_temporary_upgrade("temporary", "copr_ability") then
			local out_of_health = self._unit:character_damage():health_ratio() + 0.01 < managers.player:upgrade_value("player", "copr_static_damage_ratio", 0)
	
			if out_of_health then
				multiplier = multiplier * managers.player:upgrade_value("player", "copr_out_of_health_move_slow", 1)
			end
		end
		
		if self._slowdown_mul then
			multiplier = multiplier * self._slowdown_mul
		end

		final_speed = movement_speed * multiplier
	end

	return final_speed
end

Hooks:PostHook(PlayerStandard, "_start_action_ducking", "sydchSO", function(self, params)
	self:_check_slide()
end)

function PlayerStandard:_check_slide()
	if sydchSO.settings.stepSLIDE and sydchSO.settings.stepSLIDE > 1 then
		if self._last_velocity_xy and (self._running or self._state_data.in_air) then
			local movedir = self._move_dir or self._last_velocity_xy
			local velocity = Vector3()
			mvector3.set(velocity, self._last_velocity_xy)
			local horizontal_speed = mvector3.normalize(velocity)
			local walkspeed = self:_get_modified_move_speed()
			local slide_cooldown = 1
			if self._slide_dir then
				local slide_angle = math.atan2(self._slide_dir.y, self._slide_dir.x)
				local move_angle = math.atan2(movedir.y, movedir.x)
				local angle_diff = math.abs(move_angle - slide_angle)
				if angle_diff > 45 then
					slide_cooldown = slide_cooldown / (angle_diff/45)
				end
			end
			if (horizontal_speed > (walkspeed * 1.1)) and ((self._last_t - self._last_slide_time) > slide_cooldown) then
				self._is_sliding = true
				self:_interupt_action_reload(t)
				self._slide_dir = mvector3.copy(movedir)
				self._slide_slow_add = 0
				self._slide_desired_dir = mvector3.copy(movedir)
				self._sprinting_speed = self:_get_modified_move_speed("run") * (1 + (managers.player:body_armor_value("durability")/10))
				self._slide_speed = self._sprinting_speed * 1.3
				self._slide_refresh_t = 0
				self._slide_last_z = self._unit:position().z
				self._slide_last_speed = self._slide_speed
				self._slide_end_speed = self:_get_modified_move_speed("crouch")/4
				self._slide_speed_factor = self._slide_speed/(self._tweak_data.movement.speed.RUNNING_MAX * 1.1)
				self:_stance_entered()
				self._last_slide_time = self._last_t
			end
		end
	end
end

Hooks:PostHook(PlayerStandard, "_determine_move_direction", "sydchSO", function(self)
    if self._is_sliding then
		if self._move_dir then
			local slide_angle = math.atan2(self._slide_dir.y, self._slide_dir.x)
			local move_angle = math.atan2(self._move_dir.y, self._move_dir.x)
			local angle_diff = math.abs(math.abs(move_angle - slide_angle) - 180)
			if angle_diff < 30 then
				self._slide_slow_add = 1600
			elseif angle_diff < 60 then
				self._slide_slow_add = 800
			elseif angle_diff < 90 then
				self._slide_slow_add = 400
			elseif angle_diff < 120 then
				self._slide_slow_add = 200
			else
				self._slide_slow_add = 0
			end

			self._slide_desired_dir = mvector3.copy(self._move_dir)
			mvector3.multiply(self._slide_desired_dir, 0.2)
		elseif sydchSO.settings.stepSLIDE == 2 then
			self._slide_slow_add = 1600
		end
		self._move_dir = self._slide_dir
	end
end)

Hooks:PostHook(PlayerStandard, "_end_action_ducking", "sydchSO", function(self, params)
	self:_cancel_slide()
end)

Hooks:PostHook(PlayerStandard, "_update_movement", "sydchSO", function(self, t, dt)
	if self._is_sliding then
		if not self._state_data.in_air then
			local drain_mult = self._slide_speed/self._sprinting_speed
			self._unit:movement():subtract_stamina((drain_mult + tweak_data.player.movement_state.stamina.JUMP_STAMINA_DRAIN) * dt)
			if drain_mult > 0.50 then
				self._unit:movement():_restart_stamina_regen_timer()
			end
		end

		self._slide_speed = math.clamp(self._slide_speed - ((400 + self._slide_slow_add) * dt * self._slide_speed_factor^2), 0, 1500)
		local last_refresh_dt = t - self._slide_refresh_t
		if self._slide_refresh_t and last_refresh_dt > 0.1 then

			if not self._state_data.in_air and (t - self._last_jump_t) > 0.20 then
				if not self._slide_has_played_shaker then
					if managers.user:get_setting("use_headbob") then
						self._ext_camera:play_shaker("player_start_running", 1)
					end
					self._slide_has_played_shaker = true
					if self._using_superblt then
						local choice = math.random(1, 2)
						self._inf_sound:post_event("slide_enter" .. choice)
					end
					self._unit:movement():subtract_stamina(tweak_data.player.movement_state.stamina.JUMP_STAMINA_DRAIN)
				end
				if (t - self._last_snd_slide_t) > 0.20 then
					self._last_snd_slide_t = t
					self._last_snd_slide = self._last_snd_slide or 0
					self._last_snd_slide = (self._last_snd_slide % 6) + 1
					local pitch = ""
					if self._last_speed > (self._slide_end_speed * 5) then
						pitch = ""
					elseif self._last_speed > (self._slide_end_speed * 3) then
						pitch = "slow"
					elseif self._last_speed > (self._slide_end_speed * 2) then
						pitch = "slower"
					else
						pitch = "slowest"
					end
					if self._using_superblt then
						self._inf_sound:post_event("slide_loop" .. self._last_snd_slide .. pitch)
					end
				end
			end

			local current_z = self._unit:position().z
			local downspeed = self._slide_last_z - current_z

			self._slide_refresh_t = t
			self._slide_last_z = current_z
			if self._move_dir then
				mvector3.add(self._slide_dir, self._slide_desired_dir)
				mvector3.normalize(self._slide_dir)
			end
			
			if self._last_speed < (self._slide_end_speed * 5) then
				self:_cancel_slide()
			end
		end
	elseif self._is_dashing and self._state_data.ducking then
		self:_check_slide()
	end
	
	if sydchSO.settings.stepDODGE and sydchSO.settings.stepDODGE > 1 then
		local input = self._controller:get_input_axis("move")
		local zero_input = (input.x == 0) and (input.y == 0)
		local input_matches_dash_dir = self._dash_dir and (input.x == self._dash_dir.x) and (input.y == self._dash_dir.y)
		local dash_off_cooldown = (t - (self._last_dash_time or 0)) > 0.80
		local dash_conditions = dash_off_cooldown and not self:on_ladder()

		if not self._state_data.in_air then
			local input_not_matching_or_zero = not zero_input and not input_matches_dash_dir
			local within_doubletap_window = ((t - (self._dash_primed_t or 0)) <= 0.15) and ((t - (self._dash_initial_tap_t or 0)) <= 0.30)
			local dash_primed_timeout = not within_doubletap_window
			local doubletap_conditions = (zero_input and within_doubletap_window) and sydchSO.settings.stepDODGE == 2

			if input_matches_dash_dir and self._dash_stage == 2 then
				self._dash_stage = 3
				self._dash_primed_t = t
			elseif dash_off_cooldown and (self._dash_stage == 3 and doubletap_conditions) then
				local dir = self._dash_dir or input
				local dashed = self:_do_dash(dir)
				if dashed then
					self._dash_dir = nil
					self._dash_stage = 0
				end
			elseif input_not_matching_or_zero then
				self._dash_dir = input
				self._dash_stage = 1
				self._dash_initial_tap_t = t
			elseif dash_primed_timeout and self._dash_stage and (self._dash_stage > 2) then
				self._dash_dir = nil
				self._dash_stage = 0
			elseif zero_input and self._dash_stage == 1 then
				self._dash_stage = 2
			end
		end

		if self._is_dashing and ((t - (self._last_dash_time or 0)) > 0.30) then
			self._is_dashing = nil
		end
	end
end)

function PlayerStandard:_cancel_slide(timemult)
	self._is_sliding = nil
	self._slide_has_played_shaker = nil
	self:_stance_entered(nil, timemult)
end

Hooks:PostHook(PlayerStandard, "enter", "sydchSO", function(self, params)
	self:_cancel_slide()
	self._slide_end_speed = self:_get_modified_move_speed("crouch")/4
	self._last_snd_slide_t = 0
	self._last_jump_t = 0
	self._last_slide_time = 0
	self._last_sprint_t = 0
end)

function PlayerStandard:_check_step(t)
	if self._is_sliding then
		return
	end

	self._last_step_pos = self._last_step_pos or Vector3()
	local step_length = self._state_data.on_ladder and 50 or self._state_data.in_steelsight and (managers.player:has_category_upgrade("player", "steelsight_normal_movement_speed") and 150 or 100) or self._state_data.ducking and 125 or self._running and 175 or 150

	if mvector3.distance_sq(self._last_step_pos, self._pos) > step_length * step_length then
		mvector3.set(self._last_step_pos, self._pos)
		self._unit:base():anim_data_clbk_footstep()
	end
end

function PlayerStandard:_reverse_vector(vector)
	local new_vector = Vector3(0, 0, 0)
	mvector3.subtract(new_vector, vector)
	return new_vector
end

function PlayerStandard:_get_sampled_xy()
	local vel = mvector3.copy(self._unit:sampled_velocity())
	mvector3.set_z(vel, 0)
	return vel
end

function PlayerStandard:_do_dash(input)
	if not (managers.player:current_state() == "mask_off" or managers.player:current_state() == "civilian" or self:_interacting()) then
		local my_carry_data = managers.player:get_my_carry_data()
		local dash_mult = 1
		local dash_height_mult = 1
		if my_carry_data then
			local carried_type = tweak_data.carry[my_carry_data.carry_id].type
			if tweak_data.carry.types[carried_type] then
				dash_mult = tweak_data.carry.types[carried_type].move_speed_modifier
				dash_height_mult = tweak_data.carry.types[carried_type].jump_modifier
			end
		end
		if self._unit:mover() then
			local rotation_flat = self._ext_camera:rotation()
			mvector3.set_x(rotation_flat, 0)
			mvector3.set_y(rotation_flat, 0)
			mvector3.rotate_with(input, rotation_flat)
			mvector3.multiply(input, (510 * dash_mult))
			mvector3.add(input, Vector3(0, 0, 90 * dash_height_mult))
			self._last_velocity_xy = input
			self._unit:mover():set_velocity(self._last_velocity_xy)
			self._last_dash_time = self._last_t
			self._ext_camera:play_shaker("player_land", 0.5)
			self._unit:sound():_play("footstep_land")
			self._is_dashing = true
			self._unit:movement():subtract_stamina(tweak_data.player.movement_state.stamina.JUMP_STAMINA_DRAIN)
			self._unit:movement():_restart_stamina_regen_timer()
			return true
		end
	end
	return false
end

Hooks:PostHook(PlayerStandard, "_calculate_standard_variables", "sydchSO", function(self, t, dt)
	self._last_speed = mvector3.normalize(self._unit:sampled_velocity())
end)

Hooks:PostHook(PlayerStandard, "_start_action_jump", "sydchSO", function(self, t, action_start_data)
	self._last_jump_t = t
end)

if sydchSO.settings.skillOVERHAUL == 2 then
function PlayerStandard:_check_action_primary_attack(t, input)
	local new_action = nil
	local action_wanted = input.btn_primary_attack_state or input.btn_primary_attack_release
	action_wanted = action_wanted or self:is_shooting_count()	
	action_wanted = action_wanted or self:_is_charging_weapon()
	local current_time = managers.player:player_timer():time()

	if action_wanted then
		local action_forbidden = self:_is_reloading() or self:_changing_weapon() or self:_is_meleeing() or self._use_item_expire_t or self:_interacting() or self:_is_throwing_projectile() or self:_is_deploying_bipod() or self._menu_closed_fire_cooldown > 0 or self:is_switching_stances()
		
		if not action_forbidden then
			self._queue_reload_interupt = nil
			local start_shooting = false

			self._ext_inventory:equip_selected_primary(false)

			if self._equipped_unit then
				local weap_base = self._equipped_unit:base()
				local fire_mode = weap_base:fire_mode()
				local fire_on_release = weap_base:fire_on_release()

				local anim_speed_mult = 1
				if fire_mode == "burst" then
					anim_speed_mult = weap_base:fire_rate_multiplier() or 1
				end
				if weap_base._anim_speed_mult then
					anim_speed_mult = anim_speed_mult * weap_base._anim_speed_mult
				end
				if not self._state_data.in_steelsight then
					anim_speed_mult = anim_speed_mult * (weap_base._hipfire_anim_speed_mult or 1)
				else
					anim_speed_mult = anim_speed_mult * (weap_base._ads_anim_speed_mult or 1)
				end

				if weap_base:out_of_ammo() then
					if input.btn_primary_attack_press then
						weap_base:dryfire()
					end
				elseif weap_base.clip_empty and weap_base:clip_empty() then
					if not self:_is_reloading() and not weap_base:out_of_ammo() then
						if current_time > self._last_sprint_t and sydchSO.settings.reloadTYPE == 2 then
							new_action = true
							self:_start_action_reload_enter(t)
						end
					end
					if input.btn_primary_attack_press then
						if not weap_base:is_category("grenade_launcher") then
							weap_base:dryfire()
						end
						if sydchSO.settings.reloadTYPE == 3 then
							if self:_is_using_bipod() then
								self._equipped_unit:base():tweak_data_anim_stop("fire")
							elseif fire_mode == "single" then
								if (input.btn_primary_attack_press or self._equipped_unit:base().should_reload_immediately) and not sydchSO.settings.reloadTYPE == 3 then
									if current_time > self._last_sprint_t then
										self:_start_action_reload_enter(t)
									end
								end
							end
						else
							if current_time > self._last_sprint_t then
								new_action = true
								self:_start_action_reload_enter(t)
							end
						end
					end
				elseif self._running and not self._equipped_unit:base():run_and_shoot_allowed() then
					self:_interupt_action_running(t)
				else
					if not self._shooting then
						if weap_base:start_shooting_allowed() then
							local start = fire_mode == "single" and input.btn_primary_attack_press
							start = start or fire_mode ~= "single" and input.btn_primary_attack_state
							start = start and not fire_on_release
							start = start or fire_on_release and input.btn_primary_attack_release

							if start then
								weap_base:start_shooting()
								self._camera_unit:base():start_shooting()

								self._shooting = true
								self._shooting_t = t
								start_shooting = true

								if fire_mode == "auto" then
									self._unit:camera():play_redirect(self:get_animation("recoil_enter"), anim_speed_mult)

									if (not weap_base.akimbo or weap_base:weapon_tweak_data().allow_akimbo_autofire) and (not weap_base.third_person_important or weap_base.third_person_important and not weap_base:third_person_important()) then
										self._ext_network:send("sync_start_auto_fire_sound", 0)
									end
								end
							end
						else
							self:_check_stop_shooting()

							return false
						end
					end

					local suppression_ratio = self._unit:character_damage():effective_suppression_ratio()
					local spread_mul = math.lerp(1, tweak_data.player.suppression.spread_mul, suppression_ratio)
					local autohit_mul = math.lerp(1, tweak_data.player.suppression.autohit_chance_mul, suppression_ratio)
					local suppression_mul = managers.blackmarket:threat_multiplier()
					local dmg_mul = 1
					local weapon_tweak_data = weap_base:weapon_tweak_data()
					local primary_category = weapon_tweak_data.categories[1]

					if not weapon_tweak_data.ignore_damage_multipliers then
						dmg_mul = dmg_mul * managers.player:temporary_upgrade_value("temporary", "dmg_multiplier_outnumbered", 1)

						if managers.player:has_category_upgrade("player", "overkill_all_weapons") or weap_base:is_category("shotgun", "saw") then
							dmg_mul = dmg_mul * managers.player:temporary_upgrade_value("temporary", "overkill_damage_multiplier", 1)
						end

						local health_ratio = self._ext_damage:health_ratio()
						local damage_health_ratio = managers.player:get_damage_health_ratio(health_ratio, primary_category)

						if damage_health_ratio > 0 then
							local upgrade_name = weap_base:is_category("saw") and "melee_damage_health_ratio_multiplier" or "damage_health_ratio_multiplier"
							local damage_ratio = damage_health_ratio
							dmg_mul = dmg_mul * (1 + managers.player:upgrade_value("player", upgrade_name, 0) * damage_ratio)
						end

						dmg_mul = dmg_mul * managers.player:temporary_upgrade_value("temporary", "berserker_damage_multiplier", 1)
						dmg_mul = dmg_mul * managers.player:get_property("trigger_happy", 1)
					end

					local fired = nil

					if fire_mode == "single" then
						if input.btn_primary_attack_press and start_shooting then
							fired = weap_base:trigger_pressed(self:get_fire_weapon_position(), self:get_fire_weapon_direction(), dmg_mul, nil, spread_mul, autohit_mul, suppression_mul)
						elseif fire_on_release then
							if input.btn_primary_attack_release then
								fired = weap_base:trigger_released(self:get_fire_weapon_position(), self:get_fire_weapon_direction(), dmg_mul, nil, spread_mul, autohit_mul, suppression_mul)
							elseif input.btn_primary_attack_state then
								weap_base:trigger_held(self:get_fire_weapon_position(), self:get_fire_weapon_direction(), dmg_mul, nil, spread_mul, autohit_mul, suppression_mul)
							end
						end
					elseif fire_mode == "burst" then
						fired = weap_base:trigger_held(self:get_fire_weapon_position(), self:get_fire_weapon_direction(), dmg_mul, nil, spread_mul, autohit_mul, suppression_mul)
					elseif fire_mode == "volley" then
						if self._shooting then
							fired = weap_base:trigger_held(self:get_fire_weapon_position(), self:get_fire_weapon_direction(), dmg_mul, nil, spread_mul, autohit_mul, suppression_mul)
						end
					elseif input.btn_primary_attack_state then
						fired = weap_base:trigger_held(self:get_fire_weapon_position(), self:get_fire_weapon_direction(), dmg_mul, nil, spread_mul, autohit_mul, suppression_mul)
					end

					if weap_base.manages_steelsight and weap_base:manages_steelsight() then
						if weap_base:wants_steelsight() and not self._state_data.in_steelsight then
							self:_start_action_steelsight(t)
						elseif not weap_base:wants_steelsight() and self._state_data.in_steelsight then
							self:_end_action_steelsight(t)
						end
					end

					local charging_weapon = weap_base:charging()

					if not self._state_data.charging_weapon and charging_weapon then
						self:_start_action_charging_weapon(t)
					elseif self._state_data.charging_weapon and not charging_weapon then
						self:_end_action_charging_weapon(t)
					end

					new_action = true

					if fired then
						managers.rumble:play("weapon_fire")

						local weap_tweak_data = tweak_data.weapon[weap_base:get_name_id()]	
						local shake_tweak_data = weap_tweak_data.shake[fire_mode] or weap_tweak_data.shake	
						local shake_multiplier = shake_tweak_data[self._state_data.in_steelsight and "fire_steelsight_multiplier" or "fire_multiplier"]

						self._ext_camera:play_shaker("fire_weapon_rot", 1 * shake_multiplier)
						self._ext_camera:play_shaker("fire_weapon_kick", 1 * shake_multiplier, 1, 0.15)
						self._equipped_unit:base():tweak_data_anim_stop("unequip")
						self._equipped_unit:base():tweak_data_anim_stop("equip")

						if not self._state_data.in_steelsight or not weap_base:tweak_data_anim_play("fire_steelsight", anim_speed_mult) then
							weap_base:tweak_data_anim_play("fire", anim_speed_mult)
						end

						if fire_mode == "single" and weap_base:get_name_id() ~= "saw" then
							if not self._state_data.in_steelsight and not weap_base:weapon_tweak_data().hipfire_uses_ads_anim == true then
								self._ext_camera:play_redirect(self:get_animation("recoil"), anim_speed_mult)
							elseif weap_tweak_data.animations.recoil_steelsight then
								self._ext_camera:play_redirect(((weap_base:is_second_sight_on() or weap_base:weapon_tweak_data().ads_uses_hipfire_anim) and self:get_animation("recoil")) or self:get_animation("recoil_steelsight"), anim_speed_mult)
							end
						end

						local recoil_multiplier = (weap_base:recoil() + weap_base:recoil_addend()) * weap_base:recoil_multiplier()

						cat_print("jansve", "[PlayerStandard] Weapon Recoil Multiplier: " .. tostring(recoil_multiplier))

						local kick_tweak_data = weap_tweak_data.kick[fire_mode] or weap_tweak_data.kick
						local up, down, left, right = unpack(kick_tweak_data[self._state_data.in_steelsight and "steelsight" or self._state_data.ducking and "crouching" or "standing"])

						self._camera_unit:base():recoil_kick(up * recoil_multiplier, down * recoil_multiplier, left * recoil_multiplier, right * recoil_multiplier)

						if self._shooting_t then
							local time_shooting = t - self._shooting_t
							local achievement_data = tweak_data.achievement.never_let_you_go

							if achievement_data and weap_base:get_name_id() == achievement_data.weapon_id and achievement_data.timer <= time_shooting then
								managers.achievment:award(achievement_data.award)

								self._shooting_t = nil
							end
						end

						if managers.player:has_category_upgrade(primary_category, "stacking_hit_damage_multiplier") then
							self._state_data.stacking_dmg_mul = self._state_data.stacking_dmg_mul or {}
							self._state_data.stacking_dmg_mul[primary_category] = self._state_data.stacking_dmg_mul[primary_category] or {
								nil,
								0
							}
							local stack = self._state_data.stacking_dmg_mul[primary_category]

							if fired.hit_enemy then
								stack[1] = t + managers.player:upgrade_value(primary_category, "stacking_hit_expire_t", 1)
								stack[2] = math.min(stack[2] + 1, tweak_data.upgrades.max_weapon_dmg_mul_stacks or 5)
							else
								stack[1] = nil
								stack[2] = 0
							end
						end

						if weap_base.set_recharge_clbk then
							weap_base:set_recharge_clbk(callback(self, self, "weapon_recharge_clbk_listener"))
						end

						managers.hud:set_ammo_amount(weap_base:selection_index(), weap_base:ammo_info())

						local impact = not fired.hit_enemy

						if weap_base.third_person_important and weap_base:third_person_important() then
							self._ext_network:send("shot_blank_reliable", impact, 0)
						elseif fire_mode ~= "auto" or weap_base.akimbo and not weap_base:weapon_tweak_data().allow_akimbo_autofire then
							self._ext_network:send("shot_blank", impact, 0)
						end

						if fire_mode == "volley" then
							self:_check_stop_shooting()
						end
					elseif fire_mode == "single" then
						new_action = false
					elseif fire_mode == "burst" then
						if weap_base:shooting_count() == 0 then
							new_action = false
						end
					elseif fire_mode == "volley" then
						new_action = self:_is_charging_weapon()
					end
				end
			end
		elseif self:_is_reloading() and self._equipped_unit:base():reload_interuptable() and input.btn_primary_attack_press then
			self._queue_reload_interupt = true
		end
	end
	
	if not new_action then
		self:_check_stop_shooting()
	end

	return new_action
end
end

--CHAINSAWS THAT ACTUALLY CHAINSAW by Solo Queue Pixy
if sydchSO.settings.weaponOVERHAUL == true then
function PlayerStandard:_is_melee_instant()
	return tweak_data.blackmarket.melee_weapons[managers.blackmarket:equipped_melee_weapon()].instant
end

Hooks:PostHook(PlayerStandard, "_start_action_melee", "sydchSO", function(self, t, action_start_data)
	local melee_entry = managers.blackmarket:equipped_melee_weapon()
	if tweak_data.blackmarket.melee_weapons[melee_entry].chainsaw == true then
		self._state_data.chainsaw_t = t + (tweak_data.blackmarket.melee_weapons[melee_entry].chainsaw_delay or 0.8)
	end
end)

-- MELEE OVERHAUL REVAMPED by Undeadsewer, gone but not forgotten...
function PlayerStandard:_check_action_melee(t, input)
	if self._state_data.melee_attack_wanted or (self._state_data.meleeing and input.btn_primary_attack_state) then
		if not self._state_data.melee_attack_allowed_t then
			self._state_data.melee_attack_wanted = nil
			self:_do_action_melee(t, input)
		end
		return
	end
	
	local action_wanted = input.btn_melee_press or input.btn_melee_release or input.btn_primary_attack_press or self._state_data.melee_charge_wanted
	if not action_wanted then
		return
	end
	
	if input.btn_primary_attack_press or input.btn_melee_release then
		if self._state_data.meleeing then
			if self._state_data.melee_attack_allowed_t then
				self._state_data.melee_attack_wanted = true
				return
			end
			self._state_data.chainsaw_t = nil
			self:_do_action_melee(t, input)
		end
		return
	end

	local action_forbidden = not self:_melee_repeat_allowed() or self._use_item_expire_t or self:_changing_weapon() or self:_interacting() or self:_is_throwing_projectile() or self:_is_using_bipod() or self:is_shooting_count()
	if action_forbidden then
		return
	end
	
	local melee_entry = managers.blackmarket:equipped_melee_weapon()
	self:_start_action_melee(t, input, self:_is_melee_instant())
	return true
end

function PlayerStandard:_do_chainsaw_damage(t)
	melee_entry = melee_entry or managers.blackmarket:equipped_melee_weapon()
	local charge_lerp_value = 0
	local sphere_cast_radius = 20
	local col_ray = nil

	if melee_hit_ray then
		col_ray = melee_hit_ray ~= true and melee_hit_ray or nil
	else
		col_ray = self:_calc_melee_hit_ray(t, sphere_cast_radius)
	end

	if col_ray and alive(col_ray.unit) then
		local damage, damage_effect = managers.blackmarket:equipped_melee_weapon_damage_info(charge_lerp_value)
		local damage_effect_mul = math.max(managers.player:upgrade_value("player", "melee_knockdown_mul", 1), managers.player:upgrade_value(self._equipped_unit:base():weapon_tweak_data().categories and self._equipped_unit:base():weapon_tweak_data().categories[1], "melee_knockdown_mul", 1))
		if tweak_data.blackmarket.melee_weapons[melee_entry].stats.tick_damage then
			damage = tweak_data.blackmarket.melee_weapons[melee_entry].stats.tick_damage
		end
		damage = damage * managers.player:get_melee_dmg_multiplier()
		damage_effect = damage_effect * damage_effect_mul
		col_ray.sphere_cast_radius = sphere_cast_radius
		local hit_unit = col_ray.unit
		if hit_unit:character_damage() then
			local hit_sfx = "hit_body"
			if hit_unit:character_damage() and hit_unit:character_damage().melee_hit_sfx then
				hit_sfx = hit_unit:character_damage():melee_hit_sfx()
			end
			self:_play_melee_sound(melee_entry, hit_sfx, self._melee_attack_var)
			if not hit_unit:character_damage()._no_blood then
				managers.game_play_central:play_impact_flesh({
					col_ray = col_ray
				})
				managers.game_play_central:play_impact_sound_and_effects({
					no_decal = true,
					no_sound = true,
					col_ray = col_ray
				})
			end
		elseif self._on_melee_restart_drill and hit_unit:base() and (hit_unit:base().is_drill or hit_unit:base().is_saw) then
			hit_unit:base():on_melee_hit(managers.network:session():local_peer():id())
		else
			self:_play_melee_sound(melee_entry, "hit_gen", self._melee_attack_var)
			self:_play_melee_sound(melee_entry, "charge", self._melee_attack_var)
			managers.game_play_central:play_impact_sound_and_effects({
				no_decal = true,
				no_sound = true,
				col_ray = col_ray,
				effect = Idstring("effects/payday2/particles/impacts/fallback_impact_pd2")
			})
		end
		local custom_data = nil
		if _G.IS_VR and hand_id then
			custom_data = {
				engine = hand_id == 1 and "right" or "left"
			}
		end
		managers.game_play_central:physics_push(col_ray)
		local character_unit, shield_knock = nil
		local can_shield_knock = managers.player:has_category_upgrade("player", "shield_knock")
		if can_shield_knock and hit_unit:in_slot(8) and alive(hit_unit:parent()) and not hit_unit:parent():character_damage():is_immune_to_shield_knockback() then
			shield_knock = true
			character_unit = hit_unit:parent()
		end
		character_unit = character_unit or hit_unit
		if character_unit:character_damage() and character_unit:character_damage().damage_melee then
			local dmg_multiplier = 1
			if not managers.enemy:is_civilian(character_unit) and not managers.groupai:state():is_enemy_special(character_unit) then
				dmg_multiplier = dmg_multiplier * managers.player:upgrade_value("player", "non_special_melee_multiplier", 1)
			else
				dmg_multiplier = dmg_multiplier * managers.player:upgrade_value("player", "melee_damage_multiplier", 1)
			end
			dmg_multiplier = dmg_multiplier * managers.player:upgrade_value("player", "melee_" .. tostring(tweak_data.blackmarket.melee_weapons[melee_entry].stats.weapon_type) .. "_damage_multiplier", 1)
			if managers.player:has_category_upgrade("melee", "stacking_hit_damage_multiplier") then
				self._state_data.stacking_dmg_mul = self._state_data.stacking_dmg_mul or {}
				self._state_data.stacking_dmg_mul.melee = self._state_data.stacking_dmg_mul.melee or {
					nil,
					0
				}
				local stack = self._state_data.stacking_dmg_mul.melee

				if stack[1] and t < stack[1] then
					dmg_multiplier = dmg_multiplier * (1 + managers.player:upgrade_value("melee", "stacking_hit_damage_multiplier", 0) * stack[2])
				else
					stack[2] = 0
				end
			end
			local health_ratio = self._ext_damage:health_ratio()
			local damage_health_ratio = managers.player:get_damage_health_ratio(health_ratio, "melee")

			if damage_health_ratio > 0 then
				local damage_ratio = damage_health_ratio
				dmg_multiplier = dmg_multiplier * (1 + managers.player:upgrade_value("player", "melee_damage_health_ratio_multiplier", 0) * damage_ratio)
			end
			dmg_multiplier = dmg_multiplier * managers.player:temporary_upgrade_value("temporary", "berserker_damage_multiplier", 1)
			local target_dead = character_unit:character_damage().dead and not character_unit:character_damage():dead()
			local target_hostile = managers.enemy:is_enemy(character_unit) and not tweak_data.character[character_unit:base()._tweak_table].is_escort and character_unit:brain():is_hostile()
			local life_leach_available = managers.player:has_category_upgrade("temporary", "melee_life_leech") and managers.player:has_activate_temporary_upgrade("temporary", "melee_life_leech")
			if target_dead and target_hostile and life_leach_available then
				managers.player:activate_temporary_upgrade("temporary", "melee_life_leech")
				--self._unit:character_damage():restore_health(managers.player:temporary_upgrade_value("temporary", "melee_life_leech", 1))
			end
			local special_weapon = tweak_data.blackmarket.melee_weapons[melee_entry].special_weapon
			local action_data = {
				variant = "melee"
			}
			if special_weapon == "taser" then
				action_data.variant = "taser_tased"
			end
			if _G.IS_VR and melee_entry == "weapon" and not bayonet_melee then
				dmg_multiplier = 0.1
			end
			action_data.damage = shield_knock and 0 or damage * dmg_multiplier
			action_data.damage_effect = damage_effect
			action_data.attacker_unit = self._unit
			action_data.col_ray = col_ray
			if shield_knock then
				action_data.shield_knock = can_shield_knock
			end
			action_data.name_id = melee_entry
			action_data.charge_lerp_value = charge_lerp_value
			if managers.player:has_category_upgrade("melee", "stacking_hit_damage_multiplier") then
				self._state_data.stacking_dmg_mul = self._state_data.stacking_dmg_mul or {}
				self._state_data.stacking_dmg_mul.melee = self._state_data.stacking_dmg_mul.melee or {
					nil,
					0
				}
				local stack = self._state_data.stacking_dmg_mul.melee

				if character_unit:character_damage().dead and not character_unit:character_damage():dead() then
					stack[1] = t + managers.player:upgrade_value("melee", "stacking_hit_expire_t", 1)
					stack[2] = math.min(stack[2] + 1, tweak_data.upgrades.max_melee_weapon_dmg_mul_stacks or 5)
				else
					stack[1] = nil
					stack[2] = 0
				end
			end
			local defense_data = character_unit:character_damage():damage_melee(action_data)
			self:_check_melee_dot_damage(col_ray, defense_data, melee_entry)
			self:_perform_sync_melee_damage(hit_unit, col_ray, action_data.damage)
			return defense_data
		else
			self:_perform_sync_melee_damage(hit_unit, col_ray, damage)
		end
	end
	if managers.player:has_category_upgrade("melee", "stacking_hit_damage_multiplier") then
		self._state_data.stacking_dmg_mul = self._state_data.stacking_dmg_mul or {}
		self._state_data.stacking_dmg_mul.melee = self._state_data.stacking_dmg_mul.melee or {
			nil,
			0
		}
		local stack = self._state_data.stacking_dmg_mul.melee
		stack[1] = nil
		stack[2] = 0
	end
	return col_ray
end

Hooks:PostHook(PlayerStandard, "_do_action_melee", "sydchSO", function(self, t, input, skip_damage)
	self._state_data.melee_voice_charged = nil
end)

local old_meleetimers = PlayerStandard._update_melee_timers
function PlayerStandard:_update_melee_timers(t, input)
	local meleewpn = managers.blackmarket:equipped_melee_weapon()
	if tweak_data.blackmarket.melee_weapons[meleewpn].chainsaw == true and self._state_data.chainsaw_t and self._state_data.chainsaw_t < t then
		self:_do_chainsaw_damage(t)
		self._state_data.chainsaw_t = t + 0.2
	end
	old_meleetimers(self, t, input)
	local shortener = tweak_data.blackmarket.melee_weapons[meleewpn].early_expire_t or 0
	if self._state_data.melee_expire_t and self._state_data.melee_expire_t <= t+shortener and not (self._state_data.melee_charge_wanted or self._state_data.meleeing) then
		if not self:_is_meleeing() then
			return
		end
		local speed_multiplier = self:_get_swap_speed_multiplier()
		local tweak_data = self._equipped_unit:base():weapon_tweak_data()
		speed_multiplier = speed_multiplier * (tweak_data.equip_speed_mult or 1)
		self._ext_camera:play_redirect(self:get_animation("equip"), speed_multiplier)
		self._equipped_unit:base():tweak_data_anim_stop("unequip")
		self._equipped_unit:base():tweak_data_anim_play("equip", speed_multiplier)
		self._camera_unit:base():unspawn_melee_item()
		self._camera_unit:base():show_weapon()
		if self._running and not self._is_jumping then
			if not self._equipped_unit:base():run_and_shoot_allowed() and (not self._end_running_expire_t or not self:_is_meleeing()) then
				self._ext_camera:play_redirect(self:get_animation("start_running"))
			elseif self._end_running_expire_t or self:_is_meleeing() then
				self._equipped_unit:base():tweak_data_anim_play("equip", speed_multiplier)
			else
				self._ext_camera:play_redirect(self:get_animation("idle"))
			end
		end
		if self._state_data.melee_charge_shake then
			self._ext_camera:stop_shaker(self._state_data.melee_charge_shake)

			self._state_data.melee_charge_shake = nil
		end
		self._state_data.fire_disallow_t = self._state_data.melee_expire_t
		self._state_data.melee_hit_ray = nil
		self._state_data.melee_charge_wanted = nil
		self._state_data.melee_expire_t = nil
		self._state_data.melee_repeat_expire_t = nil
		self._state_data.melee_attack_allowed_t = nil
		self._state_data.melee_damage_delay_t = nil
		self._state_data.meleeing = nil
		self._state_data.chainsaw_t = nil
		self:_stance_entered()
	end
	
	if self._state_data.meleeing then
		local shouts = {
			"t03x_sin",
			"g67",
			"g23",
			"g10",
			"f42_any",
			"f45x_any"
		}
		
		if self:_get_melee_charge_lerp_value(t) >= 0.99 and not self._state_data.melee_voice_charged and tweak_data.blackmarket.melee_weapons[meleewpn].saw_breach then
			self._state_data.melee_voice_charged = true
			managers.player:player_unit():sound():say(shouts[math.random(#shouts)], nil, true)
		end
	end
end

local old_interrupt = PlayerStandard._interupt_action_melee
function PlayerStandard:_interupt_action_melee(t)
	old_interrupt(self, t)
	local instant_hit = tweak_data.blackmarket.melee_weapons[managers.blackmarket:equipped_melee_weapon()].instant

	t = t or managers.player:player_timer():time()

	if not instant_hit then
		self._ext_network:send("sync_melee_discharge")
	end
	self._state_data.melee_voice_charged = nil
	self._state_data.chainsaw_t = nil
end

Hooks:PreHook(PlayerStandard, "_check_action_primary_attack", "sydchSO", function(self, t, input)
	if self._state_data.melee_charge_wanted then
		input.btn_primary_attack_state = nil
		input.btn_primary_attack_release = nil
	end
end)

Hooks:PostHook(PlayerStandard, "_check_action_interact", "sydchSO", function(self, t, input)
	local new_action, timer, interact_object
	local action_forbidden = self:chk_action_forbidden("interact") or self._unit:base():stats_screen_visible() or self:_interacting() or self._ext_movement:has_carry_restriction() or self:is_deploying() or self:_changing_weapon() or self:_is_throwing_projectile() or self:_on_zipline()
	
	if not self._state_data.meleeing or self._state_data.melee_repeat_expire_t or self:_is_melee_instant() then
		return
	end
	
	if input.btn_interact_press and not action_forbidden then
		new_action, timer, interact_object = self._interaction:interact(self._unit, input.data)
		
		if new_action then
			self:_play_interact_redirect(t, input)
		end
		
		if timer then
			new_action = true
			self:_interupt_action_melee(t)
			self._ext_camera:camera_unit():base():set_limits(80, 50)
			self:_start_action_interact(t, input, timer, interact_object)
		end
		
		new_action = new_action or self:_start_action_intimidate(t)
	end
end)

Hooks:PostHook(PlayerStandard, "_check_use_item", "sydchSO", function(self, t, input)
	local action_wanted = input.btn_use_item_press
	
	if not self._state_data.meleeing or self._state_data.melee_expire_t or self:_is_melee_instant() then
		return
	end
	
	if action_wanted then
		local action_forbidden = self._use_item_expire_t or self:_interacting() or self:_changing_weapon() or self:_is_throwing_projectile()
		
		if not action_forbidden and managers.player:can_use_selected_equipment(self._unit) then
			self:_interupt_action_melee(t)
			self:_start_action_use_item(t)
		end
	end
end)

Hooks:PostHook(PlayerStandard, "_check_action_equip", "sydchSO", function(self, t, input)
	local new_action
	local selection_wanted = input.btn_primary_choice
	
	if not self._state_data.meleeing or self._state_data.melee_expire_t or self:_is_melee_instant() then
		return
	end
	
	if selection_wanted then
		local action_forbidden = self:chk_action_forbidden("equip")
		action_forbidden = action_forbidden or not self._ext_inventory:is_selection_available(selection_wanted) or self._use_item_expire_t or self:_changing_weapon() or self:_interacting() or self:_is_throwing_projectile()
		
		if not action_forbidden then
			local new_action = not self._ext_inventory:is_equipped(selection_wanted)
			if new_action then
				self:_interupt_action_melee(t)
				self:_start_action_unequip_weapon(t, { selection_wanted = selection_wanted })
			else
				self:_interupt_action_melee(t)
			end
		end
	end
	return new_action
end)

Hooks:PostHook(PlayerStandard, "_check_change_weapon", "sydchSO", function(self, t, input)
	local new_action
	local action_wanted = input.btn_switch_weapon_press
	
	if not self._state_data.meleeing or self._state_data.melee_expire_t or self:_is_melee_instant() then
		return
	end
	
	if action_wanted then
		local action_forbidden = self:_changing_weapon()
		action_forbidden = action_forbidden or self._use_item_expire_t or self._change_item_expire_t
		action_forbidden = action_forbidden or self._unit:inventory():num_selections() == 1 or self:_interacting() or self:_is_throwing_projectile()
		
		if not action_forbidden then
			local data = {}
			data.next = true
			self:_interupt_action_melee(t)
			self._change_weapon_pressed_expire_t = t + 0.33
			self:_start_action_unequip_weapon(t, data)
			new_action = true
			managers.player:send_message(Message.OnSwitchWeapon)
		end
	end
	
	return new_action
end)

Hooks:PostHook(PlayerStandard, "_check_action_throw_grenade", "sydchSO", function(self, t, input)
	if not self._state_data.meleeing or self._state_data.melee_expire_t or self:_is_melee_instant() then
		return
	end
	
	local action_wanted = input.btn_throw_grenade_press
	if not action_wanted then
		return
	end
	
	if not managers.player:can_throw_grenade() then
		return
	end
	
	local action_forbidden = not PlayerBase.USE_GRENADES or self:chk_action_forbidden("interact") or self._unit:base():stats_screen_visible() or self:_is_throwing_grenade() or self:_interacting() or self:is_deploying() or self:_changing_weapon() or self:_is_using_bipod()
	if action_forbidden then
		return
	end
	
	self:_interupt_action_melee(t)
	self:_start_action_throw_grenade(t, input)
	
	return action_wanted
end)

Hooks:PostHook(PlayerStandard, "_check_action_throw_projectile", "sydchSO", function(self, t, input)
	if not self._state_data.meleeing or self._state_data.melee_expire_t or self:_is_melee_instant() then
		return
	end

	local projectile_entry = managers.blackmarket:equipped_projectile()

	if tweak_data.blackmarket.projectiles[projectile_entry].is_a_grenade then
		return self:_check_action_throw_grenade(t, input)
	elseif tweak_data.blackmarket.projectiles[projectile_entry].ability then
		return self:_check_action_use_ability(t, input)
	end

	if not managers.player:can_throw_grenade() then
		self._state_data.projectile_throw_wanted = nil
		self._state_data.projectile_idle_wanted = nil
		return
	end

	if self._state_data.projectile_throw_wanted then
		if not self._state_data.projectile_throw_allowed_t then
			self._state_data.projectile_throw_wanted = nil
			self:_do_action_throw_projectile(t, input)
		end
		return
	end

	local action_wanted = input.btn_projectile_press or input.btn_projectile_release or self._state_data.projectile_idle_wanted

	if not action_wanted then
		return
	end

	if input.btn_projectile_release then
		if self._state_data.throwing_projectile then
			if self._state_data.projectile_throw_allowed_t then
				self._state_data.projectile_throw_wanted = true
				return
			end
			self:_do_action_throw_projectile(t, input)
		end
		return
	end

	local action_forbidden = not PlayerBase.USE_GRENADES or not self:_projectile_repeat_allowed() or self:chk_action_forbidden("interact") or self:_interacting() or self:is_deploying() or self:_changing_weapon() or self:_is_using_bipod()
	
	if action_forbidden then
		return
	end
	
	self:_interupt_action_melee(t)
	self:_start_action_throw_projectile(t, input)

	return true
end)
end

if sydchSO.settings.soundIMMERSION == true then
local _check_action_jump_old = PlayerStandard._check_action_jump
math.randomseed(os.time())
local randomsound = self
local sound = string	
function PlayerStandard:_check_action_jump(t, input)
	if input and input.btn_jump_press and not self._state_data.in_air and not self._state_data.ducking then
		randomsound = math.random(0,8)
		if randomsound == 1 then
		  sound = "jump1"
		elseif randomsound == 2 then
		  sound = "jump2"
		elseif randomsound == 3 then
		  sound = "jump3"
		elseif randomsound == 4 then
		  sound = "jump4"
		elseif randomsound == 5 then
		  sound = "jump5"
		elseif randomsound == 6 then
		  sound = "jump6"
		elseif randomsound == 7 then
		  sound = "jump7"	  		  		  		  		  		  
		else
		  sound = "jump8"
		end
		self._unit:sound():play(sound)
		local _result = _check_action_jump_old(self, t, input)
		return _result		
	elseif input and input.btn_duck_press or input.btn_jump_press and not self._state_data.in_air then
		randomsound = math.random(0,8)
		if randomsound == 1 then
		  sound = "crouch1"
		elseif randomsound == 2 then
		  sound = "crouch2"
		elseif randomsound == 3 then
		  sound = "crouch3"
		elseif randomsound == 4 then
		  sound = "crouch4"
		elseif randomsound == 5 then
		  sound = "crouch5"
		else
		  sound = "crouch6"
		end			
		self._unit:sound():play(sound)
		local _result = _check_action_jump_old(self, t, input)
		return _result
	end
	return _check_action_jump_old(self, t, input)
end
end

if sydchSO.settings.vocalHEISTERS == 1 or sydchSO.settings.vocalHEISTERS == 2 then
	return
end

local last_revive_say_t = 0

Hooks:PostHook(PlayerStandard, "_start_action_interact", "sydchSO_revivecomment", function(self)
    if not self._interact_params or self._interact_params.tweak_data ~= "revive" then
        return
    end

    if(os.clock() - last_revive_say_t) < 5 then
        return
    end

    local voice_to_say = "s08x_sin"
    if math.random() > 0.5 then
        voice_to_say = "s09a"
    end

    local revived_unit = self._interact_params.object
    if revived_unit and revived_unit:base().downs then
        local downs = revived_unit:base().downs
        if downs == 2 then
            voice_to_say = "s09b"
        elseif downs == 3 then
            voice_to_say = "s09c"
        end
    end
    
    sydchSO:Say(voice_to_say)
    last_revive_say_t = os.clock()
end)

if sydchSO.settings.copBEHAVIOR == true then
	Hooks:PostHook(PlayerStandard, "_start_action_interact", "sydchSO", function(self)
		if Network and Network:is_client() then
			return
		end

		sydchSO.CopUtils:SendCopToArrestPlayer(self._unit)
	end)
end

function PlayerStandard:_check_action_deploy_underbarrel(t, input)
	local new_action
	local action_forbidden = false
	if not input.btn_deploy_bipod then
		return new_action
	end
	action_forbidden = self:_is_throwing_projectile() or self:_is_meleeing() or self:is_equipping() or self:_changing_weapon() or self:shooting() or self:_is_reloading() or self:is_switching_stances() or self:_interacting()
	if not action_forbidden then
		local weapon = self._equipped_unit:base()
		local underbarrel_names = managers.weapon_factory:get_parts_from_weapon_by_type_or_perk("underbarrel", weapon._factory_id, weapon._blueprint)
		if underbarrel_names and underbarrel_names[1] then
			local underbarrel = weapon._parts[underbarrel_names[1]]
			if underbarrel then
				local underbarrel_base = underbarrel.unit:base()
				local underbarrel_tweak = tweak_data.weapon[underbarrel_base.name_id]
				if weapon.record_fire_mode then
					weapon:record_fire_mode()
				end
				underbarrel_base:toggle()
				new_action = true
				if weapon.reset_cached_gadget then
					weapon:reset_cached_gadget()
				end
				if weapon._update_stats_values then
					weapon:_update_stats_values(true)
				end
				local anim_ids
				local switch_delay = 1
				if underbarrel_base:is_on() then
					anim_ids = Idstring("underbarrel_enter_contraband")
					switch_delay = underbarrel_tweak.timers.equip_underbarrel
					self:set_animation_state("underbarrel")
				else
					anim_ids = Idstring("underbarrel_exit_contraband")
					switch_delay = underbarrel_tweak.timers.unequip_underbarrel
					self:set_animation_state("standard")
				end
				if anim_ids then
					self._ext_camera:play_redirect(anim_ids, 1)
				end
				self:set_animation_weapon_hold(nil)
				self:set_stance_switch_delay(switch_delay)
				if alive(self._equipped_unit) then
					managers.hud:set_ammo_amount(self._equipped_unit:base():selection_index(), self._equipped_unit:base():ammo_info())
					managers.hud:set_teammate_weapon_firemode(HUDManager.PLAYER_PANEL, self._unit:inventory():equipped_selection(), self._equipped_unit:base():fire_mode())
				end
				managers.network:session():send_to_peers_synched("sync_underbarrel_switch", self._equipped_unit:base():selection_index(), underbarrel_base.name_id, underbarrel_base:is_on())
			end
		end
	end
	return new_action
end

local _add_unit_to_char_table_old = PlayerStandard._add_unit_to_char_table
function PlayerStandard:_add_unit_to_char_table(char_table, unit, unit_type, ...)
	if unit_type ~= 3 or unit:base()._detection_delay or (Network:is_client() and unit:base().cam_disabled ~= true) then
		_add_unit_to_char_table_old(self, char_table, unit, unit_type, ...)
	end
end

function PlayerStandard:_get_walk_headbob()
	if self._state_data.using_bipod then
		return 0.001
	elseif self._state_data.in_steelsight then
		return 0.0015
	elseif self._state_data.in_air then
		return 0.006
	elseif self._state_data.ducking then
		return 0.0065
	elseif self._running then
		return 0.1 * (self._equipped_unit:base():run_and_shoot_allowed() and 0.4 or 0.8)
	end

	return 0.01
end