dofile(ModPath .. "lua/core/sydchSO.lua")

CopDamage._ARMOR_DAMAGE_REDUCTION = 1

CopDamage.trauma_table = { 
	null = 134,
	civilian = 1, 
	civilian_female = 1,
	sniper = 3,
	shield = 6,
	phalanx_minion = 19,
	medic = 16,
	taser = 19,
	spooc = 16,
	tank = 92,
	tank_hw = 134,
	tank_medic = 102,
	tank_mini = 112,
	shadow_spooc = 21,
	security = 3,
	gensec = 3,
	cop = 3,
	cop_scared = 3,
	cop_female = 3,
	fbi = 5,
	swat = 7,
	heavy_swat = 13,
	heavy_swat_sniper = 3,
	fbi_swat = 7,
	fbi_heavy_swat = 13,
	city_swat = 7,
	gangster = 3,
	biker = 3,
	biker_escape = 3,
	mobster = 3,
	mobster_boss = 21,
	biker_boss = 52,
	chavez_boss = 26,
	hector_boss = 40, 
	hector_boss_no_armor = 3,
	bolivian = 3,
	bolivian_indoors = 3,
	drug_lord_boss = 52,
	drug_lord_boss_stealth = 3,
	swat_turret = 134,
	triad_boss = 64,
	triad_boss_no_armor = 3,
	marshal_marksman = 5,
	marshal_shield = 7,
	marshal_shield_break = 7
}

CopDamage.trauma_multipliers = {  
	tank = 11.5,
	tank_hw = 16.75,
	tank_medic = 12.75,
	tank_mini = 14
}

CopDamage.trauma_addend = {
	easy = 0,
	normal = 1,
	overkill = 2,
	overkill_145 = 3,
	easy_wish = 4,
	overkill_290 = 5,
	sm_wish = 6
}

if sydchSO.settings.weaponOVERHAUL == true then
function CopDamage:check_decapitations(damage_data)
	local body = damage_data.body
	local head = body:key() == Idstring("head"):key() or body:key() == Idstring("hit_head"):key() or body:key() == Idstring("rag_head"):key()
	local melee_entry = managers.blackmarket:equipped_melee_weapon() or "weapon"
	
	if not damage_data.attacker_unit then
		damage_data.attacker_unit = managers.player:player_unit()
	end
	if managers.network:session() and managers.network:session():peer_by_unit(damage_data.attacker_unit) then
		melee_entry = managers.network:session():peer_by_unit(damage_data.attacker_unit):melee_id()
	end
	
	local deep_wound = tweak_data.blackmarket.melee_weapons[melee_entry].deep_wound
	local execution = tweak_data.blackmarket.melee_weapons[melee_entry].execution
	local bleed = tweak_data.blackmarket.melee_weapons[melee_entry].bleed
	local blunt = tweak_data.blackmarket.melee_weapons[melee_entry].multiply or tweak_data.blackmarket.melee_weapons[melee_entry].knockdown
	
	if self._dead then
		if deep_wound or execution then
			if self._unit:base()._tweak_table == "spooc" then
				if head then
					if self._unit:damage():has_sequence("dismember_head") and not self._decapitated then	
						self._unit:sound():play("split_gen_head")
						self._unit:damage():run_sequence_simple("dismember_head")
						self._decapitated = true	
					end
				else
					if self._unit:damage():has_sequence("dismember_body_top") and not self._decapitated then	
						self._unit:sound():play("split_gen_body")
						self._unit:damage():run_sequence_simple("dismember_body_top")
						self._decapitated = true
					end
				end
			end
		end
		if blunt then
			if head then
				if self._unit:damage():has_sequence("kill_tazer_headshot") and self._unit:base()._tweak_table == "taser" and not self._decapitated then
					self._unit:sound():play("split_gen_head")
					
					self:_spawn_head_gadget({
						position = self._unit:get_object(Idstring("head")):position(),
						rotation = self._unit:get_object(Idstring("head")):rotation(),
						dir = -self._unit:movement():m_head_rot():y()
					})
					
					self._unit:damage():run_sequence_simple("kill_tazer_headshot")
					self._decapitated = true
				end
			end
		end
		if head and not self._decapitated then
			self._unit:movement():enable_update()
			self._unit:movement()._frozen = nil
			
			if self._unit:movement()._active_actions[1] then
				self._unit:movement()._active_actions[1]:force_ragdoll(true)
			end
			
			if deep_wound or execution then
				self._unit:sound():play("split_gen_head")
				
				self:_spawn_head_gadget({
					position = self._unit:get_object(Idstring("head")):position(),
					rotation = self._unit:get_object(Idstring("head")):rotation(),
					dir = -self._unit:movement():m_head_rot():y()
				})
				
				self._unit:movement():add_dismemberment("head")
			end
			if bleed then
				self._unit:sound():play("split_gen_head")
				self._unit:movement():add_dismemberment("head")
			end
		end
	end
end

function CopDamage:check_blunt_force(damage_data)
	local body = damage_data.body
	local head = body:key() == Idstring("head"):key() or body:key() == Idstring("hit_head"):key() or body:key() == Idstring("rag_head"):key()
	
	local melee_entry = managers.blackmarket:equipped_melee_weapon()
	
	if not damage_data.attacker_unit then
		damage_data.attacker_unit = managers.player:player_unit()
	end
	if managers.network:session() and managers.network:session():peer_by_unit(damage_data.attacker_unit) then
		melee_entry = managers.network:session():peer_by_unit(damage_data.attacker_unit):melee_id()
	end
	
	local deep_wound = tweak_data.blackmarket.melee_weapons[melee_entry].deep_wound
	local execution = tweak_data.blackmarket.melee_weapons[melee_entry].execution
	local blunt = tweak_data.blackmarket.melee_weapons[melee_entry].multiply or tweak_data.blackmarket.melee_weapons[melee_entry].knockdown
	
	if damage_data.death and head and blunt and not managers.groupai:state():whisper_mode() then
		self._unit:movement():enable_update()
		self._unit:movement()._frozen = nil
		
		local hit_pos = mvector3.copy(self._unit:movement():m_pos())
		local attack_dir = damage_data.attacker_unit:movement():m_head_rot():y()
		
		if self._unit:movement()._active_actions[1] then
			self._unit:movement()._active_actions[1]:force_ragdoll()
		end
		
		local height = mvector3.distance(hit_pos, self._unit:position()) - 100
		local twist_dir = math.random(2) == 1 and 1 or -1
		local rot_acc = (attack_dir:cross(math.UP) + math.UP * (0.5 * twist_dir)) * (-1000 * math.sign(height))
		local rot_time = 1 + math.rand(2)
		local nr_u_bodies = self._unit:num_bodies()
		local i_u_body = 0
		
		while nr_u_bodies > i_u_body do
			local u_body = self._unit:body(i_u_body)
			if u_body:enabled() and u_body:dynamic() then
				World:play_physic_effect(Idstring("physic_effects/shotgun_hit"), u_body, Vector3(attack_dir.x, attack_dir.y, attack_dir.z + 0.5) * 600 * 1, 4 * u_body:mass() / math.random(2), rot_acc, rot_time)
			end
			i_u_body = i_u_body + 1
		end
	end
end
end

Hooks:PostHook(CopDamage, "init", "sydchSO", function(self)
	self.current_trauma = 1
	self._chk_dmg_count = 1
	self._chk_dmg_head = 3.25
	self._chk_dmg_done = false
	self._chk_deep_wound = false
	--self._insta_kill = (9223372036854775807 * 9223372036854775807)
end)

function CopDamage:damage_bullet(attack_data, ...)
	if self._dead or self._invulnerable then
		return
	end

	if self:is_friendly_fire(attack_data.attacker_unit) then
		return "friendly_fire"
	end

	if sydchSO.settings.streamLINED == 3 then
	if self._head_gear and self._char_tweak.headgear_dmg_penalty then
		attack_data = self:_chk_headgear_damage_reduction(attack_data)
	end

	if self._char_tweak.body_armor_dmg_penalty then
		attack_data = self:_chk_armor_damage_reduction(attack_data)
	end

	if self._has_plate and attack_data.col_ray.body and attack_data.col_ray.body:name() == self._ids_plate_name then
		attack_data.col_ray.body = self._unit:body("body")
	end
	end

	local is_civilian = CopDamage.is_civilian(self._unit:base()._tweak_table)
	if self._has_plate and attack_data.col_ray.body and attack_data.col_ray.body:name() == self._ids_plate_name and not attack_data.armor_piercing then
		local armor_pierce_roll = math.rand(1)
		local armor_pierce_value = 0
		local armor_pierce_professional = managers.player:upgrade_value("weapon", "armor_piercing_chance_silencer", 0)
		local armor_pierce_gain = managers.player:upgrade_value("weapon", "armor_piercing_chance", 0)

		if attack_data.attacker_unit == managers.player:player_unit() and not attack_data.weapon_unit:base().thrower_unit then
			armor_pierce_value = armor_pierce_value + attack_data.weapon_unit:base():armor_piercing_chance()
			armor_pierce_value = armor_pierce_value + managers.player:upgrade_value("player", "armor_piercing_chance", 0)
			armor_pierce_value = armor_pierce_value + armor_pierce_gain
			armor_pierce_value = armor_pierce_value + managers.player:upgrade_value("weapon", "armor_piercing_chance_2", 0)

			if attack_data.weapon_unit:base():got_silencer() then
				armor_pierce_value = armor_pierce_value + armor_pierce_professional
			end
			

			if attack_data.weapon_unit:base():is_category("saw") then
				armor_pierce_value = armor_pierce_value + managers.player:upgrade_value("saw", "armor_piercing_chance", 0)
			end
		elseif attack_data.attacker_unit:base() and attack_data.attacker_unit:base().sentry_gun then
			local owner = attack_data.attacker_unit:base():get_owner()

			if alive(owner) then
				if owner == managers.player:player_unit() then
					armor_pierce_value = armor_pierce_value + managers.player:upgrade_value("sentry_gun", "armor_piercing_chance", 0)
					armor_pierce_value = armor_pierce_value + managers.player:upgrade_value("sentry_gun", "armor_piercing_chance_2", 0)
				else
					armor_pierce_value = armor_pierce_value + (owner:base():upgrade_value("sentry_gun", "armor_piercing_chance") or 0)
					armor_pierce_value = armor_pierce_value + (owner:base():upgrade_value("sentry_gun", "armor_piercing_chance_2") or 0)
				end
			end
		end

		if armor_pierce_roll >= armor_pierce_value then
			if managers.player:has_category_upgrade("weapon", "armor_piercing_chance_silencer", 0) then
				armor_pierce_professional = armor_pierce_professional + 0.1
			end
			armor_pierce_gain = armor_pierce_gain + 0.33
			return
		end
	end

	local result = nil
	local body_index = self._unit:get_body_index(attack_data.col_ray.body:name())
	local enemy_base = self._unit:base()
	local unit_type = enemy_base._tweak_table
	local head = self._head_body_name and attack_data.col_ray.body and attack_data.col_ray.body:name() == self._ids_head_body_name
	local damage = attack_data.damage

	if self._unit:base():char_tweak().DAMAGE_CLAMP_BULLET then
		damage = math.min(damage, self._unit:base():char_tweak().DAMAGE_CLAMP_BULLET)
	end

	damage = damage * (self._marked_dmg_mul or 1)

	if self._marked_dmg_mul and self._marked_dmg_dist_mul then
		local dst = mvector3.distance(attack_data.origin, self._unit:position())
		local spott_dst = tweak_data.upgrades.values.player.marked_inc_dmg_distance[self._marked_dmg_dist_mul]

		if spott_dst[1] < dst then
			damage = damage * spott_dst[2]
		end
	end

	if self._unit:movement():cool() then
		damage = self._HEALTH_INIT
	end

	local headshot = false
	local headshot_multiplier = 1

	if attack_data.attacker_unit == managers.player:player_unit() then
		attack_data.backstab = self:check_backstab(attack_data)
		local critical_hit, crit_damage = self:roll_critical_hit(attack_data)

		if critical_hit then
			managers.hud:on_crit_confirmed()

			damage = crit_damage
			attack_data.critical_hit = true
		else
			managers.hud:on_hit_confirmed()
		end

		headshot_multiplier = managers.player:upgrade_value("weapon", "passive_headshot_damage_multiplier", 1)

		if tweak_data.character[self._unit:base()._tweak_table].priority_shout then
			damage = damage * managers.player:upgrade_value("weapon", "special_damage_taken_multiplier", 1)
		end
		
		if not attack_data.weapon_unit:base().thrower_unit then
			if attack_data.weapon_unit:base():got_silencer() and managers.player:has_category_upgrade("weapon", "silencer_instant_kill") then
			local chance = 0.34
				if math.random() <= chance then
					damage = damage * (self._char_tweak.headshot_dmg_mul * 3)
					if sydchSO.settings.buffEFFECTS == 2 or sydchSO.settings.buffEFFECTS == 3 then
						managers.environment_controller:set_buff_effect(0.2)
					end
				else
					chance = chance + 0.33
				end
			end
		end
		
		--if tweak_data.character[self._unit:base()._tweak_table].priority_shout and managers.weapon_factory:has_perk("silencer", weapon.factory_id, blueprint) then
		--	damage = damage * managers.player:upgrade_value("weapon", "special_silencer_damage_taken_multiplier", 1)
		--end

		-- trauma damage >>>
		-- this part calculates how many shots you need to have from the table.
		if not self._chk_dmg_done then
			local enemy_base = self._unit:base()
			local unit_type = enemy_base._tweak_table
			unit_type = unit_type or "nil"
			local trauma = self.trauma_table[unit_type] or self.trauma_table.null
			trauma = trauma - (self.trauma_addend[Global.game_settings.difficulty] or 0)
			self.current_trauma = self.current_trauma + trauma
			self._chk_dmg_done = true
			self._chk_dmg_head = self._chk_dmg_head * (self.trauma_multipliers[unit_type] or 1)
		end
		-- let's add shot counters. this was easier then what i thought.
		if head then
			managers.player:on_headshot_dealt()
			headshot = true
			self._chk_dmg_count = self._chk_dmg_count + (1 * self._chk_dmg_head)
		else
			self._chk_dmg_count = self._chk_dmg_count + 1
		end
		
		-- resets if it's crime spree.
		if managers.crime_spree:is_active() then
			self._chk_dmg_count = self._chk_dmg_count - self._chk_dmg_count
		end
		
		-- low damage weapon breakpoints are awful. with this code, it still be awful but slightly better.
		-- anything below 63.51 damage is now fixed to 16 for body and 4 with head breakpoints. silly solution, but eh.
		-- what does this is if x amount of shots made to normal enemies it'll multiply your damage to the max.
		if sydchSO.settings.streamLINED == 2 or sydchSO.settings.streamLINED == 3 then
			if self._chk_dmg_count > self.current_trauma then
				damage = damage * (self._char_tweak.headshot_dmg_mul * 3)
				--self._chk_dmg_count = self._chk_dmg_count - self._chk_dmg_count
			end
			--if math.random() <= (0.05 * self._chk_dmg_head) or math.random() <= (0.01 * self._chk_dmg_count) then
			--	damage = damage * (9223372036854775807 * 9223372036854775807)
			--end
		end
	end

	if not self._char_tweak.ignore_headshot and not self._damage_reduction_multiplier and head then
		if self._char_tweak.headshot_dmg_mul then
			damage = damage * self._char_tweak.headshot_dmg_mul * headshot_multiplier
		else
			damage = self._health * 10
		end
	end

	if attack_data.weapon_unit:base().get_add_head_shot_mul then
		local add_head_shot_mul = attack_data.weapon_unit:base():get_add_head_shot_mul()

		if not head and add_head_shot_mul and self._char_tweak then
			local tweak_headshot_mul = math.max(0, self._char_tweak.headshot_dmg_mul - 1)
			local mul = tweak_headshot_mul * add_head_shot_mul + 1
			damage = damage * mul
		end
	end

	damage = self:_apply_damage_reduction(damage)
	attack_data.raw_damage = damage
	attack_data.headshot = head
	local damage_percent = math.ceil(math.clamp(damage / self._HEALTH_INIT_PRECENT, 1, self._HEALTH_GRANULARITY))
	damage = damage_percent * self._HEALTH_INIT_PRECENT
	damage, damage_percent = self:_apply_min_health_limit(damage, damage_percent)

	if self._immortal then
		damage = math.min(damage, self._health - 1)
	end

	if self._health <= damage then
		if self:check_medic_heal() then
			result = {
				type = "healed",
				variant = attack_data.variant
			}
		else
			if head then
				managers.player:on_lethal_headshot_dealt(attack_data.attacker_unit, attack_data)

				if math.random(10) < damage then
					self:_spawn_head_gadget({
						position = attack_data.col_ray.body:position(),
						rotation = attack_data.col_ray.body:rotation(),
						dir = attack_data.col_ray.ray
					})
				end
			end

			attack_data.damage = self._health
			result = {
				type = "death",
				variant = attack_data.variant
			}

			self:die(attack_data)
			self:chk_killshot(attack_data.attacker_unit, "bullet", headshot)
		end
	else
		attack_data.damage = damage
		local result_type = not self._char_tweak.immune_to_knock_down and (attack_data.knock_down and "knock_down" or attack_data.stagger and not self._has_been_staggered and "stagger") or self:get_damage_type(damage_percent, "bullet")
		result = {
			type = result_type,
			variant = attack_data.variant
		}

		self:_apply_damage_to_health(damage)
	end

	attack_data.result = result
	attack_data.pos = attack_data.col_ray.position

	if result.type == "death" then
		local data = {
			name = self._unit:base()._tweak_table,
			stats_name = self._unit:base()._stats_name,
			head_shot = head,
			weapon_unit = attack_data.weapon_unit,
			variant = attack_data.variant
		}

		if managers.groupai:state():all_criminals()[attack_data.attacker_unit:key()] then
			managers.statistics:killed_by_anyone(data)
		end

		if attack_data.attacker_unit == managers.player:player_unit() then
			local special_comment = self:_check_special_death_conditions(attack_data.variant, attack_data.col_ray.body, attack_data.attacker_unit, attack_data.weapon_unit)

			self:_comment_death(attack_data.attacker_unit, self._unit, special_comment)
			self:_show_death_hint(self._unit:base()._tweak_table)

			local attacker_state = managers.player:current_state()
			data.attacker_state = attacker_state

			managers.statistics:killed(data)
			self:_check_damage_achievements(attack_data, head)

			if not is_civilian and managers.player:has_category_upgrade("temporary", "overkill_damage_multiplier") then
			--if not is_civilian and managers.player:has_category_upgrade("temporary", "overkill_damage_multiplier") and not attack_data.weapon_unit:base().thrower_unit and attack_data.weapon_unit:base():is_category("shotgun", "saw") then
				managers.player:activate_temporary_upgrade("temporary", "overkill_damage_multiplier")
				if sydchSO.settings.buffEFFECTS == 2 or sydchSO.settings.buffEFFECTS == 3 then
					managers.environment_controller:set_buff_effect(0.2)
				end
			end

			if is_civilian then
				managers.money:civilian_killed()
			end
		elseif attack_data.attacker_unit:in_slot(managers.slot:get_mask("criminals_no_deployables")) then
			--self:_AI_comment_death(attack_data.attacker_unit, self._unit:base()._tweak_table)
			--nothing
		elseif attack_data.attacker_unit:base().sentry_gun then
			if Network:is_server() then
				local server_info = attack_data.weapon_unit:base():server_information()

				if server_info and server_info.owner_peer_id ~= managers.network:session():local_peer():id() then
					local owner_peer = managers.network:session():peer(server_info.owner_peer_id)

					if owner_peer then
						owner_peer:send_queued_sync("sync_player_kill_statistic", data.name, data.head_shot and true or false, data.weapon_unit, data.variant, data.stats_name)
					end
				else
					data.attacker_state = managers.player:current_state()

					managers.statistics:killed(data)
				end
			end

			local sentry_attack_data = deep_clone(attack_data)
			sentry_attack_data.attacker_unit = attack_data.attacker_unit:base():get_owner()

			if sentry_attack_data.attacker_unit == managers.player:player_unit() then
				self:_check_damage_achievements(sentry_attack_data, head)
			else
				self._unit:network():send("sync_damage_achievements", sentry_attack_data.weapon_unit, sentry_attack_data.attacker_unit, sentry_attack_data.damage, sentry_attack_data.col_ray and sentry_attack_data.col_ray.distance, head)
			end
		end
	end

	local hit_offset_height = math.clamp(attack_data.col_ray.position.z - self._unit:movement():m_pos().z, 0, 300)
	local attacker = attack_data.attacker_unit

	if attacker:id() == -1 then
		attacker = self._unit
	end

	local weapon_unit = attack_data.weapon_unit

	if alive(weapon_unit) and weapon_unit:base() and weapon_unit:base().add_damage_result then
		weapon_unit:base():add_damage_result(self._unit, result.type == "death", attacker, damage_percent)
	end

	local variant = nil

	if result.type == "knock_down" then
		variant = 1
	elseif result.type == "stagger" then
		variant = 2
		self._has_been_staggered = true
	elseif result.type == "healed" then
		variant = 3
	else
		variant = 0
	end

	self:_send_bullet_attack_result(attack_data, attacker, damage_percent, body_index, hit_offset_height, variant)
	self:_on_damage_received(attack_data)

	if not is_civilian then
		managers.player:send_message(Message.OnEnemyShot, nil, self._unit, attack_data)
	end
	
	result.attack_data = attack_data

	return result
end

function CopDamage:_chk_headgear_damage_reduction(attack_data)
	if self._dead or self._invulnerable then
		return attack_data
	end

	if not attack_data.damage then
		return attack_data
	end

	if not self._head_gear then
		return attack_data
	end

	local is_headshot = self._head_body_name and attack_data.col_ray.body and attack_data.col_ray.body:name() == self._ids_head_body_name
	if not is_headshot then
		return attack_data
	end

	if not self._char_tweak or not self._char_tweak.headgear_dmg_penalty then
		return attack_data
	end

	local penalty = self._char_tweak.headgear_dmg_penalty
	local penalty_mul = attack_data.weapon_unit:base()._body_armor_dmg_penalty_mul
	if penalty_mul then
		penalty = penalty * penalty_mul
	end

	attack_data.damage = attack_data.damage * (1 - penalty)

	if self._char_tweak.headgear_flyoff_chance and math.random() < self._char_tweak.headgear_flyoff_chance then
		self:_spawn_head_gadget({
			position = attack_data.col_ray.body:position(),
			rotation = attack_data.col_ray.body:rotation(),
			dir = attack_data.col_ray.ray
		})
	end

	if attack_data.damage < 0 then
		attack_data.damage = 0
	end

	return attack_data
end

function CopDamage:_chk_armor_damage_reduction(attack_data)
	if self._dead or self._invulnerable then
		return attack_data
	end

	if not attack_data.damage then
		return attack_data
	end

	if not self._has_plate or not attack_data.col_ray.body or attack_data.col_ray.body:name() ~= self._ids_plate_name then
		return attack_data
	end

	if not self._char_tweak or not self._char_tweak.body_armor_dmg_penalty then
		return attack_data
	end

	local penalty = self._char_tweak.body_armor_dmg_penalty
	local penalty_mul = attack_data.weapon_unit:base()._body_armor_dmg_penalty_mul
	if penalty_mul then
		penalty = penalty * penalty_mul
	end

	attack_data.damage = attack_data.damage * (1 - penalty)

	if attack_data.damage < 0 then
		attack_data.damage = 0
	end

	return attack_data
end

local damage_fire_original = CopDamage.damage_fire
function CopDamage:damage_fire(attack_data)
	local headshot = false
	local headshot_multiplier = 1
	local head = self._head_body_name and attack_data.col_ray.body and attack_data.col_ray.body:name() == self._ids_head_body_name

	if attack_data.attacker_unit == managers.player:player_unit() then
		local critical_hit, crit_damage = self:roll_critical_hit(attack_data)

		if critical_hit then
			managers.hud:on_crit_confirmed()

			attack_data.damage = crit_damage
			attack_data.critical_hit = true
		else
			managers.hud:on_hit_confirmed()
		end

		headshot_multiplier = managers.player:upgrade_value("weapon", "passive_headshot_damage_multiplier", 1)

		if tweak_data.character[self._unit:base()._tweak_table].priority_shout then
			attack_data.damage = attack_data.damage * managers.player:upgrade_value("weapon", "special_damage_taken_multiplier", 1)
		end

		if head then
			managers.player:on_headshot_dealt()
			headshot = true
		end
	end

	if not self._char_tweak.ignore_headshot and not self._damage_reduction_multiplier and head then
		if self._char_tweak.headshot_dmg_mul then
			attack_data.damage = attack_data.damage * self._char_tweak.headshot_dmg_mul * headshot_multiplier
		else
			attack_data.damage = self._health * 10
		end
	end

	if head and attack_data.weapon_unit and attack_data.weapon_unit:base() and attack_data.weapon_unit:base().get_add_head_shot_mul then 
		local add_head_shot_mul = attack_data.weapon_unit:base():get_add_head_shot_mul()

		if not head and add_head_shot_mul and self._char_tweak and self._char_tweak.access ~= "tank" then
			local tweak_headshot_mul = math.max(0, self._char_tweak.headshot_dmg_mul - 1)
			local mul = tweak_headshot_mul * add_head_shot_mul + 1
			attack_data.damage = attack_data.damage * mul
		end
	end
	
	damage_fire_original(self, attack_data)
end

Hooks:PreHook(CopDamage, "damage_melee", "sydchSO", function(self, attack_data)
	if not attack_data then return end
	if self._invulnerable then return end
	local body = attack_data.body_name or attack_data.col_ray.body:name()
	local head = body:key() == Idstring("head"):key() or body:key() == Idstring("hit_head"):key() or body:key() == Idstring("rag_head"):key()
	local melee_entry = managers.blackmarket:equipped_melee_weapon()
	
	local critical_hits = self._char_tweak.critical_hits or {}
	local critical_hit = false
	local critical_value = (critical_hits.base_chance or 0) + managers.player:critical_hit_chance() * (critical_hits.player_chance_multiplier or 1)
	
	if head and attack_data.attacker_unit and attack_data.attacker_unit:key() == managers.player:player_unit():key() then
		attack_data.damage = attack_data.damage * self._char_tweak.headshot_dmg_mul * managers.player:upgrade_value("weapon", "passive_headshot_damage_multiplier", 1)
		if sydchSO.settings.weaponOVERHAUL == true and tweak_data.blackmarket.melee_weapons[melee_entry].execution then
			attack_data.damage = attack_data.damage * (self._char_tweak.headshot_dmg_mul * 3)
		end
	end
	
	if sydchSO.settings.weaponOVERHAUL == true then
		self:check_decapitations({
			body = attack_data.body_name or attack_data.col_ray.body:name(),
			attacker_unit = attack_data.attacker_unit
		})
		self:check_blunt_force({
			body = attack_data.body_name or attack_data.col_ray.body:name(),
			attacker_unit = attack_data.attacker_unit,
			death = attack_data.result and attack_data.result.type == "death"
		})
		if tweak_data.blackmarket.melee_weapons[melee_entry].deep_wound then
			self._chk_deep_wound = true
		elseif tweak_data.blackmarket.melee_weapons[melee_entry].mark_enemy and self._unit:contour() then
			self._unit:contour():add(managers.player:get_contour_for_marked_enemy(), true, managers.player:upgrade_value("player", "mark_enemy_time_multiplier", 1))
		end
		if attack_data.attacker_unit == managers.player:player_unit() then
			if not self._dead and attack_data.attacker_unit and attack_data.attacker_unit:key() == managers.player:player_unit():key() and not PlayerDamage.is_friendly_fire(self, attack_data.attacker_unit) and not CopDamage.is_civilian(self._unit:base()._tweak_table) then
				if tweak_data.blackmarket.melee_weapons[melee_entry].fire_dot_data and not managers.player:player_unit():movement():current_state()._state_data.melee_enhancement_expire_t then
					managers.player:player_unit():movement():current_state()._state_data.melee_enhancement_expire_t = managers.player:player_timer():time() + tweak_data.blackmarket.melee_weapons[melee_entry].fire_dot_data.dot_length
					--managers.fire:add_doted_enemy(self._unit, managers.player:player_timer():time(), managers.player:player_unit(), 5, attack_data.damage * 0.25)
					--managers.network:session():send_to_peers_synched("sync_add_doted_enemy", self._unit, managers.player:player_timer():time(), managers.player:player_unit(), 5, attack_data.damage * 0.25)
					managers.fire:start_burn_body_sound({enemy_unit = self._unit}, 5)
					
					World:effect_manager():spawn({
						effect = Idstring( "effects/payday2/particles/explosions/molotov_grenade_enemy_on_fire_5s"),
						parent = self._unit:get_object(Idstring("Spine"))
					})
				elseif tweak_data.blackmarket.melee_weapons[melee_entry].snatch then
					if 0.7 >= math.rand(1) then						
						for id, weapon in pairs(managers.player:player_unit():inventory():available_selections()) do
							if managers.player:has_category_upgrade("player", "pick_up_ammo_multiplier") then
								weapon.unit:base():add_ammo(2)
							else
								weapon.unit:base():add_ammo(1)
							end
							managers.hud:set_ammo_amount(id , weapon.unit:base():ammo_info())
						end
						if managers.player:has_activate_temporary_upgrade("temporary", "loose_ammo_restore_health") then
							local values = managers.player:temporary_upgrade_value("temporary", "loose_ammo_restore_health", 0)
							local restore_value = math.random(values[1], values[2])
							local num_more_hp = 1
							if managers.player:num_connected_players() > 0 then
								num_more_hp = managers.player:num_players_with_more_health()
							end
							local base = tweak_data.upgrades.loose_ammo_restore_health_values.base
							local sync_value = math.round(math.clamp(restore_value - base, 0, 13))
							restore_value = restore_value * (tweak_data.upgrades.loose_ammo_restore_health_values.multiplier or 0.1)
							local percent_inc = managers.player:upgrade_value("player", "gain_life_per_players", 0) * num_more_hp + 1
							print(percent_inc - 1)
							restore_value = restore_value * percent_inc
							managers.player:player_unit():character_damage():restore_health(restore_value, true)
							managers.player:player_unit():character_damage():restore_armor(math.random(1, 2))
							managers.player:player_unit():sound():play("pickup_ammo_health_boost")
						end
					end
				end 
				if tweak_data.blackmarket.melee_weapons[melee_entry].moneymaker then
					World:effect_manager():spawn({
						effect = Idstring("effects/payday2/particles/impacts/money_impact_pd2"),
						position = self._unit:movement():m_pos()
					})
					local amount = attack_data.damage
					managers.money:_add_to_total(amount)
				end
			end
		end
		if attack_data.result and attack_data.result.type == "taser_tased" then
			if self._tase_effect then
				World:effect_manager():fade_kill(self._tase_effect)
				self._tase_effect = nil
			end
			
			self._tase_effect = World:effect_manager():spawn({
				effect = Idstring("effects/payday2/particles/character/taser_hittarget"),
				parent = self._unit:get_object(Idstring("Spine1"))
			})
		end
		if attack_data.backstab and tweak_data.blackmarket.melee_weapons[melee_entry].backstab then
			attack_data.damage = attack_data.damage * (self._char_tweak.headshot_dmg_mul * 3)
		end
	end
end)

if sydchSO.settings.weaponOVERHAUL == true then
Hooks:PostHook(CopDamage, "sync_damage_melee", "sydchSO", function(self, attacker_unit, damage_percent, damage_effect_percent, i_body, hit_offset_height, variant, death)
	if variant == 5 then
		if self._tase_effect then
			World:effect_manager():fade_kill(self._tase_effect)
			self._tase_effect = nil
		end
		
		self._tase_effect = World:effect_manager():spawn({
			effect = Idstring("effects/payday2/particles/character/taser_hittarget"),
			parent = self._unit:get_object(Idstring("Spine1"))
		})
	end
end)
end

function CopDamage:check_medic_heal()
	if self._unit:anim_data() and self._unit:anim_data().act then
		return false
	end
	
	if self._chk_deep_wound then
		return false
	end

	local medic = managers.enemy:get_nearby_medic(self._unit)

	return medic and medic:character_damage():heal_unit(self._unit)
end

function CopDamage.is_gangster(type)
	return type == "gangster" or type == "biker_escape" or type == "mobster" or type == "mobster_boss" or type == "biker" or type == "biker_boss" or type == "triad" or type == "bolivian" or type == "drug_lord_boss" or type == "drug_lord_boss_stealth" or type == "ranchmanager" or type == "bolivian_indoors_mex" or type == "tank" or type == "spooc" or type == "taser" or type == "shield" or type == "sniper" or type == "medic" or type == "captain" or type == "marshal_marksman" or type == "marshal_shield" or type == "marshal_shield_break"
end

function CopDamage:roll_critical_hit(attack_data)
	local damage = attack_data.damage

	if not self:can_be_critical(attack_data) then
		return false, damage
	end

	local critical_hits = self._char_tweak.critical_hits or {}
	local critical_hit = false
	local critical_value = (critical_hits.base_chance or 0) + managers.player:critical_hit_chance() * (critical_hits.player_chance_multiplier or 1)
	
	--if attack_data.backstab then
	--	critical_value = critical_value + managers.player:upgrade_value("player", "backstab_crit", 0)
	--end

	if critical_value > 0 then
		local critical_roll = math.rand(1)
		critical_hit = critical_roll < critical_value
	end

	if critical_hit then
		local critical_damage_mul = critical_hits.damage_mul or self._char_tweak.headshot_dmg_mul

		if critical_damage_mul then
			if attack_data.backstab then
				damage = damage * critical_damage_mul * managers.player:upgrade_value("player", "backstab_crit", 0)
			else
				damage = damage * critical_damage_mul
			end
		else
			if attack_data.backstab then
				damage = self._health * 10 * managers.player:upgrade_value("player", "backstab_crit", 0)
			else
				damage = self._health * 10
			end
		end
	end

	return critical_hit, damage
end

function CopDamage:check_backstab(attack_data)
	if self._unit.movement and self._unit:movement().m_rot then
		local fwd_vec = mvector3.dot(self._unit:movement():m_rot():y(), managers.player:player_unit():movement():m_head_rot():y())
		if fwd_vec > 0.15 then
			return true
		end
	end
	return false
end

local can_be_critical = CopDamage.can_be_critical
function CopDamage:can_be_critical(...)
	if managers.player:has_category_upgrade("player", "passive_extend_critical_hit") then
		return true
	end
	return can_be_critical(self, ...)
end

function CopDamage:build_suppression(amount, panic_chance)
	if self._dead or self._invulnerable or self._unit:in_slot(16) or not self._char_tweak.suppression then
		return
	end

	local t = TimerManager:game():time()
	local sup_tweak = self._char_tweak.suppression

	if panic_chance then
		if panic_chance == -1 or panic_chance > 0 and sup_tweak.panic_chance_mul > 0 and math.random() < panic_chance * sup_tweak.panic_chance_mul then
			amount = "panic"
		end
	end

	local amount_val = nil

	if amount == "max" or amount == "panic" then
		local value = sup_tweak.brown_point or sup_tweak.react_point

		amount_val = value[2]
	elseif Network:is_server() and self._suppression_hardness_t and t < self._suppression_hardness_t then
		amount_val = amount * 0.5
	else
		amount_val = amount
	end

	if not Network:is_server() then
		local sync_amount = nil

		if amount == "panic" then
			sync_amount = 16
		elseif amount == "max" then
			sync_amount = 15
		else
			local sync_amount_ratio = nil

			if sup_tweak.brown_point then
				if sup_tweak.brown_point[2] <= 0 then
					sync_amount_ratio = 1
				else
					sync_amount_ratio = amount_val / sup_tweak.brown_point[2]
				end
			elseif sup_tweak.react_point[2] <= 0 then
				sync_amount_ratio = 1
			else
				sync_amount_ratio = amount_val / sup_tweak.react_point[2]
			end

			sync_amount = math.clamp(math.ceil(sync_amount_ratio * 15), 1, 15)
		end

		managers.network:session():send_to_host("suppression", self._unit, sync_amount)

		return
	end

	if self._suppression_data then
		self._suppression_data.value = math.min(self._suppression_data.brown_point or self._suppression_data.react_point, self._suppression_data.value + amount_val)
		self._suppression_data.last_build_t = t
		self._suppression_data.decay_t = t + self._suppression_data.duration

		managers.enemy:reschedule_delayed_clbk(self._suppression_data.decay_clbk_id, self._suppression_data.decay_t)
	else
		local duration = math.lerp(sup_tweak.duration[1], sup_tweak.duration[2], math.random())
		local decay_t = t + duration
		self._suppression_data = {
			value = amount_val,
			last_build_t = t,
			decay_t = decay_t,
			duration = duration,
			react_point = sup_tweak.react_point and math.lerp(sup_tweak.react_point[1], sup_tweak.react_point[2], math.random()),
			brown_point = sup_tweak.brown_point and math.lerp(sup_tweak.brown_point[1], sup_tweak.brown_point[2], math.random()),
			decay_clbk_id = "CopDamage_suppression" .. tostring(self._unit:key())
		}

		managers.enemy:add_delayed_clbk(self._suppression_data.decay_clbk_id, callback(self, self, "clbk_suppression_decay"), decay_t)
	end

	if not self._suppression_data.brown_zone and self._suppression_data.brown_point and self._suppression_data.brown_point <= self._suppression_data.value then
		self._suppression_data.brown_zone = true

		local state = amount == "panic" and "panic" or true

		self._unit:brain():on_suppressed(state)
	elseif amount == "panic" then
		self._unit:brain():on_suppressed("panic")
	end

	if not self._suppression_data.react_zone and self._suppression_data.react_point and self._suppression_data.react_point <= self._suppression_data.value then
		self._suppression_data.react_zone = true

		local state = amount == "panic" and "panic" or true

		self._unit:movement():on_suppressed(state)
	elseif amount == "panic" then
		self._unit:movement():on_suppressed("panic")
	end
end

if sydchSO.settings.assaultTWEAKS == 3 then
CopDamage._HEALTH_GRANULARITY = 8192

local _dismember_condition_original = CopDamage._dismember_condition
function CopDamage:_dismember_condition(attack_data, ...)
	if alive(attack_data.attacker_unit) and attack_data.attacker_unit:base().is_local_player then
		return _dismember_condition_original(self, attack_data, ...)
	end
end

local _sync_dismember_original = CopDamage._sync_dismember
function CopDamage:_sync_dismember(attacker_unit, ...)
	if alive(attacker_unit) and attacker_unit:base().is_husk_player then
		return _sync_dismember_original(self, attacker_unit, ...)
	end
end
end

Hooks:PreHook(CopDamage, "damage_bullet", "sydchSO", function(self)
	if self._unit:movement() and not self._unit:movement()._team then
		self._unit:movement():set_team(managers.groupai:state()._teams[tweak_data.levels:get_default_team_ID(self._unit:base():char_tweak().access == "gangster" and "gangster" or "combatant")])
	end
end)

Hooks:PreHook(CopDamage, "damage_melee", "sydchSO", function(self)
	if self._unit:movement() and not self._unit:movement()._team then
		self._unit:movement():set_team(managers.groupai:state()._teams[tweak_data.levels:get_default_team_ID(self._unit:base():char_tweak().access == "gangster" and "gangster" or "combatant")])
	end
end)

function CopDamage:_spawn_head_gadget(params)
	if not self._head_gear or not self._unit then
		return
	end

	if self._head_gear_object then
		if self._nr_head_gear_objects then
			for i = 1, self._nr_head_gear_objects do
				local head_gear_obj_name = self._head_gear_object .. tostring(i)
				local head_gear_obje = self._unit:get_object(Idstring(head_gear_obj_name))
				if head_gear_obje then
					head_gear_obje:set_visibility(false)
				end
			end
		else
			local head_gear_obje = self._unit:get_object(Idstring(self._head_gear_object))
			if head_gear_obje then
				head_gear_obje:set_visibility(false)
			end
		end

		if self._head_gear_decal_mesh then
			local mesh_name_idstr = Idstring(self._head_gear_decal_mesh)

			self._unit:decal_surface(mesh_name_idstr):set_mesh_material(mesh_name_idstr, Idstring("flesh"))
		end
	end

	local unit = World:spawn_unit(Idstring(self._head_gear), params.position, params.rotation)

	if not params.skip_push then
		local dir = math.UP - params.dir / 2
		dir = dir:spread(25)
		local body = unit:body(0)

		body:push_at(body:mass(), dir * math.lerp(300, 650, math.random()), unit:position() + Vector3(math.rand(1), math.rand(1), math.rand(1)))
	end

	self._head_gear = false
end

local old_stun = CopDamage.stun_hit
function CopDamage:stun_hit(attack_data)
	if self._unit:in_slot(16, 21, 22) then
		return
	end
	return old_stun(self, attack_data)
end

if not Network:is_server() or not sydchSO.settings.expandedCREW == 3 then
	return
end

-- AI IMPROVEMENTS: bots does not drop ammo boxes, think is as they pick them up instead
Hooks:PreHook(CopDamage, "die", "sydchSO", function(self, attack_data)
	local attacker_unit = attack_data.attacker_unit
	if attacker_unit then
		if attacker_unit:in_slot(16) and self._pickup == "ammo" then
			self:set_pickup(nil)
		end
	end
end)