dofile(ModPath .. "lua/core/sydchSO.lua")

if not Network:is_server() or not sydchSO.settings.expandedCREW == 3 then
	return
end

-- AI IMPROVEMENTS: don't just dive in for revive and follow improvements
local upd_advance_original = CopLogicTravel.upd_advance
function CopLogicTravel.upd_advance(data, ...)
	if not data.is_team_ai then
		return upd_advance_original(data, ...)
	end

	local revive_unit = data.objective and data.objective.type == "revive" and data.objective.follow_unit
	if not alive(revive_unit) or mvector3.distance_sq(data.m_pos, revive_unit:position()) > 250000 then
		return upd_advance_original(data, ...)
	end

	if data.unit:character_damage():health_ratio() < 0.5 then
		return upd_advance_original(data, ...)
	end

	local timer = math.huge
	if revive_unit:base().is_local_player then
		timer = revive_unit:character_damage()._downed_timer or timer
	elseif revive_unit:interaction().get_waypoint_time then
		timer = revive_unit:interaction():get_waypoint_time() or timer
	end

	if timer < 10 then
		return upd_advance_original(data, ...)
	end

	local focus_enemy = data.attention_obj
	if focus_enemy and focus_enemy.verified and focus_enemy.dis < 1000 and focus_enemy.unit:base() and focus_enemy.unit:base().has_tag then
		if focus_enemy.unit:base():has_tag("spooc") or focus_enemy.unit:base():has_tag("taser") then
			if data.internal_data.advancing then
				data.unit:brain():action_request({
					body_part = 2,
					type = "idle"
				})
			end

			TeamAILogicAssault._upd_aim(data, data.internal_data)

			return
		end
	end

	return upd_advance_original(data, ...)
end

local _chk_stop_for_follow_unit_original = CopLogicTravel._chk_stop_for_follow_unit
function CopLogicTravel._chk_stop_for_follow_unit(data, my_data, ...)
	if data.objective and alive(data.objective.follow_unit) and my_data.coarse_path_index and my_data.coarse_path and my_data.coarse_path[my_data.coarse_path_index + 1] then
		return _chk_stop_for_follow_unit_original(data, my_data, ...)
	end
end

local _on_destination_reached_original = CopLogicTravel._on_destination_reached
function CopLogicTravel._on_destination_reached(data, ...)
	if data.objective then
		return _on_destination_reached_original(data, ...)
	end
end

if not Iter and not Iter.settings and not Iter.settings.streamline_path then
local _get_exact_move_pos_original = CopLogicTravel._get_exact_move_pos
function CopLogicTravel._get_exact_move_pos(data, nav_index, ...)
	local my_data = data.internal_data
	local coarse_path = my_data.coarse_path
	if nav_index >= #coarse_path or data.team.id ~= "criminal1" and data.team.id ~= "converted_enemy" then
		return _get_exact_move_pos_original(data, nav_index, ...)
	end

	if my_data.moving_to_cover then
		managers.navigation:release_cover(my_data.moving_to_cover[1])
		my_data.moving_to_cover = nil
	end

	local doors = managers.navigation:find_segment_doors(coarse_path[nav_index][1], function (seg) return seg == coarse_path[nav_index + 1][1] end)
	local door = table.random(doors)
	return door and door.center or _get_exact_move_pos_original(data, nav_index, ...)
end
end
