local sydchSOpath = ModPath
local sydchSOID = Idstring(sydchSOpath):key()
local bulletstorm_trigger = function(__id)
	return "BST_"..Idstring(tostring(__id).."::"..sydchSOID):key()
end

local bulletstorm_init = bulletstorm_trigger("take_ammo")
local bulletstorm_update = bulletstorm_trigger("OnWeaponFired")

local bullet_storm_hold = false

AmmoBagBase[bulletstorm_init] = AmmoBagBase[bulletstorm_init] or AmmoBagBase.take_ammo

function AmmoBagBase:take_ammo(player_save, ...)
	local interact, bulletstorm_delay = self[bulletstorm_init](self, player_save, ...)
	if managers.player and player_save and alive(player_save) and player_save == managers.player:player_unit() then
		if bulletstorm_delay and type(bulletstorm_delay) == "number" and bulletstorm_delay > 0 then
			bullet_storm_hold = bulletstorm_delay
			bulletstorm_delay = false
			managers.player:unregister_message(Message.OnWeaponFired, bulletstorm_update)
			managers.player:register_message(Message.OnWeaponFired, bulletstorm_update, function()
				if managers.player and bullet_storm_hold and type(bullet_storm_hold) == "number" and bullet_storm_hold > 0 then
					managers.player:add_to_temporary_property("bullet_storm", bullet_storm_hold, 1)
					bullet_storm_hold = false				
				end
			end)
		end
	end
	return interact, bulletstorm_delay
end

function AmmoBagBase:_take_ammo(unit)
	local taken = 0
	local inventory = unit:inventory()

	if inventory and managers.player:has_category_upgrade("ammo_bag", "take_less_from_ammo_bag") then
		for _, weapon in pairs(inventory:available_selections()) do
			local took = self:round_value(weapon.unit:base():add_ammo_from_bag(self._ammo_amount)) * managers.player:upgrade_value("ammo_bag", "take_less_from_ammo_bag")
			taken = taken + took 
			self._ammo_amount = self:round_value(self._ammo_amount - took)
			
			if self._ammo_amount <= 0 then
				taken = self._max_ammo_amount

				self:_set_empty()

				return taken
			end
		end
	elseif inventory and not managers.player:has_category_upgrade("ammo_bag", "take_less_from_ammo_bag") then
	for _, weapon in pairs(inventory:available_selections()) do
			local took = self:round_value(weapon.unit:base():add_ammo_from_bag(self._ammo_amount))
			taken = taken + took 
			self._ammo_amount = self:round_value(self._ammo_amount - took)
			
			if self._ammo_amount <= 0 then
				taken = self._max_ammo_amount

				self:_set_empty()

				return taken
			end
		end
	end
	return taken
end

Hooks:PreHook(AmmoBagBase, "_set_empty", "sydchSO", function (self)
	managers.network:session():send_to_peers_synched("sync_ammo_bag_ammo_taken", self._unit, self._max_ammo_amount + 1)
end)