local active_feedback_jammers = 0
local _set_feedback_active_original = ECMJammerBase._set_feedback_active
function ECMJammerBase:_set_feedback_active(...)
	local active_state = self:feedback_active()
	_set_feedback_active_original(self, ...)    
	if active_state ~= self:feedback_active() then
		active_feedback_jammers = math.max(0, active_feedback_jammers + (active_state and -1 or 1))
	end
end

function ECMJammerBase:mark_enemy_feedback()
	local range = tweak_data.upgrades.ecm_jammer_base_range
	local detected = World:find_units_quick("sphere", self._unit:position(), range, managers.slot:get_mask("enemies"))
	for _, unit in ipairs(detected) do
		if alive(unit:body("mover_blocker")) then
			local col_ray = {}
			col_ray.ray = Vector3(1, 0, 0)
			col_ray.position = unit:position()
			local action_data = {}
			action_data.variant = "stun"
			action_data.damage = 0
			action_data.attacker_unit = self:owner()
			action_data.col_ray = col_ray
			unit:character_damage():damage_explosion(action_data)
		end
	end
end

local retrigger = 0
local old_update = ECMJammerBase.update
function ECMJammerBase:update(unit, t, dt)
	old_update(self, unit, t, dt)
	if self._feedback_active then
		retrigger = retrigger - dt
		if retrigger <= 0 then
			self:mark_enemy_feedback()	
			retrigger = 3
		end
	end
end