function GrenadeCrateBase:take_grenade(unit)
	if self._empty then
		return
	end

	local can_take_grenade = self:_can_take_grenade() and 1 or 0
	local max_grenades = managers.player:get_max_grenades()
	local recover_amount = 1
	
	if max_grenades == 4 then
		recover_amount = recover_amount + 1
	end
	
	if max_grenades == 6 then
		recover_amount = recover_amount + 2
	end
	
	if max_grenades == 10 or max_grenades == 21 then
		recover_amount = recover_amount + 4
	end

	if can_take_grenade == 1 then
		unit:sound():play("pickup_ammo")
		managers.player:add_grenade_amount(recover_amount, true)
		managers.player:add_cable_ties(1)
		managers.network:session():send_to_peers_synched("sync_unit_event_id_16", self._unit, "base", 1)
		managers.player:register_grenade(managers.network:session():local_peer():id())
		self._grenade_amount = self._grenade_amount - 1
	end

	if self._grenade_amount <= 0 then
		self:_set_empty()
	end

	self:_set_visual_stage()
	return can_take_grenade
end

function GrenadeCrateDeployableBase:take_grenade(unit)
	if self._empty or not managers.network:session() then
		return
	end

	local max_grenades = managers.player:get_max_grenades()
	local equip = BlackMarketManager:equipped_grenade()
	if equip == "chico_injector" or equip == "tag_team" or equip == "pocket_ecm_jammer" or equip == "copr_ability" or equip == "smoke_screen_grenade" or equip == "damage_control" then
		max_grenades = 0
	end
	local grenade_amount = managers.player:add_grenade_amount(max_grenades, true)
	
	unit:sound():play("pickup_ammo")
	managers.network:session():send_to_peers_synched("sync_unit_event_id_16", self._unit, "base", 1)
	self._grenade_amount = self._grenade_amount - 1
	
	for id,weapon in pairs(managers.player:player_unit():inventory():available_selections()) do
		if alive(weapon.unit) then
			local get_ammo = weapon.unit:base():get_ammo_max_per_clip()
			weapon.unit:base():add_ammo(get_ammo)
			managers.hud:set_ammo_amount(id, weapon.unit:base():ammo_info())
		end
	end

	if self._grenade_amount <= 0 then
		self:_set_empty()
	end

	self:_set_visual_stage()
	return grenade_amount
end