dofile(ModPath .. "lua/core/sydchSO.lua")

if not Network:is_server() or not sydchSO.settings.expandedCREW == 3 then
	return
end

-- AI IMPROVEMENTS: mark enemies client sync etc.
TeamAILogicAssault._mark_special_chk_t = math.huge
function TeamAILogicAssault.mark_enemy(data, criminal, to_mark)
	if to_mark:base().char_tweak then
		criminal:sound():say(to_mark:base():char_tweak().priority_shout .. "x_any", true)
	end
	managers.network:session():send_to_peers_synched("play_distance_interact_redirect", data.unit, "cmd_point")
	data.unit:movement():play_redirect("cmd_point")
	to_mark:contour():add("mark_enemy", true)
end

local p = pairs
local w = World
local REACT_COMBAT = AIAttentionObject.REACT_COMBAT
local mvec3_angle = mvector3.angle
local mvec3_norm = mvector3.normalize
local math_ceil = math.ceil
function TeamAILogicAssault.check_smart_reload(data)
	local unit = data.unit
	if not unit:anim_data().reload then
		if not unit:movement():chk_action_forbidden("reload") then
			local current_wep = unit:inventory():equipped_unit()
			if current_wep then
				local ammo_max, ammo = current_wep:base():ammo_info()
				if ammo <= math_ceil(ammo_max * 0.6) then
					local reload_action = { type = "reload", body_part = 3 }
					unit:brain():action_request(reload_action)
				end
			end
		end
	end
end

local function _do_melee(data, criminal)
	local can_melee
	local current_wep = criminal:inventory():equipped_unit()
	local crim_mov = criminal:movement()
	local my_pos = crim_mov:m_head_pos()
	local look_vec = crim_mov:m_rot():y()
	local detected_obj = data.detected_attention_objects
	for u_key, u_char in p(detected_obj) do
		if u_char.identified then
			local unit = u_char.unit
			if unit:in_slot(12) then
				if u_char.verified then
					if u_char.verified_dis <= 200 then
						local unit_pos = u_char.m_head_pos
						local vec = unit_pos - my_pos
						if mvec3_angle(vec, look_vec) <= 45 then
							local is_shield = u_char.is_shield
							if not u_char.char_tweak.priority_shout or is_shield then
								if unit:inventory():get_weapon() then
									if not unit:anim_data().hurt then
										local damage = unit:character_damage()
										local health_damage = math_ceil(damage._HEALTH_INIT/2)
										local col_ray = { ray = -vec, body = unit:body("body"), position = unit_pos }
										local damage_info = {}
										damage_info.attacker_unit = criminal
										damage_info.weapon_unit = current_wep
										damage_info.variant = is_shield and "melee" or "bullet"
										damage_info.damage = is_shield and 0 or health_damage
										damage_info.col_ray = col_ray
										damage_info.origin = my_pos
										if is_shield then
											damage_info.shield_knock = true
											damage:damage_melee(damage_info)
										else
											damage_info.knock_down = true
											damage:damage_bullet(damage_info)
										end
										if not can_melee then
											can_melee = true
										end
									end
								end
							end
						end
					end
				end
			end
		end
	end
	if can_melee then
		crim_mov:play_redirect("melee")
		managers.network:session():send_to_peers("play_distance_interact_redirect", criminal, "melee")
	end
end

local old_update = TeamAILogicAssault.update
function TeamAILogicAssault.update(data, ...)
	local t = TimerManager:game():time()
	local my_data = data.internal_data
	if not my_data.melee_t or my_data.melee_t + 1 < t then
		my_data.melee_t = t
		_do_melee(data, data.unit)
	end
	return old_update(data, ...)
end

local old_exit = TeamAILogicAssault.exit
function TeamAILogicAssault.exit(data, ...)
	TeamAILogicAssault.check_smart_reload(data)
	return old_exit(data, ...)
end

if not Keepers then
	Hooks:PostHook(TeamAILogicAssault, "action_complete_clbk", "action_complete_clbk_ub", TeamAILogicIdle._check_objective_pos)
end

function TeamAILogicAssault._upd_sneak_spotting(data, my_data)
end