dofile(ModPath .. "lua/core/sydchSO.lua")

function TeamAIDamage:down_time()
	if self._deaths == nil then self._deaths = 0 end
	
	if managers.job:is_current_job_professional() then
		self._deaths = self._deaths + 1
	end
	
	local get_down_time = math.max(self._char_dmg_tweak.DOWNED_TIME - self._deaths, 1)
	return get_down_time
end

function TeamAIDamage:update(unit, t, dt)
	if self._regenerate_t then
		if self._regenerate_t < t then
			self:_regenerated()
		end
	elseif self._arrested_timer and self._arrested_paused_counter == 0 then
		self._arrested_timer = self._arrested_timer - dt

		if self._arrested_timer <= 0 then
			self._arrested_timer = nil
			local action_data = {
				variant = "stand",
				body_part = 1,
				type = "act",
				blocks = {
					heavy_hurt = -1,
					hurt = -1,
					action = -1,
					aim = -1,
					walk = -1
				}
			}
			local res = self._unit:movement():action_request(action_data)

			self._unit:brain():on_recovered(self._unit)
			self._unit:network():send("from_server_unit_recovered")
			managers.groupai:state():on_criminal_recovered(self._unit)
			managers.hud:set_mugshot_normal(self._unit:unit_data().mugshot_id)
		end
	end
	
	if self._revive_feign_death_t and self._revive_feign_death_t < t then
		self:revive()
		self._revive_feign_death_t = nil
		local cooldown = managers.player:crew_ability_upgrade_value("crew_feign_death", 1)
		managers.player:start_custom_cooldown("team", "crew_feign_death", cooldown)
	end

	if self._revive_reminder_line_t and self._revive_reminder_line_t < t then
		self._unit:sound():say("f11e_plu", true)
		self._revive_reminder_line_t = nil
	end
end

function TeamAIDamage:_check_bleed_out()
	if self._health <= 0 then
		self._bleed_out_health = self._HEALTH_BLEEDOUT_INIT
		self._health = 0
		self._bleed_out = true
		self._regenerate_t = nil
		self._bleed_out_paused_count = 0
		
		if Network:is_server() then
			if self._unit:movement():carrying_bag() then
				self._unit:movement():throw_bag()
			end

			if not self._to_dead_clbk_id then
				self._to_dead_clbk_id = "TeamAIDamage_to_dead" .. tostring(self._unit:key())
				self._to_dead_t = TimerManager:game():time() + self:down_time()
				managers.enemy:add_delayed_clbk(self._to_dead_clbk_id, callback(self, self, "clbk_exit_to_dead"), self._to_dead_t)
			end

			self._unit:sound():say("f11e_plu", true)
			self._revive_reminder_line_t = self._to_dead_t - 10
			if managers.player:is_custom_cooldown_not_active("team", "crew_feign_death") then
				self._revive_feign_death_t = self._to_dead_t - 1
			end
		end

		managers.groupai:state():on_criminal_disabled(self._unit)

		if Network:is_server() then
			managers.groupai:state():report_criminal_downed(self._unit)
		end

		self._unit:interaction():set_tweak_data("revive")
		self._unit:interaction():set_active(true, false)
		managers.hud:set_mugshot_downed(self._unit:unit_data().mugshot_id)
	end
end

if not Network:is_server() or not sydchSO.settings.expandedCREW == 3 then
	return
end

Hooks:PostHook(TeamAIDamage, "_apply_damage", "_apply_damage_ub", function (self)
	local t = TimerManager:game():time()
	if not sydchSO.settings.vocalHEISTERS == 1 and (not self._said_hurt_t or self._said_hurt_t + 10 < t) and self._health_ratio < 0.3 and not self:need_revive() and not self._unit:sound():speaking() then
		self._said_hurt_t = t
		self._unit:sound():say("g80x_plu", true, true)
	end
end)

-- AI IMPROVEMENTS: bots will mark the taser that tasing them
local damage_tase_original = TeamAIDamage.damage_tase
function TeamAIDamage:damage_tase(attack_data, ...)
	local result = damage_tase_original(self, attack_data, ...)

	if result then
		local attacker = attack_data.attacker_unit
		if alive(attacker) and attacker:base() and attacker:base().has_tag and attacker:base():has_tag("taser") then
			attacker:contour():add("mark_enemy", true)
			local priority_shout = attacker:base():char_tweak().priority_shout
			if priority_shout then
				self._unit:sound():say(priority_shout .. "x_any", true)
			end
		end
	end

	return result
end