dofile(ModPath .. "lua/core/sydchSO.lua")

if not Network:is_server() or not sydchSO.settings.expandedCREW == 3 then
	return
end

-- AI IMPROVEMENTS: return objective special objective, stop improvement, carry like human 
Hooks:OverrideFunction(HuskPlayerMovement, "set_need_assistance", function (self, need_assistance)
	if self._need_assistance == need_assistance then
		return
	end

	self._need_assistance = need_assistance

	if need_assistance and not self._assist_SO_id then
		self._assist_SO_id = "PlayerHusk_assistance" .. tostring(self._unit:key())
		managers.groupai:state():add_special_objective(self._assist_SO_id, sydchSO:get_assist_SO(self._unit))
	elseif not need_assistance and self._assist_SO_id then
		sydchSO:stop_assist_objective(self._unit)
		managers.groupai:state():remove_special_objective(self._assist_SO_id)
		self._assist_SO_id = nil
	end
end)

if not Keepers then
TeamAIMovement.chk_action_forbidden = CopMovement.chk_action_forbidden
Hooks:PostHook(TeamAIMovement, "set_should_stay", "sydchSO", function (self, should_stay, pos)
	if should_stay and pos then
		self._should_stay_pos = mvector3.copy(pos)
	end
	self._ext_brain:set_objective(managers.groupai:state():_determine_objective_for_criminal_AI(self._unit))
end)
end

if not BotWeapons then
	TeamAIMovement.set_visual_carry = HuskPlayerMovement.set_visual_carry
	TeamAIMovement._destroy_current_carry_unit = HuskPlayerMovement._destroy_current_carry_unit
	TeamAIMovement._create_carry_unit = HuskPlayerMovement._create_carry_unit
	local p = pairs
	local math_rand = math.random
	function TeamAIMovement:check_visual_equipment()
		local level_id = tweak_data.levels[managers.job:current_level_id()]
		local bags = { { g_medicbag = true }, { g_ammobag = true } }
		local bag_choice = bags[math_rand(#bags)]
		for k, v in p(bag_choice) do
			local mesh_obj = self._unit:get_object(Idstring(k))
			if mesh_obj then
				mesh_obj:set_visibility(v)
			end
		end
		if level_id then
			if not level_id.player_sequence then
				self._unit:damage():run_sequence_simple("var_model_02")
			end
		end
	end
	
	local old_set = TeamAIMovement.set_carrying_bag
	function TeamAIMovement:set_carrying_bag(unit, ...)
		local name_label = managers.hud:_get_name_label(self._unit:unit_data().name_label_id)
		local bag_unit = unit or self._carry_unit
		self:set_visual_carry(unit and unit:carry_data():carry_id())
		if bag_unit then
			bag_unit:set_visible(not unit)
		end
		if name_label then
			local bag_panel = name_label.panel and name_label.panel:child("bag")
			if bag_panel then
				bag_panel:set_visible(unit)
			end
		end
		return old_set(self, unit, ...)
	end
end