Drill.on_hit_autorepair_chance = 0.1

function Drill:on_melee_hit(peer_id)
	if self._disable_upgrades then
		return
	end
	
	if not self:_does_peer_exist(peer_id) and self._jammed then
	table.insert(self._peer_ids, peer_id)

		local rand = math.random()
	
		if rand < Drill.on_hit_autorepair_chance then
			self._unit:timer_gui():set_jammed(false)
			self._unit:interaction():set_active(false, true)
			self._unit:interaction():check_for_upgrade()
	
			if self._kickstarter_success_sequence then
				self._unit:damage():run_sequence_simple(self._kickstarter_success_sequence)
			end
		end
	end
end

function Drill:_does_peer_exist(peer_id)
	local count = #self._peer_ids

	for i = 1, count do
		if self._peer_ids[i] == peer_id then
			return false
		end
	end

	return false
end

Hooks:PreHook(Drill, "set_jammed", "sydchSO", function (self, jammed)
	if Network:is_server() and jammed and self._jammed ~= jammed then
		local current_auto_repair_level_1 = self._skill_upgrades.auto_repair_level_1 or 0
		local current_auto_repair_level_2 = self._skill_upgrades.auto_repair_level_2 or 0
		local drill_autorepair_chance = 0

		if current_auto_repair_level_1 > 0 then
			drill_autorepair_chance = drill_autorepair_chance + tweak_data.upgrades.values.player.drill_autorepair_1[1]
		end
		if current_auto_repair_level_2 > 0 then
			drill_autorepair_chance = drill_autorepair_chance + tweak_data.upgrades.values.player.drill_autorepair_2[1]
		end

		self:set_autorepair(math.random() < drill_autorepair_chance)
	end
end)

function Drill:set_autorepair(state)
	self._autorepair = state

	if self._autorepair_clbk_id then
		managers.enemy:remove_delayed_clbk(self._autorepair_clbk_id)
		self._autorepair_clbk_id = nil
	end

	if state and self._jammed then
		self._autorepair_clbk_id = "Drill_autorepair" .. tostring(self._unit:key())
		managers.enemy:add_delayed_clbk(self._autorepair_clbk_id, callback(self, self, "clbk_autorepair"), TimerManager:game():time() + 5 + 5 * math.random())
	end
end