dofile(ModPath .. "lua/core/sydchSO.lua")

if sydchSO.settings.skillOVERHAUL == 2 then
Hooks:PostHook(RaycastWeaponBase, "init", "sydchSO", function (self)
	self._autohit_data = tweak_data.weapon[self._name_id].autohit
	self._autohit_current = (self._autohit_data.INIT_RATIO * 0.1)
end)

-- Restoration Mod's MG Specialist Skill
local setup = RaycastWeaponBase.setup
function RaycastWeaponBase:setup(...)
	setup(self, ...)
	if managers.player:has_category_upgrade("weapon", "full_auto_free_ammo") then
		self._bullets_until_free = managers.player:upgrade_value("weapon", "full_auto_free_ammo")
	end
	self._shots_without_releasing_trigger = 0
end

Hooks:PostHook(RaycastWeaponBase, "fire", "sydchSO", function(self)
	if self._shots_without_releasing_trigger and managers.player:has_category_upgrade("weapon", "full_auto_free_ammo") then
		self._shots_without_releasing_trigger = self._shots_without_releasing_trigger + 1
		if self._shots_without_releasing_trigger > self._bullets_until_free then
			self:set_ammo_remaining_in_clip(math.min(self:get_ammo_remaining_in_clip() + 1))
			self:set_ammo_total(math.min(self:get_ammo_total() + 1))
			self._shots_without_releasing_trigger = 0
		end
	end
end)

Hooks:PostHook(RaycastWeaponBase, "stop_shooting", "sydchSO", function(self)
	self._shots_without_releasing_trigger = 0
end)

function RaycastWeaponBase:update_next_shooting_time()
	local next_fire
	if self:is_single_shot() and self:is_category("one_shot") and managers.player:has_activate_temporary_upgrade("temporary", "berserker_damage_multiplier") then
		next_fire = ((tweak_data.weapon[self._name_id].fire_mode_data and tweak_data.weapon[self._name_id].fire_mode_data.fire_rate or 0) - 0.8) / self:fire_rate_multiplier()
	else
		next_fire = ((tweak_data.weapon[self._name_id].fire_mode_data and tweak_data.weapon[self._name_id].fire_mode_data.fire_rate or 0) * 1) / self:fire_rate_multiplier()
	end
	self._next_fire_allowed = self._next_fire_allowed + next_fire
end

local on_reload = RaycastWeaponBase.on_reload
function RaycastWeaponBase:on_reload(...)
	if self._setup.expend_ammo and Global.game_settings.one_down and not self:is_category("shell_load") and sydchSO.settings.restorePROJOB == true then
		local ammo_base = self._reload_ammo_base or self:ammo_base()
		ammo_base:set_ammo_total(ammo_base:get_ammo_total() - ammo_base:get_ammo_remaining_in_clip())
	end
	on_reload(self, ...)
end

local special_add = 0
function RaycastWeaponBase:add_ammo(ratio, add_amount_override)
	local function _add_ammo(ammo_base, ratio, add_amount_override)
		if not managers.player:has_category_upgrade("player", "loose_ammo_no_restriction") then
			if managers.player:has_category_upgrade("team", "crew_fully_loaded") then
				if ammo_base:get_ammo_max() + ammo_base:get_ammo_max_per_clip() == ammo_base:get_ammo_total() then
					return false, 0
				end
			else
				if ammo_base:get_ammo_max() == ammo_base:get_ammo_total() then
					return false, 0
				end
			end
		end

		local multiplier_min = 1
		local multiplier_max = 1

		if ammo_base._ammo_data and ammo_base._ammo_data.ammo_pickup_min_mul then
			multiplier_min = ammo_base._ammo_data.ammo_pickup_min_mul
		else
			multiplier_min = managers.player:upgrade_value("player", "pick_up_ammo_multiplier", 1)
			multiplier_min = multiplier_min + managers.player:upgrade_value("player", "pick_up_ammo_multiplier_2", 1) - 1
			multiplier_min = multiplier_min + managers.player:crew_ability_upgrade_value("crew_scavenge", 0)
		end

		if ammo_base._ammo_data and ammo_base._ammo_data.ammo_pickup_max_mul then
			multiplier_max = ammo_base._ammo_data.ammo_pickup_max_mul
		else
			multiplier_max = managers.player:upgrade_value("player", "pick_up_ammo_multiplier", 1)
			multiplier_max = multiplier_max + managers.player:upgrade_value("player", "pick_up_ammo_multiplier_2", 1) - 1
			multiplier_max = multiplier_max + managers.player:crew_ability_upgrade_value("crew_scavenge", 0)
		end

		local add_amount = add_amount_override
		local picked_up = true

		if not add_amount then
			local rng_ammo = math.lerp(ammo_base._ammo_pickup[1] * multiplier_min, ammo_base._ammo_pickup[2] * multiplier_max, math.random())
			picked_up = rng_ammo > 0
			add_amount = math.max(0, math.round(rng_ammo))
		end

		add_amount = math.floor(add_amount * (ratio or 1))
		
		-- i made an overlook on this code so this part fixed by https://steamcommunity.com/id/Deadoon
		if not (self:is_category("grenade_launcher") or self:is_category("bow") or self:is_category("crossbow") or self:is_category("rocket_launcher") or self:is_category("saw")) then
			if add_amount < 1 then
				add_amount = 1
			end
			if managers.player:has_category_upgrade("player", "pick_up_ammo_multiplier") then
				add_amount = add_amount + 1
			end
		end

		if self:is_category("grenade_launcher") then
			if add_amount < 1 then
				special_add = special_add + 1
			end
			if managers.player:has_category_upgrade("player", "pick_up_ammo_multiplier") then
				special_add = special_add + 1.2
			end
			if special_add > 30 then
				add_amount = 1
				special_add = special_add - 30
			end
		end
			
		ammo_base:set_ammo_total(math.clamp(ammo_base:get_ammo_total() + add_amount, 0, ammo_base:get_ammo_max()))

		return picked_up, add_amount
	end
 
	local picked_up, add_amount = nil
	picked_up, add_amount = _add_ammo(self, ratio, add_amount_override)

	if self.AKIMBO then
		local akimbo_rounding = self:get_ammo_total() % 2 + #self._fire_callbacks

		if akimbo_rounding > 0 then
			_add_ammo(self, nil, akimbo_rounding)
		end
	end

	for _, gadget in ipairs(self:get_all_override_weapon_gadgets()) do
		if gadget and gadget.ammo_base then
			local p, a = _add_ammo(gadget:ammo_base(), ratio, add_amount_override)
			picked_up = p or picked_up
			add_amount = add_amount + a
		end
	end

	return picked_up, add_amount
end

function RaycastWeaponBase:add_ammo_to_pool(ammo, index)
	local max_ammo = self:get_ammo_max()
	local current_ammo = self:get_ammo_total()
	local clip_ammo = self:ammo_base():get_ammo_max_per_clip()
	local new_ammo = current_ammo + ammo

	if managers.player:has_category_upgrade("team", "crew_fully_loaded") then
		if max_ammo + clip_ammo < new_ammo then
			new_ammo = max_ammo
		end
	else
		if max_ammo < new_ammo then
			new_ammo = max_ammo
		end
	end

	self:set_ammo_total(new_ammo)
	managers.hud:set_ammo_amount(index, self:ammo_info())
end

function RaycastWeaponBase:exit_run_speed_multiplier()
	local multiplier = 1

	for _, category in ipairs(self:weapon_tweak_data().categories) do
		multiplier = multiplier * managers.player:upgrade_value(category, "exit_run_speed_multiplier", 1)
	end

	multiplier = multiplier * managers.player:upgrade_value(self._name_id, "exit_run_speed_multiplier", 1)
	
	if managers.player:has_activate_temporary_upgrade("temporary", "gun_kata_onenemykilled") then
		multiplier = multiplier * managers.player:temporary_upgrade_value("temporary", "gun_kata_onenemykilled", 1)
	end
	
	if managers.player:has_activate_temporary_upgrade("temporary", "gun_kata_onplayerdodge") then
		multiplier = multiplier * managers.player:temporary_upgrade_value("temporary", "gun_kata_onplayerdodge", 1)
	end

	return multiplier
end

local reflect_result = Vector3()
function InstantBulletBase:on_graze(col_ray, weapon_unit, user_unit, damage, blank, no_sound)
	local ignore_units = {}
	local range = 2000
	local angle = math.abs(mvector3.angle(col_ray.ray, reflect_result))
	--local can_graze = not (angle < 0) and not (angle > 90)
	local from_pos = col_ray.hit_position + col_ray.normal
	local ray_hits = World:raycast_all("ray", from_pos, from_pos + reflect_result * range, "slot_mask", self:bullet_slotmask(), "ignore_unit", ignore_units)
	local hit_enemy = false
	local enemy_mask = managers.slot:get_mask("enemies")
	local wall_mask = managers.slot:get_mask("world_geometry", "vehicles")
	local shield_mask = managers.slot:get_mask("enemy_shield_check")
	local bodies = World:find_bodies("intersect", "sphere", from_pos, range, enemy_mask)
	local ai_vision_ids = Idstring("ai_vision")
	local bulletproof_ids = Idstring("bulletproof")
	local units_hit = {}
	local unique_hits = {}
	local on_hit = {}
	local trail = World:effect_manager():spawn({
		effect = Idstring("effects/particles/weapons/weapon_trail"),
		position = from_pos,
		normal = reflect_result
	})
	if weapon_unit and alive(weapon_unit) then
		if weapon_unit:base()._setup and weapon_unit:base()._setup.ignore_units then
			ignore_units = weapon_unit:base()._setup.ignore_units
		else
			table.insert(ignore_units, weapon_unit)

			if user_unit then
				table.insert(ignore_units, user_unit)
			end
		end
	end
	if #bodies > 0 then
		for _, hit_body in ipairs(bodies) do
			local hit_unit = hit_body:unit()
			if hit_unit.character_damage and hit_unit:character_damage() and hit_unit:character_damage().damage_bullet and not hit_unit:character_damage():dead() then
				local raycast = World:raycast("ray", from_pos, hit_body:center_of_mass(), "slot_mask", self:bullet_slotmask(), "ignore_unit", ignore_units)
				if raycast and raycast.unit and raycast.unit:key() == hit_unit:key() then
					mvector3.set(reflect_result, raycast.ray)
					col_ray.ray = raycast.ray
					hit_enemy = true
					break
				end
			end
		end
		if not hit_enemy then
			return
		end
	else
		return
	end
	--mvector3.set_zero(reflect_result)
	--mvector3.set(reflect_result, col_ray.ray) 
	--mvector3.add(reflect_result, -2 * col_ray.ray:dot(col_ray.normal) * col_ray.normal) 
	--if not can_graze then
	--	return
	--end
	--mvector3.spread(reflect_result, math.random(10, 30)) --done till here
	for i, hit in ipairs(ray_hits) do
		if not units_hit[hit.unit:key()] then
			units_hit[hit.unit:key()] = true
			unique_hits[#unique_hits + 1] = hit
			hit.hit_position = hit.position
			hit_enemy = hit_enemy or hit.unit:in_slot(enemy_mask)
			local weak_body = hit.body:has_ray_type(ai_vision_ids)
			weak_body = weak_body or hit.body:has_ray_type(bulletproof_ids)
			if not self._can_shoot_through_enemy and hit_enemy then
				break
			elseif not self._can_shoot_through_wall and hit.unit:in_slot(wall_mask) and weak_body then
				break
			elseif not self._can_shoot_through_shield and hit.unit:in_slot(shield_mask) then
				break
			end
		end
	end
	for _, hit in ipairs(unique_hits) do
		if hit.unit and hit.unit:character_damage() then
			table.insert(on_hit, hit.unit)
		end
		if not hit.unit:in_slot(managers.slot:get_mask("civilians")) then
			InstantBulletBase:on_collision(hit, weapon_unit, user_unit, damage, blank, no_sound, true)
		end
	end
	for _, d in pairs(on_hit) do 
		managers.statistics:shot_fired({
			skip_bullet_count = true,
			hit = true,
			weapon_unit = weapon_unit
		})
	end
	World:effect_manager():set_remaining_lifetime(trail, math.clamp((range - 600) / 10000, 0, range))
end

function InstantBulletBase:on_collision(col_ray, weapon_unit, user_unit, damage, blank, no_sound, do_graze)
	local hit_unit = col_ray.unit
	local is_shield = hit_unit:in_slot(8) and alive(hit_unit:parent())
	local graze_chance = 0.5
	if managers.player:has_category_upgrade("player", "graze_damage") and not do_graze and user_unit and user_unit == managers.player:player_unit() and col_ray.unit and weapon_unit and alive(weapon_unit) and not weapon_unit:base().thrower_unit and weapon_unit:base().is_category then
		if math.random() <= graze_chance then
			InstantBulletBase:on_graze(col_ray, weapon_unit, user_unit, damage, blank, no_sound, true)
			graze_chance = 0.5
		else
			graze_chance = graze_chance + 0.1
		end
	end

	if alive(weapon_unit) and is_shield and weapon_unit:base()._shield_knock then
		local enemy_unit = hit_unit:parent()

		if enemy_unit:character_damage() and enemy_unit:character_damage().dead and not enemy_unit:character_damage():dead() then
			if enemy_unit:base():char_tweak() and not enemy_unit:base().is_phalanx and enemy_unit:base():char_tweak().damage.shield_knocked and not enemy_unit:character_damage():is_immune_to_shield_knockback() then
				local MIN_KNOCK_BACK = 200
				local KNOCK_BACK_CHANCE = 0.8
				local dmg_ratio = math.min(damage, MIN_KNOCK_BACK)
				dmg_ratio = dmg_ratio / MIN_KNOCK_BACK + 1

				local rand = math.random() * dmg_ratio

				if KNOCK_BACK_CHANCE < rand then
					local damage_info = {
						damage = 0,
						type = "shield_knock",
						variant = "melee",
						col_ray = col_ray,
						result = {
							variant = "melee",
							type = "shield_knock"
						}
					}

					enemy_unit:character_damage():_call_listeners(damage_info)
				end
			end
		end
	end

	local play_impact_flesh = not hit_unit:character_damage() or not hit_unit:character_damage()._no_blood

	if hit_unit:damage() and managers.network:session() and col_ray.body:extension() and col_ray.body:extension().damage then
	local sync_damage = not blank and hit_unit:id() ~= -1
	local network_damage = math.ceil(damage * 163.84)
	damage = network_damage / 163.84

	if sync_damage then
		local normal_vec_yaw, normal_vec_pitch = self._get_vector_sync_yaw_pitch(col_ray.normal, 128, 64)
		local dir_vec_yaw, dir_vec_pitch = self._get_vector_sync_yaw_pitch(col_ray.ray, 128, 64)

		managers.network:session():send_to_peers_synched("sync_body_damage_bullet", col_ray.unit:id() ~= -1 and col_ray.body or nil, user_unit:id() ~= -1 and user_unit or nil, normal_vec_yaw, normal_vec_pitch, col_ray.position, dir_vec_yaw, dir_vec_pitch, math.min(16384, network_damage))
	end

		local local_damage = not blank or hit_unit:id() == -1

		if local_damage then
			col_ray.body:extension().damage:damage_bullet(user_unit, col_ray.normal, col_ray.position, col_ray.ray, 1)
			col_ray.body:extension().damage:damage_damage(user_unit, col_ray.normal, col_ray.position, col_ray.ray, damage)

			if alive(weapon_unit) and weapon_unit:base().categories and weapon_unit:base():categories() then
				for _, category in ipairs(weapon_unit:base():categories()) do
					col_ray.body:extension().damage:damage_bullet_type(category, user_unit, col_ray.normal, col_ray.position, col_ray.ray, 1)
				end
			end
		end
	end

	local do_shotgun_push, result, do_push, push_mul = nil

	if alive(weapon_unit) and hit_unit:character_damage() and hit_unit:character_damage().damage_bullet then
		local is_alive = not hit_unit:character_damage():dead()
		
		if user_unit == managers.player:player_unit() then
			if managers.player:has_category_upgrade("player", "overkill_close_range") and weapon_unit and alive(weapon_unit) and not weapon_unit:base().thrower_unit and weapon_unit:base().is_category and weapon_unit:base():is_category("shotgun") then 
				local range = 200
				if range > 0 then 
					if col_ray and col_ray.distance and (col_ray.distance <= range) then 
						damage = managers.player:upgrade_value("player", "overkill_close_range", 1)
					end
				end
			end
		end
		
		local knock_down = weapon_unit:base()._knock_down and weapon_unit:base()._knock_down > 0 and math.random() < weapon_unit:base()._knock_down
		result = self:give_impact_damage(col_ray, weapon_unit, user_unit, damage, weapon_unit:base()._use_armor_piercing, false, knock_down, weapon_unit:base()._stagger, weapon_unit:base()._variant)

		if result ~= "friendly_fire" then
			local is_dead = hit_unit:character_damage():dead()
			do_push = true
			push_mul = self:_get_character_push_multiplier(weapon_unit, is_alive and is_dead)

			if weapon_unit:base() and result and result.type == "death" and weapon_unit:base().should_shotgun_push and weapon_unit:base():should_shotgun_push() then
				do_shotgun_push = true
			end
		else
			play_impact_flesh = false
		end
	else
		do_push = true
	end
	
	if do_push then
		managers.game_play_central:physics_push(col_ray, push_mul)
	end

	if do_shotgun_push then
		managers.game_play_central:do_shotgun_push(col_ray.unit, col_ray.position, col_ray.ray, col_ray.distance, user_unit)
	end

	if play_impact_flesh then
		managers.game_play_central:play_impact_flesh({
			col_ray = col_ray,
			no_sound = no_sound
		})
		self:play_impact_sound_and_effects(weapon_unit, col_ray, no_sound)
	end
	return result
end

local mvec_to = Vector3()
local mvec_spread_direction = Vector3()
local mvec1 = Vector3()

function RaycastWeaponBase:_fire_raycast(user_unit, from_pos, direction, dmg_mul, shoot_player, spread_mul, autohit_mul, suppr_mul)
	if self:gadget_overrides_weapon_functions() then
		return self:gadget_function_override("_fire_raycast", self, user_unit, from_pos, direction, dmg_mul, shoot_player, spread_mul, autohit_mul, suppr_mul)
	end

	local result = {}
	local spread_x, spread_y = self:_get_spread(user_unit)
	spread_y = spread_y or spread_x
	local ray_distance = self:weapon_range()
	local right = direction:cross(Vector3(0, 0, 1)):normalized()
	local up = direction:cross(right):normalized()
	local r = math.random()^0.5
	local theta = math.random() * 360
	local ax = r * math.rad(spread_x) * (spread_mul or 1) * math.cos(theta)
	local ay = r * math.rad(spread_y) * (spread_mul or 1) * math.sin(theta)

	mvector3.set(mvec_spread_direction, direction)
	mvector3.add(mvec_spread_direction, right * ax)
	mvector3.add(mvec_spread_direction, up * ay)
	mvector3.set(mvec_to, mvec_spread_direction)
	mvector3.multiply(mvec_to, ray_distance)
	mvector3.add(mvec_to, from_pos)

	local damage = self:_get_current_damage(dmg_mul)
	local ray_hits, hit_enemy = self:_collect_hits(from_pos, mvec_to)
	local hit_anyone = false
	local auto_hit_candidate, suppression_enemies = self:check_autoaim(from_pos, direction)

	if suppression_enemies and self._suppression then
		result.enemies_in_cone = suppression_enemies
	end

	if self._autoaim then
		local weight = 0.1

		if auto_hit_candidate and not hit_enemy then
			local autohit_chance = 1 - math.clamp((self._autohit_current - self._autohit_data.MIN_RATIO) / (self._autohit_data.MAX_RATIO - self._autohit_data.MIN_RATIO), 0, 1)

			if autohit_mul then
				autohit_chance = autohit_chance * autohit_mul
			end

			if math.random() < autohit_chance then
				self._autohit_current = (self._autohit_current + weight) / (1 + weight)

				mvector3.set(mvec_to, from_pos)
				mvector3.add_scaled(mvec_to, auto_hit_candidate.ray, ray_distance)

				ray_hits, hit_enemy = self:_collect_hits(from_pos, mvec_to)
			end
		end

		if hit_enemy then
			self._autohit_current = (self._autohit_current + weight) / (1 + weight)
		elseif auto_hit_candidate then
			self._autohit_current = self._autohit_current / (1 + weight)
		end
	end

	local hit_count = 0
	local cop_kill_count = 0
	local hit_through_wall = false
	local hit_through_shield = false
	local hit_result = nil

	for _, hit in ipairs(ray_hits) do
		damage = self:get_damage_falloff(damage, hit, user_unit)
		hit_result = nil

		if damage > 0 then
			hit_result = self._bullet_class:on_collision(hit, self._unit, user_unit, damage)
		end

		if hit_result and hit_result.type == "death" then
			local unit_type = hit.unit:base() and hit.unit:base()._tweak_table
			local is_civilian = unit_type and CopDamage.is_civilian(unit_type)

			if not is_civilian then
				cop_kill_count = cop_kill_count + 1
			end

			if self:is_category(tweak_data.achievement.easy_as_breathing.weapon_type) and not is_civilian then
				self._kills_without_releasing_trigger = (self._kills_without_releasing_trigger or 0) + 1

				if tweak_data.achievement.easy_as_breathing.count <= self._kills_without_releasing_trigger then
					managers.achievment:award(tweak_data.achievement.easy_as_breathing.award)
				end
			end
		end

		if hit_result then
			hit.damage_result = hit_result
			hit_anyone = true
			hit_count = hit_count + 1
		end

		if hit.unit:in_slot(managers.slot:get_mask("world_geometry")) then
			hit_through_wall = true
		elseif hit.unit:in_slot(managers.slot:get_mask("enemy_shield_check")) then
			hit_through_shield = hit_through_shield or alive(hit.unit:parent())
		end

		if hit_result and hit_result.type == "death" and cop_kill_count > 0 then
			local unit_type = hit.unit:base() and hit.unit:base()._tweak_table
			local multi_kill, enemy_pass, obstacle_pass, weapon_pass, weapons_pass, weapon_type_pass = nil

			for achievement, achievement_data in pairs(tweak_data.achievement.sniper_kill_achievements) do
				multi_kill = not achievement_data.multi_kill or cop_kill_count == achievement_data.multi_kill
				enemy_pass = not achievement_data.enemy or unit_type == achievement_data.enemy
				obstacle_pass = not achievement_data.obstacle or achievement_data.obstacle == "wall" and hit_through_wall or achievement_data.obstacle == "shield" and hit_through_shield
				weapon_pass = not achievement_data.weapon or self._name_id == achievement_data.weapon
				weapons_pass = not achievement_data.weapons or table.contains(achievement_data.weapons, self._name_id)
				weapon_type_pass = not achievement_data.weapon_type or self:is_category(achievement_data.weapon_type)

				if multi_kill and enemy_pass and obstacle_pass and weapon_pass and weapons_pass and weapon_type_pass then
					if achievement_data.stat then
						managers.achievment:award_progress(achievement_data.stat)
					elseif achievement_data.award then
						managers.achievment:award(achievement_data.award)
					elseif achievement_data.challenge_stat then
						managers.challenge:award_progress(achievement_data.challenge_stat)
					elseif achievement_data.trophy_stat then
						managers.custom_safehouse:award(achievement_data.trophy_stat)
					elseif achievement_data.challenge_award then
						managers.challenge:award(achievement_data.challenge_award)
					end
				end
			end
		end
	end

	if not tweak_data.achievement.tango_4.difficulty or table.contains(tweak_data.achievement.tango_4.difficulty, Global.game_settings.difficulty) then
		if self._gadgets and table.contains(self._gadgets, "wpn_fps_upg_o_45rds") and cop_kill_count > 0 and managers.player:player_unit():movement():current_state():in_steelsight() then
			if self._tango_4_data then
				if self._gadget_on == self._tango_4_data.last_gadget_state then
					self._tango_4_data = nil
				else
					self._tango_4_data.last_gadget_state = self._gadget_on
					self._tango_4_data.count = self._tango_4_data.count + 1
				end

				if self._tango_4_data and tweak_data.achievement.tango_4.count <= self._tango_4_data.count then
					managers.achievment:_award_achievement(tweak_data.achievement.tango_4, "tango_4")
				end
			else
				self._tango_4_data = {
					count = 1,
					last_gadget_state = self._gadget_on
				}
			end
		elseif self._tango_4_data then
			self._tango_4_data = nil
		end
	end

	result.hit_enemy = hit_anyone

	if self._autoaim then
		self._shot_fired_stats_table.hit = hit_anyone
		self._shot_fired_stats_table.hit_count = hit_count

		if (not self._ammo_data or not self._ammo_data.ignore_statistic) and not self._rays then
			managers.statistics:shot_fired(self._shot_fired_stats_table)
		end
	end

	local furthest_hit = ray_hits[#ray_hits]

	if (furthest_hit and furthest_hit.distance > 600 or not furthest_hit) and alive(self._obj_fire) then
		self._obj_fire:m_position(self._trail_effect_table.position)
		mvector3.set(self._trail_effect_table.normal, mvec_spread_direction)

		local trail = World:effect_manager():spawn(self._trail_effect_table)

		if furthest_hit then
			World:effect_manager():set_remaining_lifetime(trail, math.clamp((furthest_hit.distance - 600) / 10000, 0, furthest_hit.distance))
		end
	end

	if self._alert_events then
		result.rays = ray_hits
	end

	return result
end

local graze_pos = Vector3()
local graze_mul = Vector3()
local mvec_to = Vector3()
local mvec1 = Vector3()
local mvec_spread_direction = Vector3()
local graze_degree = 120
local graze_max = 20000
local graze_loop = 200

Hooks:PostHook(RaycastWeaponBase, "_fire_raycast", "sydchSO", function(self, user_unit, from_pos, direction, dmg_mul, shoot_player, spread_mul, autohit_mul, suppr_mul, shoot_through_data)
	if managers.player:has_category_upgrade("player", "graze_shave") and self:is_category("snp") and user_unit and direction then
		mvec_to = Vector3()
		mvec_spread_direction = Vector3()
		mvec1 = Vector3()
		graze_pos = Vector3()
		graze_mul = Vector3()
		
		local spread_x, spread_y = self:_get_spread(user_unit)
		local ray_distance = graze_max
		local right = direction:cross(Vector3(0, 0, 1)):normalized()
		local up = direction:cross(right):normalized()
		local theta = math.random() * 360
		local ax = math.sin(theta) * math.random() * spread_x * (spread_mul or 1)
		local ay = math.cos(theta) * math.random() * spread_y * (spread_mul or 1)
	
		mvector3.set(mvec_spread_direction, direction)
		mvector3.add(mvec_spread_direction, right * math.rad(ax))
		mvector3.add(mvec_spread_direction, up * math.rad(ay))
		mvector3.set(mvec_to, mvec_spread_direction)
		mvector3.multiply(mvec_to, ray_distance)
		mvector3.add(mvec_to, from_pos)
	
		local graze_shave = managers.player:upgrade_value("player", "graze_shave", 1)
	
		mvector3.set(graze_mul, direction)
		mvector3.multiply(graze_mul, 10)
		mvector3.add(graze_pos, from_pos)
		mvector3.add(graze_pos, graze_mul)
		local i = 1
		local touch = {}
		while mvector3.distance(from_pos, graze_pos) < graze_max and i < graze_loop do
			local units = World:find_units("sphere", graze_pos, graze_degree, self._bullet_slotmask) or {}
			for _, unit in pairs(units) do
				if not unit or not alive(unit) or not unit:base() or type(unit:base()._tweak_table) ~= "string" or not managers.enemy:is_enemy(unit) or not unit:character_damage() or unit:character_damage()._immortal or unit:character_damage():dead() then else
					touch[tostring(unit:key())] = unit
				end
			end
			i = i + 1
			mvector3.set(graze_mul, direction)
			mvector3.multiply(graze_mul, 10 * i)
			mvector3.add(graze_pos, graze_mul)
		end
		for _, unit in pairs(touch) do
			unit:character_damage():damage_explosion({
				variant = "explosion",
				damage = graze_shave,
				weapon_unit = self._unit,
				attacker_unit = user_unit,
				col_ray = {
					ray = Vector3(1, 0, 0),
					position = unit:position()
				}
			})
		end
	end
end)
end

if sydchSO.settings.weaponOVERHAUL == true then
BleedBulletBase = BleedBulletBase or class(DOTBulletBase)
BleedBulletBase.VARIANT = "bleed"
ProjectilesBleedBulletBase = ProjectilesBleedBulletBase or class(BleedBulletBase)
ProjectilesBleedBulletBase.NO_BULLET_INPACT_SOUND = false

function ProjectilesBleedBulletBase:on_collision(col_ray, weapon_unit, user_unit, damage, blank)
	local result = DOTBulletBase.super.on_collision(self, col_ray, weapon_unit, user_unit, damage, blank, self.NO_BULLET_INPACT_SOUND)

	if result ~= "friendly_fire" then
		local hit_unit = col_ray.unit
		local hit_dmg_ext = alive(hit_unit) and hit_unit:character_damage()

		if hit_dmg_ext and hit_dmg_ext.damage_dot and not hit_dmg_ext:dead() then
			weapon_unit = alive(weapon_unit) and weapon_unit or nil
			local weap_base = weapon_unit and weapon_unit:base()

			if weap_base then
				local dot_data = tweak_data.projectiles[weap_base._projectile_entry]
				dot_data = dot_data and dot_data.dot_data

				if not dot_data then
					return
				end

				local dot_type_data = tweak_data:get_dot_type_data(dot_data.type)

				if not dot_type_data then
					return
				end

				local weapon_id = weap_base and weap_base.get_name_id and weap_base:get_name_id()
				user_unit = alive(user_unit) and user_unit or nil

				self:start_dot_damage(col_ray, weapon_unit, {
					dot_damage = dot_type_data.dot_damage,
					dot_length = dot_data.custom_length or dot_type_data.dot_length
				}, weapon_id, user_unit)
			end
		end
	end

	return result
end

function BleedBulletBase:start_dot_damage(col_ray, weapon_unit, dot_data, weapon_id, user_unit)
	if not alive(col_ray.unit) then
		return
	end
	
	dot_data = dot_data or self.DOT_DATA
	weapon_unit = alive(weapon_unit) and weapon_unit or nil
	local hurt_animation = not dot_data.hurt_animation_chance or math.rand(1) < dot_data.hurt_animation_chance

	if dot_data.use_weapon_damage_falloff then
		local weap_base = weapon_unit and weapon_unit:base()

		if weap_base and weap_base.get_damage_falloff then
			user_unit = alive(user_unit) and user_unit or nil
			dot_length = weap_base:get_damage_falloff(dot_length, col_ray, user_unit)
		end
	end

	managers.dot:add_doted_enemy(col_ray.unit, TimerManager:game():time(), weapon_unit, dot_data.dot_length, dot_data.dot_damage, hurt_animation, self.VARIANT, weapon_id)
end

function DOTBulletBase:give_damage_dot(col_ray, weapon_unit, attacker_unit, damage, hurt_animation, weapon_id)
	if alive(col_ray.unit) and col_ray.unit.movement and col_ray.unit:movement() and col_ray.unit:movement()._obj_spine then
		World:effect_manager():spawn({
			effect = Idstring("effects/payday2/particles/impacts/blood/blood_impact_a"),
			position = col_ray.unit:movement()._obj_spine:position(),
			normal = Vector3(math.random(-1, 1), math.random(-1, 1), math.random(-1, 1))
		})
	end
	
	local action_data = {
		variant = self.VARIANT,
		damage = damage,
		weapon_unit = weapon_unit,
		attacker_unit = attacker_unit,
		col_ray = col_ray,
		hurt_animation = hurt_animation,
		weapon_id = weapon_id
	}
	local defense_data = {}

	if col_ray and col_ray.unit and alive(col_ray.unit) and col_ray.unit:character_damage() then
		defense_data = col_ray.unit:character_damage():damage_dot(action_data)
	end

	return defense_data
end
end